 	bsr	schermadr_opvraag
	bsr	go_init
	bsr	sup_vis_mode
	dc.w	$a00a
	bsr	cls
	bsr	set_colors
	bsr	user_mode
back:
	bsr	do_scroll
	bsr	scrollnr1
	bsr	twist_update
	bsr	do_buis

	REPT	1
	bsr	vsync
	ENDR
	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back

	bsr	wacht_toets

	clr.l	-(sp)
	trap	#1

;/----------------\;
;|  DO THE TWIST  |;
;\----------------/;
twist_update:
	sub.w	#1,addbuiscntr

	cmp.w	#0,twcnt8
	bne.s	not_0
	add.l	#1,twistcounter
	move.w	#3,w14
	bsr	set_font
not_0:
	cmp.w	#1,twcnt8
	bne.s	not_1
	move.w	#2,w14
	bsr	set_font
not_1:
	cmp.w	#2,twcnt8
	bne.s	not_2
	move.w	#1,w14
	bsr	set_font
not_2:
	cmp.w	#3,twcnt8
	bne.s	not_3
	move.w	#0,w14
	bsr	set_font
not_3:
	cmp.w	#4,twcnt8
	bne.s	not_4
	move.w	#3,w14
not_4:
	cmp.w	#5,twcnt8
	bne.s	not_5
	move.w	#2,w14
not_5:
	cmp.w	#6,twcnt8
	bne.s	not_6
	move.w	#1,w14
not_6:
	cmp.w	#7,twcnt8
	bne.s	not_7
	move.w	#0,w14
not_7:

	add.w	#1,twcnt8
	and.w	#7,twcnt8


	btst	#7,addbuiscntr
	beq	not_0_addbcntr
	add.w	#100,addbuiscntr
not_0_addbcntr:

	RTS

do_buis:
	move.l	schermadres2,a1
	add.w	#16000,a1
	move.l	#buisy,a2
	move.l	schermadres,a3
	move.w	w14,d1
	mulu	#8000,d1
	add.w	d1,a3

	move.w	#32-1,d0
ybuis1
	move.l	a3,a0
	move.w	(a2)+,d1
	add.w	addbuiscntr,d1
	cmp.w	#100,d1
	blo	over_100_1
	sub.w	#100,d1
over_100_1:

	mulu	#80,d1
	add.w	d1,a0
pl set 0
	REPT	20
	move.w	(a0)+,pl(a1)
pl set pl+8
	ENDR
	add.w	#160,a1
	dbra	d0,ybuis1

	add.w	#2,a1

	move.w	#32-1,d0
ybuis2
	sub.w	#160,a1
	move.l	a3,a0
	move.w	(a2)+,d1
	add.w	addbuiscntr,d1
	cmp.w	#100,d1
	blo	over_100_2
	sub.w	#100,d1
over_100_2:
	mulu	#80,d1
	add.w	d1,a0
pl set 0
	REPT	20
	move.w	(a0)+,pl(a1)
pl set pl+8
	ENDR
	dbra	d0,ybuis2
	RTS
;/--------\;
;-  INIT  -;
;\--------/;
go_init:
	move.l	#twisttekst,twistcounter

	move.l	#font+34,a3
	move.l	schermadres,a4
	move.l	schermadres,a5
	add.w	#40,a5
	move.l	#twistfntbuff,a6

	move.w	#5-1,d7
shift_y:
	move.w	#10-1,d6
shift_x:
	move.w	#4-1,d5
shift_4:

	move.l	a3,a0
	move.l	a4,a1
	move.l	a5,a2

	move.w	#9,d0
	sub.w	d6,d0
	asl.w	#4,d0	; *2*8 (*32 pixels)
	add.w	d0,a0

	move.w	#4,d0
	sub.w	d7,d0
	mulu	#160*28,d0
	add.w	d0,a0

	move.w	d5,d3	; 16-12-8-4..
	add.w	#1,d3
	asl.w	#2,d3
p1 set 0
p2 set 0
	REPT	28
	move.w	#0,d0
	swap	d0
	move.w	p1(a0),d0
	move.w	p1(a0),d1
	swap	d1
	move.w	p1+8(a0),d1
	move.w	p1+8(a0),d2
	swap	d2
	move.w	#0,d2

	rol.l	d3,d0
	rol.l	d3,d1
	rol.l	d3,d2

	swap	d0
	swap	d1
	swap	d2

	move.w	d0,p2(a1)
	move.w	d1,p2+2(a1)
	move.w	d2,p2+4(a1)
p1 set p1+160
p2 set p2+80
	ENDR


	move.w	#%1100000000000000,d1
	bsr	init_scroll_sub1
	REPT	7
	add.w	#80,a2
	lsr.w	#2,d1
	bsr	init_scroll_sub2
	ENDR

	sub.w	#80*7,a2
	add.w	#2,a2
	add.w	#2,a1

	move.w	#%1100000000000000,d1
	bsr	init_scroll_sub1
	REPT	7
	add.w	#80,a2
	lsr.w	#2,d1
	bsr	init_scroll_sub2
	ENDR

 	sub.w	#80*7,a2
	add.w	#2,a2
	add.w	#2,a1

	move.w	#%1100000000000000,d1
	bsr	init_scroll_sub1
	REPT	7
	add.w	#80,a2
	lsr.w	#2,d1
	bsr	init_scroll_sub2
	ENDR

pl set 0
	REPT	36
	move.l	pl(a5),(a6)+
	move.w	pl+4(a5),(a6)+
pl set pl+80
	ENDR

;	REPT	4
;	bsr	vsync
;	ENDR

	dbra	d5,shift_4
	dbra	d6,shift_x
	dbra	d7,shift_y
	RTS

init_scroll_sub1:
pl1 set 0
pl2 set 0
	REPT	28
	move.w	pl1(a1),d0
	and.w	d1,d0
	move.w	d0,pl2(a2)
pl1 set pl1+80
pl2 set pl2+80
	ENDR
	move.w	#0,d0
	REPT	8
	move.w	d0,pl2(a2)
pl2 set pl2+80
	ENDR
	RTS
init_scroll_sub2:
pl1 set 0
pl2 set 0
	REPT	28
	move.w	pl1(a1),d0
	and.w	d1,d0
	or.w	d0,pl2(a2)
pl1 set pl1+80
pl2 set pl2+80
	ENDR
	RTS


;-----------------------------------;
;           SCROLLUH !!             ;
;-----------------------------------;

do_scroll:
	move.w	#8-1,d0
scrloop1:
	move.l	schermadres,a0
	move.l	schermadres,a1
	move.w	w14,d1
	mulu	#8000,d1
	add.w	d1,a0
	add.w	d1,a1
b1 set 0
b2 set 0
b3 set 0

	REPT	20	
b2 set (b1*(80*8+2))	; bereken de plaats
b3 set (b2+(80*8+2))
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)

; (0-3)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)

; (4-7)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)

; (8-11)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)

; (12-15)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)

; (16-19)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)

; (20-23)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)

; (24-27)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)

; (28-31)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)

; (32-35)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)
	move.w	b3(a0),b2(a1)
b2 set b2+80
b3 set b3+80
b2 set b2-((b2/8000)*8000)
b3 set b3-((b3/8000)*8000)

b1 set b1+1

	ENDR
	RTS

scrollnr2:
b3 set b3+8000
b3 set b3-80*36
b3 set b3-((b3/8000)*8000)
b1 set 0
	REPT	36
	move.w	b1+b3+2(a0),d0
	or.w	d0,b1+b3(a1)
	move.w	b1+b3+4(a0),b1+b3+2(a1)
b1 set b1+80
	ENDR
	RTS

scrollnr1:
b1 set 0
	REPT	36
	move.w	b1+b3+2(a0),b1+b3(a1)
	move.w	b1+b3+4(a0),b1+b3+2(a1)
b1 set b1+80
	ENDR
	RTS

set_font:
	move.l	twistcounter,a0
	move.l	#fontlocation,a1
	clr.l	d0
	move.b	(a0),d0
	tst.w	d0
	bne.s	no_wrap
	move.l	#twisttekst,twistcounter
	move.l	twistcounter,a0
	move.b	(a0),d0
no_wrap:
	asl.w	#1,d0
	move.w	(a1,d0.w),d0

	move.l	#twistfntbuff,a0
	add.l	d0,a0

	move.w	w14,d1
	mulu	#36*6,d1
	add.w	d1,a0

	move.l	schermadres,a1

	move.w	w14,d1
	mulu	#8000,d1
	add.w	d1,a1

	REPT	36
	move.w	(a0)+,d0
	or.w	d0,b3(a1)
	move.w	(a0)+,b3+2(a1)
	move.w	(a0)+,b3+4(a1)
b3 set b3+80
b3 set b3-((b3/8000)*8000)
	ENDR
	RTS


;/--------------------------\;
;-  ADDITIONAL SUBROUTINES  -;
;\--------------------------/;
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres2	; screen add filled in d0 ->screenadd
	move.l	#twistscreen,schermadres
	RTS
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
cls:
	move.l	schermadres2,a0
	move.l	#twistscreen,a1
	move.w	#32000/4/4-1,d0
clsloop:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	dbra	d0,clsloop
	RTS
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
set_colors:
	move.w	#$000,$ff8240
	move.w	#$740,$ff8242
	move.w	#$300,$ff8244
	move.w	#$740,$ff8246
	move.w	#$700,$ff8248
	move.w	#$777,$ff825E
	RTS

;-----------------------------------;
;      VARIABELEN EN BUFFERS !!     ;
;-----------------------------------;


schermadres:	dc.l	0
schermadres2:	dc.l	0


font:	INCBIN	'F:\DRAW\PICTURES\FONTS\TWISTFNT.pi1'
charcnt:	dc.w	0

F1LOC	EQU	6*36*4
EM	EQU	46*F1LOC
fontlocation:
	dc.w	EM
	dc.w	47*F1LOC
	dc.w	48*F1LOC
	dc.w	49*F1LOC
	REPT	29	; 3-32
	dc.w	EM
	ENDR
	dc.w	36*F1LOC ; (!) 33
	dc.w	EM	;     34
	dc.w	EM	;     35
	dc.w	EM	;     36
	dc.w	EM	;     37
	dc.w	EM	;     38
	dc.w	42*F1LOC ; (') 39
	dc.w	39*F1LOC ; "(" 40
	dc.w	40*F1LOC ; ")" 41
	dc.w	EM	;     42
	dc.w	EM	;     43
	dc.w	43*F1LOC ; (,) 44
	dc.w	37*F1LOC ; (-) 45
	dc.w	38*F1LOC ; (.) 46
	dc.w	EM	;     47
	dc.w	0*F1LOC  ; (0) 48
	dc.w	1*F1LOC  ; (1) 49
	dc.w	2*F1LOC  ; (2) 50
	dc.w	3*F1LOC  ; (3) 51
	dc.w	4*F1LOC  ; (4) 52
	dc.w	5*F1LOC  ; (5) 53
	dc.w	6*F1LOC  ; (6) 54
	dc.w	7*F1LOC  ; (7) 55
	dc.w	8*F1LOC  ; (8) 56
	dc.w	9*F1LOC  ; (9) 57
	dc.w	41*F1LOC  ; (:) 58
	dc.w	45*F1LOC  ; (;) 59
	dc.w	EM	;     60
	dc.w	EM	;     61
	dc.w	EM	;     62
	dc.w	44*F1LOC  ; (?) 63
	dc.w	EM	;     64
pl set 10
	REPT	26
	dc.w	pl*F1LOC ; A-Z
pl set pl+1
	ENDR

twisttekst:	
	dc.b	" MARK AMENT DOES IT AGAIN !!  ACCW - COMPUTERCLUB   ",1,2
	dc.b	0
twistcounter:	dc.l	0
twcnt8:	dc.w	0
w14:	dc.w	0
ssp:	dc.l	0
addbuiscntr:	dc.w	2
buisy:	
	dc.w	0,2,5,7,10,12,14,16,18,19,20,21,22,23,24,25
	dc.w	26,27,28,29,30,31,32,33,34,35,37,39,41,44,47,50
	dc.w	50,52,55,57,60,62,64,66,68,69,70,71,72,73,74,75
	dc.w	76,77,78,79,80,81,82,83,84,85,87,89,91,94,97,100

;	dc.w	0,4,10,14,20,24,28,32,36,38,40,42,44,46,48,50
;	dc.w	50,52,54,56,58,60,62,64,66,70,74,78,84,88,94,100
;	dc.w	0,4,10,14,20,24,28,32,36,38,40,42,44,46,48,50
;	dc.w	50,52,54,56,58,60,62,64,66,70,74,78,84,88,94,100


twistfntbuff:	ds.b	6*36*4*50	(breed*hoog*shifts*aantfonts)
twistscreen:	ds.b	32000
