; x Blokjes die kunnen verdwijnen
;   bij aanraking doen dat ook.
;   (ANIMATIE)
; x Bekijk procedure waar voor
;   een puntje raak is (onderste,
;   rechts/links) -> sp_y=0 weg
; x Blokjes die bij het erop staan
;   zakken en bij het eraf gaan weer
;   naar de oude positie stijgt.
; x Vuur en water -> DOOD !
; x Banaan moet MASK zien op populos
;   blokken , omdat dan de voetjes
;   gaan lopen
; x Populos z'n 0-blokjes omranding
;   niet bij een ander blokje dan -1

; - Populos FOUT bij springen
;   en dan komt hij niet meer op
;   het blokje, (door dat hij een
;   een ander blokje ervoor aan
;   ziet ???)

; - Sprite bots-routine maken:
;   * Banaan kan schieten
;   * Enemy maken
; - Banaan kan glijden over een
;   stijl stuk

Indicate_Time	equ	$20
Scroll_adres	equ	$ffff8265
mousevec	equ	16
joyvec		equ	24
ikbdws		equ	25
kbdvec		equ	34
JUMPstart_sp	equ	8
jumpmax_time	equ	80/8
aantblok_cop	equ	60+1
aantblok_back	equ	57+1
unused_cop	equ	2*(256-21)
unused_voor	equ	2*(19)
unused_back	equ	2*(19)
length_cop	equ	256
color_indicate	equ	0 ; 0=N,1=J
ch_coord_indic	equ	0 ; 0=N,1=J
show_veld_hoog	equ	11
BANX		EQU	10
BANCENTX	EQU	11
BANUPPER	EQU	6

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

	move.w	#$00,getal
	bsr	schermadr_opvraag
	bsr	sup_vis_mode
	bsr	store_palette
	bsr	set_palette
	bsr	install_mo_jo
dood:
	bsr	cls
	bsr	beeld_change
	bsr	vsync
	move.w	#0,camera_x
	move.w	#0,camera_y
	move.w	#0,scrx_speed
	move.w	#0,speed_x
	move.w	#0,speed_y
	move.w	#0,DEAD
	move.w	#0,addcleadr
	move.w	#20,coord_x
	move.w	#80,coord_y
	move.l	schermadres,banacleadres
	move.l	schermadres,banacleadres+4
	bsr	bewerk_pop_array
hoofdlus:
	move.l	#$33330033,d0
	bsr	go_indicate

	move.b	jpacket+2,d0
	and.w	#2,d0
	beq.s	geen_down
	add.w	#10,coord_x
geen_down:

	move.w	#0,DEAD

	bsr	cle_sprite
	bsr	update_camera
	move.w	#0,pophandle
	bsr	animatie_populos
	bsr	bereken_veld_offset
	bsr	show_veld
	bsr	calc_new_coords
	bsr	speed_y_begrens
	bsr	GO_X
	bsr	GO_Y
	bsr	right_sprite
	bsr	put_sprite
	bsr	clear_borders
	bsr	animatie_blokje
	;bsr	printnr
	bsr	fire_water
	move.l	#$0,d0
	bsr	go_indicate
;	bsr	vsync
;	bsr	vsync
	bsr	vsync
	bsr	beeld_change
	tst.w	DEAD
	bne	dood

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	hoofdlus

	bsr	wacht_toets
	bsr	restore_mo_jo

	move.l	schermadres_oud,schermadres
	bsr	beeld_change
	move.b	#0,Scroll_adres
	bsr	restore_palette
	bsr	user_mode
	clr.l	-(sp)
	trap	#1

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
bewerk_pop_array:
	move.l	#inc_pop_array,a0
	move.l	#populos_array,a1
	move.w	#140,d6
	move.w	#6-1,d7
bewerk_pop_loop:
	move.w	(a0),(a1)
	move.l	#0,2(a1)
	move.w	2(a0),6(a1)
	move.w	#0,8(a1)
	move.w	d6,10(a1)

	add.w	#2,d6
	add.w	#4,a0
	add.w	#12,a1
	dbra	d7,bewerk_pop_loop

	RTS
fire_water:
	cmp.w	#1,DEAD
	bne.s	geen_dood_scene_lava
	bsr	dood_scene
geen_dood_scene_lava:
	RTS

dood_scene:
	;move.l	#$0,$ff9800
	move.w	#100,dood_scene_cntr
dood_scene_loop:

	move.w	#0,scrx_speed
	move.w	coord_x,d0
	sub.w	camera_x,d0
	cmp.w	#164,d0
	blo	niet_te_ver_camera_x2
	move.w	#2,scrx_speed
niet_te_ver_camera_x2:
	cmp.w	#160,d0
	bhi	niet_te_ver_camera_x3
	move.w	#-2,scrx_speed
niet_te_ver_camera_x3:
	cmp.w	#0,scrx_speed
	beq.s	exit_centreren

	move.w	scrx_speed,d0
	add.w	d0,camera_x
	or.w	#1,camera_x

	bsr	cle_sprite
	bsr	bereken_veld_offset
	bsr	show_veld
	bsr	put_sprite
	bsr	clear_borders
	bsr	vsync
	bsr	beeld_change

	sub.w	#1,dood_scene_cntr
	move.w	dood_scene_cntr,d7
	cmp.w	#0,d7
	bne	dood_scene_loop
exit_centreren:



	; DOOD SEQUENCE
	move.w	#0,dood_scene_cntr
dood_scene_loop2:
	bsr	cle_sprite
	bsr	bereken_veld_offset
	bsr	show_veld
	bsr	clear_borders

	move.l	#dood_sequence+34,a0
	move.l	schermadres,a1

	cmp.w	#1,side
	bne.s	andere_kant
	add.w	#160*32,a0
andere_kant:

	move.w	dood_scene_cntr,d0
	asl.w	#4,d0	;*16
	add.w	d0,a0

	clr.l	d0
	move.w	coord_y,d0
	sub.w	camera_y,d0
	sub.w	#16,d0
	mulu	#336,d0
	add.l	d0,a1

	move.w	coord_x,d0
	sub.w	camera_x,d0
	and.w	#$fff0,d0
	add.w	d0,a1

	move.w	#32-1,d6
copy_y_loop:
	bsr	ga_dood_scene_1_part
	add.w	#8,a0
	add.w	#16,a1
	bsr	ga_dood_scene_1_part
	add.w	#160-8,a0
	add.w	#336-16,a1
	dbra	d6,copy_y_loop

	bsr	vsync
	bsr	vsync
	bsr	vsync
	bsr	vsync
	bsr	vsync

	bsr	beeld_change
	add.w	#1,dood_scene_cntr
	move.w	dood_scene_cntr,d7
	cmp.w	#10,d7
	bne	dood_scene_loop2

	move.w	#50,d7
wacht_even_na_dood:
	bsr	vsync
	dbra	d7,wacht_even_na_dood
	bsr	cls
	RTS

ga_dood_scene_1_part:
	move.w	(a0),d1
	or.w	2(a0),d1
	or.w	4(a0),d1
	or.w	6(a0),d1
	not.w	d1
	and.w	d1,(a1)
	and.w	d1,2(a1)
	and.w	d1,4(a1)
	and.w	d1,6(a1)

	move.l	(a0),d1
	or.l	d1,(a1)
	move.l	4(a0),d1
	or.l	d1,4(a1)
	RTS

animatie_populos:
	move.l	#populos_array,a0
	move.w	#6-1,d7
anim_pop_loop:
	tst.w	8(a0) ; GONE DOWN
	bne.s	niet_omhoog
	sub.w	#2,2(a0)
	cmp.w	#700,2(a0)
	blo.s	niet_omhoog
	move.w	#0,2(a0)
niet_omhoog
	move.w	#0,8(a0)
	add.w	#12,a0
	dbra	d7,anim_pop_loop

	move.l	#populos_array,a0
	move.w	#6-1,d7
animpoploop:

	move.l	#veld+32,a1
	move.w	(a0),d0 ; OFFSET VELD
	add.w	d0,a1

	move.w	2(a0),d0
	and.w	#$fff0,d0
	asl.w	#5,d0	; /16*256*2
	add.w	d0,a1

	move.w	10(a0),d0

	move.w	#-514,d1
	bsr	go_set_vraagteken2
	move.w	#-512,d1
	bsr	go_set_vraagteken
	move.w	#-510,d1
	bsr	go_set_vraagteken2

	move.w	#-2,d1
	bsr	go_set_vraagteken2
	move.w	#2,d1
	bsr	go_set_vraagteken2

	move.w	d0,(a1) ; 2 2

	move.w	#510,d1
	bsr	go_set_vraagteken2
	move.w	#514,d1
	bsr	go_set_vraagteken2

	add.w	#1,d0
	move.w	d0,512(a1) ; 2 3

	move.w	#1022,d1
	bsr	go_set_vraagteken2
	move.w	#1024,d1
	bsr	go_set_vraagteken
	move.w	#1026,d1
	bsr	go_set_vraagteken2
	move.w	(a1,d1.w),d2

	move.w	#0,4(a0) ; BEWEEG FLAG=AAN(TIJDELIJK)
	add.w	#12,a0
	dbra	d7,animpoploop

	; clear 140,141
	move.l	#blokpic,a0
	add.w	#140*16*8,a0
	move.w	#6-1,d7
anim_pop_loop3
	REPT	32*8/4
	clr.l	(a0)+
	ENDR
	dbra	d7,anim_pop_loop3

	move.l	#maskblokpic,a0
	add.w	#140*16*2,a0
	REPT	32*2/4
	clr.l	(a0)+
	ENDR

	move.l	#populos_array,a2
	move.w	#0,d6	; counter
	move.w	#6-1,d7
anim_pop_loop2:
	move.l	#blokpic,a0
	add.w	#140*16*8,a0
	add.w	d6,a0
	move.l	#blokpic,a1
	add.w	#108*16*8,a1
	move.w	2(a2),d0
	and.w	#15,d0
	asl.w	#3,d0 ; *8
	add.w	d0,a0
	REPT	16*8/4
	move.l	(a1)+,(a0)+
	ENDR
	add.w	#12,a2
	add.w	#16*8*2,d6
	dbra	d7,anim_pop_loop2

	move.l	#populos_array,a2
	move.w	#0,d6	; counter
	move.w	#6-1,d7
anim_pop_loop4:
	move.l	#maskblokpic,a0
	add.w	#140*4*8,a0
	add.w	d6,a0
	move.l	#maskblokpic,a1
	add.w	#108*4*8,a1
	move.w	2(a2),d0
	and.w	#15,d0
	asl.w	#1,d0 ; *8/4=>*2
	add.w	d0,a0
	REPT	4*8/4
	move.l	(a1)+,(a0)+
	ENDR
	add.w	#12,a2
	add.w	#4*8*2,d6
	dbra	d7,anim_pop_loop4
	RTS

; WEGHALEN  : POPULOS
; N.WEGHALEN: WATER
go_set_vraagteken:
	move.w	(a1,d1.w),d5
	cmp.w	#140,d5
	blo.s	ne
	cmp.w	#196,d5
	bhi.s	ne
	move.w	#0,(a1,d1.w)
ne:
	RTS

go_set_vraagteken2:
	move.w	(a1,d1.w),d5
	cmp.w	#-1,d5
	bne.s	skip_ne
	move.w	#0,(a1,d1.w)
skip_ne:
	RTS

animatie_blokje:
	add.w	#1,animbloktel
	cmp.w	#3,animbloktel
	beq.s	go_animblok
	RTS

go_animblok:
	move.w	#0,animbloktel
	move.l	#animation_array,a3
	move.w	#8-1,d3
verder_zoeken3:
	cmp.w	#0,(a3)  ; X blokje
	beq.s	niet_leeg
	cmp.w	#0,2(a3) ; Y blokje
	beq.s	niet_leeg

	move.w	(a3),d0
	move.w	2(a3),d1

	move.l	#veld+32,a2
	move.w	d1,d2
	mulu	#length_cop*2,d2
	add.w	d2,a2
	move.w	d0,d2
	asl.w	#1,d2	; .W
	add.w	d2,a2
	add.w	#1,4(a3)
	move.w	4(a3),(a2)
	cmp.w	#130,(a2)
	bne.s	niet_leeg
	move.w	#0,(a2)
	move.w	#0,(a3)
	move.w	#0,2(a3)
	move.w	#0,4(a3)
niet_leeg
	add.w	#8,a3
	dbra	d3,verder_zoeken3
	RTS

speed_y_begrens:
	move.w	speed_y,d0
	add.w	#100,d0
	cmp.w	#100+16,d0
	blo.s	speed_y_16
	move.w	#16,speed_y
speed_y_16:
	RTS

clear_borders:
	move.l	schermadres,a0
	add.l	#(show_veld_hoog-1)*16*336,a0
	move.w	#(336*16)/16,d0
	bsr	cbord_loop
	RTS
cbord_loop:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra	d0,cbord_loop
	RTS

right_sprite:
	cmp.w	#0,event
	bne.s	done

	move.w	speed_x,d0
	tst.w	d0
	bne.s	spx_n0
	move.w	#0,banana_anim_teller
	bra	done
spx_n0:

	move.w	#0,side ; DEFAULT
	cmp.w	#100,d0 ; tellen !
	blo.s	inv_
	neg.w	d0
	move.w	#1,side
inv_:
	cmp.w	#1,on_ice
	beq.s	skip_anim_teller
	add.w	d0,banana_anim_teller
	bra	skip_anim_teller2

skip_anim_teller:
	cmp.w	#4,speed_x
	bhi.s	skip_anim_teller2
	cmp.w	#0,speed_x
	blo.s	skip_anim_teller2
	move.w	#0,banana_anim_teller
skip_anim_teller2:

	cmp.w	#27,banana_anim_teller
	blo.s	done
	move.w	#0,banana_anim_teller
done:	
	cmp.w	#1,event
	bne.s	done2
	move.w	#0,banana_anim_teller

	move.w	speed_x,d0
	tst.w	d0
	beq.s	done2
	move.w	#0,side ; DEFAULT
	cmp.w	#100,d0 ; tellen !
	blo.s	done2
	move.w	#1,side
done2:

	move.l	#go_banana_l,a0
	move.w	#160*30,d0
	cmp.w	#0,side
	bne.s	wrong_side
	move.l	#go_banana_r,a0
	move.w	#136*30,d0
wrong_side:

	move.w	speed_x,d1
	cmp.w	#100,d1 ; tellen !
	blo.s	done3
	neg.w	d1
done3:
	mulu	#11,d1
	asr.w	#5,d1
	mulu	#4*30,d1
	add.w	d1,d0

	add.w	banana_anim_teller,a0
	add.w	banana_anim_teller,a0
	add.w	banana_anim_teller,a0
	add.w	banana_anim_teller,a0
	move.l	(a0),a0
	move.w	d0,(a0)+
	add.w	#30,d0
	move.w	d0,(a0)+
	add.w	#30,d0
	move.w	d0,(a0)+
	RTS

cle_sprite:
	move.l	#banacleadres,a6
	add.w	addcleadr,a6

	move.l	(a6),a2
	move.w	#32-1,d0
cle_loop:
	clr.l	(a2)
	clr.l	4(a2)
	clr.l	16(a2)
	clr.l	20(a2)
	clr.l	32(a2)
	clr.l	36(a2)
	add.w	#336,a2
	dbra	d0,cle_loop
	RTS
put_sprite:
	move.l	#go_banana_l,a0
	cmp.w	#0,side
	bne.s	wrong_side2
	move.l	#go_banana_r,a0
wrong_side2:
	add.w	banana_anim_teller,a0
	add.w	banana_anim_teller,a0
	add.w	banana_anim_teller,a0
	add.w	banana_anim_teller,a0
	move.l	(a0),a0

	move.w	coord_x,d0 ;(-X-)
	sub.w	camera_x,d0
	sub.w	#BANCENTX,d0

	move.w	camera_x,d1 ; ADD SHIFT
	and.w	#15,d1
	add.w	d1,d0

	move.w	d0,d1     ; (-X-)
	and.l	#15,d1
	mulu	#25*30,d1 ; 200*30
	asl.l	#3,d1

	move.l	schermadres,a2
	sub.w	#336*16,a2

	and.w	#$fff0,d0 ; (-X-)
	add.w	d0,a2

	clr.l	d0	; (-Y-)
	move.w	coord_y,d0
	sub.w	camera_y,d0
	mulu	#336,d0
	add.l	d0,a2

	move.l	#banacleadres,a6
	add.w	addcleadr,a6
	move.l	a2,(a6)

	move.w	#32-1,d0
puts_lp	move.l	#banana_picture,a1
	add.l	d1,a1 ; side

	add.w	(a0)+,a1

	move.w	(a1),d2
	swap	d2
	move.w	(a1),d2
	and.l	d2,(a2)
	and.l	d2,4(a2)
	move.l	2(a1),d2
	or.l	d2,(a2)
	move.l	6(a1),d2
	or.l	d2,4(a2)

	move.w	10(a1),d2
	swap	d2
	move.w	10(a1),d2
	and.l	d2,16(a2)
	and.l	d2,20(a2)
	move.l	12(a1),d2
	or.l	d2,16(a2)
	move.l	16(a1),d2
	or.l	d2,20(a2)

	move.w	20(a1),d2
	swap	d2
	move.w	20(a1),d2
	and.l	d2,32(a2)
	and.l	d2,36(a2)
	move.l	22(a1),d2
	or.l	d2,32(a2)
	move.l	26(a1),d2
	or.l	d2,36(a2)

	add.w	#336,a2
	dbra	d0,puts_lp
	RTS
store_palette:
	move.l	#$ffff9800,a0
	move.l	#oud_palette,a1
	move.w	#256-1,d0
store_l	move.l	(a0)+,(a1)+
	dbra	d0,store_l
	RTS
restore_palette:
	move.l	#oud_palette,a0
	move.l	#$ffff9800,a1
	move.w	#256-1,d0
restore	move.l	(a0)+,(a1)+
	dbra	d0,restore
	RTS
set_palette:
	move.l	#palette,a0
	move.l	#$ffff9800,a1
	move.w	#256-1,d0
setloop	move.l	(a0)+,(a1)+
	dbra	d0,setloop
	RTS
update_camera:
	move.w	coord_x,d0
	sub.w	camera_x,d0
	add.w	#1,d0

	cmp.w	#240,d0
	blo.s	no_sp_screen1
	cmp.w	#2,scrx_speed
	bne.s	no_sp_screen1a
	move.w	#4,scrx_speed
no_sp_screen1a:
	cmp.w	#0,scrx_speed
	bne.s	no_sp_screen1
	move.w	#4,scrx_speed
no_sp_screen1:

	cmp.w	#80,d0
	bhi.s	no_sp_screen2
	cmp.w	#-2,scrx_speed
	bne.s	no_sp_screen2a
	move.w	#-4,scrx_speed
no_sp_screen2a:
	cmp.w	#0,scrx_speed
	bne.s	no_sp_screen2
	move.w	#-4,scrx_speed
no_sp_screen2:

	cmp.w	#210,d0
	bhi.s	no_sp_screen3
	cmp.w	#4,scrx_speed
	bne.s	no_sp_screen3
	move.w	#2,scrx_speed
no_sp_screen3:

	cmp.w	#110,d0
	blo.s	no_sp_screen4
	cmp.w	#-4,scrx_speed
	bne.s	no_sp_screen4
	move.w	#-2,scrx_speed
no_sp_screen4:

	cmp.w	#170,d0
	bhi.s	no_sp_screen5
	cmp.w	#2,scrx_speed
	bne.s	no_sp_screen5
	move.w	#0,scrx_speed
no_sp_screen5:

	cmp.w	#150,d0
	blo.s	no_sp_screen6
	cmp.w	#-2,scrx_speed
	bne.s	no_sp_screen6
	move.w	#0,scrx_speed
no_sp_screen6:

	move.w	scrx_speed,d0
	add.w	d0,camera_x
	or.w	#1,camera_x

	move.w	camera_x,d0
	add.w	#10,d0
	cmp.w	#10,d0
	bhi	niet_te_ver_camera_x
	move.w	#1,camera_x
niet_te_ver_camera_x:

	move.w	coord_y,d0
	sub.w	#100,d0
	cmp.w	#0,d0
	bpl	not_zero2
	move.w	#0,d0
not_zero2:
	move.w	d0,camera_y

	RTS


begrens_sprite:
	tst.w	coord_x
	bpl.s	n_neg1
	move.w	#0,coord_x
	move.w	#0,speed_x
n_neg1
	tst.w	coord_y
	bpl.s	n_neg2
	move.w	#0,coord_y
	move.w	#0,speed_y
n_neg2
	cmp.w	#16*2*(256-20)-1,coord_x
	blo	n_neg3
	move.w	#16*2*(256-20)-1,coord_x
	move.w	#0,speed_x
n_neg3
	cmp.w	#500,coord_y
	blo	n_neg4
	move.w	#510,coord_y
	move.w	#0,speed_y
n_neg4
	RTS

calc_new_coords:
	clr.w	d0
	move.b	jpacket+2,d0
; joy=UP & jumpready=1
	move.b	d0,d1
	and.w	#1,d1
	tst.w	d1
	beq.s	not_up
	tst.w	jumpready ; In air=0
	beq.s	not_up
	move.w	#-JUMPstart_sp,speed_y
	add.w	#1,jumpteller
	move.w	#1,event
not_up
; joy<>UP
	move.b	d0,d1
	and.w	#1,d1
	tst.w	d1
	bne.s	not_up2
	move.w	#0,jumpready
not_up2
; jumpteller=JUMPMAXTIME
	move.w	jumpteller,d1
	cmp.w	#jumpmax_time,d1
	bne.s	not_maxcnt_jmp
	move.w	#0,jumpready
not_maxcnt_jmp
; LINKS & RECHTS
	move.b	d0,d1
	and.w	#4,d1
	tst.w	d1
	beq.s	n_left
	sub.w	#2,speed_x
n_left	
	move.b	d0,d1
	and.w	#8,d1
	tst.w	d1
	beq.s	n_right
	add.w	#2,speed_x
n_right

; (-Xspeed-) LIMITATIONS
	move.w	speed_x,d0
	add.w	#100,d0

	cmp.w	#1,on_ice
	beq.s	speed_limit_4
	cmp.w	#99,d0
	bhi.s	speed_limit_3
	add.w	#1,d0
speed_limit_3
	cmp.w	#101,d0
	blo.s	speed_limit_4
	sub.w	#1,d0
speed_limit_4

	cmp.w	#116,d0
	blo.s	speed_limit_1
	move.w	#116,d0
speed_limit_1

	cmp.w	#84,d0
	bhi.s	speed_limit_2
	move.w	#84,d0
speed_limit_2

	sub.w	#100,d0
	move.w	d0,speed_x

; (-Yspeed-) LIMITATIONS
	move.w	speed_y,d0
	add.w	#101,d0
	sub.w	#100,d0
	move.w	d0,speed_y
	RTS

GO_X:
	move.w	speed_x,d6
	asr.w	#2,d6
	tst.w	d6	; sp=0
	beq.s	NOSP_X
	tst.w	d6
	bpl.s	NEGSP_X

	not.w	d6	; sp<0
le_loop	bsr	left_check
	dbra	d6,le_loop
	bra	NOSP_X
NEGSP_X
	sub.w	#1,d6	; sp>0
ri_loop	bsr	right_check
	dbra	d6,ri_loop
NOSP_X	RTS

GO_Y:
	move.w	speed_y,d6
	asr.w	#1,d6
	tst.w	d6	; sp=0
	beq.s	NOSP_Y
	tst.w	d6
	bpl.s	NEGSP_Y

	not.w	d6	; sp<0
up_loop	bsr	up_check
	dbra	d6,up_loop
	bra	NOSP_Y
NEGSP_Y
	sub.w	#1,d6	; sp>0
dowloop	bsr	down_check
	dbra	d6,dowloop
NOSP_Y	RTS

up_check:
	move.w	#0,pophandle2
	sub.w	#1,coord_y ; DEC Y
	bsr	begrens_sprite
	move.w	coord_x,d0 ; #1
	move.w	coord_y,d1
	add.w	#BANUPPER,d1
	bsr	check_coord
	move.w	d7,d5
	move.w	coord_x,d0 ; #2
	move.w	coord_y,d1
	add.w	#BANX/2,d0
	add.w	#BANUPPER,d1
	bsr	check_coord
	add.w	d7,d5
	move.w	coord_x,d0 ; #3
	move.w	coord_y,d1
	add.w	#BANX,d0
	add.w	#BANUPPER,d1
	bsr	check_coord
	add.w	d7,d5

	tst.w	d5
	beq.s	ok_up
	add.w	#1,coord_y
	move.w	#0,speed_y
ok_up	RTS
down_check:
	add.w	#1,coord_y ; INC Y
	bsr	begrens_sprite
	move.w	coord_x,d0 ; #1
	move.w	coord_y,d1
	add.w	#31,d1
	bsr	check_coord
	move.w	d7,d5

	move.w	#1,pophandle2
	move.w	coord_x,d0 ; #2
	move.w	coord_y,d1
	add.w	#BANX/2,d0
	add.w	#31,d1
	bsr	check_coord
	add.w	d7,d5
	move.w	#0,pophandle2

	move.w	coord_x,d0 ; #3
	move.w	coord_y,d1
	add.w	#BANX,d0
	add.w	#31,d1
	bsr	check_coord
	add.w	d7,d5

	tst.w	d5
	beq.s	ok_down
	sub.w	#1,coord_y
	move.w	#0,speed_y
	move.w	#1,jumpready
	move.w	#0,jumpteller
	move.w	#0,event
ok_down	RTS
right_check:
	add.w	#1,coord_x
	bsr	begrens_sprite

	move.w	coord_x,d0
	move.w	coord_y,d1
	add.w	#BANX,d0
	add.w	#BANUPPER,d1
	bsr	check_coord
	move.w	d7,checkcoord_8

	move.w	coord_x,d0
	move.w	coord_y,d1
	add.w	#BANX,d0
	add.w	#13,d1
	bsr	check_coord
	move.w	d7,checkcoord_7

	move.w	coord_x,d0
	move.w	coord_y,d1
	add.w	#BANX,d0
	add.w	#25,d1
	bsr	check_coord
	move.w	d7,checkcoord_6

	move.w	coord_x,d0
	move.w	coord_y,d1
	add.w	#BANX,d0
	add.w	#31,d1
	bsr	check_coord
	move.w	d7,checkcoord_5

	move.w	checkcoord_8,d0
	asl.w	#1,d0
	add.w	checkcoord_7,d0
	asl.w	#1,d0
	add.w	checkcoord_6,d0
	asl.w	#1,d0
	add.w	checkcoord_5,d0

	cmp.w	#1,d0
	bne.s	geen1_r
	sub.w	#1,coord_x
	bsr	up_check
	;add.w	#1,speed_y
	bra	geen0_r
geen1_r	cmp.w	#0,d0
	beq.s	geen0_r
	sub.w	#1,coord_x
geen0_r	RTS

left_check:
	sub.w	#1,coord_x
;	bsr	begrens_sprite

	move.w	coord_x,d0
	move.w	coord_y,d1
	add.w	#BANUPPER,d1
	bsr	check_coord
	move.w	d7,checkcoord_0

	move.w	coord_x,d0
	move.w	coord_y,d1
	add.w	#13,d1
	bsr	check_coord
	move.w	d7,checkcoord_1

	move.w	coord_x,d0
	move.w	coord_y,d1
	add.w	#25,d1
	bsr	check_coord
	move.w	d7,checkcoord_2

	move.w	coord_x,d0
	move.w	coord_y,d1
	add.w	#31,d1
	bsr	check_coord
	move.w	d7,checkcoord_3

	move.w	checkcoord_0,d0
	asl.w	#1,d0
	add.w	checkcoord_1,d0
	asl.w	#1,d0
	add.w	checkcoord_2,d0
	asl.w	#1,d0
	add.w	checkcoord_3,d0

	cmp.w	#1,d0
	bne.s	geen1_l
	add.w	#1,coord_x
	bsr	up_check
	bra	geen0_l
geen1_l	cmp.w	#0,d0
	beq.s	geen0_l
	add.w	#1,coord_x
geen0_l	RTS

;            T E K E N   V E L D

show_veld:
	move.l	schermadres,a0
	sub.w	#336*16,a0
	move.w	camera_y,d0
	not.w	d0
	and.w	#15,d0
	mulu	#336,d0
	add.w	d0,a0
	move.l	#veld+32,a2
	add.w	veld_offset,a2
	move.w	#show_veld_hoog-1,d6 ; d6,Yloop
Yloop_show
	move.w	#21-1,d7 ; d6,Xloop
Xloop_show
	move.l	#blokpic,a1
	move.w	(a2)+,d0
	cmp.w	#-1,d0
	beq	neg_blok
	asl.w	#7,d0
	add.w	d0,a1
	REPT	16
	move.l	(a1)+,(a0)+
	move.l	(a1)+,(a0)+
	add.w	#336-8,a0
	ENDR	
	sub.w	#336*16,a0
neg_blok:
	add.w	#16,a0
	dbra	d7,Xloop_show
	add.w	#unused_cop,a2
	add.w	#336*15,a0
	dbra	d6,Yloop_show
	RTS
bereken_veld_offset:
	move.w	camera_y,d0
	asr.w	#4,d0	; div 16
	add.w	#1,d0
	mulu	#length_cop*2,d0
	move.w	camera_x,d1
	asr.w	#4,d1	; div 16
	asl.w	#1,d1	; .W
	add.w	d1,d0
	move.w	d0,veld_offset
	RTS

check_coord: ; d0=X,d1=Y, d7=>JA/NEE
	move.l	#maskblokpic,a1
	move.l	#veld+32,a2
	move.l	#tabel1,a3

	move.w	d1,d2
	asr.w	#4,d2	; div 16
	mulu	#length_cop*2,d2
	add.w	d2,a2
	move.w	d0,d2
	asr.w	#4,d2	; div 16
	asl.w	#1,d2	; .W
	add.w	d2,a2

	bsr	go_check_blok_banana

	move.w	(a2),d4 ;Goede blokje
	asl.w	#5,d4	; *32
	add.w	d4,a1

	move.w	d1,d2 ; Y MOD 15
	and.w	#15,d2
	asl.w	#1,d2 ; *2 {1plane}
	add.w	d2,a1

	move.w	d0,d2 ; X MOD 15
	and.w	#15,d2
	asl.w	#1,d2 ; *2 {1plane}
	move.w	(a3,d2.w),d3 ; de bit

	and.w	(a1),d3 ; inh. REEPJE

	move.w	#0,d7 ; DEFAULT=0
	tst.w	d3
	beq.s	gelijk_aan_0
	move.w	#1,d7 ; BIT AAN
gelijk_aan_0:

	; CHECK_COORD_INDICATIE
	move.w	#ch_coord_indic,d2
	tst.w	d2
	beq.s	no_ch_color_indicate
	sub.w	camera_x,d0
	sub.w	camera_y,d1
	bsr	plot_XY
no_ch_color_indicate:
	RTS

go_check_blok_banana:
	move.w	(a2),d4 ;Goede blokje
	cmp.w	#123,d4 ; 123 t/m 128
	blo.s	not_124
	cmp.w	#128,d4 ; 123 t/m 128
	bhi.s	not_124
	bsr	set_in_animation_array
not_124

	move.w	(a2),d4 ;Goede blokje
	cmp.w	#6,d4  ; ELEKTRO-BOL
	beq.s	dood_eq
	cmp.w	#12,d4 ; STEKELS
	beq.s	dood_eq
	cmp.w	#32,d4 ; WATER
	beq.s	dood_eq
	cmp.w	#33,d4 ; VUUR
	beq.s	dood_eq
	cmp.w	#48,d4 ; DOODS HOOFD
	beq.s	dood_eq
	cmp.w	#51,d4 ; STEKELS
	beq.s	dood_eq
	cmp.w	#91,d4 ; VUUR
	beq.s	dood_eq
	cmp.w	#92,d4 ; WATER
	beq.s	dood_eq
	cmp.w	#95,d4 ; WATER
	beq.s	dood_eq
	cmp.w	#96,d4 ; VUUR
	beq.s	dood_eq
	cmp.w	#97,d4 ; VUUR
	beq.s	dood_eq
	cmp.w	#98,d4 ; WATER
	beq.s	dood_eq
	cmp.w	#104,d4 ; STEKELS
	beq.s	dood_eq
	cmp.w	#105,d4 ; STEKELS
	beq.s	dood_eq
	cmp.w	#106,d4 ; STEKELS
	beq.s	dood_eq

	bra	dood_skip
dood_eq:
	move.w	#1,DEAD
dood_skip:

	move.w	(a2),d4 ;Goede blokje
	move.w	#0,on_ice
	cmp.w	#7,d4
	bne.s	geen_ijs
	move.w	#1,on_ice
geen_ijs:
	move.w	d0,-(sp)
	move.w	d1,-(sp)
	move.w	(a2),d4 ;Goede blokje
	move.w	d4,getal ; *
	cmp.w	#1,pophandle2
	bne	ik_ben_klaar2
	cmp.w	#0,pophandle
	bne	ik_ben_klaar2
	cmp.w	#140,d4
	blo	ik_ben_klaar2
	cmp.w	#169,d4
	bhi	ik_ben_klaar2
	bra	go_pop
ik_ben_klaar2:
	move.w	512(a2),d4 ;Goede blokje
	move.w	d4,getal2 ; *
	cmp.w	#1,pophandle2
	bne	ik_ben_klaar3
	cmp.w	#0,pophandle
	bne	ik_ben_klaar3
	cmp.w	#140,d4
	blo	ik_ben_klaar3
	cmp.w	#169,d4
	bhi	ik_ben_klaar3
	bra	go_pop
ik_ben_klaar3:
	bra	ik_ben_klaar
go_pop
	move.l	#populos_array,a4
	move.w	#6-1,d3
check_meer_populos:


	move.w	10(a4),d4
	move.w	(a2),d2 ;Goede blokje
	cmp.w	d2,d4
	beq.s	doit2
	move.l	#$88000000,$ff9800
	move.w	512(a2),d2 ;Goede blokje
	cmp.w	d2,d4
	beq.s	doit2

	move.l	#$0,$ff9800
	bra	not_108
doit2

	move.w	(a4),d2 ; goede X
	asr.w	#1,d2
	and.w	#$ff,d2
	move.w	coord_x,d4
	add.w	#BANX/2,d4
	asr.w	#4,d4
	cmp.w	d2,d4
	beq.s	doit4
	bra	not_108
doit4
	move.w	(a4),d4 ; goede Y
	asr.w	#8,d4 ; DIV 512
	asr.w	#1,d4 ;
	asl.w	#4,d4 ; *16
	add.w	2(a4),d4
	cmp.w	d4,d1
	beq.s	doit
	bra	not_108
doit
	move.w	6(a4),d4
	and.w	#$7F,d4
	cmp.w	2(a4),d4
	blo.s	max_x
	add.w	#1,coord_y
	move.w	#1,speed_y
	add.w	#2,2(a4) ; MAX=6(a4)
	bra	max_x2
max_x
	move.w	6(a4),d4
	and.w	#$80,d4
	tst.w	d4
	beq.s	max_x3
	sub.w	#0,coord_y !1 <- goed
	move.w	#0,speed_y !2  werken
	bra	max_x2
max_x3:
	sub.w	#1,coord_y !1 <- goed
	move.w	#2,speed_y !2  werken
max_x2:

	move.w	#0,d6 ; teller downcheck stoppen
	move.w	#0,d3 ; teller stop
	move.w	#1,jumpready ; mag weer springen vanaf pop.blok
	move.w	#0,jumpteller
	move.w	#1,8(a4) ; GONE DOWN
	move.w	#1,pophandle
	move.w	#0,event
	bra	ik_ben_klaar
not_108
	add.w	#12,a4
	dbra	d3,check_meer_populos
ik_ben_klaar:

	move.w	(sp)+,d1
	move.w	(sp)+,d0
	RTS

set_in_animation_array:
	move.w	d0,-(sp)
	move.w	d1,-(sp)
	asr.w	#4,d0
	asr.w	#4,d1
	move.l	#animation_array,a4
	move.w	#8-1,d2
verder_zoeken:
	move.w	(a4),d3  ; X blokje
	move.w	2(a4),d4 ; Y blokje
	cmp.w	d3,d0 ; VERGELIJK
	bne.s	niet_gelijkXY
	cmp.w	d4,d1
	bne.s	niet_gelijkXY
	bra	klaar ; BESTAAT_AL
niet_gelijkXY
	add.w	#8,a4
	dbra	d2,verder_zoeken

	; bestaat nog niet,zoek
	; vrije ruimte
	move.l	#animation_array,a4
	move.w	#8-1,d2
verder_zoeken2:
	cmp.w	#0,(a4)  ; X blokje
	bne.s	niet_leeg2
	cmp.w	#0,2(a4) ; Y blokje
	bne.s	niet_leeg2

	move.w	d0,(a4)
	move.w	d1,2(a4)
	move.w	(a2),4(a4)
	bra	klaar
niet_leeg2
	add.w	#8,a4
	dbra	d2,verder_zoeken2

klaar:
	move.w	(sp)+,d1
	move.w	(sp)+,d0
	RTS

wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
schermadr_opvraag:
	move	#2,-(sp)
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres_oud
	move.l	#screen1+256,schermadres
	move.l	#screen2+256,schermadres2
	and.l	#$ffffff00,schermadres
	and.l	#$ffffff00,schermadres2
	RTS
vsync:	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
install_mo_jo:
	move.w	#kbdvec,-(sp)
	trap	#14
	addq.l	#2,a7
	move.l	d0,a0
	move.l	d0,save_old_base
	lea	mo_handler,a1
	lea	jo_handler,a2
	move.l	mousevec(a0),save_old_mvec
	move.l	a1,mousevec(a0)
	move.l	joyvec(a0),save_old_jvec
	move.l	a2,joyvec(a0)


	pea	ikbdstring ; OUT 2,8
	move.w	#0,-(sp)
	move.w	#ikbdws,-(sp)
	trap	#14
	addq.l	#8,sp
	RTS
restore_mo_jo:
	move.l	save_old_base,a0
	move.l	save_old_mvec,d0
	move.l	d0,mousevec(a0)
	move.l	save_old_jvec,d0
	move.l	d0,joyvec(a0)
	RTS
mo_handler
	lea	mpacket,a1
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	RTS
jo_handler
	lea	jpacket,a1
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	RTS
cls:
	move.l	#(320*200)/4/4-1,d0
	move.l	schermadres,a0
	move.l	schermadres2,a1
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	dbra d0,go_cls
	RTS
beeld_change:
	move.w	camera_x,d0
	and.w	#15,d0
	or.w	#1,d0
	move.b	d0,Scroll_adres
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	move.w	#4,d0
	sub.w	addcleadr,d0
	move.w	d0,addcleadr
	RTS
go_indicate:
	move.w	#color_indicate,d1
	tst.w	d1
	beq.s	no_colindicate
	move.l	d0,$ffff9800
no_colindicate
	RTS
plot_XY:
	move.l	#tabel1,a0
	move.l	schermadres,a2
	sub.w	#336*16,a2
	move.w	camera_x,d2
	or.w	#1,d2
	and.w	#15,d2
	add.w	d2,d0
	move.w	d0,d2 ; X bound(16)
	and.w	#$fff0,d2
	add.w	d2,a2
	move.w	d0,d2 ; X MOD 15
	and.w	#15,d2
	asl.w	#1,d2
	move.w	(a0,d2.w),d3
	clr.l	d2
	move.w	d1,d2 ; Y
	mulu	#336,d2
	add.l	d2,a2
	or.w	d3,(a2)
	or.w	d3,2(a2)
	or.w	d3,4(a2)
	or.w	d3,6(a2)
	RTS
printnr:
	move.w	#0,prntx
	move.w	#0,prnty

	move.w	getal,d0
	and.w	#$f,d0
	move.b	hexa(PC,d0.w),d1
	move.b	d1,tkstnr+3
	move.w	getal,d0
	and.w	#$f0,d0
	asr.w	#4,d0
	move.b	hexa(PC,d0.w),d1
	move.b	d1,tkstnr+2
	move.w	getal,d0
	and.w	#$f00,d0
	asr.w	#8,d0
	move.b	hexa(PC,d0.w),d1
	move.b	d1,tkstnr+1
	move.w	getal,d0
	and.w	#$f000,d0
	asr.w	#8,d0
	asr.w	#4,d0
	move.b	hexa(PC,d0.w),d1
	move.b	d1,tkstnr
	bra	skip_hexa
hexa	dc.b	'0123456789ABCDEF'
skip_hexa:
	move.w	getal2,d0
	and.w	#$f,d0
	move.b	hexa2(PC,d0.w),d1
	move.b	d1,tkstnr2+3
	move.w	getal2,d0
	and.w	#$f0,d0
	asr.w	#4,d0
	move.b	hexa2(PC,d0.w),d1
	move.b	d1,tkstnr2+2
	move.w	getal2,d0
	and.w	#$f00,d0
	asr.w	#8,d0
	move.b	hexa2(PC,d0.w),d1
	move.b	d1,tkstnr2+1
	move.w	getal2,d0
	and.w	#$f000,d0
	asr.w	#8,d0
	asr.w	#4,d0
	move.b	hexa2(PC,d0.w),d1
	move.b	d1,tkstnr2

	bsr	print
	RTS
hexa2	dc.b	'0123456789ABCDEF'

print:
	move.l	#tekst,a2
PRNTLOOP:
	move.l	schermadres,a0
	move.l	#font,a1
	clr.w	d1
	move.b	(a2)+,d1
	tst.w	d1
	beq	PRNTEND
	asl.w	#3,d1	; 1 kar=8 bytes
	add.w	d1,a1
	move.w	prntx,d0
	and.w	#%0001,d0 ; 1
	add.w	d0,a0
	move.w	prntx,d0
	and.w	#%11111110,d0 ; 2
	asl.w	#3,d0	  ; ->16
	add.w	d0,a0
	move.w	prnty,d0
	mulu	#336,d0
	add.w	d0,a0
pl set 0
	REPT	8
	move.b	pl(a1),pl*336(a0)
pl set pl+1
	ENDR
	add.w	#1,prntx
	cmp.w	#40,prntx
	bne.s	geen_terugslag
	move.w	#0,prntx
	add.w	#8,prnty
geen_terugslag:
	bra	PRNTLOOP
PRNTEND:
	RTS


;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

ssp		dc.l	0
schermadres_oud	dc.l	0
schermadres	dc.l	0
schermadres2	dc.l	0
veld_offset	dc.w	0
camera_x	dc.w	0 ; COORDINATEN CAMERA
camera_y	dc.w	0
scrx_speed:	dc.w	0
coord_x:	dc.w	20 ; COORDINATEN SPRITE
coord_y:	dc.w	80
speed_x:	dc.w	0 ; SNELHEDEN SPRITE
speed_y:	dc.w	0
event:		dc.w	0 ; WAT DE SPRITE DOET
side:		dc.w	0
banacleadres	dc.l	0
banacleadres2	dc.l	0
addcleadr	dc.w	0
pophandle:	dc.w	0
pophandle2:	dc.w	0	; Middelste uit checkcoords DOWN !!
lastvbl_blokhit	dc.w	0;  ??
DEAD:		dc.w	0
on_ice:		dc.w	0
dood_scene_cntr	dc.w	0

jumpready:	dc.w	0
jumpteller:	dc.w	0
ikbdstring	dc.b	$8
mpacket		ds.b	3
jpacket		ds.b	3
save_old_mvec	ds.l	1
save_old_jvec	ds.l	1
save_old_base	ds.l	1

veld		INCBIN	"F:\LEVELS\LEVELA  .DAT"
veldend
		ds.b	8*16
blokpic		INCBIN	"F:\LEVELS\CON1BLK .DAT"
		ds.b	2*16
maskblokpic	INCBIN	"F:\LEVELS\CON1BLKM.DAT"
palette		INCBIN	"F:\LEVELS\PAL1    .DAT"
banana_picture	INCBIN	"F:\LEVELS\BANAPCAL.DAT"
dood_sequence	INCBIN	"F:\LEVELS\BANADOOD.PI1"
veldlen		EQU	veldend-veld-32

tabel1:		dc.w	$8000,$4000,$2000,$1000,$800,$400,$200,$100,$80,$40,$20,$10,$8,$4,$2,$1

banana_anim_teller:	dc.w	0

V	equ	30
go_banana_0r	dc.w	0*V,1*V,2*V,3*V,4*V,5*V,6*V,7*V,8*V,9*V,10*V,11*V,12*V,13*V,14*V,15*V,16*V,17*V,18*V,19*V,20*V,21*V,22*V,23*V,24*V,25*V,26*V,27*V,28*V,29*V,30*V,31*V
go_banana_1r	dc.w	0*V,1*V,2*V,3*V,4*V,5*V,6*V,7*V,8*V,9*V,10*V,11*V,12*V,13*V,14*V,15*V,16*V,17*V,18*V,19*V,20*V,21*V,22*V,23*V,24*V,25*V,32*V,33*V,34*V,35*V,36*V,37*V
go_banana_2r	dc.w	0*V,1*V,2*V,3*V,4*V,5*V,6*V,7*V,8*V,9*V,10*V,11*V,12*V,13*V,14*V,15*V,16*V,17*V,18*V,19*V,20*V,21*V,22*V,23*V,24*V,25*V,38*V,39*V,40*V,41*V,42*V,43*V
go_banana_3r	dc.w	0*V,1*V,2*V,3*V,4*V,5*V,6*V,7*V,8*V,9*V,10*V,11*V,12*V,13*V,14*V,15*V,16*V,17*V,18*V,19*V,20*V,21*V,22*V,23*V,24*V,25*V,44*V,45*V,46*V,47*V,48*V,49*V
go_banana_4r	dc.w	0*V,1*V,2*V,3*V,4*V,5*V,6*V,7*V,8*V,9*V,10*V,11*V,12*V,13*V,14*V,15*V,16*V,17*V,18*V,19*V,20*V,21*V,22*V,23*V,24*V,25*V,50*V,51*V,52*V,53*V,54*V,55*V
go_banana_5r	dc.w	0*V,1*V,2*V,3*V,4*V,5*V,6*V,7*V,8*V,9*V,10*V,11*V,12*V,13*V,14*V,15*V,16*V,17*V,18*V,19*V,20*V,21*V,22*V,23*V,24*V,25*V,56*V,57*V,58*V,59*V,60*V,61*V
go_banana_6r	dc.w	0*V,1*V,2*V,3*V,4*V,5*V,6*V,7*V,8*V,9*V,10*V,11*V,12*V,13*V,14*V,15*V,16*V,17*V,18*V,19*V,20*V,21*V,22*V,23*V,24*V,25*V,62*V,63*V,64*V,65*V,66*V,67*V

go_banana_r:
		dc.l	go_banana_0r,go_banana_0r,go_banana_0r,go_banana_0r
		dc.l	go_banana_1r,go_banana_1r,go_banana_1r,go_banana_1r
		dc.l	go_banana_2r,go_banana_2r,go_banana_2r,go_banana_2r
		dc.l	go_banana_3r,go_banana_3r,go_banana_3r,go_banana_3r
		dc.l	go_banana_4r,go_banana_4r,go_banana_4r,go_banana_4r
		dc.l	go_banana_5r,go_banana_5r,go_banana_5r,go_banana_5r
		dc.l	go_banana_6r,go_banana_6r,go_banana_6r,go_banana_6r

go_banana_0l	dc.w	68*V,69*V,70*V,71*V,72*V,73*V,74*V,75*V,76*V,77*V,78*V,79*V,80*V,81*V,82*V,83*V,84*V,85*V,86*V,87*V,88*V,89*V,90*V,91*V,92*V,93*V,94*V,95*V,96*V,97*V,98*V,99*V
go_banana_1l	dc.w	68*V,69*V,70*V,71*V,72*V,73*V,74*V,75*V,76*V,77*V,78*V,79*V,80*V,81*V,82*V,83*V,84*V,85*V,86*V,87*V,88*V,89*V,90*V,91*V,92*V,93*V,100*V,101*V,102*V,103*V,104*V,105*V
go_banana_2l	dc.w	68*V,69*V,70*V,71*V,72*V,73*V,74*V,75*V,76*V,77*V,78*V,79*V,80*V,81*V,82*V,83*V,84*V,85*V,86*V,87*V,88*V,89*V,90*V,91*V,92*V,93*V,106*V,107*V,108*V,109*V,110*V,111*V
go_banana_3l	dc.w	68*V,69*V,70*V,71*V,72*V,73*V,74*V,75*V,76*V,77*V,78*V,79*V,80*V,81*V,82*V,83*V,84*V,85*V,86*V,87*V,88*V,89*V,90*V,91*V,92*V,93*V,112*V,113*V,114*V,115*V,116*V,117*V
go_banana_4l	dc.w	68*V,69*V,70*V,71*V,72*V,73*V,74*V,75*V,76*V,77*V,78*V,79*V,80*V,81*V,82*V,83*V,84*V,85*V,86*V,87*V,88*V,89*V,90*V,91*V,92*V,93*V,118*V,119*V,120*V,121*V,122*V,123*V
go_banana_5l	dc.w	68*V,69*V,70*V,71*V,72*V,73*V,74*V,75*V,76*V,77*V,78*V,79*V,80*V,81*V,82*V,83*V,84*V,85*V,86*V,87*V,88*V,89*V,90*V,91*V,92*V,93*V,124*V,125*V,126*V,127*V,128*V,129*V
go_banana_6l	dc.w	68*V,69*V,70*V,71*V,72*V,73*V,74*V,75*V,76*V,77*V,78*V,79*V,80*V,81*V,82*V,83*V,84*V,85*V,86*V,87*V,88*V,89*V,90*V,91*V,92*V,93*V,130*V,131*V,132*V,133*V,134*V,135*V

go_banana_l:
		dc.l	go_banana_0l,go_banana_0l,go_banana_0l,go_banana_0l
		dc.l	go_banana_1l,go_banana_1l,go_banana_1l,go_banana_1l
		dc.l	go_banana_2l,go_banana_2l,go_banana_2l,go_banana_2l
		dc.l	go_banana_3l,go_banana_3l,go_banana_3l,go_banana_3l
		dc.l	go_banana_4l,go_banana_4l,go_banana_4l,go_banana_4l
		dc.l	go_banana_5l,go_banana_5l,go_banana_5l,go_banana_5l
		dc.l	go_banana_6l,go_banana_6l,go_banana_6l,go_banana_6l


checkcoord_0:	dc.w	0
checkcoord_1:	dc.w	0
checkcoord_2:	dc.w	0
checkcoord_3:	dc.w	0
checkcoord_4:	dc.w	0
checkcoord_5:	dc.w	0
checkcoord_6:	dc.w	0
checkcoord_7:	dc.w	0
checkcoord_8:	dc.w	0
checkcoord_9:	dc.w	0
animation_array	ds.w	8*4
animbloktel:	dc.w	0
inc_pop_array:	INCBIN	"F:\LEVELS\POPULOS.DAT"
populos_array	
; MAXY 6(ax)+$80 -> expres fout doorlaten
; MAXY 6(ax)     -> werkt goed
; OFFSET veld (ax)
; BLOK NR 10(ax)
		ds.w	6*6
		dc.w	77*2+20*512,0,0,40+$80,0,140
		dc.w	78*2+20*512,0,0,40+$80,0,142
		dc.w	79*2+20*512,0,0,40,0,144
		dc.w	80*2+20*512,0,0,40,0,146
		dc.w	81*2+20*512,0,0,40,0,148
		dc.w	82*2+20*512,0,0,40,0,150
oud_palette:	ds.l	256
		ds.l	(335*16+256)/4
screen1:	ds.l	(336*240+256)/4
		ds.l	(335*16+256)/4
screen2:	ds.l	(336*240+256)/4

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

prntx:	dc.w	0
prnty:	dc.w	0
getal:	dc.w	0
getal2:	dc.w	0
oldest:	dc.w	0
font:	INCBIN	'F:\MARKFNT.FNT'
tekst:	dc.b	' X-offset waarde (AND $ff)  = ' ; 30
tkstnr:	dc.b	'    ','      '
	dc.b	' X-offset waarde2 (AND $ff) = ' ; 30
tkstnr2 dc.b	'    ','      '
	dc.b	0
