
	bsr	schermadr_opvraag
	bsr	sup_vis_mode
	dc.w	$a00a
	bsr	cls

	move.l	#$00000000,$ffff9800
	move.l	schermadres4,a0
	move.l	schermadres,a1
	bsr	fill_screen
	move.l	schermadres4,a0
	move.l	schermadres2,a1
	bsr	fill_screen
back:
	bsr	beeld_change
;	move.l	#$c0c000c0,$ffff9800

	add.w	#1,counter
	cmp.w	#360,counter
	blo	res_cntr
	sub.w	#360,counter
res_cntr:
	add.w	#3,counter2
	cmp.w	#240,counter2
	blo	res_cntr2
	sub.w	#240,counter2
res_cntr2:

	move.l	#sinus1,a0
	move.l	#sinus2,a1
	move.w	counter,d0
	asl.w	#1,d0	; .W
	move.w	(a0,d0.w),d1 ; 0-255
	mulu	#13,d1
	asr.w	#4,d1	; /2 (0-127)
	add.w	#7,d1
	move.w	d1,bolx

	move.w	counter2,d0
	add.w	#240,d0
	asl.w	#1,d0	; .W
	clr.l	d1
	move.w	(a1,d0.w),d1 ; 0-255
	mulu	#18,d1
	asr.w	#5,d1	; /2 (0-127)
	add.w	#12,d1
	move.w	d1,boly


	bsr	remove_copy
	bsr	copy_it
;	move.l	#$00000000,$ffff9800
	bsr	vsync

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back
end:

	move.l	#$ffff00ff,$ffff9800
	move.l	oude_schermadres,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	bsr	user_mode

	clr.l	-(sp)
	trap	#1


;********************************
;*	SUBROUTINES    !!!!!	*
;********************************

;-------------------------
copy_it:
	move.l	schermadres3,a4	; VAN
	move.l	schermadres,a5	; NAAR
; SINUS X
	move.w	bolx,d1
	asl.w	#1,d1	; 1PIXEL=1W
	add.w	d1,a4	; VAN
	add.w	d1,a5	; NAAR

	move.w	boly,d1
	mulu.w	#160,d1	; *160
	asl.l	#2,d1	; *4 (160*4=640= ONE LINE)
	add.l	d1,a4	; VAN
	add.l	d1,a5	; NAAR

	move.l	#data1,a2
	move.l	#data2,a3
	move.l	#data2+32310,a6

	move.w	#49-1,d7
y_bol_loop:
	move.l	a4,a0
	move.l	a5,a1

	move.w	(a2)+,d1  ; nr.x in data2
	asl.w	#1,d1
	add.w	d1,a1
; PUT MISVORMDE LIJN
	move.l	(a6)+,d0
	jsr	(a3,d0.l)

	add.w	#640,a5
	dbra	d7,y_bol_loop


	add.w	#640*50,a4

	move.w	#50-1,d7
y_bol_loop2:
	move.l	a4,a0
	move.l	a5,a1

	move.w	(a2)+,d1  ; nr.x in data2
	asl.w	#1,d1
	add.w	d1,a1
; PUT MISVORMDE LIJN
	move.l	(a6)+,d0
	jsr	(a3,d0.l)

	add.w	#640,a5
	dbra	d7,y_bol_loop2

	RTS
;-------------------------
remove_copy:
	move.l	#screen4,a0	; VAN
	move.l	schermadres,a1	; NAAR
	move.l	#data3,a2

	move.w	bolx,d1
	sub.w	#11,d1
	asl.w	#1,d1	; 1PIXEL=1W
	add.w	d1,a0	; VAN
	add.w	d1,a1	; NAAR

	move.w	boly,d1
	sub.w	#12,d1
	mulu.w	#160,d1	; *160
	asl.l	#2,d1	; *4 (160*4=640= ONE LINE)
	add.l	d1,a0	; VAN
	add.l	d1,a1	; NAAR

	move.w	#222-1,d7
rem_cop_loop:
	move.w	(a2)+,d0  ; add
	add.w	d0,a0
	add.w	d0,a1

	move.w	#61,d0
	move.w	(a2)+,d1  ; lengte
	sub.w	d1,d0

	asl.w	#1,d0
	jmp	rem_label(PC,d0.w)
rem_label:
	REPT	61
	move.w	(a0)+,(a1)+
	ENDR

	dbra	d7,rem_cop_loop
	RTS
;-------------------------
fill_screen:
	move.w	#128000/4/4-1,d0
copy_fill:
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	dbra	d0,copy_fill
	RTS
;-------------------------
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
;	move	#37,-(sp)
;	trap	#14
;	addq.l	#2,sp

	move.w	latest464,d0
vsynclus:
	move.w	$464,d1
	cmp.w	d0,d1
	beq.s	vsynclus
	move.w	$464,latest464

	movem.l	(sp)+,d0-d7/a0-a6
	RTS

;-------------------------
beeld_change:
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	RTS

;-------------------------
wacht_toets:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
;-------------------------
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
;-------------------------
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
;-------------------------
cls:
	move.l	schermadres,a0
	move.l	#(640*200)/16-1,d0
go_cls1:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls1
	move.l	schermadres2,a0
	move.l	#(640*200)/16-1,d0
go_cls2:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls2
	RTS
;-------------------------
cls_all:
	move.l	#64000/4/4-1,d0
	move.l	schermadres,a0
go_cls_all:
	clr.l	(a0)+ 
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls_all
	RTS
;-------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	move.l	d0,oude_schermadres

	move.l	#screen2,schermadres2
	add.l	#256,schermadres2
	and.l	#$FFFFFF00,schermadres2
	move.l	#screen3,schermadres3
	move.l	#screen4,schermadres4

	RTS
;-------------------------
wacht_lusje:
	move.l	#16000,d0
wachtlus	nop
	dbra	d0,wachtlus
	RTS
;-------------------------
	
;	VARIABELEN
;-----------------------------------
oude_schermadres:	dc.l	0
schermadres:	dc.l	0
schermadres2:	dc.l	0
schermadres3:	dc.l	0
schermadres4:	dc.l	0
counter:	dc.w	0
counter2:	dc.w	0
bolx:	dc.w	0
boly:	dc.w	0
latest464:	dc.w	0
ssp:		dc.l	0
data1:	
	dc.w	40,36,32,30,28,26,24,22,21,20,18,17,16,15,14,13,12,11,10,10,9,8,7,7,6,6
	dc.w	5,5,4,4,3,3,2,2,2,2,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dc.w	1,1,1,1,2,2,2,2,3,3,4,4,5,5,6,6,7,7,8,9,10,10,11,12,13,14,15,16,17
	dc.w	18,19,21,22,24,26,28,30,32,36,40
	
	dc.w	19,27,35,39,43,47,51,55,57,59,63,65,67,69,71,73,75,77,79,79,81,83
	dc.w	85,85,87,87,89,89,91,91,93,93,95,95,95,95,97,97,97,97,99,99,99
	dc.w	99,99,99,99,99,99,99,100,99,99,99,99,99,99,99,99,99,97,97,97,97
	dc.w	95,95,95,95,93,93,91,91,89,89,87,87,85,85,83,81,79,79,77,75,73,71
	dc.w	69,67,65,63,59,57,55,51,47,43,39,35,28,19
	ds.w	100
data2:	INCBIN	'F:\BOL_OK_F.DAT'
data3:	INCBIN	'F:\BOL_OKFR.DAT'
sinus1:	INCBIN	'F:\PROGRAMM\ALL_DATA\SIN360.DAT'
sinus2:	INCBIN	'F:\PROGRAMM\ALL_DATA\SIN480.DAT'
screen2:	ds.b	128256
screen3:	
		INCBIN	'F:\DRAW\PICTURES\TRUE_COL\PICTURE1.TC'
screen4:
		INCBIN	'F:\DRAW\PICTURES\TRUE_COL\PICTURE2.TC'
