SHOW	EQU	2

	bsr	schermadr_opvraag
	bsr	preshift_sprites
	bsr	sup_vis_mode
	bsr	save_palette
	bsr	set_palette
	move.l	schermadres,a1
	bsr	copy
	move.l	schermadres2,a1
	bsr	copy
back:
	move.l	#realcoords,a0
	move.l	coordspointer1,a1
	move.l	#realcoords_influence,a2
	move.l	#stuiter,a3
	move.w	#11-1,d0
coords_exchange:
	move.w	(a0),d6
	move.w	2(a0),d7

	move.w	(a2),d1
	add.w	d1,d6
	cmp.w	#319-32,d6
	blo.s	other_way1
	move.w	#-2,(a2)
other_way1:
	cmp.w	#0,d6
	bhi.s	other_way2
	move.w	#2,(a2)
other_way2:

	move.w	2(a2),d1
	add.w	#1,d1
	cmp.w	#270,d1
	blo.s	other_way3
	move.w	#180,d1
other_way3:
	move.w	d1,2(a2)
	asl.w	#1,d1
	move.w	(a3,d1.w),d7

	move.w	d6,(a1)+
	move.w	d7,(a1)+
	move.w	d6,(a0)+
	move.w	d7,(a0)+
	add.w	#4,a2
	dbra	d0,coords_exchange

	move.l	#$10000000*SHOW,$ff9800

	move.l	coordspointer1,a2
	move.w	#7,d7	;T
	bsr	do_sprite

	add.w	#4,a2
	move.w	#2,d7	;H
	bsr	do_sprite

	add.w	#4,a2
	move.w	#8,d7	;U
	bsr	do_sprite

	add.w	#4,a2
	move.w	#4,d7	;N
	bsr	do_sprite

	add.w	#4,a2
	move.w	#0,d7	;D
	bsr	do_sprite

	add.w	#4,a2
	move.w	#1,d7	;E
	bsr	do_sprite

	add.w	#4,a2
	move.w	#6,d7	;R
	bsr	do_sprite

	add.w	#4,a2
	move.w	#0,d7	;D
	bsr	do_sprite

	add.w	#4,a2
	move.w	#5,d7	;O
	bsr	do_sprite

	add.w	#4,a2
	move.w	#3,d7	;M
	bsr	do_sprite

	add.w	#4,a2
	move.w	#1,d7	;E
	bsr	do_sprite

	move.l	#$00000000,$ff9800
	bsr	vsync
	bsr	do_cycle_invert
	bsr	beeld_change

	move.l	#$00100000*SHOW,$ff9800

	move.l	coordspointer1,a2
	move.w	#11-1,d7
clear_sprite_loop:
;	bsr	clear_sprite
	add.w	#4,a2
	dbra	d7,clear_sprite_loop

	bsr	do_big_fade

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back

	bsr	load_palette
	move.l	oldscreenbase,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	bsr	user_mode
	clr.l	-(sp)
	trap	#1


;---------------------------
do_big_fade:
	add.w	#1,big_fade_count
	and.w	#31,big_fade_count

	move.l	schermadres,a0
	add.w	#8,a0
	move.w	#200/4-1,d0

	move.w	big_fade_count,d2
	asr.w	#1,d2
	asl.w	#2,d2
	move.w	fade_data(PC,d2.w),d1
	add.w	fade_data+2(PC,d2.w),a0
	bra	fade_loop
fade_data:
	dc.w	%0111011101110111,0
	dc.w	%1101110111011101,640
	dc.w	%1101110111011101,0
	dc.w	%0111011101110111,640

	dc.w	%1011101110111011,320
	dc.w	%1110111011101110,960
	dc.w	%1110111011101110,320
	dc.w	%1011101110111011,960

	dc.w	%0111011101110111,320
	dc.w	%1101110111011101,960
	dc.w	%1101110111011101,320
	dc.w	%0111011101110111,960

	dc.w	%1011101110111011,0
	dc.w	%1110111011101110,640
	dc.w	%1110111011101110,0
	dc.w	%1011101110111011,640


;	dc.w	%1010101010101010,0
;	dc.w	%0101010101010101,320
;	dc.w	%0101010101010101,0
;	dc.w	%1010101010101010,320

fade_loop:
pl set 0
	REPT	20
	and.w	d1,pl(a0)
	and.w	d1,pl+2(a0)
	and.w	d1,pl+4(a0)
pl set pl+16
	ENDR
	add.w	#320*4,a0	
	dbra	d0,fade_loop
	RTS
;---------------------------
clear_sprite:
	move.l	schermadres,a1
	add.w	#8,a1

	cmp.w	#0,2(a2)
	bhi.s	other_way4
	RTS
other_way4:


	move.w	(a2),d0	  ; X
	and.w	#15,d0
	mulu	#8*3*32,d0
	add.w	d0,a0

	move.w	(a2),d0	  ; X
	and.w	#-1-15,d0
	add.w	d0,a1

	clr.l	d0
	move.w	2(a2),d0  ; Y
	mulu	#80,d0
	asl.l	#2,d0
	add.l	d0,a1

	move.w	#32-1,d0
y_loop2:
pl set 0
	REPT	3
	clr.l	pl(a1)
	clr.w	pl+4(a1)
pl set pl+16
	ENDR
	add.w	#320,a1
	dbra	d0,y_loop2

	RTS

do_sprite:
	move.l	#sprite_memory,a0
	move.l	schermadres,a1
	add.w	#8,a1


	cmp.w	#0,2(a2)
	bhi.s	other_way5
	RTS
other_way5:

	clr.l	d0
	move.w	d7,d0
	mulu	#8*3*32,d0
	asl.l	#4,d0	; *16
	add.l	d0,a0

	move.w	(a2),d0	  ; X
	and.w	#15,d0
	mulu	#8*3*32,d0
	add.w	d0,a0

	move.w	(a2),d0	  ; X
	and.w	#-1-15,d0
	add.w	d0,a1

	clr.l	d0
	move.w	2(a2),d0  ; X
	mulu	#80,d0
	asl.l	#2,d0
	add.l	d0,a1

	move.w	#32-1,d0
y_loop:
pl set 0
	REPT	3
	move.w	(a0)+,d2
	and.w	d2,pl(a1)
	and.w	d2,pl+2(a1)
	and.w	d2,pl+4(a1)
	move.l	(a0)+,d2
	or.l	d2,pl(a1)
	move.w	(a0)+,d2
	or.w	d2,pl+4(a1)
pl set pl+16
	ENDR
	add.w	#320,a1
	dbra	d0,y_loop
	RTS


;-----------PRESHIFT SPRITES-------
preshift_sprites:
	move.l	#sprite_memory,a1

	move.w	#9-1,d7
letter_loop:
	move.w	#16-1,d1	; SHIFTS
shift_loop:
	move.l	#bigsprites+34,a0

	move.w	#8,d2
	sub.w	d7,d2
	asl.w	#4,d2
	add.w	d2,a0
	move.w	#32-1,d0	; y
Y_shift_loop:

	bsr	shift_case1
	bsr	shift_case4
	bsr	shift_case2
	bsr	shift_case4
	bsr	shift_case3
	bsr	shift_case4

	add.w	#160,a0
	dbra	d0,Y_shift_loop
	dbra	d1,shift_loop
	dbra	d7,letter_loop
	RTS

shift_case1:
	clr.l	d2
	clr.l	d3
	clr.l	d4
	clr.l	d5
	move.w	0(a0),d2
	move.w	2(a0),d3
	move.w	4(a0),d4
	move.w	6(a0),d5
	RTS
shift_case2:
	move.w	0(a0),d2
	move.w	2(a0),d3
	move.w	4(a0),d4
	move.w	6(a0),d5
	swap	d2
	swap	d3
	swap	d4
	swap	d5
	move.w	8(a0),d2
	move.w	10(a0),d3
	move.w	12(a0),d4
	move.w	14(a0),d5
	RTS
shift_case3:
	move.w	8(a0),d2
	move.w	10(a0),d3
	move.w	12(a0),d4
	move.w	14(a0),d5
	swap	d2
	swap	d3
	swap	d4
	swap	d5
	move.w	#0,d2
	move.w	#0,d3
	move.w	#0,d4
	move.w	#0,d5
	RTS
shift_case4:
	add.w	#1,d1
	asl.l	d1,d2
	asl.l	d1,d3
	asl.l	d1,d4
	asl.l	d1,d5
	sub.w	#1,d1
	swap	d2
	swap	d3
	swap	d4
	swap	d5
	not.w	d5	; MASK-AND
	move.w	d5,(a1)+
	move.w	d2,(a1)+
	move.w	d3,(a1)+
	move.w	d4,(a1)+
	RTS
;-----------COLOR CYCLE---------

do_cycle_invert:
	move.l	#cycle_colors,a1
	add.w	counter,a1
	add.w	counter,a1
	add.w	counter,a1
	add.w	counter,a1

	move.l	#$ff9804,a0
pl set 56
	REPT	14
	move.l	pl-4(a0),pl(a0)
pl set pl-4
	ENDR
	move.l	(a1),pl(a0)

	move.w	counter,d1
	add.w	#1,d1
	cmp.w	#LENCYCL,d1
	bne.s	no_res_cycle_counter2
	move.w	#0,d1
no_res_cycle_counter2:
	move.w	d1,counter
	RTS

;------------- COLORS AFTER/BEFORE ----
save_palette:
	move.l	#$ff9800,a0
	move.l	#oldpalette,a1
	move.w	#256-1,d0
save_loop:
	move.l	(a0)+,(a1)+
	dbra	d0,save_loop
	RTS
load_palette:
	move.l	#oldpalette,a0
	move.l	#$ff9800,a1
	move.w	#256-1,d0
load_loop:
	move.l	(a0)+,(a1)+
	dbra	d0,load_loop
	RTS
set_palette:
	move.l	#newpalette,a0
	move.l	#$ff9800,a1
	move.w	#256-1,d0
set_loop:
	move.l	(a0)+,(a1)+
	dbra	d0,set_loop
	RTS

; --------KOPIEER SCHERM--------

copy:
	move.l	#fadescreen+34,a0
	move.w	#(32000)/4/4-1,d0
copy_loop:
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	dbra	d0,copy_loop
	RTS
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	move.l	d0,oldscreenbase

	move.l	#screen2+256,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2

	move.l	#coords1,coordspointer1
	move.l	#coords2,coordspointer2
	RTS
beeld_change:
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	move.l	schermadres2,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2

	move.l	coordspointer1,d0
	move.l	coordspointer2,d1
	move.l	d1,coordspointer1
	move.l	d0,coordspointer2

	RTS


ssp:		dc.l	0
oldscreenbase:	dc.l	0
schermadres:	dc.l	0
schermadres2:	dc.l	0
counter:	dc.w	0
coordspointer1:	dc.l	0
coordspointer2:	dc.l	0
big_fade_count:	dc.l	0
fadescreen:	INCBIN	"F:\DRAW\PICTURES\PI1's\CFADE2.PI1"
bigsprites:	INCBIN	"F:\DRAW\PICTURES\FONTS\THUNDFNT.PI1"
		ds.l	20
stuiter:
	REPT	90
	dc.w	0
	ENDR
		INCBIN	"F:\PROGRAMM\ALL_DATA\THUNJMP.DAT"
coords1:
	ds.l	11
coords2:
	ds.l	11
realcoords:
pl set 0
	REPT	11
	dc.w	pl,0
pl set pl+26
	ENDR
realcoords_influence:
pl set 0
	REPT	11
	dc.w	2,pl
pl set pl+8
	ENDR

oldpalette:	ds.l	256
newpalette:
	REPT	16
	dc.l	0
	ENDR

	REPT	16
	dc.l	$00000000
	ENDR
	REPT	16
	dc.l	$22220022
	ENDR
	REPT	16
	dc.l	$44440044
	ENDR
	REPT	16
	dc.l	$66660066
	ENDR
	REPT	16
	dc.l	$88880088
	ENDR
	REPT	16
	dc.l	$AAAA00AA
	ENDR
	REPT	16
	dc.l	$CCCC00CC
	ENDR
	REPT	16
	dc.l	$FFFF00FF
	ENDR
	REPT	128
	dc.l	0
	ENDR

	EVEN


PAUSE	EQU	8

cycle_colors:

BEGCYCL:
	dc.l	$0,$22220022,$44440044,$66660066
	dc.l	$88880088,$aaaa00aa,$cccc00cc,$eeee00ee

	REPT	PAUSE
	dc.l	$ffff00ff
	ENDR

	dc.l	$ffff00ff
	dc.l	$ffff00dd
	dc.l	$ffff00bb
	dc.l	$ffff0099
	dc.l	$ffff0077
	dc.l	$ffff0055
	dc.l	$ffff0033
	dc.l	$ffff0011
	dc.l	$ffdd0000
	dc.l	$ffbb0000
	dc.l	$ff990000
	dc.l	$ff770000
	dc.l	$ff550000
	dc.l	$ff330000
	dc.l	$ff110000
	dc.l	$dd000000
	dc.l	$bb000000
	dc.l	$99000000
	dc.l	$77000000
	dc.l	$55000000
	dc.l	$33000000
	dc.l	$11000000

	REPT	PAUSE
	dc.l	$00000000
	ENDR

	dc.l	$00000011
	dc.l	$00000033
	dc.l	$00000055
	dc.l	$00000077
	dc.l	$00000099
	dc.l	$000000bb
	dc.l	$000000dd
	dc.l	$001100ff
	dc.l	$003300ff
	dc.l	$005500ff
	dc.l	$007700ff
	dc.l	$009900ff
	dc.l	$00bb00ff
	dc.l	$00dd00ff
	dc.l	$11ff00ff
	dc.l	$33ff00ff
	dc.l	$55ff00ff
	dc.l	$77ff00ff
	dc.l	$99ff00ff
	dc.l	$bbff00ff
	dc.l	$ddff00ff

	REPT	PAUSE
	dc.l	$ffff00ff
	ENDR

	dc.l	$f0f000f0
	dc.l	$d0d000d0
	dc.l	$b0b000b0
	dc.l	$90900090
	dc.l	$70700070
	dc.l	$50500050
	dc.l	$30300030
	dc.l	$10100010

	REPT	PAUSE
	dc.l	$00000000
	ENDR

ENDCYCL:
LENCYCL	EQU	(ENDCYCL-BEGCYCL)/4

sprite_memory:	ds.b	(8*3*32*16)*9  !(3pl)*(3wordsX)*(32Y)*(16Shift)
screen2:	ds.b	64256
