DUUR_TE_ZOOMEN	EQU	180
SHOW	EQU	$F

keybufleegloop
	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	keybuffleeg
	jsr	wacht_toets
	bra	keybufleegloop
keybuffleeg:	; geen toets

	bsr	schermadr_opvraag
	bsr	preshift_sprites
	bsr	sup_vis_mode
	dc.w	$a00a
	bsr	save_palette
	bsr	set_palette
	move.l	schermadres,a1
	bsr	copy
	move.l	schermadres2,a1
	bsr	copy
back:
	move.l	#realcoords,a0
	move.l	coordspointer1,a1
	move.l	#realcoords_influence,a2
	move.l	#stuiter,a3
	move.w	#11-1,d0
coords_exchange:
	move.w	(a0),d6
	move.w	2(a0),d7

	move.w	(a2),d1
	add.w	d1,d6
	cmp.w	#319-32,d6
	blo.s	other_way1
	move.w	#-2,(a2)
other_way1:
	cmp.w	#0,d6
	bhi.s	other_way2
	move.w	#2,(a2)
other_way2:

	move.w	2(a2),d1
	add.w	#1,d1
	cmp.w	#270,d1
	blo.s	other_way3
	move.w	#180,d1
other_way3:
	move.w	d1,2(a2)
	asl.w	#1,d1
	move.w	(a3,d1.w),d7

	move.w	d6,(a1)+
	move.w	d7,(a1)+
	move.w	d6,(a0)+
	move.w	d7,(a0)+
	add.w	#4,a2
	dbra	d0,coords_exchange

;	move.l	#$10000000*SHOW,$ff9800

	move.l	coordspointer1,a2
	move.w	#7,d7	;T
	bsr	do_sprite

	add.w	#4,a2
	move.w	#2,d7	;H
	bsr	do_sprite

	add.w	#4,a2
	move.w	#8,d7	;U
	bsr	do_sprite

	add.w	#4,a2
	move.w	#4,d7	;N
	bsr	do_sprite

	add.w	#4,a2
	move.w	#0,d7	;D
	bsr	do_sprite

	add.w	#4,a2
	move.w	#1,d7	;E
	bsr	do_sprite

	add.w	#4,a2
	move.w	#6,d7	;R
	bsr	do_sprite

	add.w	#4,a2
	move.w	#0,d7	;D
	bsr	do_sprite

	add.w	#4,a2
	move.w	#5,d7	;O
	bsr	do_sprite

	add.w	#4,a2
	move.w	#3,d7	;M
	bsr	do_sprite

	add.w	#4,a2
	move.w	#1,d7	;E
	bsr	do_sprite

;	move.l	#$00100000*SHOW,$ff9800
	jsr	preset_zoom

	jsr	y_stretch_clear
	jsr	y_calc_stretch
	jsr	y_stretch

;	move.l	#$00000000,$ff9800
	bsr	vsync

	bsr	do_cycle_invert
	bsr	beeld_change

	sub.w	#1,zoomteller
	move.w	zoomteller,d0
	tst.w	d0
	bne	no_restore_z
	move.w	#0,zoomlength
	move.w	#DUUR_TE_ZOOMEN,zoomteller

; VOLGENDE
	move.l	#zoomerdata+28,a0
	add.w	zoom_dat_add,a0
	move.w	(a0),d3

	move.w	d3,d1
	mulu	#6,d1
	add.w	#2,d1
	add.w	d1,zoom_dat_add
no_restore_z:


;	move.l	#$00100000*SHOW,$ff9800

	move.l	coordspointer1,a2
	move.w	#11-1,d7
clear_sprite_loop:
	bsr	clear_sprite
	add.w	#4,a2
	dbra	d7,clear_sprite_loop

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back

	bsr	load_palette
	move.l	oldscreenbase,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	jsr	wacht_toets
	dc.w	$a009
	bsr	user_mode
	clr.l	-(sp)
	trap	#1


;---------------------------
clear_sprite:
	move.l	schermadres,a1
	add.w	#8,a1

	cmp.w	#0,2(a2)
	bhi.s	other_way4
	RTS
other_way4:


	move.w	(a2),d0	  ; X
	and.w	#15,d0
	mulu	#8*3*32,d0
	add.w	d0,a0

	move.w	(a2),d0	  ; X
	and.w	#-1-15,d0
	add.w	d0,a1

	clr.l	d0
	move.w	2(a2),d0  ; Y
	mulu	#80,d0
	asl.l	#2,d0
	add.l	d0,a1

	move.w	#32-1,d0
y_loop2:
pl set 0
	REPT	3
	clr.l	pl(a1)
	clr.w	pl+4(a1)
pl set pl+16
	ENDR
	add.w	#320,a1
	dbra	d0,y_loop2

	RTS

do_sprite:
	move.l	#sprite_memory,a0
	move.l	schermadres,a1
	add.w	#8,a1


	cmp.w	#0,2(a2)
	bhi.s	other_way5
	RTS
other_way5:

	clr.l	d0
	move.w	d7,d0
	mulu	#8*3*32,d0
	asl.l	#4,d0	; *16
	add.l	d0,a0

	move.w	(a2),d0	  ; X
	and.w	#15,d0
	mulu	#8*3*32,d0
	add.w	d0,a0

	move.w	(a2),d0	  ; X
	and.w	#-1-15,d0
	add.w	d0,a1

	clr.l	d0
	move.w	2(a2),d0  ; X
	mulu	#80,d0
	asl.l	#2,d0
	add.l	d0,a1

	move.w	#32-1,d0
y_loop:
pl set 0
	REPT	3
	move.w	(a0)+,d2
	and.w	d2,pl(a1)
	and.w	d2,pl+2(a1)
	and.w	d2,pl+4(a1)
	move.l	(a0)+,d2
	or.l	d2,pl(a1)
	move.w	(a0)+,d2
	or.w	d2,pl+4(a1)
pl set pl+16
	ENDR
	add.w	#320,a1
	dbra	d0,y_loop
	RTS


;-----------PRESHIFT SPRITES-------
preshift_sprites:
	move.l	#sprite_memory,a1

	move.w	#9-1,d7
letter_loop:
	move.w	#16-1,d1	; SHIFTS
shift_loop:
	move.l	#bigsprites+34,a0

	move.w	#8,d2
	sub.w	d7,d2
	asl.w	#4,d2
	add.w	d2,a0
	move.w	#32-1,d0	; y
Y_shift_loop:

	bsr	shift_case1
	bsr	shift_case4
	bsr	shift_case2
	bsr	shift_case4
	bsr	shift_case3
	bsr	shift_case4

	add.w	#160,a0
	dbra	d0,Y_shift_loop
	dbra	d1,shift_loop
	dbra	d7,letter_loop
	RTS

shift_case1:
	clr.l	d2
	clr.l	d3
	clr.l	d4
	clr.l	d5
	move.w	0(a0),d2
	move.w	2(a0),d3
	move.w	4(a0),d4
	move.w	6(a0),d5
	RTS
shift_case2:
	move.w	0(a0),d2
	move.w	2(a0),d3
	move.w	4(a0),d4
	move.w	6(a0),d5
	swap	d2
	swap	d3
	swap	d4
	swap	d5
	move.w	8(a0),d2
	move.w	10(a0),d3
	move.w	12(a0),d4
	move.w	14(a0),d5
	RTS
shift_case3:
	move.w	8(a0),d2
	move.w	10(a0),d3
	move.w	12(a0),d4
	move.w	14(a0),d5
	swap	d2
	swap	d3
	swap	d4
	swap	d5
	move.w	#0,d2
	move.w	#0,d3
	move.w	#0,d4
	move.w	#0,d5
	RTS
shift_case4:
	add.w	#1,d1
	asl.l	d1,d2
	asl.l	d1,d3
	asl.l	d1,d4
	asl.l	d1,d5
	sub.w	#1,d1
	swap	d2
	swap	d3
	swap	d4
	swap	d5
	not.w	d5	; MASK-AND
	move.w	d5,(a1)+
	move.w	d2,(a1)+
	move.w	d3,(a1)+
	move.w	d4,(a1)+
	RTS
;-----------COLOR CYCLE---------

do_cycle_invert:
	move.l	#cycle_colors,a1
	add.w	counter,a1
	add.w	counter,a1
	add.w	counter,a1
	add.w	counter,a1

	move.l	#$ff9804,a0
pl set 56
	REPT	14
	move.l	pl-4(a0),pl(a0)
pl set pl-4
	ENDR
	move.l	(a1),pl(a0)

	move.w	counter,d1
	add.w	#1,d1
	cmp.w	#LENCYCL,d1
	bne.s	no_res_cycle_counter2
	move.w	#0,d1
no_res_cycle_counter2:
	move.w	d1,counter
	RTS

;------------- COLORS AFTER/BEFORE ----
save_palette:
	move.l	#$ff9800,a0
	move.l	#oldpalette,a1
	move.w	#256-1,d0
save_loop:
	move.l	(a0)+,(a1)+
	dbra	d0,save_loop
	RTS
load_palette:
	move.l	#oldpalette,a0
	move.l	#$ff9800,a1
	move.w	#256-1,d0
load_loop:
	move.l	(a0)+,(a1)+
	dbra	d0,load_loop
	RTS
set_palette:
	move.l	#newpalette,a0
	move.l	#$ff9800,a1
	move.w	#256-1,d0
set_loop:
	move.l	(a0)+,(a1)+
	dbra	d0,set_loop
	RTS

; --------KOPIEER SCHERM--------

copy:
	move.l	#fadescreen+34,a0
	move.w	#(32000)/4/4-1,d0
copy_loop:
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	dbra	d0,copy_loop
	RTS
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	move.l	d0,oldscreenbase

	move.l	#screen2+256,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2

	move.l	#coords1,coordspointer1
	move.l	#coords2,coordspointer2
	RTS
beeld_change:
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	move.l	schermadres2,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2

	move.l	coordspointer1,d0
	move.l	coordspointer2,d1
	move.l	d1,coordspointer1
	move.l	d0,coordspointer2

	RTS





;------------------;
;- EINDE HOOFDLUS -;
;------------------;

	dc.w	$a009

;  PROCEDURES
;--------------------


preset_zoom:
	move.l	#zoomerdata+28,a0
	add.w	zoom_dat_add,a0
	move.w	(a0),d3
	tst.w	d3
	bne.s	no_wrap_zoom_dat
	move.w	#0,zoom_dat_add
no_wrap_zoom_dat:


	move.l	#zoomdata,a0
	add.w	zoomlength,a0
	move.w	(a0)+,begin_zoomer_x
	move.w	(a0)+,xlengtezoomer
	move.w	(a0)+,begin_zoomer_y
	move.w	(a0)+,ylengtezoomer

	add.w	#8,zoomlength

	bsr	calc_allxes
	move.l	#hlinedata,a2
	move.l	#xzoombuffer,a3
	move.l	#zoomerdata+2+28,a4
	add.w	zoom_dat_add,a4
	move.l	#allxes,a5
	move.l	a3,a0
	bsr	clr_zoom

	move.l	#zoomerdata+28,a0
	add.w	zoom_dat_add,a0
	move.w	(a0),d3
	sub.w	#1,d3

lusje:
	move.l	a2,a1
	move.l	a3,a0

	move.w	(a4)+,d1 ; goede y op uitrekscherm
	mulu	#160,d1
	add.w	d1,a0

	move.w	(a4),d2
	asl.w	#1,d2	; .w in array
	move.w	(a5,d2.w),d2 ; allxes
	and.w	#$0F,d2
	asl.w	#3,d2	;*8
	add.w	d2,a1

	move.w	(a4)+,d2
	asl.w	#1,d2	; .w in array
	move.w	(a5,d2.w),d2 ; allxes
	move.w	d2,d0
	and.w	#$FFF0,d2
	asr.w	#1,d2	; 16->8
	add.w	d2,a0

	move.w	(a4)+,d1
	asl.w	#1,d1	; .w in array
	move.w	(a5,d1.w),d1 ; allxes
	sub.w	d0,d1
	add.w	#1,d1
	asl.w	#7,d1 ;*16*8 in d1 de lengte
	add.w	d1,a1

	move.w	#-1,d0	; fill
	move.l	#back2,a6
	move.w	(a1)+,d1
	jmp	hlindo(PC,d1.w)
back2:
	dbra	d3,lusje
	RTS

hlindo:
;-- 8
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	jmp	(a6)      ; 2
;-- 16
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$8(a0) ; 4
	jmp	(a6)      ; 2
;-- 20
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$10(a0); 4
	or.w	d0,$8(a0) ; 4
	jmp	(a6)      ; 2
;-- 24
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$18(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	jmp	(a6)      ; 2
;-- 28
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$20(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	jmp	(a6)      ; 2
;-- 32
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$28(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	jmp	(a6)      ; 2
;-- 36
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$30(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	jmp	(a6)      ; 2
;-- 40
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$38(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	jmp	(a6)      ; 2
;-- 44
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$40(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	jmp	(a6)      ; 2
;-- 48
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$48(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	jmp	(a6)      ; 2
;-- 52
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$50(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	jmp	(a6)      ; 2
;-- 56
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$58(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	jmp	(a6)      ; 2
;-- 60
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$60(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	jmp	(a6)      ; 2
;-- 64
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$68(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	jmp	(a6)      ; 2
;-- 68
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$70(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	jmp	(a6)      ; 2
;-- 72
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$78(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	or.w	d0,$70(a0); 4
	jmp	(a6)      ; 2
;-- 76
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$80(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	or.w	d0,$70(a0); 4
	or.w	d0,$78(a0); 4
	jmp	(a6)      ; 2
;-- 80
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$88(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	or.w	d0,$70(a0); 4
	or.w	d0,$78(a0); 4
	or.w	d0,$80(a0); 4
	jmp	(a6)      ; 2
;-- 84
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$90(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	or.w	d0,$70(a0); 4
	or.w	d0,$78(a0); 4
	or.w	d0,$80(a0); 4
	or.w	d0,$88(a0); 4
	jmp	(a6)      ; 2
;-- 88
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$98(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	or.w	d0,$70(a0); 4
	or.w	d0,$78(a0); 4
	or.w	d0,$80(a0); 4
	or.w	d0,$88(a0); 4
	or.w	d0,$90(a0); 4
	jmp	(a6)      ; 2



clr_zoom:
	move.w	#8,d0
clrzlus:
pl set 0
	REPT	20
	clr.w	pl(a0)
pl set pl+8
	ENDR
	add.w	#160,a0
	dbra	d0,clrzlus
	RTS
;---------------------;
; REKKUH DIE Y-AAS !! ;
;---------------------;


y_calc_stretch:
	move.w	begin_zoomer_y,d0
	move.w	ylengtezoomer,d1
	move.w	d1,d7
	asr.w	#3,d7 ; ipv divu 9 , 'divu 8'

	move.w	#0,d2
	move.w	#0,d4
ycstr_loop:
	move.w	d1,d3
	mulu	d2,d3
	divu	#9,d3
	add.w	d0,d3

	tst.w	d3	; <0 (-> 0)
	bpl	not_negative3
	move.w	#0,d3
not_negative3:
	cmp.w	#200,d3	; >319 (-> 319)
	blo	not_negative4
	move.w	#200,d3
not_negative4:


	move.l	#allyes,a0
	add.w	d3,a0
	add.w	d3,a0
	move.w	d7,d6
do_y_in_array:
	move.w	d2,(a0)+
	dbra	d6,do_y_in_array
no_y_str:
	move.w	d3,d4	; oude d3 in d4
	add.w	#1,d2
	cmp.w	#10,d2
	bne.s	ycstr_loop
	RTS

y_stretch_clear:
	move.l	#allyes,a0
	move.w	#200-1,d0
clr_allyes:
	move.w	#9,(a0)+
	dbra	d0,clr_allyes
	RTS


y_stretch:
	move.l	#allyes,a3
	move.l	#xzoombuffer,a2
	move.l	schermadres,a1
	add.w	#14,a1
	move.w	#200-1,d0
ystrloop:
	move.l	a2,a0
	move.w	(a3)+,d1
	mulu	#160,d1
	add.w	d1,a0
pl1 set 0
pl2 set 0
	REPT	20
	move.w	pl1(a0),pl2(a1)
pl1 set pl1+8
pl2 set pl2+16
	ENDR
	add.w	#320,a1
	dbra	d0,ystrloop
	RTS

;------------------------------;
;- YO! BEREKEN DE X-AS PUNTEN -;
;------------------------------;


calc_allxes:
	move.l	#allxes,a0
	move.w	xlengtezoomer,d0

	move.w	#64-1,d7
calc_allxasloop:
	move.w	begin_zoomer_x,d6

	move.w	d0,d5
	mulu	d7,d5
	divu	#64,d5
	add.w	d5,d6

	tst.w	d6	; <0 (-> 0)
	bpl	not_negative1
	move.w	#0,d6
not_negative1:
	cmp.w	#319,d6	; >319 (-> 319)
	blo	not_negative2
	move.w	#319,d6
not_negative2:

	asl.w	#1,d7	; tijdelijk *2
	move.w	d6,(a0,d7.w)
	asr.w	#1,d7
	dbra	d7,calc_allxasloop
	RTS


wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
cls:
	move.l	#(320*200)/4/4-1,d0
	move.l	schermadres,a0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS



ssp:		dc.l	0
oldscreenbase:	dc.l	0
schermadres:	dc.l	0
schermadres2:	dc.l	0
counter:	dc.w	0
coordspointer1:	dc.l	0
coordspointer2:	dc.l	0
fadescreen:	INCBIN	"F:\DRAW\PICTURES\PI1's\CFADE2.PI1"
bigsprites:	INCBIN	"F:\DRAW\PICTURES\FONTS\THUNDFNT.PI1"
		ds.l	20
stuiter:
	REPT	90
	dc.w	0
	ENDR
	INCBIN	"F:\PROGRAMM\ALL_DATA\THUNJMP.DAT"
coords1:	ds.l	11
coords2:	ds.l	11
realcoords:
pl set 0
	REPT	11
	dc.w	pl,0
pl set pl+26
	ENDR
realcoords_influence:
pl set 0
	REPT	11
	dc.w	2,pl
pl set pl+8
	ENDR
oldpalette:	ds.l	256
newpalette:
	REPT	16
	dc.l	0
	ENDR
	REPT	16
	dc.l	$00000000
	ENDR
	REPT	16
	dc.l	$22220022
	ENDR
	REPT	16
	dc.l	$44440044
	ENDR
	REPT	16
	dc.l	$66660066
	ENDR
	REPT	16
	dc.l	$88880088
	ENDR
	REPT	16
	dc.l	$AAAA00AA
	ENDR
	REPT	16
	dc.l	$CCCC00CC
	ENDR
	REPT	16
	dc.l	$FFFF00FF
	ENDR
	REPT	128
	dc.l	$ffff00ff
	ENDR
	EVEN
PAUSE	EQU	8

cycle_colors:

BEGCYCL:
	dc.l	$0,$22220022,$44440044,$66660066
	dc.l	$88880088,$aaaa00aa,$cccc00cc,$eeee00ee
	REPT	PAUSE
	dc.l	$ffff00ff
	ENDR
	dc.l	$ffff00ff
	dc.l	$ffff00dd
	dc.l	$ffff00bb
	dc.l	$ffff0099
	dc.l	$ffff0077
	dc.l	$ffff0055
	dc.l	$ffff0033
	dc.l	$ffff0011
	dc.l	$ffdd0000
	dc.l	$ffbb0000
	dc.l	$ff990000
	dc.l	$ff770000
	dc.l	$ff550000
	dc.l	$ff330000
	dc.l	$ff110000
	dc.l	$dd000000
	dc.l	$bb000000
	dc.l	$99000000
	dc.l	$77000000
	dc.l	$55000000
	dc.l	$33000000
	dc.l	$11000000
	REPT	PAUSE
	dc.l	$00000000
	ENDR
	dc.l	$00000011
	dc.l	$00000033
	dc.l	$00000055
	dc.l	$00000077
	dc.l	$00000099
	dc.l	$000000bb
	dc.l	$000000dd
	dc.l	$001100ff
	dc.l	$003300ff
	dc.l	$005500ff
	dc.l	$007700ff
	dc.l	$009900ff
	dc.l	$00bb00ff
	dc.l	$00dd00ff
	dc.l	$11ff00ff
	dc.l	$33ff00ff
	dc.l	$55ff00ff
	dc.l	$77ff00ff
	dc.l	$99ff00ff
	dc.l	$bbff00ff
	dc.l	$ddff00ff
	REPT	PAUSE
	dc.l	$ffff00ff
	ENDR
	dc.l	$f0f000f0
	dc.l	$d0d000d0
	dc.l	$b0b000b0
	dc.l	$90900090
	dc.l	$70700070
	dc.l	$50500050
	dc.l	$30300030
	dc.l	$10100010
	REPT	PAUSE
	dc.l	$00000000
	ENDR
ENDCYCL:
LENCYCL	EQU	(ENDCYCL-BEGCYCL)/4
sprite_memory:	ds.b	(8*3*32*16)*9  !(3pl)*(3wordsX)*(32Y)*(16Shift)
screen2:	ds.b	64256
begin_zoomer_x:	dc.w	160
xlengtezoomer:	dc.w	10
begin_zoomer_y:	dc.w	160
ylengtezoomer:	dc.w	150
zoomlength:	dc.w	0
zoomteller:	dc.w	DUUR_TE_ZOOMEN
zoom_dat_add	dc.w	0
	;dc.w	(11+16+9+16+8+9+9)*6+2
hlinedata:	INCBIN 'F:\PROGRAMM\FASTVECT\POLYDATA.DAT'
;			y,x1,x2

allxes:
nr set 0
	REPT	64
	dc.w	nr*20
nr set nr+1
	ENDR

allyes:
nr set 0
	REPT	400
	dc.w	9
;	dc.w	nr*9/200
nr set nr+1
	ENDR
xzoombuffer:
	ds.b	160*10
zoomdata:	INCBIN	'F:\PROGRAMM\ALL_DATA\ZOOMER_Z.DAT'
zoomerdata:
	;      y,xb,xe

	INCBIN	'F:\PROGRAMM\ALL_DATA\ZOOMCONT'
