SHOW	EQU	0
	bsr	schermadr_opvraag
	bsr	sup_vis_mode
	dc.w	$a00a
	bsr	vsync
	bsr	cls
	bsr	store_pal
	bsr	set_pal
	bsr	zet_except_chars
	bsr	set_text
	move.w	#0,teller
back:
	move.l	#$ff000000*SHOW,$ff9800
	add.w	#1,teller
	bsr	clear_y_rij

	move.l	#logaritme,a0
	add.w	teller,a0
	add.w	teller,a0
	move.w	#140-1,d0
	move.w	#0,d2
calc_loop
	move.l	#y_rij,a1
	move.w	(a0)+,d1
	add.w	d2,d1
	asl.w	#1,d1

	cmp.w	#400,d1
	bhi.s	niet_calc
	move.w	d2,d7
	mulu	#160,d7

	move.w	(a1,d1.w),d3
	bne.s	niet_calc
	move.w	d7,(a1,d1.w)
niet_calc
	add.w	#1,d2
	dbra	d0,calc_loop

	move.l	#$00ff0000*SHOW,$ff9800
; PLAK DOOR

	move.l	#y_rij,a2
	move.l	#y_rij2,a3
	move.w	#200-1,d0
	move.w	#0,d6
	move.w	#0,d1 ; Y-teller
	move.w	#0,d2 ; lang-teller
	move.w	#0,d5 ; last Y
plak_loop:

	move.w	(a2),d7

	tst.w	d7
	beq.s	gelijkaan0
	move.w	d7,d6 ; nieuwe
	move.b	d2,(a3,d5.w)
	move.w	d1,d5 ; d5=old_Y
	move.w	#0,d2 ; lengte=0
gelijkaan0:

	move.w	d6,(a2)+
	add.w	#1,d1 ; INC Y
	add.w	#1,d2 ; INC lengte
	dbra	d0,plak_loop

	move.l	#$00ff00ff*SHOW,$ff9800
; ZET NEER
	move.l	#y_rij,a2
	move.l	#y_rij2,a3
	move.l	#fade,a4
	move.l	schermadres,a1
	add.w	#60*320,a1
	move.w	#140-1,d0
line_copy:

	; NORMALE LIJN
	move.l	#page,a0
	add.w	(a2)+,a0
pl set 0
	REPT	20
	move.l	pl*8+0(a0),pl*16+0(a1)
	move.l	pl*8+4(a0),pl*16+4(a1)
pl set pl+1
	ENDR

	;bra	skipstripe
	; STRIPE EFFECT
	clr.w	d1
	move.b	(a3)+,d1
	tst.w	d1
	beq.s	stripezero
	move.l	#fade,a4
	asr.w	#1,d1 ; /2
	asl.w	#2,d1 ; .L
	sub.w	d1,a4
stripezero:
	move.l	(a4)+,d2
pl set 0
	REPT	20
	move.l	d2,pl*16+12(a1)
pl set pl+1
	ENDR
skipstripe:
	add.w	#160,a0
	add.w	#320,a1
	dbra	d0,line_copy

	move.l	#$0,$ff9800
	bsr	vsync
	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back

	bsr	restore_pal
	bsr	user_mode
	clr.l	-(sp)
	trap	#1
clear_y_rij:
	move.l	#y_rij,a0
	move.l	#y_rij2,a1
	move.w	#200/2-1,d0
cyrijloop:
	clr.l	(a0)+
	clr.w	(a1)+
	dbra	d0,cyrijloop
	move.w	#-1,(a0)+
	RTS
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
wacht_lusje:
	move.l	#16000,d0
wachtlus	nop
	dbra	d0,wachtlus
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
store_pal
	move.l	#$ffff9800,a0
	move.l	#oldpal,a1
	bsr	move256long
	RTS
restore_pal
	move.l	#oldpal,a0
	move.l	#$ffff9800,a1
	bsr	move256long
	RTS
set_pal
	move.l	#newpal,a0
	move.l	#$ffff9800,a1
	bsr	move256long
	RTS
move256long
	move.w	#256-1,d0
m256l_loop:
	move.l	(a0)+,(a1)+
	dbra	d0,m256l_loop
	RTS
cls
	move.l	schermadres,a0
	move.w	#64000/4/4-1,d0
clsloop	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra	d0,clsloop
	RTS
set_text:
	move.l	#page,a0
	move.l	#text,a1
	move.l	#fontpoint,a2

next_font:
	move.l	#fontpic+34,a3
	clr.w	d5
	move.b	(a1)+,d5
	move.w	d5,d4
	cmp.w	#0,d5
	beq.s	exit_set_text
	cmp.w	#1,d5
	beq.s	exit_set_text
	asl.w	#1,d5
	move.w	(a2,d5.w),d6
	add.w	d6,a3

	move.l	a3,a5
	move.l	a0,a6
	move.w	#47-1,d0
	cmp.w	#'(',d4
	beq.s	except
	cmp.w	#')',d4
	beq.s	except
	cmp.w	#'/',d4
	beq.s	except
	move.w	#31-1,d0
	add.w	#16*160,a6
except
	cmp.w	#'(',d4
	bne.s	except2
	add.w	#16*160,a6
except2
do_font
	move.l	(a5),(a6)
	move.l	4(a5),4(a6)
	move.l	8(a5),8(a6)
	move.l	12(a5),12(a6)
	add.w	#160,a5
	add.w	#160,a6 ! 320
	dbra	d0,do_font
	add.w	#16,a0
	bra	next_font
exit_set_text:
	cmp.w	#1,d5
	bne.s	code_1
	move.l	#page,a0
	clr.w	d0
	move.b	(a1)+,d0
	mulu	#160,d0
	add.w	d0,a0
	bra	next_font
code_1
	RTS
zet_except_chars
	move.w	#16*0+5120*4,fontpoint+'('*2
	move.w	#16*1+5120*4,fontpoint+')'*2
	move.w	#16*2+5120*4,fontpoint+'/'*2
	RTS

text:	;dc.b	'VAKANTIE',1,40
	;dc.b	'        IN',1,80
	;dc.b	'OOSTENRYK',0
	;dc.b	' CAMPING',0	;<
	; ,dc.b	'  MUZIEK',0	;<
	;dc.b	'KLOOF',1,40	;<
	;dc.b	'SEISENBERG',1,40
	;dc.b	'KLAMM',0
	;dc.b	1,1,'KITZB)HEL',0	;<
	;dc.b	'PANNE',1,40	; <
	;dc.b	'    KOEKEN',0
	;dc.b	'CONCERT IN',1,40 ;<
	;dc.b	'  ITTER   ',0
	;dc.b	'RATTENBERG',0	;<
	;dc.b	'AACHEN SEE',0	;<
	;dc.b	'INNSBRUCK',0	;<
	;dc.b	'KERK IN',1,40	;<
	;dc.b	'INNSBRUCK',0
	;dc.b	'GRO(',1,40	;<
	;dc.b	'  GLOCKNER',1,80
	;dc.b	'  STRA(E',0
	dc.b	'KRIMMLER',1,32	;<
	dc.b	'WASSER',1,80
	dc.b	'    F/LLE',0
	;dc.b	'KUFSTEIN',0	;<
	;dc.b	'WASCHLAND',0	;<
	;dc.b	'KABELBAAN',1,40;<
	;dc.b	'HOHE SALVE',0
	;dc.b	'   EINDE',0
	;dc.b	'   THE'
	;dc.b	1,40,'EXPERIENCE'
	;dc.b	1,80,' PRESENTS',0
empty:	EQU	16*9+5120*4
	EVEN
fontpoint:
	REPT	48
	dc.w	empty
	ENDR
	dc.w	empty ; 48
	dc.w	16*1+5120*3 ; 49
	dc.w	16*2+5120*3
	dc.w	16*3+5120*3 ; 51
	dc.w	16*4+5120*3
	dc.w	16*5+5120*3
	dc.w	16*6+5120*3 ; 54
	dc.w	16*7+5120*3
	dc.w	16*8+5120*3
	dc.w	16*9+5120*3 ; 57
	REPT	65-58
	dc.w	empty
	ENDR
pl set 0
	REPT	10
	dc.w	16*pl
pl set pl+1
	ENDR
pl set 0
	REPT	10
	dc.w	16*pl+5120
pl set pl+1
	ENDR
pl set 0
	REPT	6
	dc.w	16*pl+5120*2
pl set pl+1
	ENDR


y_rij:	ds.w	300
y_rij2:	ds.b	300
teller:	dc.w	0
logaritme:
	REPT	200
	dc.w	0
	ENDR
;A	dc.w	0,3,5,6,7,7,6,5,3
;B	dc.w	0,-3,-5,-6,-7,-7,-6,-5,-3
;A	dc.w	0,1,2,2,1,0,-1,-2,-2,-1
;	REPT	5
;	dc.w	0,0,1,1,2,2,3,3,4,4
;	dc.w	5,5,4,4,3,3,2,2,1,1
;	ENDR
	;REPT	10
	;dc.w	0,0,1,1,1,1,2,2,2,2,2,2,2,2,1,1,1,1
	;dc.w	0,0,-1,-1,-1,-1,-2,-2,-2,-2,-2,-2,-2,-2,-1,-1,-1,-1
	;ENDR
	;dc.w	0,0,1,1,1,2,2,3,4,6,9,13,18,24,31,39,48,58,69,81,94,108,123,139,156,174,192,211,231
;pl set 0
;	REPT	20
;	dc.w	0,0
;	ENDR
	INCBIN	'F:\DRAW\PICTURES\FIT3FADB.DAT'
	REPT	200
	dc.w	240
	ENDR
	REPT	200
	dc.w	0
	ENDR
	INCBIN	'F:\DRAW\PICTURES\FIT3FADB.DAT'
	REPT	200
	dc.w	240
	ENDR
	REPT	200
	dc.w	0
	ENDR
	INCBIN	'F:\DRAW\PICTURES\FIT3FADB.DAT'

	dc.l	$ffffffff
	dc.l	$ffffffff
	dc.l	$ffffffff
	dc.l	$ffffffff
	dc.l	$ffffffff
	dc.l	$ffffffff
	dc.l	$ffffffff
	dc.l	$ffffffff
	dc.l	$ffffffff
	dc.l	$ffffffff
	dc.l	$0000ffff
	dc.l	$0000ffff
	dc.l	$0000ffff
	dc.l	$ffff0000
fade:	dc.l	$00000000
	dc.l	$ffff0000
	dc.l	$0000ffff
	dc.l	$0000ffff
	dc.l	$0000ffff
	dc.l	$ffffffff
	dc.l	$ffffffff
	dc.l	$ffffffff
	dc.l	$ffffffff
	dc.l	$ffffffff
	dc.l	$ffffffff
	dc.l	$ffffffff
	dc.l	$ffffffff
	dc.l	$ffffffff
	dc.l	$ffffffff

fontpic		INCBIN	'F:\DRAW\PICTURES\FONTS\FITURE3.pi1'
oldpal		ds.l	256
newpal		INCBIN	'F:\DRAW\PICTURES\FIT3FADE.DAT'
ssp		dc.l	0
schermadres	dc.l	0
page:		ds.l	32000/4
