CLSBYTES	EQU	32000
	bsr	schermadr_opvraag
	bsr	cls
	bsr	init
	move.w	#15,d7
vallop2	bsr	calval
	bsr	goprint
	dbra	d7,vallop2
back:
	bsr	vsync
	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back
	bsr	wacht_toets

	clr.l	-(sp)
	trap	#1

wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
goval
	move.w	values,d0
	and.w	#$F000,d0
	asr.w	#8,d0
	asr.w	#4,d0
	bsr	zet_getal
	move.w	values,d0
	and.w	#$F00,d0
	asr.w	#8,d0
	bsr	zet_getal
	move.w	values,d0
	and.w	#$F0,d0
	asr.w	#4,d0
	bsr	zet_getal
	move.w	values,d0
	and.w	#$F,d0
	bsr	zet_getal
	RTS
zet_getal:
	move.b	hexa(PC,d0.w),(a0)+
	RTS
	dc.b	'0123456789ABCDEF'
hexa:	
	dc.b	'0123456789ABCDEF'
	dc.b	'0123456789ABCDEF'
cls:
	move.l	#CLSBYTES/16-1,d0
	move.l	schermadres,a0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
calval:
	move.l	#valstr,a0
	bsr	goval
	move.w	values+2,values
	move.l	#valstr+4,a0
	bsr	goval
	move.l	#values,a0
	move.w	#15,d0
valloop	move.l	4(a0),(a0)
	add.w	#4,a0
	dbra	d0,valloop
	RTS
goprint:
	move.l	#string,-(sp)
	move.w	#9,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
init:
	lea	module(pc),a0
	lea	$03B8(a0),a1 ; module+952

	moveq	#$7F,d0 ; Het aantal patterns!
	moveq	#$0,d1
loop	move.l	d1,d2
	subq.w	#1,d0
lop2	move.b	(a1)+,d1
	cmp.b	d2,d1
	bgt.s	loop
	dbra	d0,lop2
	addq.b	#1,d2

	lea	samplestarts(pc),a1
	asl.l	#8,d2
	asl.l	#2,d2
	add.l	#$043c,d2
	add.l	a0,d2
	move.l	d2,a2

	moveq	#$1E,d0
lop3	clr.l	(a2)
	move.l	a2,(a1)+
	moveq	#0,d1
	move.w	42(a0),d1
	add.l	d1,d1
	add.l	d1,a2
	add.l	#$1E,a0
	dbra	d0,lop3

	move.l	a2,end_of_samples


	;move.l	#samplestarts+16*4,a0
	;move.l	#values,a1
	;move.w	#14,d0
;lopje	;move.l	(a0)+,(a1)+
	;dbra	d0,lopje
	;move.l	end_of_samples,(a1)+
	RTS
getnew:	lea	module+$043c(pc),a0
	lea	-$043c+$0c(a0),a2
	lea	-$043c+$03B8(a0),a1

	moveq	#0,d0
	moveq	#0,d1
	move.b	songpos(pc),d0
	move.b	(a1,d0.w),d1
	asl.l	#8,d1
	asl.l	#2,d1
	add.w	pattpos(pc),d1

	lea	aud1lc(pc),a3
	lea	voice(pc),a4
	bsr.s	playvoice

	RTS

values		ds.l	16
schermadres	dc.l	0
clsstr	dc.b	27,'E',0
string	dc.b	'Value : #$'
valstr	dc.b	'        '
	dc.b	13,12
samplestarts:	ds.l	$1F
end_of_samples	dc.l	0

module	INCBIN	"F:\MODULES\EXECUTE2.MOD"

		ds.l	16384
workspace	dc.w	0