	bsr	sup_vis_mode
	bsr	schermadr_opvraag
	bsr	cls
	bsr	store_colors
	bsr	set_colors
back:
	bsr	wacht_lusje
;	move.l	#$0,$ff9800
	bsr	calc_plasma
	bsr	show_plasma
;	move.l	#$77000000,$ff9800
	bsr	vsync
	bsr	beeld_change

	move.w	cntr,d0
	add.w	#41,d0
	cmp.w	#42*40,d0
	blo.s	no_warp_cntr
	sub.w	#42*40,d0
no_warp_cntr:
	move.w	d0,cntr

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back

	bsr	wacht_toets
	bsr	restore_colors
	bsr	user_mode
	clr.l	-(sp)
	trap	#1

;-----------------------------
calc_plasma:
	move.l	#pla_raster_set,a0
	add.w	cntr,a0
	move.b	#SET_CF,(a0)  ;%0111
	move.b	#SET_CE,1(a0)
	move.b	#SET_CD,2(a0)
	move.b	#SET_CC,3(a0)
	move.b	#SET_CB,4(a0)
	move.b	#SET_CA,5(a0)
	move.b	#SET_C9,6(a0)
	move.b	#SET_C8,7(a0)
	move.b	#SET_C7,8(a0)
	move.b	#SET_C6,9(a0)
	move.b	#SET_C5,10(a0)
	move.b	#SET_C4,11(a0)
	move.b	#SET_C3,12(a0)
	move.b	#SET_C2,13(a0)
	move.b	#SET_C1,14(a0)
	RTS
;-----------------------------
show_plasma:
	move.l	schermadres,a0
	move.l	#pla_raster_set,a1
	move.l	#SET_col0,a3
	move.l	#SET2_col0,a4
	move.l	#RETURN,a5
	move.l	#RETURN2,a6
	clr.w	d0

	move.w	#40-1,d2 ; 40 in de Y
set_y_as:

	; \___________/
	; >CLEAR KOLOM<
	; /^^^^^^^^^^^\

	move.w	#20-1,d1 ; 20 kolommen
clear_kolom:
	clr.l	(a0)+
	clr.l	(a0)+
	addq	#8,a0
	dbra	d1,clear_kolom

	sub.w	#320,a0

	; \_________/
	; >SET KOLOM<
	; /^^^^^^^^^\

	move.w	#20-1,d1 ; 20 kolommen
set_kolom:
	move.b	(a1)+,d0  ; doe 2
	jmp	(a3,d0.w)
RETURN:
	move.b	(a1)+,d0
	jmp	(a4,d0.w)
RETURN2:
	add.w	#16,a0
	dbra	d1,set_kolom

	sub.w	#320,a0

	; \__________/
	; >COPY KOLOM<
	; /^^^^^^^^^^\

	move.w	#20-1,d1 ; 20 kolommen
copy_kolom:
	move.l	(a0)+,d3
	move.l	d3,320-4(a0)
	move.l	d3,640-4(a0)
	move.l	d3,960-4(a0)
	move.l	(a0)+,d3
	move.l	d3,320-4(a0)
	move.l	d3,640-4(a0)
	move.l	d3,960-4(a0)
	addq	#8,a0
	dbra	d1,copy_kolom

	add.w	#320*3,a0
	dbra	d2,set_y_as
	RTS
;-----------------------------
wacht_lusje:
	move.l	#4500,d0
wachtlus	nop
	dbra	d0,wachtlus
	RTS
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
cls:
	move.l	#(320*200)/4/4-1,d0
	move.l	schermadres,a0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres

	move.l	#screen2+256,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2
	RTS
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
store_colors:
	move.l	#$ffff9800,a0
	move.l	#old_palette,a1
	move.w	#16-1,d0
store_col_loop:
	move.l	(a0)+,(a1)+
	dbra	d0,store_col_loop
	RTS
set_colors:
	move.l	#$ffff9800,a0

	move.l	#$00000000,0(a0)
	move.l	#$FFFF00FF,1*4(a0)
	move.l	#$DDFF00DD,2*4(a0)
	move.l	#$AAFF00AA,4*4(a0)
	move.l	#$66FF0066,8*4(a0)
	move.l	#$33FF0033,3*4(a0)
	move.l	#$00FF0000,6*4(a0)
	move.l	#$33FF0000,12*4(a0)
	move.l	#$66FF0000,9*4(a0)
	move.l	#$AAFF0000,5*4(a0)
	move.l	#$DDFF0000,10*4(a0)
	move.l	#$FFFF0033,7*4(a0)
	move.l	#$FFFF0066,14*4(a0)
	move.l	#$FFFF00AA,13*4(a0)
	move.l	#$EEFF00DD,11*4(a0)
	move.l	#$FFFF00FF,15*4(a0)
	RTS
restore_colors:
	move.l	#old_palette,a0
	move.l	#$ffff9800,a1
	move.w	#16-1,d0
restore_col_loop:
	move.l	(a0)+,(a1)+
	dbra	d0,restore_col_loop
	RTS
beeld_change:
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	move.l	schermadres2,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2
	RTS
;------------------------------------

schermadres:	dc.l	0
schermadres2:	dc.l	0
ssp:		dc.l	0
cntr:		dc.w	0
old_palette	ds.l	16
screen2: 	ds.b	64256
pla_raster_set:	ds.b	40*50


;	>>>>>><<<<<<

SET_col0:	;%0000
	JMP (A5)
SET_col1:	;%1000
	move.b	#$FF,(a0)
	JMP (A5)
	dc.w	0
SET_col2:	;%0100
	move.b	#$FF,2(a0)
	JMP (A5)
SET_col3:	;%0010
	move.b	#$FF,4(a0)
	JMP (A5)
SET_col4:	;%0001
	move.b	#$FF,6(a0)
	JMP (A5)
SET_col5:	;%1100
	or.l	#$FF00FF00,(a0)
	JMP (A5)
SET_col6:	;%0110
	or.l	#$FF00FF00,2(a0)
	JMP (A5)
SET_col7:	;%0011
	or.l	#$FF00FF00,4(a0)
	JMP (A5)
SET_col8:	;%1001
	move.b	#$FF,6(a0)
	move.b	#$FF,0(a0)
	JMP (A5)
SET_col9:	;%1010
	move.b	#$FF,(a0)
	move.b	#$FF,4(a0)
	JMP (A5)
	dc.w	0
SET_colA:	;%0101
	move.b	#$FF,2(a0)
	move.b	#$FF,6(a0)
	JMP (A5)
SET_colB:	;%1110
	or.l	#$FF00FF00,(a0)
	move.b	#$FF,4(a0)
	JMP (A5)
SET_colC:	;%0111
	or.l	#$FF00FF00,2(a0)
	move.b	#$FF,6(a0)
	JMP (A5)
SET_colD:	;%1011
	or.l	#$FF00FF00,4(a0)
	move.b	#$FF,(a0)
	JMP (A5)
	dc.w	0
SET_colE:	;%1101
	or.l	#$FF00FF00,(a0)
	move.b	#$FF,6(a0)
	JMP (A5)
SET_colF:	;%1111
	or.l	#$FF00FF00,(a0)
	or.l	#$FF00FF00,4(a0)
	JMP (A5)


;	>>>>>><<<<<<

SET2_col0:
	JMP (A6)
SET2_col1:
	move.b	#$FF,1(a0)
	JMP (A6)
SET2_col2:
	move.b	#$FF,3(a0)
	JMP (A6)
SET2_col3:
	move.b	#$FF,5(a0)
	JMP (A6)
SET2_col4:
	move.b	#$FF,7(a0)
	JMP (A6)
SET2_col5:
	or.l	#$00FF00FF,(a0)
	JMP (A6)
SET2_col6:
	or.l	#$00FF00FF,2(a0)
	JMP (A6)
SET2_col7:
	or.l	#$00FF00FF,4(a0)
	JMP (A6)
SET2_col8:
	move.b	#$FF,7(a0)
	move.b	#$FF,1(a0)
	JMP (A6)
SET2_col9:
	move.b	#$FF,1(a0)
	move.b	#$FF,5(a0)
	JMP (A6)
SET2_colA:
	move.b	#$FF,3(a0)
	move.b	#$FF,7(a0)
	JMP (A6)
SET2_colB:	;%1110
	or.l	#$FF00FF,(a0)
	move.b	#$FF,5(a0)
	JMP (A6)
SET2_colC:	;%0111
	or.l	#$FF00FF,2(a0)
	move.b	#$FF,7(a0)
	JMP (A6)
SET2_colD:	;%1011
	or.l	#$FF00FF,4(a0)
	move.b	#$FF,1(a0)
	JMP (A6)
SET2_colE:	;%1101
	or.l	#$FF00FF,(a0)
	move.b	#$FF,7(a0)
	JMP (A6)
SET2_colF:	;%1111
	or.l	#$FF00FF,(a0)
	or.l	#$FF00FF,4(a0)
	JMP (A6)

;	>>>>>><<<<<<

SET_C0:	EQU	SET_col0-SET_col0
SET_C1:	EQU	SET_col1-SET_col0
SET_C2:	EQU	SET_col2-SET_col0
SET_C3:	EQU	SET_col3-SET_col0
SET_C4:	EQU	SET_col4-SET_col0
SET_C5:	EQU	SET_col5-SET_col0
SET_C6:	EQU	SET_col6-SET_col0
SET_C7:	EQU	SET_col7-SET_col0
SET_C8:	EQU	SET_col8-SET_col0
SET_C9:	EQU	SET_col9-SET_col0
SET_CA:	EQU	SET_colA-SET_col0
SET_CB:	EQU	SET_colB-SET_col0
SET_CC:	EQU	SET_colC-SET_col0
SET_CD:	EQU	SET_colD-SET_col0
SET_CE:	EQU	SET_colE-SET_col0
SET_CF:	EQU	SET_colF-SET_col0



