mousevec	equ	16
ikbdws	equ	25
kbdvec	equ	34

	bsr	install_mouse
	bsr	schermadr_opvraag
	bsr	cls
	bsr	sup_vis_mode
;	bsr	muson
	bsr	set_colors1

loop:
;	bsr	vsync
	move.l	$462,tel
chmouse:
	bsr	mousenew
	move.l	$462,d0
	cmp.l	tel,d0
	beq.s	chmouse
	bsr	plotmouse

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	loop

;	bsr	musoff
	bsr	user_mode

	bsr	wacht_toets

	bsr	restore_mouse

	illegal




;	SUBROUTINES    !!!!!
;-------------------------------
plotmouse:
	move.l	schermadres,a0
	move.l	#calc_table1,a3
	move.l	#calc_table2,a4
	move.l	#calc_table3,a5


	move.w	mousex,d2
	move.w	mousey,d1
	asl.w	#1,d1
	move.w	(a5,d1.w),d1

	add.w	d2,d2
	add.w	(a3,d2.w),d1
	move.w	(a4,d2.w),d2
	or.w	d2,4(a0,d1.w)

	RTS

mousenew:
; muis variabelen bij houden
;----------------------------

;(x)
	clr.w	d0
	move.b	packet+1,d0
	btst	#7,d0
	beq	not_neg

	not.b	d0
	add.w	#1,d0
	sub.w	d0,mousex

	bra	not_neg2
not_neg:
	add.w	d0,mousex
not_neg2:


;(y)
	clr.w	d0
	move.b	packet+2,d0
	btst	#7,d0
	beq	not_neg3

	neg.b	d0
	add.w	#1,d1
	sub.w	d0,mousey

	bra	not_neg4
not_neg3:

	add.w	d0,mousey
not_neg4:



; (clear mouse registers ivm echo's)
	move.b	#0,packet
	move.b	#0,packet+1
	move.b	#0,packet+2


; (muis binnen bep. veld blijven)
	cmp.w	#-100,mousex
	blo	no
	move.w	#0,mousex
no
	cmp.w	#319,mousex
	blo	no2
	move.w	#319,mousex
no2

	cmp.w	#-100,mousey
	blo	no3
	move.w	#0,mousey
no3
	cmp.w	#150,mousey
	blo	no4
	move.w	#150,mousey
no4

	RTS

tresh	equ	2

mouse_acc:
	cmp.w	#tresh,d0
	blo	no_extra_sp
	sub.w	#tresh,d0
;	asl.w	#1,d0

;	cmp.w	#tresh+2,d0
;	blo	no_extra_sp2
;	asl.w	#1,d0
;no_extra_sp2:

	add.w	#tresh,d0
no_extra_sp:

	RTS
;-------------------------------
rechte_streep:

	move.l	schermadres,a0
	add.w	#160*126,a0

plus SET 2
	REPT 20
	move.w	#65535,plus(a0)
plus SET plus+8
	ENDR

	RTS
;-------------------------------
install_mouse:
	move.w	#kbdvec,-(sp)
	trap	#14
	addq.l	#2,a7
	lea	my_handler,a1
	move.l	d0,a0
	move.l	d0,save_old_base
	move.l	mousevec(a0),save_old_vec
	move.l	a1,mousevec(a0)
	pea	ikbdstring
	move.w	#0,-(sp)
	move.w	#ikbdws,-(sp)
	trap	#14
	addq.l	#8,sp
	RTS
;-------------------------------
restore_mouse:
	move.l	save_old_base,a0
	move.l	save_old_vec,d0
	move.l	d0,mousevec(a0)
	move.w	#0,-(sp)
	trap	#1
	RTS
;-------------------------------
my_handler:
	move.b	#3,d0
	lea	packet,a1
save_it:	move.b	(a0)+,(a1)+
	subq.b	#1,d0
	bne	save_it
	RTS
;-------------------------------
vsync:
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	RTS
;-------------------------
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
;-------------------------
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
;-------------------------
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
;-------------------------
cls:
	move.l	#32000/4/4-1,d0
	move.l	schermadres,a0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS
;-------------------------
cop:
	move.l	#$ff8240-39488-8*32000,a0	; 6,7,stukje van 8
	; lengte seriele poort buffer = waarschijnlijk 65536 bytes of 32768 words

;	move.l	#$ff8240-69952-6*32000,a0	- eind buffer , ^ - beg buffer

	move.l	schermadres,a1
	add.w	#72*160,a1
	move.l	#old_vol_buf,a2




;	move.l	#319,d0
;go_check:
;	move.w	(a0)+,d1
;	add.w	#100,a0
;	and.w	#255,d1
;	cmp.w	#126-30,d1
;	blo	n_voorwaard
;	cmp.w	#126+30,d1
;	bhi	n_voorwaard
;	bra	uit_lus
;n_voorwaard:
;	dbra	d0,go_check
;	bra	geen_voorwaarden
;uit_lus:






	add.w	#1,d6
	and.w	#1,d6
	move.w	d6,d7

	tst.w	d7
	bne.s	pl1
	move.l	#old_vol_buf,a2
	bsr	set_colors2
pl1:
	cmp.w	#1,d7
	bne.s	pl2
	add.w	#2,a1
	move.l	#old_vol_buf2,a2
	bsr	set_colors1
pl2:




;	move.w	#$700,$ff8240




	move.l	a2,a5
	move.l	#320-1,d0
go_clr:
	move.w	(a2)+,d1
	move.w	#0,(a1,d1.w)
	dbra	d0,go_clr

	move.l	a5,a2
	move.l	#calc_table1,a3
	move.l	#calc_table2,a4
	move.l	#calc_table3,a5
	move.l	#0,d3
	move.l	#320-1,d4
go_cop:

	move.w	d4,d3
;	asr.w	#1,d3

	move.w	(a0)+,d1	; get new
	and.w	#255,d1
	asr.w	#1,d1

	asl.w	#1,d1
	move.w	(a5,d1.w),d1

	move.w	d3,d2
	add.w	d2,d2
	add.w	(a3,d2.w),d1
	move.w	(a4,d2.w),d2
	or.w	d2,(a1,d1.w)

	move.w	d1,(a2)+

	add.w	#202,a0	; 200
	dbra d4,go_cop




geen_voorwaarden:

	RTS
;-------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
;-------------------------
nieuwst	EQU	$474

set_colors1:
	move.w	#$000,$ff8240 ; 0000
	move.w	#nieuwst,$ff8242 ; 0001
	move.w	#$000,$ff8244 ; 0010
	move.w	#nieuwst,$ff8246 ; 0011
	move.w	#$700,$ff8248 ; 0011
	move.w	#$777,$ff825E ; 0011
	RTS
set_colors2:
	move.w	#$000,$ff8240 ; 0000
	move.w	#$000,$ff8242 ; 0001
	move.w	#nieuwst,$ff8244 ; 0010
	move.w	#nieuwst,$ff8246 ; 0011
	move.w	#$700,$ff8248 ; 0011
	move.w	#$777,$ff825E ; 0011
	RTS

;	VARIABELEN
;-----------------------------------
schermadres:	dc.l	0
ssp:		dc.l	0
old_vol_buf:	ds.w	700
old_vol_buf2:	ds.w	700
OLDVBL:	dc.l	0
;	asr.w	#4,d2 (div 16)
;	asl.w	#3,d2 (mul 8)
plus	set 0
calc_table1:
	REPT 20 ; 20*8=320
	dc.w	plus	;0
	dc.w	plus	;1
	dc.w	plus	;2
	dc.w	plus	;3
	dc.w	plus	;4
	dc.w	plus	;5
	dc.w	plus	;6
	dc.w	plus	;7
	dc.w	plus	;8
	dc.w	plus	;9
	dc.w	plus	;10
	dc.w	plus	;11
	dc.w	plus	;12
	dc.w	plus	;13
	dc.w	plus	;14
	dc.w	plus	;15
plus set plus+8
	ENDR


calc_table2:
	REPT 20 ; 20*8=320
	dc.w	%1000000000000000
	dc.w	%0100000000000000
	dc.w	%0010000000000000
	dc.w	%0001000000000000
	dc.w	%0000100000000000
	dc.w	%0000010000000000
	dc.w	%0000001000000000
	dc.w	%0000000100000000
	dc.w	%0000000010000000
	dc.w	%0000000001000000
	dc.w	%0000000000100000
	dc.w	%0000000000010000
	dc.w	%0000000000001000
	dc.w	%0000000000000100
	dc.w	%0000000000000010
	dc.w	%0000000000000001
	ENDR


calc_table3:
plus set 0
	REPT 200
	dc.w	plus*160
plus set plus+1
	ENDR


ikbdstring	dc.b	$8
packet	ds.b	3
save_old_vec	ds.l	1
save_old_base	ds.l	1


mousex:	dc.w	0
mousey:	dc.w	0
tel:	dc.l	0





