mousevec	equ	24
ikbdws		equ	25
kbdvec		equ	34

	bsr	schermadr_opvraag
	bsr	cls
	bsr	pre_shift_mouse
	move.l	schermadres,mousepoint
	bsr	sup_vis_mode
	bsr	set_colors1
	bsr	install_mouse

loop:

	clr.w	d0
	move.b	packet+2,d0

	move.b	d0,d1
	and.w	#1,d1
	tst.w	d1
	beq.s	not_up
	sub.w	#1,duck
not_up
	move.b	d0,d1
	and.w	#2,d1
	tst.w	d1
	beq.s	not_down
	add.w	#1,jump
not_down
	move.b	d0,d1
	and.w	#4,d1
	tst.w	d1
	beq.s	not_left
	sub.w	#2,speedx
not_left
	move.b	d0,d1
	and.w	#8,d1
	tst.w	d1
	beq.s	not_right
	add.w	#2,speedx
not_right

	bsr	new_coords
	bsr	check_button
	bsr	clearmouse
	bsr	putmouse
	bsr	vsync

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	loop

	bsr	user_mode
	bsr	wacht_toets
	bsr	restore_mouse

	illegal



;	SUBROUTINES    !!!!!
;-------------------------------
new_coords
	move.w	speedx,d0
	add.w	#100,d0

	cmp.w	#99,d0
	bhi.s	speed_limit_3
	add.w	#1,d0
speed_limit_3

	cmp.w	#101,d0
	blo.s	speed_limit_4
	sub.w	#1,d0
speed_limit_4


	cmp.w	#108,d0
	blo.s	speed_limit_1
	move.w	#108,d0
speed_limit_1

	cmp.w	#92,d0
	bhi.s	speed_limit_2
	move.w	#92,d0
speed_limit_2


	sub.w	#100,d0
	move.w	d0,speedx
	asr.w	#2,d0
	add.w	d0,mousex
	RTS:
;-------------------------------
clearmouse:
	move.l	mousepoint,a5
pl set 0
	REPT	16
	clr.l	pl(a5)
	clr.l	pl+4(a5)
	clr.l	pl+8(a5)
	clr.l	pl+12(a5)
pl set pl+160
	ENDR
	RTS
;----------------------------
putmouse:
	move.l	schermadres,a0
	move.l	#mo_gr_buff,a1


	move.w	mousex,d0
	move.w	mousey,d1
;y
	asl.w	#1,d1
	mulu	#80,d1
	add.w	d1,a0
;x
	move.w	d0,d1	; save d0
	and.w	#$FFF0,d0 ;bound 16
	asr.w	#1,d0	; 8 bytes per 16 pixels
	add.w	d0,a0

	and.w	#$000F,d1 ; 0-15
	asl.w	#8,d1	; *16*16
	add.w	d1,a1

	move.l	a0,mousepoint
pl set 0
	REPT	16
	move.l	(a1)+,pl(a0)
	move.l	(a1)+,pl+4(a0)
	move.l	(a1)+,pl+8(a0)
	move.l	(a1)+,pl+12(a0)
pl set pl+160
	ENDR
	RTS
;-------------------------------
pre_shift_mouse:
	move.l	#0,d4 ; shiftcounter
	move.l	#mo_gr_buff,a1
	move.w	#15,d6 ;shift 16*
shift_loop:
	move.l	#mouse_graph,a0
	move.w	#15,d5 ;y 16*
y_loop:
;get
	move.w	(a0)+,d0
	move.w	(a0)+,d1
	move.w	(a0)+,d2
	move.w	(a0)+,d3
	swap	d0
	swap	d1
	swap	d2
	swap	d3
	clr.w	d0
	clr.w	d1
	clr.w	d2
	clr.w	d3
;shift
	lsr.l	d4,d0
	lsr.l	d4,d1
	lsr.l	d4,d2
	lsr.l	d4,d3
;put
	move.w	d0,8(a1)
	move.w	d1,10(a1)
	move.w	d2,12(a1)
	move.w	d3,14(a1)
	swap	d0
	swap	d1
	swap	d2
	swap	d3
	move.w	d0,(a1)
	move.w	d1,2(a1)
	move.w	d2,4(a1)
	move.w	d3,6(a1)
;next
	add.w	#16,a1
	dbra	d5,y_loop
	add.w	#1,d4
	dbra	d6,shift_loop
	RTS
;-------------------------------
install_mouse:
	move.w	#kbdvec,-(sp)
	trap	#14
	addq.l	#2,a7
	lea	my_handler,a1
	move.l	d0,a0
	move.l	d0,save_old_base
	move.l	mousevec(a0),save_old_vec
	move.l	a1,mousevec(a0)
	pea	ikbdstring
	move.w	#0,-(sp)
	move.w	#ikbdws,-(sp)
	trap	#14
	addq.l	#8,sp
	RTS
;-------------------------------
restore_mouse:
	move.l	save_old_base,a0
	move.l	save_old_vec,d0
	move.l	d0,mousevec(a0)
	move.w	#0,-(sp)
	trap	#1
	RTS
;-------------------------------
my_handler:
	lea	packet,a1
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	RTS
;-------------------------------
check_button:
	clr.w	d0
	move.b	packet,d0
	and.w	#3,d0

	cmp.w	#0,d0
	bne.s	not_0
	move.w	#$770,$ff8242 ; 0001
	move.w	#$330,$ff8244 ; 0010
not_0:
	cmp.w	#1,d0
	bne.s	not_1
	move.w	#$007,$ff8242 ; 0001
	move.w	#$003,$ff8244 ; 0010
not_1:
	cmp.w	#2,d0
	bne.s	not_2
	move.w	#$070,$ff8242 ; 0001
	move.w	#$030,$ff8244 ; 0010
not_2:
	cmp.w	#3,d0
	bne.s	not_3
	move.w	#$077,$ff8242 ; 0001
	move.w	#$033,$ff8244 ; 0010
not_3:

	RTS
;-------------------------
vsync:
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	RTS
;-------------------------
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
;-------------------------
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
;-------------------------
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
;-------------------------
cls:
	move.l	#32000/4/4-1,d0
	move.l	schermadres,a0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS
;-------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
;-------------------------
set_colors1:
	move.w	#$000,$ff8240 ; 0000
	move.w	#$770,$ff8242 ; 0001
	move.w	#$330,$ff8244 ; 0010
	move.w	#$000,$ff8246 ; 0011
	move.w	#$000,$ff8248 ; 0011
	move.w	#$777,$ff825E ; 0011
	RTS
set_colors2:
	move.w	#$000,$ff8240 ; 0000
	move.w	#$700,$ff8242 ; 0001
	move.w	#$300,$ff8244 ; 0010
	move.w	#$000,$ff8246 ; 0011
	move.w	#$000,$ff8248 ; 0011
	move.w	#$777,$ff825E ; 0011
	RTS

;	VARIABELEN
;-----------------------------------
schermadres:	dc.l	0
ssp:		dc.l	0
ikbdstring	dc.b	$8
packet		ds.b	3
save_old_vec	ds.l	1
save_old_base	ds.l	1

jump:	dc.w	0
duck:	dc.w	0
speedx:	dc.w	0
mousex:	dc.w	160
mousey:	dc.w	100

mousepoint:	dc.l	0

; buffer met 16* 1pix shifted mouse
mo_gr_buff:	ds.w	8*16*16 ;(4pl * 16y * 16shift)

mouse_graph:
	dc.w	%0000000000000000
	dc.w	%1100000000000000
	dc.w	%0000000000000000
	dc.w	%0000000000000000
	dc.w	%0100000000000000
	dc.w	%1010000000000000
	dc.w	%0000000000000000
	dc.w	%0000000000000000
	dc.w	%0110000000000000
	dc.w	%1001000000000000
	dc.w	%0000000000000000
	dc.w	%0000000000000000
	dc.w	%0111000000000000
	dc.w	%1000100000000000
	dc.w	%0000000000000000
	dc.w	%0000000000000000
	dc.w	%0111100000000000
	dc.w	%1000010000000000
	dc.w	%0000000000000000
	dc.w	%0000000000000000
	dc.w	%0111110000000000
	dc.w	%1000001000000000
	dc.w	%0000000000000000
	dc.w	%0000000000000000
	dc.w	%0111111000000000
	dc.w	%1000000100000000
	dc.w	%0000000000000000
	dc.w	%0000000000000000
	dc.w	%0111111100000000
	dc.w	%1000000010000000
	dc.w	%0000000000000000
	dc.w	%0000000000000000
	dc.w	%0111111110000000
	dc.w	%1000000001000000
	dc.w	%0000000000000000
	dc.w	%0000000000000000
	dc.w	%0111110000000000
	dc.w	%1000001111000000
	dc.w	%0000000000000000
	dc.w	%0000000000000000
	dc.w	%0111110000000000
	dc.w	%1000001000000000
	dc.w	%0000000000000000
	dc.w	%0000000000000000
	dc.w	%0110111000000000
	dc.w	%1001000100000000
	dc.w	%0000000000000000
	dc.w	%0000000000000000
	dc.w	%0100011000000000
	dc.w	%1011100100000000
	dc.w	%0000000000000000
	dc.w	%0000000000000000
	dc.w	%0000011100000000
	dc.w	%1100100010000000
	dc.w	%0000000000000000
	dc.w	%0000000000000000
	dc.w	%0000001100000000
	dc.w	%0000010010000000
	dc.w	%0000000000000000
	dc.w	%0000000000000000
	dc.w	%0000000000000000
	dc.w	%0000011100000000
	dc.w	%0000000000000000
	dc.w	%0000000000000000


