AANTSPR	EQU	45
DIST	EQU	6
	bsr	init_all
	bsr	beeld_change
	bsr	do_sprite_mark
	bsr	beeld_change
	bsr	do_sprite_mark
back:
	bsr	new_bob_cntr
	bsr	new_coords
;	add.w	#1,bob_coords1
	bsr	beeld_change
	move.w	#$000,$ff8240
	bsr	remove_sprite
	bsr	do_sprite_mark
	move.w	#$000,$ff8240
	bsr	vsync
	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back

	bsr	wacht_toets
	bsr	old_status

	clr.l	-(sp)
	trap	#1

new_bob_cntr:
	add.w	#1,bob_cntr
	move.w	bob_cntr,d0
	cmp.w	#400,d0
	blo	new_bob
	sub.w	#400,bob_cntr
new_bob:

	add.w	#1,bob_cntr2
	move.w	bob_cntr2,d0
	cmp.w	#800,d0
	blo	new_bob2
	sub.w	#800,bob_cntr2
new_bob2:
	RTS

new_coords:
	move.l	#movedata,a0
	move.l	#movedata2,a1
	move.l	#bob_coords1,a2
	add.w	bob_cntr,a0
	add.w	bob_cntr,a0
	add.w	#50,a1
	add.w	bob_cntr2,a1
	add.w	bob_cntr2,a1
	add.w	#AANTSPR*DIST,a1
	move.w	#AANTSPR,d0
newcoordslus:
	move.w	(a0),(a2)+
	move.w	(a1),(a2)+
	add.w	#DIST,a0
	sub.w	#DIST,a1
	dbra	d0,newcoordslus
	RTS

remove_sprite:
	move.l	schermadres2,a1

	tst.w	scrswap
	beq	if2
	move.l	#bob_remove1,a2
	bra	endif2
if2:	move.l	#bob_remove2,a2
endif2:

	move.w	#AANTSPR,d7
remloop:
	move.l	a1,a0
	add.w	(a2)+,a0
plus	set	0
	REPT	16
	clr.l	plus(a0)
	clr.l	plus+4(a0)
	clr.l	plus+8(a0)
	clr.l	plus+12(a0)
plus	set	plus+160
	ENDR
	dbra	d7,remloop
	RTS

do_sprite_mark:
	move.l	#bob_graf,a0
	move.l	schermadres2,a1

	tst.w	scrswap
	beq	if1
	move.l	#bob_remove1,a2
	move.l	#bob_coords1,a3
	bra	endif1
if1:
	move.l	#bob_remove2,a2
	move.l	#bob_coords1,a3
endif1:

	move.w	#AANTSPR,d6
do_spr_loop:
	move.l	a0,a4
	move.l	a1,a5

	move.w	(a3),d0
	and.w	#$000F,d0
	mulu	#16*20,d0
	add.w	d0,a4

	move.w	(a3),d0
	and.w	#$FFF0,d0
	asr.w	#1,d0	;\16*8
	add.w	d0,a5
	move.w	d0,d1 ; save for removing

	move.w	2(a3),d0
	mulu	#160,d0
	add.w	d0,a5
	add.w	d0,d1 ; save for removing

	move.w	d1,(a2)+
p1 set 0
p2 set 0
	REPT	16
	move.w	p1(a4),d7
	and.w	d7,p2(a5)
	and.w	d7,p2+2(a5)
	and.w	d7,p2+4(a5)
	and.w	d7,p2+6(a5)
	move.w	p1+10(a4),d7
	and.w	d7,p2+8(a5)
	and.w	d7,p2+10(a5)
	and.w	d7,p2+12(a5)
	and.w	d7,p2+14(a5)
	move.l	p1+2(a4),d7
	or.l	d7,p2(a5)
	move.l	p1+6(a4),d7
	or.l	d7,p2+4(a5)
	move.l	p1+12(a4),d7
	or.l	d7,p2+8(a5)
	move.l	p1+16(a4),d7
	or.l	d7,p2+12(a5)
p1 set p1+20
p2 set p2+160
	ENDR
	add.w	#4,a3
	dbra	d6,do_spr_loop

	RTS
pre_shift:
	move.l	a6,a1

	move.l	#15,d0	; 16 maal
shlus0:
	move.l	a5,a0
	move.l	#15,d1	; 16 maal y
shlus1:
	move.l	#0,d2
	move.w	(a0),d2
	asl.l	d0,d2	; shift eerst 15 pix. dan 14 enz..
	move.w	d2,d4
	move.w	d2,12(a1)
	swap	d2	; linker word !
	move.w	d2,d3
	move.w	d2,2(a1)

	move.l	#0,d2
	move.w	2(a0),d2
	asl.l	d0,d2	; shift eerst 15 pix. dan 14 enz..
	or.w	d2,d4
	move.w	d2,14(a1)
	swap	d2	; linker word !
	or.w	d2,d3
	move.w	d2,4(a1)

	move.l	#0,d2
	move.w	4(a0),d2
	asl.l	d0,d2	; shift eerst 15 pix. dan 14 enz..
	or.w	d2,d4
	move.w	d2,16(a1)
	swap	d2	; linker word !
	or.w	d2,d3
	move.w	d2,6(a1)

	move.l	#0,d2
	move.w	6(a0),d2
	asl.l	d0,d2	; shift eerst 15 pix. dan 14 enz..
	or.w	d2,d4
	move.w	d2,18(a1)
	swap	d2	; linker word !
	or.w	d2,d3
	move.w	d2,8(a1)

	not.w	d3
	not.w	d4
	move.w	d3,(a1)
	move.w	d4,10(a1)

	add.w	#160,a0
	add.w	#20,a1
	dbra	d1,shlus1
	dbra	d0,shlus0
	RTS
init_all:
	bsr	schermadr_opvraag
	move.l	schermadres,a0
	bsr	cls
	move.l	schermadres2,a0
	bsr	cls
	move.l	#my_bob+34,a5
	move.l	#bob_graf,a6
	bsr	pre_shift
	bsr	sup_vis_mode

	move.l	#$ffff8240,a0
	move.l	#old_colors,a1
	bsr	copy_colors
	move.l	#my_bob+2,a0
	move.l	#$ffff8240,a1
	bsr	copy_colors
	RTS
old_status:
	move.l	old_schermadres,a0
	move.l	a0,schermadres2
	bsr	beeld_change
	move.l	#old_colors,a0
	move.l	#$ffff8240,a1
	bsr	copy_colors
	bsr	user_mode
	RTS
copy_colors:
	movem.l	(a0),d0-d7
	movem.l d0-d7,(a1)
	RTS
beeld_change:
	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2
	add.w	#1,scrswap
	and.w	#1,scrswap
	RTS
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	move.l	d0,old_schermadres
	move.l	#my_scrn,d0
	add.l	#256,d0
	and.l	#$FFFF00,d0
	move.l	d0,schermadres2
	RTS
cls:
	move.l	#(32000)/4/4-1,d0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS

ssp:	dc.l	0
schermadres:	dc.l	0
schermadres2:	dc.l	0
old_schermadres	dc.l	0
old_colors:	ds.w	16
my_scrn:	ds.b	32256
my_bob:	INCBIN	"F:\DRAW\PICTURES\PI1's\4PLBAL.PI1"
bob_graf:	ds.b	(20*16)*16
bob_coords1:	
p1 set 0
p2 set 0
		REPT	AANTSPR+1
		dc.w	p1,p2
p1 set p1+1
p2 set p2+1
		ENDR
bob_remove1:	ds.w	AANTSPR+1
bob_remove2:	ds.w	AANTSPR+1
scrswap:	dc.w	0
bob_cntr:	dc.w	0
bob_cntr2:	dc.w	0
movedata:	INCBIN	'F:\PROGRAMM\ALL_DATA\BOBMOVES.DAT'
		INCBIN	'F:\PROGRAMM\ALL_DATA\BOBMOVES.DAT'
movedata2:	INCBIN	'F:\BOBMOV2B.DAT'
		INCBIN	'F:\BOBMOV2B.DAT'
