_p_cookies	EQU	$5a0
ST_val		EQU	$00000000
STE_val		EQU	$00010000
TT_val		EQU	$00020000
F30_val		EQU	$00030000

	bsr	schermadr_opvraag
	bsr	sup_vis_mode
	bsr	find_cookie
;	move.w	#2,error
	bsr	if_error_print
end:
	bsr	wacht_toets
	bsr	user_mode
	clr.l	-(sp)
	trap	#1

find_cookie:
;----------------------;
;  ZOEK HET KOEKJE ..  ;
;----------------------;
	lea	_p_cookies,a0
	move.l	(a0),a0
	beq	fail1
	move.l	#'_VDO',d0
search_cookie:
	tst.l	(a0)
	beq	fail1
	lea	8(a0),a0
	cmp.l	-8(a0),d0
	bne.s	search_cookie

	cmp.l	#ST_val,-4(a0)
	beq.s	atari_st
	move.w	#0,comp_type
	bra	found_cookie
	atari_st:

	cmp.l	#STE_val,-4(a0)
	beq.s	atari_ste
	move.w	#1,comp_type
	bra	found_cookie
	atari_ste:

	cmp.l	#TT_val,-4(a0)
	beq.s	atari_tt
	move.w	#2,comp_type
	bra	found_cookie
	atari_tt:

	cmp.l	#F30_val,-4(a0)
	beq.s	atari_falcon
	move.w	#3,comp_type
	bra	found_cookie
	atari_falcon:

	bra	fail2 ;geen ATART ST(E),TT of FALCON

	found_cookie:
	RTS

if_error_print:
	move.w	error,d0
	tst.w	d0
	beq.s	no_error_occured

	move.l	#errorpointer,a0
	asl.w	#2,d0 ; .L (*4)
	add.w	d0,a0
	move.l	(a0),a1
	move.l	a1,-(sp)

	move.w	#9,-(sp)
	trap	#1
	addq.l	#6,sp

	bra	end

no_error_occured:
	RTS

schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
fail1:
	move.w	#1,error
	RTS
fail2:
	move.w	#2,error
	RTS


schermadres:	dc.l	0
ssp:		dc.l	0
comp_type:	dc.w	0
error:		dc.w	0

errorpointer:	
		dc.l	error0
		dc.l	error1
		dc.l	error2
		REPT	10
		dc.l	error0
		ENDR

; ENGELS

;error0:	dc.b	27,'E',"I found an error ,but I don't know what to say....",13,12,12,12,"Sorry ??..",0
;error1:	dc.b	27,'E','Where is my cookie ??',0
;error2:	dc.b	27,'E','Is this a better version than a FALCON ?',0

; NEDERLANDS

error0:	dc.b	27,'E',"Ik vond een fout ,maar ik weet niets te zeggen ....",13,12,12,12,"Sorry ??..",0
error1:	dc.b	27,'E',"Waar is mijn koekje ??",0
error2:	dc.b	27,'E',"Is dit een betere computer dan een",12,13,"FALCON ?",0

; 13 - terug naar begin regel
; 12 - volgende regel
; 27 + --

; 'A' cursor naar boven
; 'B' cursor naar beneden
; 'C' cursor naar links
; 'D' cursor naar rechts
; 'E' Clear/Home
; 'H' Home
; 'I' cursor naar boven + scrollen
; 'J' wis beeldscherm vanaf cursor
; 'K' regel vanaf cursor wissen
; 'L' regel tussenvoegen
; 'M' hele regel wissen
; 'b',F  cursorkleur
; 'c',F  achtergrondkleur
; 'd' wis beeldscherm tot cursor
; 'e' Cursor aan
; 'f' Cursor uit
; 'j' Cursor positie opslaan
; 'k' Ga naar opgelagen cursor positie
; 'l' Regel wissen
; 'o' Regel tot cursor wissen
; 'p' Revwerse aan
; 'q' Reverse af
; 'v' Cursor na eind regel verder volgende regel
; 'q' Cursor na eind regel niet verder
