	bsr	schermadr_opvraag
	bsr	cls
	bsr	sup_vis_mode
	bsr	store_pal
	bsr	set_pal
back:
	bsr	vsync
	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back
	bsr	restore_pal
	bsr	user_mode
	clr.l	-(sp)
	trap	#1

vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
wacht_lusje:
	move.l	#16000,d0
wachtlus	nop
	dbra	d0,wachtlus
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
store_pal
	move.l	#$ffff9800,a0
	move.l	#oldpal,a1
	bsr	move256long
	RTS
restore_pal
	move.l	#oldpal,a0
	move.l	#$ffff9800,a1
	bsr	move256long
	RTS
set_pal
	move.l	#newpal,a0
	move.l	#$ffff9800,a1
	bsr	move256long
	RTS
move256long
	move.w	#256-1,d0
m256l_loop:
	move.l	(a0)+,(a1)+
	dbra	d0,m256l_loop
	RTS
cls
	move.l	schermadres,a0
	move.w	#64000/4/4-1,d0
clsloop	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra	d0,clsloop
	RTS

oldpal		ds.l	256
newpal		INCBIN	'F:\DRAW\PICTURES\FIT3FADE.DAT'
ssp		dc.l	0
schermadres	dc.l	0

