;/////////////////////////////
; TRAP #n     = $80+n*4
; TRAP Return = RTE


	bsr	schermadr_opvraag
	bsr	sup_vis_mode
	move.l	$BC,OLD_TRAP

	move.l	sp,old_sp
	move.l	#stack_,sp
	bsr	bewaar_allerlei
; disassembler
; ------------

	move.l	#MY_TRAP,$BC ;TR #15
	bsr	zet_even_allerlei ; zet alle registers goed
	TRAP	#15
	bsr	bewaar_allerlei   ; zet alle registers terug

	; een RTE als breekpunt
	; en bij een trace ligt
	; de RTE na de uit-te-
	; voeren instruktie !


; einde disassembler
; ------------------
	move.l	OLD_TRAP,$BC
	move.l	old_sp,sp

	bsr	user_mode
	clr.l	-(sp)
	trap	#1



MY_TRAP	move.l	schermadres,a0
	move.w	#-1,(a0)
	RTE



bewaar_allerlei:
	move.l	d0,bewaar_zone
	move.l	d1,bewaar_zone+$4
	move.l	d2,bewaar_zone+$8
	move.l	d3,bewaar_zone+$A
	move.l	d4,bewaar_zone+$10
	move.l	d5,bewaar_zone+$14
	move.l	d6,bewaar_zone+$18
	move.l	d7,bewaar_zone+$1a
	move.l	a0,bewaar_zone+$20
	move.l	a1,bewaar_zone+$24
	move.l	a2,bewaar_zone+$28
	move.l	a3,bewaar_zone+$2a
	move.l	a4,bewaar_zone+$30
	move.l	a5,bewaar_zone+$34
	move.l	a6,bewaar_zone+$38
	move.l	sp,bewaar_zone+$3a
	move.w	SR,bewaar_zone+$40
	RTS
zet_even_allerlei:
	move.l	bewaar_zone+$0,d0
	move.l	bewaar_zone+$4,d1
	move.l	bewaar_zone+$8,d2
	move.l	bewaar_zone+$a,d3
	move.l	bewaar_zone+$10,d4
	move.l	bewaar_zone+$14,d5
	move.l	bewaar_zone+$18,d6
	move.l	bewaar_zone+$1a,d7
	move.l	bewaar_zone+$20,a0
	move.l	bewaar_zone+$24,a1
	move.l	bewaar_zone+$28,a2
	move.l	bewaar_zone+$2a,a3
	move.l	bewaar_zone+$30,a4
	move.l	bewaar_zone+$34,a5
	move.l	bewaar_zone+$38,a6
	move.l	bewaar_zone+$3a,sp
	move.w	bewaar_zone+$40,SR
	RTS

user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS

ssp:		dc.l	0
old_sp:		dc.l	0
schermadres:	dc.l	0
OLD_TRAP:	dc.l	0
counter:	dc.w	0
bewaar_zone	ds.l	20
stack:		ds.l	100
stack_:
