AANTSTAR	EQU	300
	bsr	schermadr_opvraag
	bsr	fullcls
	bsr	sup_vis_mode
	bsr	set_colors
back:
	move.w	#$100,$ff8240
	bsr	do_plot
	move.w	#$000,$ff8240
	bsr	vsync
	bsr	clear_stars
	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back

	bsr	user_mode
	clr.l	-(sp)
	trap	#1

do_plot:
	move.l	#tabel1,a1
	move.l	#xzarray,a2
	move.l	#yzarray,a3
	move.l	#points3d,a4
	move.l	#removebuff,a5
	move.l	schermadres,a0
	move.w	#AANTSTAR-1,d7
plot_loop:
	; d0 - x	
	; d1 - y
	; d2 - diepte

	move.w	(a4),d0   ; 1e word +1.w
	move.w	4(a4),d2   ; 2e word +1.w
	move.w	2(a4),d1    ; 3e word
	add.w	6(a4),d1   ; 4e
	and.w	#127,d1
	move.w	d1,2(a4)
	add.w	#8,a4      ; +2 words  +2.w

	move.w	d2,d5
	asr.w	#5,d5
	asl.w	#1,d5

	move.w	d2,d3
	asl.w	#1,d3
	move.w	d0,d4
	asl.w	#8,d4
	add.w	d4,d3

	move.w	(a2,d3.w),d3
	tst.w	d3
	beq.s	no_plot
	asl.w	#2,d3
	add.w	(a1,d3.w),d5
	move.w	2(a1,d3.w),d6


	move.w	d2,d3
	asl.w	#1,d3
	move.w	d1,d4
	asl.w	#8,d4
	add.w	d4,d3

	move.w	(a3,d3.w),d3
	tst.w	d3
	beq.s	no_plot
	mulu.w	#160,d3
	add.w	d3,d5

	bset	d6,(a0,d5.w)
no_plot:
	move.w	d5,(a5)+
	dbra	d7,plot_loop
	RTS




clear_stars:
	move.l	schermadres,a0
	move.l	#removebuff,a1
	move.w	#AANTSTAR-1,d1
rem_stars:
	move.w	(a1)+,d0
	clr.w	(a0,d0.w)
	dbra	d1,rem_stars
	RTS





vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS

schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
cls:
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	schermadres,a0
	move.l	#200-1,d0
go_cls:
pl set 0
	REPT	20
	clr.w	pl(a0)
pl set pl+8
	ENDR
	add.w	#160,a0
	dbra d0,go_cls
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
fullcls:
	move.l	schermadres,a0
	move.l	#32000/4/4-1,d0
go_cls2:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls2
	RTS
set_colors:
STARCOL1 EQU	$222
STARCOL2 EQU	$444
STARCOL3 EQU	$555
STARCOL4 EQU	$777
	move.w	#$000,$ff8240
	move.w	#STARCOL1,$ff8242
	move.w	#STARCOL2,$ff8244
	move.w	#STARCOL2,$ff8246
	move.w	#STARCOL3,$ff8248
	move.w	#STARCOL3,$ff824A
	move.w	#STARCOL3,$ff824C
	move.w	#STARCOL3,$ff824E
	move.w	#STARCOL4,$ff8250
	move.w	#STARCOL4,$ff8252
	move.w	#STARCOL4,$ff8254
	move.w	#STARCOL4,$ff8256
	move.w	#STARCOL4,$ff8258
	move.w	#STARCOL4,$ff825A
	move.w	#STARCOL4,$ff825C
	move.w	#$777,$ff825E
	RTS
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS

xzarray:	INCBIN	'F:\PROGRAMM\ALL_DATA\XZ_ARRAY.DAT'
yzarray:	INCBIN	'F:\PROGRAMM\ALL_DATA\YZ_ARRAY.DAT'
ssp:		dc.l	0
schermadres:	dc.l	0
SPEQ	EQU	1
points3d:
	INCBIN	'F:\PROGRAMM\ALL_DATA\POINT127.DAT'
removebuff:
	REPT	AANTSTAR
	dc.w	0
	ENDR
tabel1:
pl set 0
	REPT	40
	dc.w	pl,7
	dc.w	pl,6
	dc.w	pl,5
	dc.w	pl,4
	dc.w	pl,3
	dc.w	pl,2
	dc.w	pl,1
	dc.w	pl,0
	dc.w	pl+1,7
	dc.w	pl+1,6
	dc.w	pl+1,5
	dc.w	pl+1,4
	dc.w	pl+1,3
	dc.w	pl+1,2
	dc.w	pl+1,1
	dc.w	pl+1,0
pl set pl+8
	ENDR



