;  *****************************************  ;
; *                                         * ;
; *   C O D E D   B Y                       * ;
; *                                         * ;
; *              ___     ___                * ;
; * EXECUTE OF    |  | | |                  * ;
; *               |  |-| |-                 * ;
; *               |  | | |__                * ;
; * ___     __  ___ __    ___      _  ___   * ;
; * |   \ / | | |   | | | |   | | / \ |     * ;
; * |-   X  |-' |-  |-' | |-  |\| |   |-    * ;
; * |__ / \ |   |__ | | | |__ | | \__ |__   * ;
; *                                         * ;
; *                                         * ;
;  *****************************************  ;
;
; HI ! THIS IS XQT(EXECUTE) OF 
; THE EXPERIENCE. THIS PROGRAMM SHOWS
; A SIMPLE (BUT OK!) PLATFORM-GAME.
; TECNIQUES:
;   - 4 PLANES PRE-SHIFTED FOREGROUND
;   - 2 PLANES PRE-SHIFTED BACKGROUND
;   -/|\ (6)PLANES + 2  ->   SPRITES
;     |
;
; IF YOU USE THE SOURCE:
;
;  SEND 15 GUILDERS TO THIS ADDRESS:
;  SPINOZALAAN 18
;  HAREN,THE NETHERLANDS
;
; --- HAVE FUN WITH IT ! ---


mousevec	EQU	16
joyvec		EQU	24

ikbdws		EQU	25
kbdvec		EQU	34
aantblok_cop	EQU	42
aantblok_back	EQU	31

unusedcop	EQU	2*(3*20)  ; 20 op veld 3*20 niet
unusedvoor	EQU	2*(1*20)  ; 20 op veld 1*20 niet
unusedback	EQU	2*(1*20)  ; 20 op veld 1*20 niet

;- INIT -

	bsr	sup_vis_mode
	bsr	save_colors
	bsr	schermadr_opvraag
	bsr	install_mo_jo
	bsr	cls
	bsr	fade_out
	bsr	precalveld_back
	bsr	precalveld_cop
	bsr	precalveld_voor
	bsr	do_shift_voor
	bsr	do_shift_back
	bsr	last_init
	bsr	set_colors
;************************************
;------------------------------------
;------------------------------------
;************************************


back:
	clr.w	d0
	move.b	jpacket+2,d0

	move.b	d0,d1
	and.w	#1,d1
	tst.w	d1
	beq.s	not_up
	sub.w	#1,duck
not_up
	move.b	d0,d1
	and.w	#2,d1
	tst.w	d1
	beq.s	not_down
	add.w	#1,jump
not_down
	move.b	d0,d1
	and.w	#4,d1
	tst.w	d1
	beq.s	not_left
	sub.w	#2,speedx
not_left
	move.b	d0,d1
	and.w	#8,d1
	tst.w	d1
	beq.s	not_right
	add.w	#2,speedx
not_right

	move.w	speedx,d0
	add.w	#100,d0

	cmp.w	#99,d0
	bhi.s	speed_limit_3
	add.w	#1,d0
speed_limit_3

	cmp.w	#101,d0
	blo.s	speed_limit_4
	sub.w	#1,d0
speed_limit_4

	cmp.w	#108,d0
	blo.s	speed_limit_1
	move.w	#108,d0
speed_limit_1

	cmp.w	#92,d0
	bhi.s	speed_limit_2
	move.w	#92,d0
speed_limit_2

	sub.w	#100,d0
	move.w	d0,speedx

	add.w	#32*4,d0
	asr.w	#2,d0
	move.w	d0,screenx
	RTS:



;---------------------------;
;*** SLOW DOWN EVERY VBL ***;
;---------------------------;

; IF mx>32+2 THEN mx=mx-2

;	cmp.w	#32+3,screenx
;	blo	lower_34
;	sub.w	#3,screenx
;	bra	endif1

;lower_34:

; IF mx<32-2 THEN mx=mx+2

;	cmp.w	#32-3,screenx
;	bhi	higher_30
;	add.w	#3,screenx
;	bra	endif1

;higher_30:

;	move.w	#32,screenx
; ELSE

;endif1:


;-------------------;
;*** NOT TO FAST ***;
;-------------------;

;	cmp.w	#16,screenx
;	bhi	not_16
;	move.w	#16,screenx
;not_16:
;	cmp.w	#47,screenx
;	blo	not_47
;	move.w	#47,screenx
;not_47:

;------------;
;*** NEWX ***;
;------------;

	move.w	screenx,d0
	add.w	d0,cntrx
	sub.w	#32,cntrx ; centrate


;----------------------------;
;*** NOT OUT OF PLAYFIELD ***;
;----------------------------;

	tst	cntrx
	bpl	not_negative
	move.w	#0,cntrx
not_negative:
	cmp.w	#16*2*30-1,cntrx
	blo	not_negativ1
	move.w	#16*2*30-1,cntrx
not_negativ1:

;---------------------;
;*** UPDATE SCREEN ***;
;---------------------;

	move.w	cntrx,d0
	mulu	#6,d0  ; *6
	asr.w	#2,d0  ; /4
	move.w	d0,cntrx2
	move.w	cntrx,d0
	divu	#3,d0  ; /3
	move.w	d0,cntrx3

;	move.l	#$50000000,$ff9800
	bsr	cop
;	move.l	#$70000000,$ff9800
	bsr	voorcop
;	move.l	#$50000000,$ff9800
	bsr	backcop
;	move.l	#$00000000,$ff9800

	bsr	vsync

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back


;- LEAVE -
	bsr	cls
	bsr	fade_in
	bsr	rest_colors
	bsr	restore_mo_jo
	bsr	user_mode
	clr.l	-(sp)
	trap	#1


;************************************
;------------------------------------
;------------------------------------
;************************************


;	SUBROUTINES    !!!!!
;-------------------------------
last_init:
	move.w	#32,screenx
	RTS
;-------------------------
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
;-------------------------
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
;-------------------------
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
;-------------------------
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
;-------------------------
cls:
	move.l	#(320*200)/4/4-1,d0
	move.l	schermadres,a0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS
;-------------------------
cop:
	move.l	schermadres,a1
	move.l	#tabel2,a2
	move.l	#kijkveld,a3
	move.l	#shiftpic_voor,a4

	move.w	cntrx,d0
	and.w	#15,d0
	mulu	#aantblok_cop*16*8,d0
	add.l	d0,a4

	clr.l	d0
	move.w	cntrx,d0
	asr.w	#4,d0
	asl.w	#1,d0
	add.w	d0,a3

	move.w	#11-1,d6
lus2:
	move.w	#20-1,d7
lus:
	move.w	(a3)+,d0
	tst.w	d0
	beq	skipcop
	move.l	a4,a0
	sub.w	#128,d0
	add.w	d0,a0
ad set 0
	REPT	16
	move.l	ad*8(a0),ad*320(a1)
	move.l	ad*8+4(a0),ad*320+4(a1)
ad set ad+1
	ENDR
skipcop:
	add.w	(a2)+,a1
	dbra	d7,lus
	add.w	#unusedcop,a3
	dbra	d6,lus2
	RTS
;-------------------------
voorcop:
	move.l	schermadres,a1
	add.w	#8,a1
	move.l	#tabel2,a2
	move.l	#voorveld,a3
	move.l	#shiftpic_back,a4

	move.w	cntrx2,d0
	and.w	#15,d0
	mulu	#aantblok_back*16*4,d0
	add.l	d0,a4

	clr.l	d0
	move.w	cntrx2,d0
	asr.w	#4,d0
	asl.w	#1,d0
	add.w	d0,a3

	move.w	#11-1,d6
lus2b:
	move.w	#20-1,d7
lusb:
	move.w	(a3)+,d0
	tst.w	d0
	beq	skipcop2
	move.l	a4,a0
	sub.w	#64,d0
	add.w	d0,a0
ad set 0
	REPT	16
	move.l	ad*4(a0),ad*320(a1)
ad set ad+1
	ENDR
skipcop2:
	add.w	(a2)+,a1
	dbra	d7,lusb
 	add.w	#unusedvoor,a3
	dbra	d6,lus2b
	RTS
;-------------------------
backcop:
	move.l	schermadres,a1
	add.w	#12,a1
	move.l	#tabel2,a2
	move.l	#backveld,a3
	move.l	#shiftpic_back,a4

	move.w	cntrx3,d0
	and.w	#15,d0
	mulu	#aantblok_back*16*4,d0
	add.l	d0,a4

	clr.l	d0
	move.w	cntrx3,d0
	asr.w	#4,d0
	asl.w	#1,d0
	add.w	d0,a3

	move.w	#11-1,d6
lus2c:
	move.w	#20-1,d7
lusc:
	move.w	(a3)+,d0
	tst.w	d0
	beq	skipcop3
	move.l	a4,a0
	sub.w	#64,d0
	add.w	d0,a0
ad set 0
	REPT	16
	move.l	ad*4(a0),ad*320(a1)
ad set ad+1
	ENDR
skipcop3:
	add.w	(a2)+,a1
	dbra	d7,lusc
 	add.w	#unusedback,a3
	dbra	d6,lus2c
	RTS
;-------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
;-------------------------
install_mo_jo:
	move.w	#kbdvec,-(sp) ; parameter
	trap	#14	      ; naar MO & JO
	addq.l	#2,a7

	move.l	d0,a0
	move.l	d0,save_old_base

	lea	mo_handler,a1
	lea	jo_handler,a2

	move.l	mousevec(a0),save_old_mvec
	move.l	a1,mousevec(a0)
	move.l	joyvec(a0),save_old_jvec
	move.l	a2,joyvec(a0)

; Muis aan : OUT 2,8
	pea	ikbdstring
	move.w	#0,-(sp)
	move.w	#ikbdws,-(sp)
	trap	#14
	addq.l	#8,sp
	RTS
;-------------------------------
restore_mo_jo:
	move.l	save_old_base,a0
	move.l	save_old_mvec,d0
	move.l	d0,mousevec(a0)
	move.l	save_old_jvec,d0
	move.l	d0,joyvec(a0)
	move.w	#0,-(sp)
	trap	#1
	RTS
;-------------------------------
jo_handler:
	lea	jpacket,a1
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	RTS
;-------------------------------
mo_handler:
	lea	mpacket,a1
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
;(x)
	clr.w	d0
	move.b	mpacket+1,d0
	ext.w	d0
	add.w	d0,screenx
;(y)
	clr.w	d0
	move.b	mpacket+2,d0
	ext.w	d0
	add.w	d0,screeny

	RTS
;-------------------------
save_colors:
	move.l	#$ffff9800,a0
	move.l	#old_palette,a1
	move.w	#255,d0
save_cloop:
	move.l	(a0)+,(a1)+
	dbra	d0,save_cloop
	RTS
;-------------------------
rest_colors:
	move.l	#old_palette,a0
	move.l	#$ffff9800,a1
	move.w	#255,d0
rest_cloop:
	move.l	(a0)+,(a1)+
	dbra	d0,rest_cloop
	RTS
;-------------------------
set_colors:
	move.l	#new_palette,a0
	move.l	#$ffff9800,a1
	move.w	#255,d0
set_cloop:
	move.l	(a0)+,(a1)+
	dbra	d0,set_cloop
	RTS
;-------------------------
fade_out:
	move.w	#$F,d7
do_fade:
	move.w	d7,d6
	asl.w	#4,d6

	move.w	d6,d5
	asl.w	#8,d6
	or.w	d6,d5

	swap	d5
	asr.w	#8,d6
	move.w	d6,d5

	move.l	d5,$ff9800
	bsr	vsync
	dbra	d7,do_fade
	move.l	#$00000000,$ff9800
	RTS
;-------------------------
fade_in:
	move.w	#$F,d7
do_fade2:
	move.w	#$F,d6
	sub.w	d7,d6
	asl.w	#4,d6

	move.w	d6,d5
	asl.w	#8,d6
	or.w	d6,d5

	swap	d5
	asr.w	#8,d6
	move.w	d6,d5

	move.l	d5,$ff9800
	bsr	vsync
	dbra	d7,do_fade2
	move.l	#$ffff00ff,$ff9800
	RTS
;-------------------------
do_shift_voor:
	move.l	#shiftpic_voor,a1
	move.l	#16-1,d6

shiftlus2:
	move.l	#tabel1,a3
	move.l	#blokpic+34,a0
	move.l	#aantblok_cop-1,d7

shiftlus:
ad set 0
	REPT	16
	move.l	ad*160(a0),d0
	move.w	d0,d2 ;pl2->d2.r
	swap	d0
	move.w	d0,d1 ;pl1->d1.r

	move.l	ad*160+4(a0),d0
	move.w	d0,d4 ;pl2->d2.r
	swap	d0
	move.w	d0,d3 ;pl1->d1.r

	swap	d1 ;r=l,l=r
	swap	d2
	swap	d3
	swap	d4

	move.l	ad*160+8(a0),d0
	move.w	d0,d2 ;pl2->d2.r
	swap	d0
	move.w	d0,d1 ;pl1->d1.r

	move.l	ad*160+12(a0),d0
	move.w	d0,d4 ;pl2->d2.r
	swap	d0
	move.w	d0,d3 ;pl1->d1.r

	asr.l	d6,d1
	asr.l	d6,d2
	asr.l	d6,d3
	asr.l	d6,d4

	move.w	d1,d0
	swap	d0
	move.w	d2,d0
	move.l	d0,ad*8(a1)

	move.w	d3,d0
	swap	d0
	move.w	d4,d0
	move.l	d0,ad*8+4(a1)
ad set ad+1
	ENDR

	add.l	#16*8,a1
	add.w	(a3)+,a0
	add.w	(a3)+,a0
	dbra	d7,shiftlus
	dbra	d6,shiftlus2
	RTS
;-------------------------
precalveld_cop:
	move.l	#kijkveld,a0
	move.l	#kijkveldlen/2-1,d0
veldlus:
	move.w	(a0),d1
	add.w	#1,d1
	mulu	#128,d1
	move.w	d1,(a0)+
	dbra	d0,veldlus
	RTS
;-------------------------
precalveld_back:
	move.l	#backveld,a0
	move.l	#backveldlen/2-1,d0
veldlus2:
	move.w	(a0),d1
	add.w	#1,d1
	mulu	#64,d1
	move.w	d1,(a0)+
	dbra	d0,veldlus2
	RTS
;-------------------------
precalveld_voor:
	move.l	#voorveld,a0
	move.l	#voorveldlen/2-1,d0
veldlus3:
	move.w	(a0),d1
	add.w	#1,d1
	mulu	#64,d1
	move.w	d1,(a0)+
	dbra	d0,veldlus3
	RTS
;-------------------------
do_shift_back:
	move.l	#shiftpic_back,a1
	move.l	#16-1,d6

shiftlus4:
	move.l	#tabel1,a3
	move.l	#backpic+34,a0
	move.l	#aantblok_back-1,d7

shiftlus3:
ad set 0
	REPT	16
	move.l	ad*160(a0),d0
	move.w	d0,d2 ;pl2->d2.r
	swap	d0
	move.w	d0,d1 ;pl1->d1.r

	swap	d1 ;r=l,l=r
	swap	d2

	move.l	ad*160+8(a0),d0
	move.w	d0,d2 ;pl2->d2.r
	swap	d0
	move.w	d0,d1 ;pl1->d1.r

	asr.l	d6,d1
	asr.l	d6,d2

	move.w	d1,d0
	swap	d0
	move.w	d2,d0
	move.l	d0,ad*4(a1)

ad set ad+1
	ENDR

	add.l	#16*4,a1
	add.w	(a3)+,a0
	add.w	(a3)+,a0
	dbra	d7,shiftlus3
	dbra	d6,shiftlus4
	RTS

;	VARIABELEN
;-----------------------------------
schermadres:	dc.l	0
ssp:		dc.l	0
jump:	dc.w	0
duck:	dc.w	0
speedx:	dc.w	0
cntrx:		dc.w	0
cntrx2:		dc.w	0
cntrx3:		dc.w	0
ikbdstring	dc.b	$8
mpacket		ds.b	3
jpacket		ds.b	3
save_old_mvec	ds.l	1
save_old_jvec	ds.l	1
save_old_base	ds.l	1
old_palette:	ds.l	256
new_palette:
col1	set	0
col2	set	0
colv1	set	$D0F000D0
colv2	set	$30C00030
colv3	set	$00800000
pl set 0
	REPT	4

	dc.w	col1,col2
	dc.l	          $C0600000,$E0A00000,$E0E00000
	dc.l	$60000000,$00600000,$00A00000,$00E00000
	dc.l	$A0000000,$60600060,$A0A000A0,$E0E000E0
	dc.l	$E0000000,$000000E0,$C0C000C0,$00E000E0
	dc.l	colv1,colv1,colv1,colv1
	dc.l	colv1,colv1,colv1,colv1
	dc.l	colv1,colv1,colv1,colv1
	dc.l	colv1,colv1,colv1,colv1
	dc.l	colv2,colv2,colv2,colv2
	dc.l	colv2,colv2,colv2,colv2
	dc.l	colv2,colv2,colv2,colv2
	dc.l	colv2,colv2,colv2,colv2
	dc.l	colv3,colv3,colv3,colv3
	dc.l	colv3,colv3,colv3,colv3
	dc.l	colv3,colv3,colv3,colv3
	dc.l	colv3,colv3,colv3,colv3
pl set 0
col1 set col1+$2020
col2 set col2+$0020
	ENDR
;	ds.l	256-64

screenx:	dc.w	0
screeny:	dc.w	0

kijkveld:	
	REPT	2
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	ENDR
	dc.w	-1,-1, 0, 1, 3, 3, 3, 3, 2, 0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	dc.w	 4, 5, 6, 6, 7, 8, 0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 0, 4, 5, 6, 6
	dc.w	 6,10,11, 0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 0,23,17,22,22
	dc.w	22,12,13, 0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	dc.w	26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,29,30,22,22
	dc.w	22,14,15,16, 0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	dc.w	24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,28,31,22,22
	dc.w	22,22,18,19,20,21, 0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	REPT	600
	dc.w	3
	ENDR
kijkveldend:
kijkveldlen	EQU	kijkveldend-kijkveld

backveld:
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 0,13,14,15,16, 0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 0, 9,10,11,12, 0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 5, 6, 7, 8, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1
	dc.w	17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17
	dc.w	18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

backveldend:
backveldlen	EQU	backveldend-backveld

voorveld:
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 0, 0,27,28,29,30, 0, 0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 0, 0,19,20,21,22,23,24, 0, 0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 0, 0,19,20,21,21,21,22,23,24, 0, 0, 0,27,28,29,30, 0, 0,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 0, 0,19,20,21,25,26,21,21,22,23,24, 0,19,20,21,22,23,24, 0, 0,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

voorveldend:
voorveldlen	EQU	voorveldend-voorveld

tabel1:
	REPT	13
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8+160*15
	ENDR
tabel2:
	REPT	13
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16+320*15
	ENDR
blokpic:
	INCBIN	"F:\PROGRAMM\JMP\JMPBLOK.PI1"
backpic:
	INCBIN	"F:\DRAW\PICTURES\PI1'S\BAN_BACK.PI1"

; 4pl->8
; 16h->16
; 16x->16 *
;      --
;      2048

shiftpic_voor:	ds.l	aantblok_cop*2048
shiftpic_back:	ds.l	aantblok_back*1024



; END 
