	bsr	sup_vis_mode
	bsr	save_colors
	bsr	schermadr_opvraag
	bsr	copy
	move.l	#plaatje+2,a0
	bsr	go_colors
	bsr	pal_save
	bsr	wacht_toets
;------
	bsr	go_my_fade
;------
	bsr	load_colors
	bsr	user_mode
; LEAVE
	clr.l	-(sp)
	trap	#1

;-------------------------------
go_my_fade:
	move.w	#16-1,d7
pal_fade:
	move.l	#my_palette,a0
	bsr	go_colors

	move.l	#my_palette,a0
	move.w	#16-1,d6
elke_kleur:

	move.w	(a0),d0
	move.w	d0,d1
	and.w	#$0007,d1
	tst.w	d1
	beq.s	niet_aftrekken_voor_blauw
	sub.w	#$0001,d0
niet_aftrekken_voor_blauw:

	move.w	d0,d1
	and.w	#$0070,d1
	tst.w	d1
	beq.s	niet_aftrekken_voor_groen
	sub.w	#$0010,d0
niet_aftrekken_voor_groen:

	move.w	d0,d1
	and.w	#$0700,d1
	tst.w	d1
	beq.s	niet_aftrekken_voor_rood
	sub.w	#$0100,d0
niet_aftrekken_voor_rood:
	move.w	d0,(a0)+

	dbra	d6,elke_kleur
	bsr	vsync
	dbra	d7,pal_fade
	RTS
;-------------------------------
save_colors:
	move.l	#$ff8240,a0
	move.l	#old_pal,a1
	REPT	16
	move.w	(a0)+,(a1)+
	ENDR
	RTS
;-------------------------------
load_colors:
	move.l	#old_pal,a0
	move.l	#$ff8240,a1
	REPT	16
	move.w	(a0)+,(a1)+
	ENDR
	RTS
;-------------------------------
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS

;-------------------------------
copy:
	move.l	#plaatje+34,a0
	move.l	schermadres,a1
	move.w	#32000/4/4-1,d0
copy_lus:
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	dbra	d0,copy_lus
	RTS
;-------------------------------
pal_save:
	move.l	#plaatje+2,a0
	move.l	#my_palette,a1
	move.w	#8-1,d0
go_col_pal:
	move.l	(a0)+,(a1)+
	dbra	d0,go_col_pal
	RTS
;-------------------------------
go_colors:
	move.l	#$ff8240,a1
	move.w	#8-1,d0
go_col_lus:
	move.l	(a0)+,(a1)+
	dbra	d0,go_col_lus
	RTS
;-------------------------------
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
;-------------------------------
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
;-------------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
;-------------------------------
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
;-------------------------------
plaatje:	INCBIN "F:\DRAW\PICTURES\pi1's\THUNDERD.pi1"
schermadres:	dc.l	0
ssp:		dc.l	0
my_palette:	ds.w	16
old_pal:	ds.w	16