SHOW	EQU	2

	bsr	schermadr_opvraag
	bsr	sup_vis_mode
	move.l	#screen2,schermadres2
	add.l	#256,schermadres2
	and.l	#$FFFFFF00,schermadres2
	bsr	cls_all
back:
	bsr	beeld_change
	bsr	animate
	bsr	vsync

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back

	bsr	user_mode
	clr.l	-(sp)
	trap	#1


;********************************
;*	SUBROUTINES    !!!!!	*
;********************************

;-------------------------
animate:
	add.w	#1,grad

	move.l	#bigsinus+1024*5,a0
	move.l	schermadres,a1
	add.w	#1280,a1

	move.w	grad,d0
	asl.w	#1,d0
	and.w	#511,d0
	move.w	(a0,d0.w),d1

	add.w	#180,d0
	and.w	#511,d0
	move.w	(a0,d0.w),d2

	asl.w	#1,d1
	move.w	#0*2048+63*32+31*1,(a1,d1.w)
	RTS
;-------------------------
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS

;-------------------------
beeld_change:
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	move.l	schermadres2,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2
	RTS

;-------------------------
wacht_toets:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
;-------------------------
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
;-------------------------
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
;-------------------------
cls_all:
	move.l	#128000/4/4-1,d0
	move.l	schermadres,a0
go_cls_all:
	clr.l	(a0)+ 
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls_all

	move.l	#128000/4/4-1,d0
	move.l	schermadres2,a0
go_cls_all2:
	clr.l	(a0)+ 
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls_all2
	RTS
;-------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
;-------------------------
wacht_lusje:
	move.l	#16000,d0
wachtlus	nop
	dbra	d0,wachtlus
	RTS
;-------------------------
	
;	VARIABELEN
;-----------------------------------
schermadres:	dc.l	0
schermadres2:	dc.l	0
grad:	dc.w	0
ssp:		dc.l	0
screen2:	ds.b	128256
bigsinus:	INCBIN	'F:\PROGRAMM\ALL_DATA\BSIN_VAR.DAT'
