R	EQU	2^8
G	EQU	2^16
B	EQU	1
SHOW	EQU	2

	bsr	schermadr_opvraag
	bsr	cls_all

	bsr	sup_vis_mode
	bsr	save_colors
	bsr	set_colors

	bsr	vsync
	move.l	#screen2,schermadres2
	add.l	#256,schermadres2
	and.l	#$FFFFFF00,schermadres2
back:
	bsr	beeld_change
	bsr	cls
	bsr	animate
	bsr	vsync

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back
end:

	bsr	save_colors
	bsr	user_mode

	clr.l	-(sp)
	trap	#1


;********************************
;*	SUBROUTINES    !!!!!	*
;********************************

;-------------------------
animate:
	add.w	#1,animteller
	cmp.w	#60,animteller
	bne.s	not_reset
	move.w	#0,animteller
not_reset:
	cmp.w	#54,animteller
	blo	go_1
	move.l	#subzgra0,a0
	bra	endif
go_1:
	cmp.w	#48,animteller
	blo	go_2
	move.l	#subzgra1,a0
	bra	endif
go_2:
	cmp.w	#42,animteller
	blo	go_3
	move.l	#subzgra2,a0
	bra	endif
go_3:
	cmp.w	#36,animteller
	blo	go_4
	move.l	#subzgra3,a0
	bra	endif
go_4:
	cmp.w	#30,animteller
	blo	go_5
	move.l	#subzgra4,a0
	bra	endif
go_5:
	cmp.w	#24,animteller
	blo	go_6
	move.l	#subzgra5,a0
	bra	endif
go_6:
	cmp.w	#18,animteller
	blo	go_7
	move.l	#subzgra4,a0
	bra	endif
go_7:
	cmp.w	#12,animteller
	blo	go_8
	move.l	#subzgra3,a0
	bra	endif
go_8:
	cmp.w	#6,animteller
	blo	go_9
	move.l	#subzgra2,a0
	bra	endif
go_9:
	cmp.w	#0,animteller
	blo	go_10
	move.l	#subzgra1,a0
	bra	endif
go_10:
	move.l	#subzgra1,a0
	endif:
	bsr	copy_it

	RTS
;-------------------------
copy_it:
	move.l	schermadres,a1
	add.w	#144+80*320,a1
	move.w	#110-1,d0
copy_y:
pl set 0
	REPT	5
	move.w	pl*2(a0),pl*16(a1)
	move.w	pl*2+10(a0),pl*16+2(a1)
	move.w	pl*2+20(a0),pl*16+4(a1)
	move.w	pl*2+30(a0),pl*16+6(a1)
	move.w	pl*2+40(a0),pl*16+8(a1)
pl set pl+1
	ENDR
	add.w	#80,a0
	add.w	#320,a1
	dbra	d0,copy_y
	RTS
;-------------------------
do_it:
;	move.w	#4,-(sp)
;	trap	#14
;	addq	#2,sp
;	move.l	schermadres,a0
;	move.l	d0,8000(a0)
	RTS
;-------------------------
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS

;-------------------------
beeld_change:
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	move.l	schermadres2,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2
	RTS

;-------------------------
wacht_toets:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
;-------------------------
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
;-------------------------
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
;-------------------------
cls:
	move.l	#200-1,d0
	move.l	schermadres,a0
go_cls:

pl set 0
	REPT	20
	clr.l	pl(a0)
	clr.l	pl+4(a0)
pl set pl+8
	ENDR
	add.w	#160,a0
	dbra d0,go_cls
	RTS
;-------------------------
cls_all:
	move.l	#64000/4/4-1,d0
	move.l	schermadres,a0
go_cls_all:
	clr.l	(a0)+ 
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls_all
	RTS
;-------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
;-------------------------
save_colors:
	move.l	#$ff9800,a0
	move.l	#oldpal,a1
	move.w	#255,d0
	move.l	(a0)+,(a1)+
go_save:
	dbra	d0,go_save
	RTS
;-------------------------
set_colors:
	move.l	#newpal,a0
	move.l	#$ff9800,a1
	move.w	#100,d0
go_set:
	move.l	(a0)+,(a1)+
	dbra	d0,go_set
	RTS
;-------------------------
load_colors:
	move.l	#oldpal,a0
	move.l	#$ff9800,a1
	move.w	#255,d0
go_load:
	move.l	(a0)+,(a1)+
	dbra	d0,go_load
	RTS
;-------------------------
wacht_lusje:
	move.l	#16000,d0
wachtlus	nop
	dbra	d0,wachtlus
	RTS
;-------------------------
	
;	VARIABELEN
;-----------------------------------
schermadres:	dc.l	0
schermadres2:	dc.l	0
ssp:		dc.l	0
animteller:	dc.w	0
screen2:	ds.b	64256
oldpal:	ds.l	256
newpal:	
	dc.l	$FFFF00FF
	dc.l	$FFFF00FF
	dc.l	$FFFF00FF
	dc.l	$FFFF00FF
	dc.l	$FFFF00FF
	dc.l	$FFFF00FF
	dc.l	$FFFF00FF
	dc.l	((98*256/100)*256+(95*256/100))*65536+(80*256/100)
	dc.l	((52*256/100)*256+(93*256/100))*65536+(99*256/100)
	dc.l	((52*256/100)*256+(80*256/100))*65536+(96*256/100)
	dc.l	((33*256/100)*256+(80*256/100))*65536+(99*256/100)
	dc.l	((18*256/100)*256+(68*256/100))*65536+(96*256/100)
	dc.l	((43*256/100)*256+(61*256/100))*65536+(74*256/100)
	dc.l	((24*256/100)*256+(61*256/100))*65536+(77*256/100)
	dc.l	((11*256/100)*256+(55*256/100))*65536+(80*256/100)
	dc.l	((11*256/100)*256+(52*256/100))*65536+(64*256/100)
	dc.l	((2*256/100)*256+(43*256/100))*65536+(64*256/100)
	dc.l	((11*256/100)*256+(43*256/100))*65536+(55*256/100)
	dc.l	((21*256/100)*256+(36*256/100))*65536+(43*256/100)
	dc.l	((5*256/100)*256+(30*256/100))*65536+(43*256/100)

	dc.l	((99*256/100)*256+(83*256/100))*65536+(64*256/100)
	dc.l	((89*256/100)*256+(61*256/100))*65536+(43*256/100)
	dc.l	((74*256/100)*256+(49*256/100))*65536+(30*256/100)
	dc.l	((64*256/100)*256+(39*256/100))*65536+(24*256/100)
	dc.l	((55*256/100)*256+(33*256/100))*65536+(18*256/100)
	dc.l	((39*256/100)*256+(18*256/100))*65536+(5*256/100)

	dc.l	((46*256/100)*256+(46*256/100))*65536+(46*256/100)
	dc.l	((36*256/100)*256+(36*256/100))*65536+(36*256/100)
	dc.l	((27*256/100)*256+(27*256/100))*65536+(27*256/100)
	dc.l	$00000000
	dc.l	$40400030
	dc.l	$FFFF00FF
	REPT	256
	dc.l	0
	ENDR
subzgra0:	INCBIN	'F:\DRAW\ANIMATIE\SUBZER0.GRA' ;8800 lang
subzgra1:	INCBIN	'F:\DRAW\ANIMATIE\SUBZER1.GRA'
subzgra2:	INCBIN	'F:\DRAW\ANIMATIE\SUBZER2.GRA'
subzgra3:	INCBIN	'F:\DRAW\ANIMATIE\SUBZER3.GRA'
subzgra4:	INCBIN	'F:\DRAW\ANIMATIE\SUBZER4.GRA'
subzgra5:	INCBIN	'F:\DRAW\ANIMATIE\SUBZER5.GRA'
