
	bsr	schermadr_opvraag
	bsr	cls_all
	bsr	sup_vis_mode
	bsr	set_colors
	bsr	vsync
	move.l	#screen2,schermadres2
	add.l	#256,schermadres2
	bsr	beeld_change
	bsr	beeld_change

back:
	add.w	#1,coord_cntr
	cmp.w	#197,coord_cntr
	bne.s	not_100
	move.w	#0,coord_cntr
	bra	end
not_100

	move.l	#coord_buff,a0
	move.w	coord_cntr,d0
	cmp.w	#100,d0
	blo.s	not_back
	move.w	#200,d1
	sub.w	d0,d1
	move.w	d1,d0
not_back:
	mulu	#12,d0	; X1,Y1,X2,Y2,X3,Y3.w	
	add.w	d0,a0

	move.l	(a0)+,real_coords
	move.l	(a0)+,real_coords+4
	move.l	(a0)+,real_coords+8


	move.w	#$001,$ff8240

	bsr	clear_where_in_list

	move.w	#$110,$ff8240

	move.l	#real_coords,a0
	move.l	#poly_coords,a1
	move.l	(a0),(a1)
	move.l	4(a0),4(a1)
	bsr	update_old_list

	move.l	#real_coords,a0
	move.l	#poly_coords,a1
	move.l	4(a0),(a1)
	move.l	8(a0),4(a1)
	bsr	update_old_list

	move.l	#real_coords,a0
	move.l	#poly_coords,a1
	move.l	8(a0),(a1)
	move.l	(a0),4(a1)
	bsr	update_old_list


	move.w	#$011,$ff8240

	bsr	do_line

	move.w	#$000,$ff8240

	bsr	vsync
;	bsr	wacht_toets
	bsr	beeld_change
	bsr	cls
	bra	back
end:

	bsr	user_mode

	clr.l	-(sp)
	trap	#1


;********************************
;*	SUBROUTINES    !!!!!	*
;********************************


do_line:
	move.l	#data_list1,a0
	move.l	schermadres,a1
	move.l	#tabel1,a2
;	move.l	#old_list,a3
; 			a4 !!!
	move.l	#tabel3,a5
	move.l	#where_in_list,a6



	move.w	#199,d7
linelus:

	cmp.w	#4,(a6)+	; lijn V niet
	bne	end_line

	move.w	(a0),d0 ;N1
	move.w	2(a0),d1 ;N2

	cmp.w	d0,d1
	beq.s	no_wis

	cmp.w	d0,d1
	bhi	swap_X1_x2
	move.w	d1,d2
	move.w	d0,d1
	move.w	d2,d0
swap_X1_x2:

; (START)
	asl.w	#2,d0 ; in tabel 1 - 2 words !
	asl.w	#2,d1

	add.w	#1280,d1 ; tabel2 !!!!

	move.w	(a2,d0.w),d2 ; bytenr
	move.w	(a2,d1.w),d3 ; tab 2

	move.w	2(a2,d0.w),d0 ; inhoud
	move.w	2(a2,d1.w),d1 ; tab 2


	cmp.w	d2,d3
	bne.s	if_neq

	and.w	d1,d0
	or.w	d0,(a1,d2.w)
	bra	end_line     ; geen fill !!

if_neq:
	or.w	d0,(a1,d2.w) ; zet neer
	or.w	d1,(a1,d3.w)



; de uiteinden zijn al neer gezet !
; d0,d1 vrij!


	move.l	a1,a4	; a4 = screen
	add.w	#8,d2
	add.w	d2,a4


	cmp.w	d2,d3
	beq.s	end_line

	sub.w	d2,d3
	sub.w	#8,d3
	asr.w	#3,d3 ; \8 , no pl. maar lus
lussie:
	or.w	#-1,(a4)
	add.w	#8,a4	; *8 , planes !!
	dbra	d3,lussie

end_line:

; (END)

no_wis:


	add.w	#4,a0	; adressen
	add.w	#160,a1    ; lijn +
	dbra	d7,linelus

	RTS
;-------------------------
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
;-------------------------------
update_old_list:
	move.l	#data_list1,a0
	move.l	#where_in_list,a1
	move.l	#poly_coords,a2



; (a2)  - x nr 1
; 4(a2) - x nr 2
; 2(a2) - y nr 1
; 6(a2) - y nr 2



; DOELEN: - X2 begin ? => X2 eind !!
; ------  - bereken verschil X1,X2
;         - kleinste waarde in d6

;    X1       X2
;   /   =>   /
; X2       X1
;
; X2       X1
;   \   =>   \
;    X1       X2


	move.w	(a2),d0  ; x1
	move.w	4(a2),d1 ; x2

	cmp.w	d0,d1
	bge.s	go_jump

; x1>x2 (staat goed)

	move.w	d1,d6 ;x1 kleinst
	sub.w	d1,d0
	move.w	d0,d3
	bra	end_jump

go_jump:
; x2>x1 (staat verkeerd)

	move.w	d0,d6 ;x2 kleinst
	sub.w	d0,d1
	move.w	d1,d3
	; SWAP !
	move.w	(a2),d7
	move.w	4(a2),(a2)
	move.w	d7,4(a2)

	move.w	2(a2),d7
	move.w	6(a2),2(a2)
	move.w	d7,6(a2)
end_jump:


; DOEL:  -by Y1>Y2 doe lijnrout1
; ----   -by Y2>Y1 doe lijnrout2
;	-bereken verschil Y1,Y2

	move.w	2(a2),d4  ; y1
	move.w	6(a2),d5 ; y2
	cmp.w	d4,d5
	beq.s	end_jumpy
	cmp.w	d4,d5
	bge.s	go_jumpy

; y1>y2 (lijnrout1)

;  Y1
;    \
;     Y2
	move.w	d4,d0 ; verschil
	sub.w	d5,d0

	add.w	d4,a0 ; kleinste
	add.w	d4,a0 ; erbij
	add.w	d4,a0 ; op tellen !
	add.w	d4,a0
	add.w	d5,a1
	add.w	d5,a1

	sub.w	#1,d0
	move.l	d0,d2 ; BEWAAR D0
;	add.w	d2,a0 ; beneden
;	add.w	d2,a0 ; v/d lijn
;	add.w	d2,a0 ; REPT N
;	add.w	d2,a0 ; -1
updlus2
	move.w	(a1),d4
	move.w	d0,d1
	mulu	d3,d1
	divu	d2,d1
	add.w	d6,d1 ; verschuif x
	move.w	d1,(a0,d4.w)
	sub.w	#4,a0 ; lijn terug
	add.w	#2,(a1)+
	dbra	d0,updlus2

	bra	end_jumpy


go_jumpy:

; y2>y1 (lijnrout2)

;     Y1
;    /
;  Y2
	move.w	d5,d0 ; verschil
	sub.w	d4,d0

	add.w	d4,a0 ; kleinste
	add.w	d4,a0 ; erbij
	add.w	d4,a0 ; op tellen !
	add.w	d4,a0
	add.w	d4,a1
	add.w	d4,a1


	sub.w	#1,d0
	move.l	d0,d2 ; BEWAAR D0
updlus1
	move.w	(a1),d4
	move.w	d0,d1
	mulu	d3,d1
	divu	d2,d1
	add.w	d6,d1 ; verschuif x
	move.w	d1,(a0,d4.w)
	add.w	#4,a0 ; lijn verder
	add.w	#2,(a1)+
	dbra	d0,updlus1

end_jumpy:
	RTS
;-------------------------
beeld_change:
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	move.l	schermadres2,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2
	RTS

;-------------------------
clear_where_in_list:
	move.l	#where_in_list,a0
	move.w	#200-1,d0
clear_where_do:
	clr.w	(a0)+
	dbra	d0,clear_where_do
	RTS
;-------------------------
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
;-------------------------
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
;-------------------------
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
;-------------------------
cls:
	move.l	#200-1,d0
	move.l	schermadres,a0
go_cls:
	REPT	20
	clr.l	(a0)+ ; nr 1
	clr.l	(a0)+
	ENDR
	dbra d0,go_cls
	RTS
;-------------------------
cls_all:
	move.l	#32000/4/4-1,d0
	move.l	schermadres,a0
go_cls_all:
	clr.l	(a0)+ 
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls_all
	RTS
;-------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
;-------------------------
set_colors:
;	move.l	#blokpic+2,a0
;	movem.l	(a0),d0-d7
;	movem.l	d0-d7,$ff8240

	move.w	#$000,$ff8240
	move.w	#$700,$ff8242
	move.w	#$070,$ff8244
	move.w	#$770,$ff8246
	move.w	#$707,$ff825C
	move.w	#$777,$ff825E

	RTS
;-------------------------
wacht_lusje:
	move.l	#16000,d0
wachtlus	nop
	dbra	d0,wachtlus
	RTS
;-------------------------
	
;	VARIABELEN
;-----------------------------------
schermadres:	dc.l	0
schermadres2:	dc.l	0
ssp:		dc.l	0
cntrx:	dc.w	0
jmpbackreg:	dc.l	0
coord_cntr:	dc.w	0


; 20 * 16 * 4.b (2.w!) = 1280 BYTES
tabel1:
ad set 0
	REPT	20
	dc.w	ad,%1111111111111111
	dc.w	ad,%0111111111111111
	dc.w	ad,%0011111111111111
	dc.w	ad,%0001111111111111
	dc.w	ad,%0000111111111111
	dc.w	ad,%0000011111111111
	dc.w	ad,%0000001111111111
	dc.w	ad,%0000000111111111
	dc.w	ad,%0000000011111111
	dc.w	ad,%0000000001111111
	dc.w	ad,%0000000000111111
	dc.w	ad,%0000000000011111
	dc.w	ad,%0000000000001111
	dc.w	ad,%0000000000000111
	dc.w	ad,%0000000000000011
	dc.w	ad,%0000000000000001
ad set ad+8
	ENDR

tabel2:
ad set 0
	REPT	20
	dc.w	ad,%1000000000000000
	dc.w	ad,%1100000000000000
	dc.w	ad,%1110000000000000
	dc.w	ad,%1111000000000000
	dc.w	ad,%1111100000000000
	dc.w	ad,%1111110000000000
	dc.w	ad,%1111111000000000
	dc.w	ad,%1111111100000000
	dc.w	ad,%1111111110000000
	dc.w	ad,%1111111111000000
	dc.w	ad,%1111111111100000
	dc.w	ad,%1111111111110000
	dc.w	ad,%1111111111111000
	dc.w	ad,%1111111111111100
	dc.w	ad,%1111111111111110
	dc.w	ad,%1111111111111111
ad set ad+8
	ENDR

tabel3:
ad set 0
	REPT	20
	dc.w	ad,%0000000000000000
	dc.w	ad,%1000000000000000
	dc.w	ad,%1100000000000000
	dc.w	ad,%1110000000000000
	dc.w	ad,%1111000000000000
	dc.w	ad,%1111100000000000
	dc.w	ad,%1111110000000000
	dc.w	ad,%1111111000000000
	dc.w	ad,%1111111100000000
	dc.w	ad,%1111111110000000
	dc.w	ad,%1111111111000000
	dc.w	ad,%1111111111100000
	dc.w	ad,%1111111111110000
	dc.w	ad,%1111111111111000
	dc.w	ad,%1111111111111100
	dc.w	ad,%1111111111111110
ad set ad+8
	ENDR

tabel4:
ad set 0
	REPT	20
	dc.w	ad,%0111111111111111
	dc.w	ad,%0011111111111111
	dc.w	ad,%0001111111111111
	dc.w	ad,%0000111111111111
	dc.w	ad,%0000011111111111
	dc.w	ad,%0000001111111111
	dc.w	ad,%0000000111111111
	dc.w	ad,%0000000011111111
	dc.w	ad,%0000000001111111
	dc.w	ad,%0000000000111111
	dc.w	ad,%0000000000011111
	dc.w	ad,%0000000000001111
	dc.w	ad,%0000000000000111
	dc.w	ad,%0000000000000011
	dc.w	ad,%0000000000000001
	dc.w	ad,%0000000000000000
ad set ad+8
	ENDR

poly_coords:
	dc.w	0,0
	dc.w	0,0

real_coords:
	dc.w	60,0
	dc.w	10,70
	dc.w	90,16
	dc.w	60,10



data_list1:
	REPT	200
	dc.w	0,2
	ENDR


where_in_list:
	REPT	200
	dc.b	0
	ENDR

coord_buff:	INCBIN 'F:\TRIANGLE.DAT'
screen2:	ds.b	32256








