SHOW	EQU	0

	bsr	schermadr_opvraag
	bsr	cls_all
	bsr	sup_vis_mode
	bsr	set_colors
	bsr	vsync
	move.l	#screen2,schermadres2
	add.l	#256,schermadres2
	bsr	beeld_change
	bsr	beeld_change

back:
	move.w	#$100*SHOW,$ff8240
	bsr	new_x_y_z
	move.w	#$000,$ff8240
	bsr	vsync
	bsr	beeld_change
	bsr	cls

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back
end:

	bsr	user_mode

	clr.l	-(sp)
	trap	#1


;********************************
;*	SUBROUTINES    !!!!!	*
;********************************

;-------------------------
new_x_y_z:
	move.l	#coordsxyz,a0
	move.l	schermadres,a1
	move.l	#zdata,a2
	move.w	#399,d0
do_plot:
	move.l	a1,a3
	add.w	#2,4(a0)
	and.w	#255,4(a0)

	move.w	(a0),d1
	move.w	2(a0),d2

	move.w	4(a0),d3
	move.b	(a2,d3.w),d3
	mulu	d3,d1
	mulu	d3,d2
	asr.w	#8,d1
	asr.w	#8,d2
	and.w	#255,d1
	and.w	#255,d2

	mulu	#80,d1
	asr.w	#6,d1
	mulu	#200,d2
	asr.w	#8,d2

	add.w	#160,d1
	add.w	#100,d2

	move.w	d3,d4
	mulu	#80,d4
	asr.w	#7,d4
	sub.w	d4,d1

	move.w	d3,d4
	mulu	#200,d4
	asr.w	#8,d4
	and.w	#255,d4
	asr.w	#1,d4
	sub.w	d4,d2

	asr.w	#6,d3
	asl.w	#1,d3
	add.w	d3,a3
; plot

	mulu	#160,d2
	add.w	d2,a3

	move.w	d1,d2
	and.w	#$FFF0,d1
	asr.w	#1,d1
	add.w	d1,a3

	and.w	#$000F,d2
	btst	#3,d2
	beq	no_add_8
	add.w	#1,a3
no_add_8:
	not.w	d2
	bset	d2,(a3)

	add.w	#6,a0
	dbra	d0,do_plot
	RTS
;-------------------------
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
;-------------------------
beeld_change:
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	move.l	schermadres2,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2
	RTS

;-------------------------
wacht_toets:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
;-------------------------
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
;-------------------------
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
;-------------------------
cls:
	move.l	#200-1,d0
	move.l	schermadres,a0
go_cls:

pl set 0
	REPT	20
	clr.l	pl(a0)
	clr.l	pl+4(a0)
pl set pl+8
	ENDR
	add.w	#160,a0
	dbra d0,go_cls
	RTS
;-------------------------
cls_all:
	move.l	#32000/4/4-1,d0
	move.l	schermadres,a0
go_cls_all:
	clr.l	(a0)+ 
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls_all
	RTS
;-------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
;-------------------------
set_colors:
;	move.l	#blokpic+2,a0
;	movem.l	(a0),d0-d7
;	movem.l	d0-d7,$ff8240

	move.w	#$000,$ff8240
	move.w	#$333,$ff8242
	move.w	#$444,$ff8244
	move.w	#$444,$ff8246
	move.w	#$555,$ff8248
	move.w	#$555,$ff824A
	move.w	#$555,$ff824C
	move.w	#$555,$ff824E

	move.w	#$777,$ff8250
	move.w	#$777,$ff8252
	move.w	#$777,$ff8254
	move.w	#$777,$ff8256
	move.w	#$777,$ff8258
	move.w	#$777,$ff825A
	move.w	#$777,$ff825C
	move.w	#$777,$ff825E


	RTS
;-------------------------
wacht_lusje:
	move.l	#16000,d0
wachtlus	nop
	dbra	d0,wachtlus
	RTS
;-------------------------
	
;	VARIABELEN
;-----------------------------------
schermadres:	dc.l	0
schermadres2:	dc.l	0
ssp:		dc.l	0
cntrx:	dc.w	0
jmpbackreg:	dc.l	0

coordsxyz:
	INCBIN	'F:\PROGRAMM\STARFLDS\STARGO2.DAT'
zdata:
	INCBIN	'F:\PROGRAMM\STARFLDS\ZDATA.DAT'
screen2:	ds.b	32256
