

; VGA - zoomer in 1 plane
; Gecoded door Mark Ament (XQT/TEC)


DUUR_TE_ZOOMEN	EQU	180

	bsr	sup_vis_mode
	bsr	schermadr_opvraag
	dc.w	$a00a
	bsr	cls

;------------------;
;- BEGIN HOOFDLUS -;
;------------------;

hoofdlus:
; WRAP
	bsr	preset_zoom

	bsr	y_stretch_clear
	bsr	y_calc_stretch
	bsr	y_stretch
	bsr	vsync

	sub.w	#1,zoomteller
	move.w	zoomteller,d0
	tst.w	d0
	bne	no_restore_z
	move.w	#0,zoomlength
	move.w	#DUUR_TE_ZOOMEN,zoomteller

; VOLGENDE
	move.l	#zoomerdata+28,a0
	add.w	zoom_dat_add,a0
	move.w	(a0),d3

	move.w	d3,d1
	mulu	#6,d1
	add.w	#2,d1
	add.w	d1,zoom_dat_add


no_restore_z:

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	hoofdlus
	
;------------------;
;- EINDE HOOFDLUS -;
;------------------;

	dc.w	$a009
	bsr	wacht_toets
	bsr	user_mode
	clr.l	-(sp)
	trap	#1


;  PROCEDURES
;--------------------


preset_zoom:
	move.l	#zoomerdata+28,a0
	add.w	zoom_dat_add,a0
	move.w	(a0),d3
	tst.w	d3
	bne.s	no_wrap_zoom_dat
	move.w	#0,zoom_dat_add
no_wrap_zoom_dat:


	move.l	#zoomdata,a0
	add.w	zoomlength,a0
	move.w	(a0)+,begin_zoomer_x
	move.w	(a0)+,xlengtezoomer
	move.w	(a0)+,begin_zoomer_y
	move.w	(a0)+,ylengtezoomer

	add.w	#8,zoomlength

	bsr	calc_allxes
	move.l	#hlinedata,a2
	move.l	#xzoombuffer,a3
	move.l	#zoomerdata+2+28,a4
	add.w	zoom_dat_add,a4
	move.l	#allxes,a5
	move.l	a3,a0
	bsr	clr_zoom

	move.l	#zoomerdata+28,a0
	add.w	zoom_dat_add,a0
	move.w	(a0),d3
	sub.w	#1,d3

lusje:
	move.l	a2,a1
	move.l	a3,a0

	move.w	(a4)+,d1 ; goede y op uitrekscherm
	mulu	#160,d1
	add.w	d1,a0

	move.w	(a4),d2
	asl.w	#1,d2	; .w in array
	move.w	(a5,d2.w),d2 ; allxes
	and.w	#$0F,d2
	asl.w	#3,d2	;*8
	add.w	d2,a1

	move.w	(a4)+,d2
	asl.w	#1,d2	; .w in array
	move.w	(a5,d2.w),d2 ; allxes
	move.w	d2,d0
	and.w	#$FFF0,d2
	asr.w	#1,d2	; 16->8
	add.w	d2,a0

	move.w	(a4)+,d1
	asl.w	#1,d1	; .w in array
	move.w	(a5,d1.w),d1 ; allxes
	sub.w	d0,d1
	add.w	#1,d1
	asl.w	#7,d1 ;*16*8 in d1 de lengte
	add.w	d1,a1

	move.w	#-1,d0	; fill
	move.l	#back,a6
	move.w	(a1)+,d1
	jmp	hlindo(PC,d1.w)
back:
	dbra	d3,lusje
	RTS

hlindo:
;-- 8
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	jmp	(a6)      ; 2
;-- 16
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$8(a0) ; 4
	jmp	(a6)      ; 2
;-- 20
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$10(a0); 4
	or.w	d0,$8(a0) ; 4
	jmp	(a6)      ; 2
;-- 24
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$18(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	jmp	(a6)      ; 2
;-- 28
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$20(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	jmp	(a6)      ; 2
;-- 32
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$28(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	jmp	(a6)      ; 2
;-- 36
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$30(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	jmp	(a6)      ; 2
;-- 40
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$38(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	jmp	(a6)      ; 2
;-- 44
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$40(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	jmp	(a6)      ; 2
;-- 48
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$48(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	jmp	(a6)      ; 2
;-- 52
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$50(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	jmp	(a6)      ; 2
;-- 56
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$58(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	jmp	(a6)      ; 2
;-- 60
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$60(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	jmp	(a6)      ; 2
;-- 64
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$68(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	jmp	(a6)      ; 2
;-- 68
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$70(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	jmp	(a6)      ; 2
;-- 72
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$78(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	or.w	d0,$70(a0); 4
	jmp	(a6)      ; 2
;-- 76
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$80(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	or.w	d0,$70(a0); 4
	or.w	d0,$78(a0); 4
	jmp	(a6)      ; 2
;-- 80
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$88(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	or.w	d0,$70(a0); 4
	or.w	d0,$78(a0); 4
	or.w	d0,$80(a0); 4
	jmp	(a6)      ; 2
;-- 84
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$90(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	or.w	d0,$70(a0); 4
	or.w	d0,$78(a0); 4
	or.w	d0,$80(a0); 4
	or.w	d0,$88(a0); 4
	jmp	(a6)      ; 2
;-- 88
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$98(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	or.w	d0,$70(a0); 4
	or.w	d0,$78(a0); 4
	or.w	d0,$80(a0); 4
	or.w	d0,$88(a0); 4
	or.w	d0,$90(a0); 4
	jmp	(a6)      ; 2



clr_zoom:
	move.w	#8,d0
clrzlus:
pl set 0
	REPT	20
	clr.w	pl(a0)
pl set pl+8
	ENDR
	add.w	#160,a0
	dbra	d0,clrzlus
	RTS
;---------------------;
; REKKUH DIE Y-AAS !! ;
;---------------------;


y_calc_stretch:
	move.w	begin_zoomer_y,d0
	move.w	ylengtezoomer,d1
	move.w	d1,d7
	asr.w	#3,d7 ; ipv divu 9 , 'divu 8'

	move.w	#0,d2
	move.w	#0,d4
ycstr_loop:
	move.w	d1,d3
	mulu	d2,d3
	divu	#9,d3
	add.w	d0,d3

	tst.w	d3	; <0 (-> 0)
	bpl	not_negative3
	move.w	#0,d3
not_negative3:
	cmp.w	#200,d3	; >319 (-> 319)
	blo	not_negative4
	move.w	#200,d3
not_negative4:


	move.l	#allyes,a0
	add.w	d3,a0
	add.w	d3,a0
	move.w	d7,d6
do_y_in_array:
	move.w	d2,(a0)+
	dbra	d6,do_y_in_array
no_y_str:
	move.w	d3,d4	; oude d3 in d4
	add.w	#1,d2
	cmp.w	#10,d2
	bne.s	ycstr_loop
	RTS

y_stretch_clear:
	move.l	#allyes,a0
	move.w	#200-1,d0
clr_allyes:
	move.w	#9,(a0)+
	dbra	d0,clr_allyes
	RTS


y_stretch:
	move.l	#allyes,a3
	move.l	#xzoombuffer,a2
	move.l	schermadres,a1
	move.w	#200-1,d0
ystrloop:
	move.l	a2,a0
	move.w	(a3)+,d1
	mulu	#160,d1
	add.w	d1,a0
pl1 set 0
pl2 set 0
	REPT	20
	move.w	pl1(a0),pl2(a1)
pl1 set pl1+8
pl2 set pl2+16
	ENDR
	add.w	#320,a1
	dbra	d0,ystrloop
	RTS

;------------------------------;
;- YO! BEREKEN DE X-AS PUNTEN -;
;------------------------------;


calc_allxes:
	move.l	#allxes,a0
	move.w	xlengtezoomer,d0

	move.w	#64-1,d7
calc_allxasloop:
	move.w	begin_zoomer_x,d6

	move.w	d0,d5
	mulu	d7,d5
	divu	#64,d5
	add.w	d5,d6

	tst.w	d6	; <0 (-> 0)
	bpl	not_negative1
	move.w	#0,d6
not_negative1:
	cmp.w	#319,d6	; >319 (-> 319)
	blo	not_negative2
	move.w	#319,d6
not_negative2:

	asl.w	#1,d7	; tijdelijk *2
	move.w	d6,(a0,d7.w)
	asr.w	#1,d7
	dbra	d7,calc_allxasloop
	RTS


schermadr_opvraag:
	move	#2,-(sp)
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres
	RTS
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
cls:
	move.l	#(320*200)/4/4-1,d0
	move.l	schermadres,a0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS

;-------------------------



schermadres:	dc.l	0
ssp:		dc.l	0
begin_zoomer_x:	dc.w	160
xlengtezoomer:	dc.w	10
begin_zoomer_y:	dc.w	160
ylengtezoomer:	dc.w	150
zoomlength:	dc.w	0
zoomteller:	dc.w	DUUR_TE_ZOOMEN
zoom_dat_add	dc.w	0
	;dc.w	(11+16+9+16+8+9+9)*6+2

hlinedata:	INCBIN 'F:\PROGRAMM\FASTVECT\POLYDATA.DAT'
;			y,x1,x2

allxes:
nr set 0
	REPT	64
	dc.w	nr*20
nr set nr+1
	ENDR

allyes:
nr set 0
	REPT	400
	dc.w	9
;	dc.w	nr*9/200
nr set nr+1
	ENDR

xzoombuffer:
	ds.b	160*10

zoomdata:	INCBIN	'F:\PROGRAMM\ALL_DATA\ZOOMER_Z.DAT'
zoomerdata:
	;      y,xb,xe

	INCBIN	'F:\PROGRAMM\ALL_DATA\ZOOMCONT'