mousevec	equ	16
ikbdws		equ	25
kbdvec		equ	34
	bsr	schermadr_opvraag
	bsr	cls
	bsr	sup_vis_mode
	bsr	install_mouse
back:
	bsr	wacht_lusje
	move.l	#$ff000000,$ffff9800.w

	move.w	mousex,xx
	move.w	mousey,xy

	bsr	do_clear
	bsr	do_set

	add.w	#6,echo_counter
	move.w	echo_counter,d0
	cmp.w	#200*6,d0
	bne.s	res
	move.w	#0,echo_counter
res:

	add.w	#2,rotatex
	move.w	rotatex,d0
	cmp.w	#2*15,d0
	bne.s	res2
	move.w	#0,rotatex
res2:

	move.l	#$0,$ffff9800.w
	bsr	vsync

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back

	bsr	wacht_toets

	move.l	#$ffff00ff,$ffff9800.w
	bsr	restore_mouse
	bsr	user_mode
	clr.l	-(sp)
	trap	#1

user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
cls:
	move.l	#(640*200)/4/4-1,d0
	move.l	schermadres,a0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS

sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
wacht_lusje:
	move.l	#16000,d0
wachtlus	nop
	dbra	d0,wachtlus
	RTS

do_clear:
	move.l	#fucking_PC_VGA,a0
	move.l	#TC_val_colors,a1
	move.l	schermadres,a2
	move.l	#end_tc_row,a3
	move.l	#DATAX,a4
	move.l	#echo_buffer,a5
	add.w	echo_counter,a5
	move.l	#DATAX_,a6
	cmp.w	#-1,(a5)
	bne.s	isgoed
	cmp.w	#-1,2(a5)
	bne.s	isgoed
	RTS
isgoed:

	add.w	4(a5),a6
	add.w	(a6),a4

	add.w	(a5),a0
	add.w	(a5),a0
	add.w	(a5),a2
	add.w	(a5)+,a2

	move.w	(a5)+,d0
	mulu	#320,d0
	asl.l	#1,d0
	add.l	d0,a0
	add.l	d0,a2

	clr.w	d0
	move.w	2(a6),d7
	sub.w	(a6),d7
	asr.w	#2,d7 ; .L
	sub.w	#1,d7
;	move.w	#40-1,d7
vis_loop:
	move.w	(a4)+,d1
	add.w	d1,a0
	add.w	d1,a2
	move.w	(a4)+,d1
	jmp	(a3,d1.w)
	REPT	40
	sub.w	#2,(a0)
	move.w	(a0)+,d0
	move.w	(a1,d0.w),(a2)+
	ENDR
end_tc_row:
	dbra	d7,vis_loop
	RTS
do_set:
	move.l	#fucking_PC_VGA,a0
	move.l	#TC_val_colors,a1
	move.l	schermadres,a2
	move.l	#end_tc_row2,a3
	move.l	#DATAX,a4
	move.l	#echo_buffer,a5
	add.w	echo_counter,a5
	move.l	#DATAX_,a6
	add.w	rotatex,a6
	add.w	(a6),a4

	move.w	xx,(a5)+
	move.w	xy,(a5)+
	move.w	rotatex,(a5)+
	add.w	xx,a0
	add.w	xx,a0
	add.w	xx,a2
	add.w	xx,a2

	clr.l	d0
	move.w	xy,d0
	mulu	#320,d0
	asl.l	#1,d0
	add.l	d0,a0
	add.l	d0,a2

	clr.w	d0
	move.w	2(a6),d7
	sub.w	(a6),d7
	asr.w	#2,d7 ; .L
	sub.w	#1,d7
vis_loop2:
	move.w	(a4)+,d1
	add.w	d1,a0
	add.w	d1,a2
	move.w	(a4)+,d1
	jmp	(a3,d1.w)
	REPT	40
	add.w	#2,(a0)
	move.w	(a0)+,d0
	move.w	(a1,d0.w),(a2)+
	ENDR
end_tc_row2:
	dbra	d7,vis_loop2
	RTS



;	SUBROUTINES    !!!!!
;-------------------------------
install_mouse:
	move.w	#kbdvec,-(sp)
	trap	#14
	addq.l	#2,a7
	lea	my_handler,a1
	move.l	d0,a0
	move.l	d0,save_old_base
	move.l	mousevec(a0),save_old_vec
	move.l	a1,mousevec(a0)
	pea	ikbdstring
	move.w	#0,-(sp)
	move.w	#ikbdws,-(sp)
	trap	#14
	addq.l	#8,sp
	RTS
;-------------------------------
restore_mouse:
	move.l	save_old_base,a0
	move.l	save_old_vec,d0
	move.l	d0,mousevec(a0)
	move.w	#0,-(sp)
	trap	#1
	RTS
;-------------------------------
my_handler:
	lea	packet,a1
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
; muis variabelen bij houden
;----------------------------
;(x)
	clr.w	d0
	move.b	packet+1,d0
	btst	#7,d0
	beq	not_neg

	not.b	d0
	add.w	#1,d0
	sub.w	d0,mousex

	bra	not_neg2
not_neg:
	add.w	d0,mousex
not_neg2:

;(y)
	clr.w	d0
	move.b	packet+2,d0
	btst	#7,d0
	beq	not_neg3

	neg.b	d0
	add.w	#1,d1
	sub.w	d0,mousey

	bra	not_neg4
not_neg3:
	add.w	d0,mousey
not_neg4:


; (muis binnen bep. veld blijven)
	cmp.w	#-100,mousex
	blo	no
	move.w	#0,mousex
no
	cmp.w	#319,mousex
	blo	no2
	move.w	#319,mousex
no2

	cmp.w	#-100,mousey
	blo	no3
	move.w	#0,mousey
no3
	cmp.w	#150,mousey
	blo	no4
	move.w	#150,mousey
no4

; (clear mouse registers ivm echo's)
	move.w	#0,packet+1

	RTS
;-------------------------------
ikbdstring	dc.b	$8
packet		ds.b	3
save_old_vec	ds.l	1
save_old_base	ds.l	1
mousex:	dc.w	0
mousey:	dc.w	0
xx:	dc.w	0
xy:	dc.w	0
ssp:		dc.l	0
schermadres:	dc.l	0
rotatex:	dc.w	0
TC_val_colors:
pl set 0
	REPT	32
	dc.w	pl*2048
pl set pl+1
	ENDR
pl set 0
	REPT	32
	dc.w	31*2048+pl*64
pl set pl+1
	ENDR
pl set 0
	REPT	32
	dc.w	31*2048+31*64+pl
pl set pl+1
	ENDR

	REPT	250-32*3
	dc.w	%1111111111011111
	ENDR


	;ds.b	65536
	

echo_buffer:
	;ds.b	200*6
	REPT	200*6/12
	dc.w	-1,-1,0
	dc.w	-1,-1,0
	ENDR
echo_counter:	dc.w	0
fucking_PC_VGA:	ds.b	(200*320)*2
DATAX:	INCBIN	"F:\PROGRAMM\ALL_DATA\TC_SHAX2.DAT"
DATAX_:	INCBIN	"F:\PROGRAMM\ALL_DATA\TC_SHA2Q.DAT"
 