Indicate_Time	equ	$20
Scroll_adres	equ	$ffff8265
mousevec	equ	16
joyvec		equ	24
ikbdws		equ	25
kbdvec		equ	34
JUMPstart_sp	equ	8
jumpmax_time	equ	80/8
aantblok_cop	equ	60+1
aantblok_back	equ	57+1
unused_cop	equ	2*(256-21)
unused_voor	equ	2*(19)
unused_back	equ	2*(19)
length_cop	equ	256

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

	bsr	schermadr_opvraag
	bsr	cls
	bsr	sup_vis_mode

	bsr	install_mo_jo
	bsr	restore_mo_jo
hoofdlus:
	move.l	#$cccc00cc,$ffff9800
	bsr	bereken_veld_offset
	bsr	show_veld
	move.l	#$ffff00ff,$ffff9800
	bsr	vsync
	bsr	beeld_change

	add.w	#2,camera_x
	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	hoofdlus


	bsr	wacht_toets

	move.l	schermadres_oud,schermadres
	bsr	beeld_change
	move.b	#0,Scroll_adres
	bsr	user_mode
	clr.l	-(sp)
	trap	#1

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

show_veld:
	move.l	schermadres,a0
	move.l	#veld+32,a2
	add.w	veld_offset,a2
	move.w	#11-1,d6 ; d6,Yloop
Yloop_show
	move.w	#21-1,d7 ; d6,Xloop
Xloop_show
	move.l	#blokpic,a1
	move.w	(a2)+,d0
	asl.w	#7,d0
	add.w	d0,a1
	REPT	16
	move.l	(a1)+,(a0)+
	move.l	(a1)+,(a0)+
	add.w	#336-8,a0
	ENDR	
	sub.w	#336*16-16,a0
	dbra	d7,Xloop_show
	add.w	#unused_cop,a2
	add.w	#336*15,a0
	dbra	d6,Yloop_show
	RTS
bereken_veld_offset:
	move.w	camera_y,d0
	asr.w	#4,d0	; div 16
	mulu	#length_cop*2,d0
	move.w	camera_x,d1
	asr.w	#4,d1	; div 16
	asl.w	#1,d1	; .W
	add.w	d1,d0
	move.w	d0,veld_offset
	RTS
show:
	move.l	schermadres,a0
	move.l	#blokpic,a1
	move.l	#maskblokpic,a2
	move.w	#200-1,d0
coploop	move.l	(a1)+,(a0)
	move.l	(a1)+,4(a0)
	move.w	(a2)+,16(a0)
	add.w	#320,a0
	dbra	d0,coploop
	RTS
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
schermadr_opvraag:
	move	#2,-(sp)
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres_oud
	move.l	#screen1+256,schermadres
	move.l	#screen2+256,schermadres2
	and.l	#$ffffff00,schermadres
	and.l	#$ffffff00,schermadres2
	RTS
vsync:	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
install_mo_jo:
	move.w	#kbdvec,-(sp)
	trap	#14
	addq.l	#2,a7
	move.l	d0,a0
	move.l	d0,save_old_base
	lea	mo_handler,a1
	lea	jo_handler,a2
	move.l	mousevec(a0),save_old_mvec
	move.l	a1,mousevec(a0)
	move.l	joyvec(a0),save_old_jvec
	move.l	a2,joyvec(a0)


	pea	ikbdstring ; OUT 2,8
	move.w	#0,-(sp)
	move.w	#ikbdws,-(sp)
	trap	#14
	addq.l	#8,sp
	RTS
restore_mo_jo:
	move.l	save_old_base,a0
	move.l	save_old_mvec,d0
	move.l	d0,mousevec(a0)
	move.l	save_old_jvec,d0
	move.l	d0,joyvec(a0)
	RTS
mo_handler
	lea	mpacket,a1
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	RTS
jo_handler
	lea	jpacket,a1
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	RTS
cls:
	move.l	#(320*200)/4/4-1,d0
	move.l	schermadres,a0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS
beeld_change:
	move.w	camera_x,d0
	and.w	#15,d0
	or.w	#1,d0
	move.b	d0,Scroll_adres
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201
	RTS


;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

ssp		dc.l	0
schermadres_oud	dc.l	0
schermadres	dc.l	0
schermadres2	dc.l	0
veld_offset	dc.w	0
camera_x	dc.w	0
camera_y	dc.w	0
ikbdstring	dc.b	$8
mpacket		ds.b	3
jpacket		ds.b	3
save_old_mvec	ds.l	1
save_old_jvec	ds.l	1
save_old_base	ds.l	1

veld		INCBIN	"F:\LEVELS\LEVELA.DAT"
veldmask	INCBIN	"F:\LEVELS\LEVELA.DAT"
		ds.w	4*16
blokpic		INCBIN	"F:\LEVELS\CON1BLK .DAT"
		ds.w	16
maskblokpic	INCBIN	"F:\LEVELS\CON1BLKM.DAT"

veldlen		EQU	veldmask-veld

screen1:	ds.l	(336*200+256)/4
screen2:	ds.l	(336*200+256)/4
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
