Indicate_Time	equ	$20
Scroll_adres	equ	$ffff8265
mousevec	equ	16
joyvec		equ	24
ikbdws		equ	25
kbdvec		equ	34
JUMPstart_sp	equ	8
jumpmax_time	equ	80/8
aantblok_cop	equ	60+1
aantblok_back	equ	57+1
unused_cop	equ	2*(256-21)
unused_voor	equ	2*(19)
unused_back	equ	2*(19)
length_cop	equ	256
color_indicate	equ	1 ; 0=N,1=J
ch_coord_indic	equ	1 ; 0=N,1=J

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

	bsr	schermadr_opvraag
	bsr	cls
	bsr	sup_vis_mode

	bsr	install_mo_jo
hoofdlus:
	move.l	#$cccc00cc,d0
	bsr	go_indicate
	bsr	bereken_veld_offset
	bsr	show_veld
	bsr	calc_new_coords
	bsr	GO_Y
	move.l	#$ffff00ff,d0
	bsr	go_indicate

	bsr	vsync
	bsr	beeld_change

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	hoofdlus


	bsr	wacht_toets

	bsr	restore_mo_jo
	move.l	schermadres_oud,schermadres
	bsr	beeld_change
	move.b	#0,Scroll_adres
	bsr	user_mode
	clr.l	-(sp)
	trap	#1

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
calc_new_coords:
	clr.w	d0
	move.b	jpacket+2,d0
; joy=UP & jumpready=1
	move.b	d0,d1
	and.w	#1,d1
	tst.w	d1
	beq.s	not_up
	tst.w	jumpready ; In air=0
	beq.s	not_up
	move.w	#-JUMPstart_sp,speed_y
	add.w	#1,jumpteller
not_up
; joy<>UP
	move.b	d0,d1
	and.w	#1,d1
	tst.w	d1
	bne.s	not_up2
	move.w	#0,jumpready
not_up2
; jumpteller=JUmPMAXTIME
	move.w	jumpteller,d1
	cmp.w	#jumpmax_time,d1
	bne.s	not_maxcnt_jmp
	move.w	#0,jumpready
not_maxcnt_jmp
; LINKS & RECHTS
	move.b	d0,d1
	and.w	#4,d1
	tst.w	d1
	beq.s	n_left
	sub.w	#2,speed_x
n_left	move.b	d0,d1
	and.w	#8,d1
	tst.w	d1
	beq.s	n_right
	add.w	#2,speed_x
n_right

; (-Yspeed-) LIMITATIONS
	move.w	speed_y,d0
	add.w	#101,d0
	sub.w	#100,d0
	move.w	d0,speed_y
	RTS

GO_Y:
	move.w	speed_y,d6
	asr.w	#1,d6
	tst.w	d6	; sp=0
	beq.s	NOSP_Y
	tst.w	d6
	bpl.s	NEGSP_Y

	not.w	d6	; sp<0
up_loop	bsr	up_check
	dbra	d6,up_loop
	bra	NOSP_Y

NEGSP_Y	sub.w	#1,d6	; sp>0
dowloop	bsr	down_check
	dbra	d6,dowloop
NOSP_Y	RTS

up_check:
	sub.w	#1,coord_y ; DEC Y
	move.w	coord_x,d0 ; #1
	move.w	coord_y,d1
	bsr	check_coord
	move.w	d7,d5
	move.w	coord_x,d0 ; #2
	move.w	coord_y,d1
	add.w	#9,d0
	bsr	check_coord
	add.w	d7,d5
	move.w	coord_x,d0 ; #3
	move.w	coord_y,d1
	add.w	#18,d0
	bsr	check_coord
	add.w	d7,d5

	tst.w	d5
	beq.s	ok_up
	add.w	#1,coord_y
	move.w	#0,speed_y
ok_up	RTS
down_check:
	add.w	#1,coord_y ; INC Y
	move.w	coord_x,d0 ; #1
	move.w	coord_y,d1
	add.w	#28,d1
	bsr	check_coord
	move.w	d7,d5
	move.w	coord_x,d0 ; #2
	move.w	coord_y,d1
	add.w	#9,d0
	add.w	#28,d1
	bsr	check_coord
	add.w	d7,d5
	move.w	coord_x,d0 ; #3
	move.w	coord_y,d1
	add.w	#18,d0
	add.w	#28,d1
	bsr	check_coord
	add.w	d7,d5

	tst.w	d5
	beq.s	ok_down
	sub.w	#1,coord_y
	move.w	#0,speed_y
	move.w	#1,jumpready
	move.w	#0,jumpteller
ok_down	RTS

;            T E K E N   V E L D

show_veld:
	move.l	schermadres,a0
	move.l	#veld+32,a2
	add.w	veld_offset,a2
	move.w	#11-1,d6 ; d6,Yloop
Yloop_show
	move.w	#21-1,d7 ; d6,Xloop
Xloop_show
	move.l	#blokpic,a1
	move.w	(a2)+,d0
	asl.w	#7,d0
	add.w	d0,a1
	REPT	16
	move.l	(a1)+,(a0)+
	move.l	(a1)+,(a0)+
	add.w	#336-8,a0
	ENDR	
	sub.w	#336*16-16,a0
	dbra	d7,Xloop_show
	add.w	#unused_cop,a2
	add.w	#336*15,a0
	dbra	d6,Yloop_show
	RTS
bereken_veld_offset:
	move.w	camera_y,d0
	asr.w	#4,d0	; div 16
	mulu	#length_cop*2,d0
	move.w	camera_x,d1
	asr.w	#4,d1	; div 16
	asl.w	#1,d1	; .W
	add.w	d1,d0
	move.w	d0,veld_offset
	RTS

check_coord: ; d0=X,d1=Y, d7=>JA/NEE
	move.l	#maskblokpic,a1
	move.l	#veld+32,a2
	move.l	#tabel1,a3

	move.w	d1,d2
	asr.w	#4,d2	; div 16
	mulu	#length_cop*2,d2
	add.w	d2,a2
	move.w	d0,d2
	asr.w	#4,d2	; div 16
	asl.w	#1,d2	; .W
	add.w	d2,a2

	move.w	(a2),d4 ;Goede blokje
	asl.w	#5,d4	; *32
	add.w	d4,a1

	move.w	d1,d2 ; Y MOD 15
	and.w	#15,d2
	asl.w	#1,d2 ; *2 {1plane}
	add.w	d2,a1

	move.w	d0,d2 ; X MOD 15
	and.w	#15,d2
	asl.w	#1,d2 ; *2 {1plane}
	move.w	(a3,d2.w),d3 ; de bit

	and.w	(a1),d3 ; inh. REEPJE

	move.w	#0,d7 ; DEFAULT=0
	tst.w	d3
	beq.s	gelijk_aan_0
	move.w	#1,d7 ; BIT AAN
gelijk_aan_0:

	; CHECK_COORD_INDICATIE
	move.w	#ch_coord_indic,d2
	tst.w	d2
	beq.s	no_ch_color_indicate
	sub.w	camera_x,d0
	sub.w	camera_y,d1
	bsr	plot_XY
no_ch_color_indicate:
	RTS

wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
schermadr_opvraag:
	move	#2,-(sp)
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres_oud
	move.l	#screen1+256,schermadres
	move.l	#screen2+256,schermadres2
	and.l	#$ffffff00,schermadres
	and.l	#$ffffff00,schermadres2
	RTS
vsync:	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
install_mo_jo:
	move.w	#kbdvec,-(sp)
	trap	#14
	addq.l	#2,a7
	move.l	d0,a0
	move.l	d0,save_old_base
	lea	mo_handler,a1
	lea	jo_handler,a2
	move.l	mousevec(a0),save_old_mvec
	move.l	a1,mousevec(a0)
	move.l	joyvec(a0),save_old_jvec
	move.l	a2,joyvec(a0)


	pea	ikbdstring ; OUT 2,8
	move.w	#0,-(sp)
	move.w	#ikbdws,-(sp)
	trap	#14
	addq.l	#8,sp
	RTS
restore_mo_jo:
	move.l	save_old_base,a0
	move.l	save_old_mvec,d0
	move.l	d0,mousevec(a0)
	move.l	save_old_jvec,d0
	move.l	d0,joyvec(a0)
	RTS
mo_handler
	lea	mpacket,a1
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	RTS
jo_handler
	lea	jpacket,a1
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	RTS
cls:
	move.l	#(320*200)/4/4-1,d0
	move.l	schermadres,a0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS
beeld_change:
	move.w	camera_x,d0
	and.w	#15,d0
	or.w	#1,d0
	move.b	d0,Scroll_adres
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201
	RTS
go_indicate:
	move.w	#color_indicate,d1
	tst.w	d1
	beq.s	no_colindicate
	move.l	d0,$ffff9800
no_colindicate
	RTS
plot_XY:
	move.l	#tabel1,a0
	move.l	schermadres,a2
	move.w	camera_x,d2
	or.w	#1,d2
	and.w	#15,d2
	add.w	d2,d0
	move.w	d0,d2 ; X bound(16)
	and.w	#$fff0,d2
	add.w	d2,a2
	move.w	d0,d2 ; X MOD 15
	and.w	#15,d2
	asl.w	#1,d2
	move.w	(a0,d2.w),d3
	clr.l	d2
	move.w	d1,d2 ; Y
	mulu	#336,d2
	add.l	d2,a2
	or.w	d3,(a2)
	or.w	d3,2(a2)
	or.w	d3,4(a2)
	or.w	d3,6(a2)
	RTS

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

ssp		dc.l	0
schermadres_oud	dc.l	0
schermadres	dc.l	0
schermadres2	dc.l	0
veld_offset	dc.w	0
camera_x	dc.w	0 ; COORDINATEN CAMERA
camera_y	dc.w	0
coord_x:	dc.w	0 ; COORDINATEN SPRITE
coord_y:	dc.w	0
speed_x:	dc.w	0 ; SNELHEDEN SPRITE
speed_y:	dc.w	0
event:		dc.w	0 ; WAT DE SPRITE DOET
jumpready:	dc.w	0
jumpteller:	dc.w	0
ikbdstring	dc.b	$8
mpacket		ds.b	3
jpacket		ds.b	3
save_old_mvec	ds.l	1
save_old_jvec	ds.l	1
save_old_base	ds.l	1

veld		INCBIN	"F:\LEVELS\LEVELA.DAT"
veldmask	INCBIN	"F:\LEVELS\LEVELA.DAT"
		ds.b	8*16
blokpic		INCBIN	"F:\LEVELS\CON1BLK .DAT"
		ds.b	2*16
maskblokpic	INCBIN	"F:\LEVELS\CON1BLKM.DAT"

veldlen		EQU	veldmask-veld

screen1:	ds.l	(336*200+256)/4
screen2:	ds.l	(336*200+256)/4

tabel1:		dc.w	$8000,$4000,$2000,$1000,$800,$400,$200,$100,$80,$40,$20,$10,$8,$4,$2,$1

checkcoord_0:	dc.w	0
checkcoord_1:	dc.w	0
checkcoord_2:	dc.w	0
checkcoord_3:	dc.w	0
checkcoord_4:	dc.w	0
checkcoord_5:	dc.w	0
checkcoord_6:	dc.w	0
checkcoord_7:	dc.w	0
checkcoord_8:	dc.w	0
checkcoord_9:	dc.w	0

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
