
	bsr	schermadr_opvraag
	bsr	sup_vis_mode
	dc.w	$a00a
	bsr	cls

	move.l	schermadres4,a0
	move.l	schermadres,a1
	bsr	fill_screen
	move.l	schermadres4,a0
	move.l	schermadres2,a1
	bsr	fill_screen
back:
	bsr	beeld_change
	move.l	#$ffff00ff,$ffff9800

	add.w	#1,counter
	cmp.w	#90,counter
	bne	res_cntr
	move.w	#0,counter
res_cntr:

	bsr	copy_it
	move.l	#$ffff00ff,$ffff9800
	bsr	vsync

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back
end:

	bsr	user_mode

	clr.l	-(sp)
	trap	#1


;********************************
;*	SUBROUTINES    !!!!!	*
;********************************

;-------------------------
copy_it:
	move.l	schermadres3,a4
	clr.l	d0
	move.w	counter,d0
	mulu	#160,d0
	asl.l	#2,d0
	add.l	d0,a4

	move.l	schermadres,a5
	add.l	d0,a5
	add.w	#100,a5

	move.l	#data1,a2
	move.l	#data2,a3
	move.l	#bol_loop,a6
	move.w	#50-1,d2
y_bol_loop:
	move.l	a4,a0
	move.l	a5,a1
	move.w	(a2)+,d1  ; nr.x in data2

	move.w	d1,d0
	and.w	#$fe,d0
	sub.w	d0,a1

bol_loop:
	move.w	(a3)+,d0
	move.w	(a0,d0.w),(a1)+
	dbra	d1,bol_loop

	add.w	#640,a5
	dbra	d2,y_bol_loop

	add.w	#640*50,a4

	move.w	#50-1,d2
y_bol_loop2:
	move.l	a4,a0
	move.l	a5,a1
	move.w	(a2)+,d1  ; nr.x in data2

	move.w	d1,d0
	and.w	#$fe,d0
	sub.w	d0,a1

bol_loop2:
	move.w	(a3)+,d0
	move.w	(a0,d0.w),(a1)+
	dbra	d1,bol_loop2

	add.w	#640,a5
	dbra	d2,y_bol_loop2

	RTS
;-------------------------
fill_screen:
	move.w	#128000/4/4-1,d0
copy_fill:
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	dbra	d0,copy_fill
	RTS
;-------------------------
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS

;-------------------------
beeld_change:
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

;	move.l	schermadres2,d0
;	asr.l	#8,d0
;	asl.l	#8,d0
;	move.l	d0,schermadres2
	RTS

;-------------------------
wacht_toets:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
;-------------------------
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
;-------------------------
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
;-------------------------
cls:
	move.l	schermadres,a0
	move.l	#(640*200)/16-1,d0
go_cls1:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls1
	move.l	schermadres2,a0
	move.l	#(640*200)/16-1,d0
go_cls2:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls2
	RTS
;-------------------------
cls_all:
	move.l	#64000/4/4-1,d0
	move.l	schermadres,a0
go_cls_all:
	clr.l	(a0)+ 
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls_all
	RTS
;-------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd

	move.l	#screen2,schermadres2
	add.l	#256,schermadres2
	and.l	#$FFFFFF00,schermadres2
	move.l	#screen3,schermadres3
;	add.l	#256,schermadres3
;	and.l	#$FFFFFF00,schermadres3
	move.l	#screen4,schermadres4
;	add.l	#256,schermadres4
;	and.l	#$FFFFFF00,schermadres4

	RTS
;-------------------------
wacht_lusje:
	move.l	#16000,d0
wachtlus	nop
	dbra	d0,wachtlus
	RTS
;-------------------------
	
BEGL:
	move.w	(a3)+,d0
	move.w	(a0,d0.w),(a1)+
ENDL:
LE	EQU	ENDL-BEGL

;	VARIABELEN
;-----------------------------------
schermadres:	dc.l	0
schermadres2:	dc.l	0
schermadres3:	dc.l	0
schermadres4:	dc.l	0
counter:	dc.w	0
ssp:		dc.l	0
data1:	dc.w	19,27,35,39,43,47,51,55,57,59,63,65,67,69,71,73,75,77,79,79,81,83
	dc.w	85,85,87,87,89,89,91,91,93,93,95,95,95,95,97,97,97,97,99,99,99
	dc.w	99,99,99,99,99,99,99,100,99,99,99,99,99,99,99,99,99,97,97,97,97
	dc.w	95,95,95,95,93,93,91,91,89,89,87,87,85,85,83,81,79,79,77,75,73,71
	dc.w	69,67,65,63,59,57,55,51,47,43,39,35,28,19
	ds.w	100
data2:	INCBIN	'F:\PROGRAMM\ALL_DATA\BOL_OK.DAT'
screen2:	ds.b	128256
screen3:	
		INCBIN	'F:\DRAW\PICTURES\TRUE_COL\PICTURE1.TC'
screen4:
		INCBIN	'F:\DRAW\PICTURES\TRUE_COL\PICTURE2.TC'
