	bsr	schermadr_opvraag
	bsr	sup_vis_mode
	bsr	save_palette
	bsr	copy
back:
	bsr	do_cycle_invert
	bsr	vsync
	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back

	bsr	load_palette
	bsr	user_mode
	clr.l	-(sp)
	trap	#1

do_cycle:
	move.l	#cycle_colors,a1
	add.w	counter,a1
	add.w	counter,a1
	move.l	#$ff8242,a0
pl set 0
	REPT	14
	move.w	pl+2(a0),pl(a0)
pl set pl+2
	ENDR
	move.w	(a1),pl(a0)

	move.w	counter,d0
	add.w	#1,d0
	cmp.w	#LENCYCL,d0
	bne.s	no_res_cycle_counter
	move.w	#0,d0
no_res_cycle_counter:
	move.w	d0,counter
	RTS

do_cycle_invert:
	move.l	#cycle_colors,a1
	add.w	counter,a1
	add.w	counter,a1
	move.l	#$ff8242,a0
pl set 28
	REPT	14
	move.w	pl-2(a0),pl(a0)
pl set pl-2
	ENDR
	move.w	(a1),pl(a0)

	move.w	counter,d0
	add.w	#1,d0
	cmp.w	#LENCYCL,d0
	bne.s	no_res_cycle_counter2
	move.w	#0,d0
no_res_cycle_counter2:
	move.w	d0,counter
	RTS


save_palette:
	move.l	#$ff8240,a0
	move.l	#oldpalette,a1
	move.w	#16-1,d0
save_loop:
	move.w	(a0)+,(a1)+
	dbra	d0,save_loop
	RTS
load_palette:
	move.l	#oldpalette,a0
	move.l	#$ff8240,a1
	move.w	#16-1,d0
load_loop:
	move.w	(a0)+,(a1)+
	dbra	d0,load_loop
	RTS

copy:
	move.l	#fadescreen+34,a0
	move.l	schermadres,a1
	move.w	#(32000)/4/4-1,d0
copy_loop:
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	dbra	d0,copy_loop
	RTS
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS

ssp:		dc.l	0
schermadres:	dc.l	0
fadescreen:	INCBIN	"F:\DRAW\PICTURES\PI1's\CFADE2.PI1"
counter:	dc.w	0
oldpalette:	ds.w	16

cycle_colors:
PAUSE	EQU	8
BEGCYCL:
; 000-777
	dc.w	$000,$111,$222,$333,$444,$555,$666

	REPT	PAUSE
	dc.w	$777
	ENDR

; 777-770-700-000
	dc.w	$777,$776,$775,$774,$773,$772,$771
	dc.w	$770,$760,$750,$740,$730,$720,$710
	dc.w	$700,$600,$500,$400,$300,$200,$100

	REPT	PAUSE
	dc.w	$000
	ENDR

; 000-007-077-777
	dc.w	$000,$001,$002,$003,$004,$005,$006
	dc.w	$007,$017,$027,$037,$047,$057,$067
	dc.w	$077,$177,$277,$377,$477,$577,$677

	REPT	PAUSE
	dc.w	$777
	ENDR

; 777-000
	dc.w	$777,$666,$555,$444,$333,$222,$111

	REPT	PAUSE
	dc.w	$000
	ENDR

	dc.w	$000,$101,$202,$303,$404,$505,$606
	dc.w	$707,$616,$525,$434,$343,$252,$161
	dc.w	$070,$060,$050,$040,$030,$020,$010


	REPT	PAUSE
	dc.w	$000
	ENDR

	REPT	3
	dc.w	$000,$111,$222,$333,$444,$555,$666
	dc.w	$777,$666,$555,$444,$333,$222,$111
	ENDR

ENDCYCL:
LENCYCL	EQU	(ENDCYCL-BEGCYCL)/2