	bsr	sup_vis_mode
	bsr	schermadr_opvraag

	move.l	schermadres,a0
	add.w	#2,a0
	bsr	cls
	move.l	schermadres,a0
	add.w	#4,a0
	bsr	cls
	move.l	schermadres,a0
	add.w	#6,a0
	bsr	cls

back:
	bsr	vsync
	add.w	#1,xlength
;	add.w	#2,ylength
	bsr	beeld_change
	move.l	schermadres,a0
	bsr	cls
	move.w	#$fef,$ff8240
	bsr	do_line
	move.w	#$fff,$ff8240


	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back

	bsr	user_mode
	clr.l	-(sp)
	trap	#1

do_line:
	; X-beginpunt in d4
	; Y-beginpunt in d5
	; X-wijdte in d6
	; Y-hoogte in d7
	clr.l	d6
	clr.l	d7
	move.w	x1,d4
	move.w	y1,d5
	move.w	xlength,d6
	move.w	ylength,d7


	move.l	schermadres,a1
					;	move.l	coords,a2
	move.l	#lindat1,a3
	move.l	#lindat2,a4
	move.l	#lindat2b,a5
	move.l	#plot_data,a6

	asl.l	#8,d6 ; Set Xlength
	asl.l	#1,d6
	add.l	d6,a3

	clr.l	d6
	move.w	d7,d6 ; R+1 (2=>1 !!)
	asl.l	#1,d6 ; Set Ylength
	move.w	(a5,d6.l),d6
	add.w	d6,a4


	move.w	d7,d0
	sub.w	#1,d0
	move.w	#199,d0
lin_loop1:

	moveq	#0,d5
	move.b	(a4)+,d5 ; CHOOSE Y
;	asl.w	#1,d5
	move.w	(a3,d5.w),d4 ; CALC X
; PLOT
	asl.w	#2,d4
	move.w	(a6,d4.w),d1
	move.w	2(a6,d4.w),d2
	or.w	d1,(a1,d2.w)

;	move.w	d4,d1
;	not.w	d1
;	and.w	#7,d1

;	move.w	d4,d2
;	and.w	#-1-15,d2
;	asr.w	#1,d2

;	move.w	d4,d3
;	and.w	#8,d3
;	asr.w	#3,d3
;	add.w	d3,d2

;	bset	d1,(a1,d2.w)
; VOLGENDE
	add.w	#160,a1
	dbra	d0,lin_loop1
	RTS
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	move.l	#screen2+256,schermadres2
	and.l	#$ffffff00,schermadres2
	RTS
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS

cls:
	move.w	#(20*200)-1,d0
go_cls:
	clr.w	(a0)
	add.w	#8,a0
	dbra d0,go_cls
	RTS
pause:
	move.w	#12000-1,d0
go_pause:
	nop
	nop
	nop
	nop
	dbra d0,go_pause
	RTS
beeld_change:
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	move.l	schermadres2,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2
	RTS
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS

schermadres:	dc.l	0
schermadres2:	dc.l	0
ssp:		dc.l	0
x1:		dc.w	0
y1:		dc.w	0
xlength:	dc.w	10
ylength:	dc.w	100
lindat1:  INCBIN  "F:\PROGRAMM\ALL_DATA\LINES_1.DAT"
lindat2:  INCBIN  "F:\PROGRAMM\ALL_DATA\LINES_2.DAT"
lindat2b: INCBIN  "F:\PROGRAMM\ALL_DATA\LINES_2B.DAT"
screen2:	ds.b	64256
pl set	0
plot_data:
	REPT	22
	dc.w	%1000000000000000,pl
	dc.w	%0100000000000000,pl
	dc.w	%0010000000000000,pl
	dc.w	%0001000000000000,pl
	dc.w	%0000100000000000,pl
	dc.w	%0000010000000000,pl
	dc.w	%0000001000000000,pl
	dc.w	%0000000100000000,pl
	dc.w	%0000000010000000,pl
	dc.w	%0000000001000000,pl
	dc.w	%0000000000100000,pl
	dc.w	%0000000000010000,pl
	dc.w	%0000000000001000,pl
	dc.w	%0000000000000100,pl
	dc.w	%0000000000000010,pl
	dc.w	%0000000000000001,pl
pl set 	pl+8
	ENDR