; ------ INIT ------
	bsr	schermadr_opvraag
	bsr	sup_vis_mode

; ------ HOOFDLUS ------
back:
	move.l	#$4f4f004f,$ff9800

	add.w	#1,xlen_x
;	add.w	#1,xlen_y
	bsr	calc_add_array

	move.l	#add_array,a0
	move.l	#bigloop+2,a1
	move.w	#80-1,d0
x_care_loop:
	move.w	(a0)+,(a1)
	add.w	#4,a1
	dbra	d0,x_care_loop

	move.l	#screen_from,a0
	move.l	schermadres,a1

	move.l	#$afaf00af,$ff9800

	move.w	#100-1,d0
bigloop:
	REPT	80
	move.l	200(a0),(a1)+
	ENDR
	add.w	#640,a0
	add.w	#(320-(80*2))*2,a1
	dbra	d0,bigloop

	move.l	#$ffff00ff,$ff9800
	bsr	vsync

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back


; ------- NETJES EINDE ------
	bsr	user_mode
	clr.l	-(sp)
	trap	#1


; -------  SUB'S --------
calc_add_array:
	move.l	#add_array,a0
	move.w	xlen_x,d1
	move.w	xlen_y,d2
	move.w	#80-1,d0
	move.w	#0,d3
calc_add_array_loop:

	move.w	d3,d4 ; 0-80
	mulu	d1,d4 ; * xlengte
	divu	#80,d4 ; /80
	asl.w	#1,d4	; .w

	move.w	d3,d5 ; 0-80
	mulu	d2,d5 ; * ylengte
	divu	#80,d5 ; /80
	mulu	#640,d5
	add.w	d4,d5

	move.w	d5,(a0)+

	add.w	#1,d3
	dbra	d0,calc_add_array_loop
	RTS

user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS

; ------- VAR'S -----------
schermadres:	dc.l	0
ssp:		dc.l	0
xlen_x:	dc.w	0
xlen_y:	dc.w	0
add_array:	
	REPT	200
	dc.w	0
	ENDR
; ------- LOADED DATA ---------
screen_from:	INCBIN	'F:\DRAW\PICTURES\TRUE_COL\ATARI.TC'

; ------- EMPTY DATA ---------
y_data:

