;true color	: 0-31 (*1)    - blauw
;		- 0-31 (*64)   - groen
;		- 0-31 (*2048) - rood

	bsr	schermadr_opvraag
	bsr	cls
	bsr	go_calc
	bsr	show_heights
	bsr	go_show
	bsr	wacht_toets
	clr.l	-(sp)
	trap	#1


show_heights:
	move.l	#array3d,a1
	move.w	hoogst,d0   ;x
	move.w	hoogst+2,d1 ;y

	asl.w	#3,d1
	add.w	d1,a1
	move.w	d0,(a1)
	move.w	d0,2(a1)

	move.l	#array3d,a1
	move.w	laagst,d0   ;x
	move.w	laagst+2,d1 ;y

	asl.w	#3,d1
	add.w	d1,a1
	move.w	d0,(a1)
	move.w	d0,2(a1)

	move.l	#array3d,a1
	move.w	andere,d0   ;x
	move.w	andere+2,d1 ;y

	asl.w	#3,d1
	add.w	d1,a1
	move.w	d0,(a1)
	move.w	d0,2(a1)
	RTS



go_calc:
	move.l	#coords,a0
	move.w	2(a0),d0

	cmp.w	8+2(a0),d0
	bhi	second_is_lower1
	move.w	8+2(a0),d0
	move.w	#1,d2
	move.w	#%010,d3
	bra	laagst_end
  second_is_lower1:
	cmp.w	16+2(a0),d0
	bhi	third_is_lower1
	move.w	16+2(a0),d0
	move.w	#2,d2
	move.w	#%100,d3
	bra	laagst_end
  third_is_lower1:
	move.w	#0,d2
	move.w	#%001,d3
  laagst_end:

	move.w	2(a0),d0
	cmp.w	8+2(a0),d0
	blo	second_is_lower2
	move.w	8+2(a0),d0
	move.w	#1,d1
	or.w	#%010,d3
	bra	hoogst_end
  second_is_lower2:
	cmp.w	16+2(a0),d0
	blo	third_is_lower2
	move.w	16+2(a0),d0
	move.w	#2,d1
	or.w	#%100,d3
	bra	hoogst_end
  third_is_lower2:
	move.w	#0,d1
	or.w	#%001,d3
  hoogst_end:

	move.l	schermadres,a1
; hoogst
	add.w	#160,a1
	move.w	#-1,(a1)
	asl.w	#3,d1
	move.w	#31*64,2(a1,d1.w)

;	asl.w	#2,d1
	move.w	(a0,d1.w),hoogst
	move.w	2(a0,d1.w),hoogst+2
	move.w	4(a0,d1.w),hoogst+4
	move.w	6(a0,d1.w),hoogst+6

; laagst
	add.w	#640*2,a1
	move.w	#-1,(a1)
	asl.w	#3,d2
	move.w	#31*64,2(a1,d2.w)

;	asl.w	#2,d2
	move.w	(a0,d2.w),laagst
	move.w	2(a0,d2.w),laagst+2
	move.w	4(a0,d2.w),laagst+4
	move.w	6(a0,d2.w),laagst+6

	and.w	#%111,d3

	cmp.w	#%100,d3
	bne.s	not_011
	move.w	#0,d3
;	bra	klaar_d3_andere
  not_011:
	cmp.w	#%010,d3
	bne.s	not_101
	move.w	#8,d3
;	bra	klaar_d3_andere
  not_101:
	cmp.w	#%001,d3
	bne.s	not_110
	move.w	#16,d3
;	bra	klaar_d3_andere
  not_110:

  klaar_d3_andere:

	move.w	#16,d3

	move.w	(a0,d3.w),andere
	move.w	2(a0,d3.w),andere+2
	move.w	4(a0,d3.w),andere+4
	move.w	6(a0,d3.w),andere+6

	RTS


go_show:
	move.l	schermadres,a0
	move.l	#array3d,a1
	move.w	#200-1,d0
y_go:
	move.w	(a1)+,d1
	asl.w	#1,d1
	move.w	#31*2048+31*64,(a0,d1.w)
	move.w	(a1)+,d2
	asl.w	#1,d2
	move.w	#31*2048+31*64,(a0,d2.w)

	add.w	#4,a1
	add.w	#640,a0
	dbra	d0,y_go
	RTS
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
cls:
	move.l	#(640*200)/4/4-1,d0
	move.l	schermadres,a0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS

schermadres:	dc.l	0
coords:	dc.w	90,10,0,0
	dc.w	80,40,0,0
	dc.w	60,50,0,0
hoogst:	dc.w	0,0,0,0
laagst:	dc.w	0,0,0,0
andere:	dc.w	0,0,0,0

array3d:	
	REPT	200
	dc.w	150,155,0,0
	ENDR
;	ds.w	4*200




