f;****************** _____.
;*   FAST-POLY    *   | \| THIS
;*      BY        *   q  |
;*   EXECUTE OF   *  /+\ |  IS
;* THE EXPERIENCE *   |  |
;******************  / \ | FAST
;                ___     |
;                | |     |  !!
;                --------|-----

	bsr	schermadr_opvraag
	bsr	sup_vis_mode

	move.l	schermadres,a0
	bsr	cls
	move.l	schermadres2,a0
	bsr	cls

	move.w	#$200,$ff8242

back:
	bsr	beeld_change
	move.l	schermadres,a0
;	bsr	cls  ; $ff8240 zakken
	bsr	fill

	move.w	#$744,$ff8240

	bsr	CLEAR3DARRAY

	move.w	#$447,$ff8240

	move.l	#coords,a5
	move.l	#coords+4,a6
	bsr	go_calc_line
	move.l	#coords+4,a5
	move.l	#coords+8,a6
	bsr	go_calc_line
	move.l	#coords+8,a5
	move.l	#coords+12,a6
	bsr	go_calc_line
 	move.l	#coords+12,a5
	move.l	#coords,a6
	bsr	go_calc_line

	move.w	#$477,$ff8240
	bsr	show_test

	move.w	#$474,$ff8240
	cmp.w	#2,d6
	bne.s	no_draw
	bsr	go_show   * tekenen
	bra	SHOWN
no_draw:
	cmp.w	#0,d6
	bne.s	SHOWN
	bsr	go_show2  * swap tekenen
SHOWN:
	move.w	#$777,$ff8240

	bsr	vsync   * VSYNC-WAIT
;	add.w	#1,coords+2

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back

	bsr	wacht_toets
	bsr	user_mode
	clr.l	-(sp)
	trap	#1


show_test:
	bsr	highest_calc ; in d4
	bsr	lowest_calc

	move.l	#array3d,a0
	move.l	schermadres,a1
	move.l	#coords+2,a2

; show hoogste-laagste
	move.w	d4,(a1)
	move.w	d5,160(a1)

	add.w	#640,a1

	move.w	#0,d6	; counter
	move.w	#4-1,d7
checkmark:
	move.w	#3,d0
	sub.w	d7,d0

	cmp.w	d0,d4	; =hoogste ?
	beq	mark_it1
	cmp.w	d0,d5	; =laagste ?
	beq	mark_it1

	asl.w	#2,d0	;*4
	move.w	(a2,d0.w),d0   ; y1
	asl.w	#3,d0	;*8
	move.w	(a0,d0.w),d1 ; van
	move.w	2(a0,d0.w),d2 ; naar

	move.w	#1,(a1)

	cmp.w	d1,d2
	ble.s	mark_it1
	add.w	#1,d6	; counter+1
	move.w	#-1,(a1)
mark_it1:
	add.w	#160,a1
	dbra	d7,checkmark ; volgende !

	RTS

lowest_calc:
	move.l	#coords+2,a2

	move.w	(a2),d0
	move.w	4(a2),d1
	move.w	8(a2),d2
	move.w	12(a2),d3

	move.w	#0,d5 ; 0=laagst

	cmp.w	d0,d1
	blo.s	b01
	move.w	d1,d0
	move.w	#1,d5 ; 1=laagst
b01:
	cmp.w	d0,d2
	blo.s	b02
	move.w	d2,d0
	move.w	#2,d5 ; 2=laagst
b02:
	cmp.w	d0,d3
	blo.s	b03
	move.w	d3,d0
	move.w	#3,d5 ; 3=laagst
b03:
	RTS

highest_calc:
	move.l	#coords+2,a2

	move.w	(a2),d0
	move.w	4(a2),d1
	move.w	8(a2),d2
	move.w	12(a2),d3

	move.w	#0,d4 ; 0=hoogst

	cmp.w	d0,d1
	bhi.s	c01
	move.w	d1,d0
	move.w	#1,d4 ; 1=hoogst
c01:
	cmp.w	d0,d2
	bhi.s	c02
	move.w	d2,d0
	move.w	#2,d4 ; 2=hoogst
c02:
	cmp.w	d0,d3
	bhi.s	c03
	move.w	d3,d0
	move.w	#3,d4 ; 3=hoogst
c03:
	RTS

; /   de BEREKEN routine   \
; --------------------------

go_calc_line:
	;a5=beginadres	=> X.w + Y.w
	;a6=eindadres	=> X.w + Y.w

	move.l	#databus1,a0 ; +(512*X-verschil)
	move.l	#array3d,a1 ; LIJN-ARRAY
	move.l	#databus2,a2
	move.l	#databus2b,a3

	move.w	(a5),d4  ; Xa
	move.w	2(a5),d5 ; Ya
	move.w	(a6),d6  ; Xb
	move.w	2(a6),d7 ; Yb

	add.w	#2,a1    ; kolom 2

	cmp.w	d5,d7
	bhi.s	NO_SWAP_BEG_EIND
; als d5>d7
	move.w	(a6),d4  ; Xa
	move.w	2(a6),d5 ; Ya
	move.w	(a5),d6  ; Xb
	move.w	2(a5),d7 ; Yb

	sub.w	#2,a1    ; kolom 2
NO_SWAP_BEG_EIND:

*******************************
*                             *
* Van de Y weet je alles zeker*
*                             *
*******************************
	move.w	d7,d2	; Y-verschil
	sub.w	d5,d2

	move.w	d5,d1	; real Y-begin
	asl.w	#3,d1	;*4
	add.w	d1,a1


************************
*                      *
* X aanpakken  / of \  *
*                      *
************************

	cmp.w	d4,d6	; Xa(d4),Xb(d6)
	bhi.s	LB_RO
 
; /
	clr.l	d1
	move.w	d4,d1	; X-verschil
	sub.w	d6,d1
	asl.l	#8,d1	; * 2^9
	asl.l	#1,d1	; d.w.z * 512
	add.l	d1,a0

	move.w	d4,d1	; real X-begin

	add.w	d2,a3	; pointer array
	add.w	d2,a3	; in words
	move.w	(a3),d0
	add.w	d0,a2

cop_loop:
	clr.w	d0
	move.b	(a2)+,d0
	asl.w	#1,d0
	move.w	(a0,d0.w),d0
	not.w	d0
	add.w	d1,d0	; schuif x op
	move.w	d0,(a1)

	add.w	#8,a1
	dbra	d2,cop_loop
	RTS
LB_RO:

; \
	clr.l	d1
	move.w	d6,d1	; X-verschil
	sub.w	d4,d1
	asl.l	#8,d1	; * 2^9
	asl.l	#1,d1	; d.w.z * 512
	add.l	d1,a0

	move.w	d4,d1	; real X-begin

	add.w	d2,a3	; pointer array
	add.w	d2,a3	; in words
	move.w	(a3),d0
	add.w	d0,a2

cop_loop2:
	clr.w	d0
	move.b	(a2)+,d0
	asl.w	#1,d0
	move.w	(a0,d0.w),d0
	add.w	d1,d0	; schuif x op
	move.w	d0,(a1)

	add.w	#8,a1
	dbra	d2,cop_loop2
	RTS


; -----------------------
; - de BEREKEN routines -
; -                     -
; -----------------------

;-------- GO SHOW 1
go_show:
	move.l	schermadres,a3
	move.l	#hlinedata,a4
	move.l	#movearray,a5
	move.l	#array3d,a2
	move.w	#-1,d0	; fill
	move.w	#0,d4	; fill
	move.w	#200-1,d3
y_go:
	move.w	(a2),d2
	asl.w	#1,d2
	move.w	(a5,d2.w),(a2)
	move.w	2(a2),d2
	asl.w	#1,d2
	move.w	(a5,d2.w),2(a2)

	move.l	a3,a0
	move.l	a4,a1
	move.w	(a2),d2 ; 1st
	and.w	#$000F,d2
	asl.w	#3,d2
	add.w	d2,a1

	move.w	(a2),d2 ; 1st
	and.w	#$FFF0,d2
	asr.w	#1,d2
	add.w	d2,a0

	move.w	2(a2),d2
	sub.w	(a2),d2
	asl.w	#7,d2
	add.w	d2,a1

	move.l	#return,a6
	move.w	(a1)+,d1
	jmp	28+hlindo(PC,d1.w)
return:
	add.w	#8,a2
	add.w	#160,a3
	dbra	d3,y_go
	RTS
hlindo:
	INCBIN	'F:\PROGRAMM\FASTEST.VEC\DATA\HLIN1AND.PRD'


;-------- GO SHOW 2

go_show2:
	move.l	schermadres,a3
	move.l	#hlinedata,a4
	move.l	#movearray,a5
	move.l	#array3d,a2
	move.w	#-1,d0	; fill
	move.w	#0,d4	; fill
	move.w	#200-1,d3
y_go2:
	move.w	(a2),d2
	asl.w	#1,d2
	move.w	(a5,d2.w),(a2)
	move.w	2(a2),d2
	asl.w	#1,d2
	move.w	(a5,d2.w),2(a2)

	move.l	a3,a0
	move.l	a4,a1
	move.w	2(a2),d2 ; 1st
	and.w	#$000F,d2
	asl.w	#3,d2
	add.w	d2,a1

	move.w	2(a2),d2 ; 1st
	and.w	#$FFF0,d2
	asr.w	#1,d2
	add.w	d2,a0

	move.w	(a2),d2
	sub.w	2(a2),d2
	asl.w	#7,d2
	add.w	d2,a1

	move.l	#return2,a6
	move.w	(a1)+,d1
	jmp	28+hlindo2(PC,d1.w)
return2:
	add.w	#8,a2
	add.w	#160,a3
	dbra	d3,y_go2
	RTS
hlindo2:
	INCBIN	'F:\PROGRAMM\FASTEST.VEC\DATA\HLIN1AND.PRD'


fill:
	move.l	schermadres,a0
	move.w	#(32000)/4/4-1,d0
fillloop:
	move.l	#65535*65536,(a0)+
	move.l	#0,(a0)+
	move.l	#65535*65536,(a0)+
	move.l	#0,(a0)+
	dbra	d0,fillloop
	RTS
;--------- CLEAR ARRAY
CLEAR3DARRAY:
	move.l	#array3d,a0
	move.w	#(200*8)/4/4-1,d0
clarray3d:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra	d0,clarray3d
	RTS

user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS

sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	move.l	#screen2,schermadres2
	add.l	#256,schermadres2
	and.l	#$ffffff00,schermadres2
	RTS
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
cls:
	move.w	#(160*200)/4/4-1,d0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
beeld_change:
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201
	RTS


ssp:	dc.l	0
schermadres:	dc.l	0
schermadres2:	dc.l	0
coords:	
	dc.w	240,10	; punt A
	dc.w	160,50	; punt B
	dc.w	100,180	; punt C
	dc.w	210,110	; punt D

array3d:
	REPT	200
	dc.w	0,255,0,0
	ENDR
;	ds.w	4*200
movearray:
pl set 0
	REPT	100
	dc.w	pl
	ENDR
	REPT	254
	dc.w	pl
pl set pl+1
	ENDR
	REPT	100
	dc.w	pl
	ENDR
screen2:	ds.b	32256

databus1:	INCBIN	'F:\PROGRAMM\FASTEST.VEC\DATA\POL_LIN1.DAT'
databus2:	INCBIN	'F:\PROGRAMM\FASTEST.VEC\DATA\POL_LIN2.DAT' ; pointers naar databus1
databus2b:	INCBIN	'F:\PROGRAMM\FASTEST.VEC\DATA\POL_LI2B.DAT' ; pointers naar databus2
hlinedata:	INCBIN	'F:\PROGRAMM\FASTEST.VEC\DATA\POLDATAN.DAT'
;			y,x1,x2



; data bus is een array x=(a,b)

; x = (b/320)*a

; hlinedata is een array met
; steeds 4 words
; word 1 - A
; word 2 - B
; word 3 - lengte

; EEN LIJN :  ----A-lengte-B----

