;******************
;*   FAST-POLY    *
;*      BY        *
;*   EXECUTE OF   *
;* THE EXPERIENCE *
;******************

	bsr	schermadr_opvraag
	bsr	sup_vis_mode
back:
	bsr	beeld_change
	bsr	cls
	move.w	#$070,$ff8240
	bsr	go_sort_high_low
	move.w	#$007,$ff8240
	bsr	calc_lines
	move.w	#$770,$ff8240
	bsr	go_show

;	add.w	#1,coords+2
	move.w	#$777,$ff8240

	bsr	vsync

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back

	bsr	wacht_toets
	bsr	user_mode
	clr.l	-(sp)
	trap	#1

go_sort_high_low:
	move.l	#coords,a0
	move.w	2(a0),d0
	move.w	#0,d4

	cmp.w	8+2(a0),d0
	bhi	second_is_lower1
	move.w	8+2(a0),d0
	move.w	#1,d2
	move.w	#%010,d3
	move.w	#1,d4	; heb al iets gedaan !
  second_is_lower1:

	cmp.w	16+2(a0),d0
	bhi	third_is_lower1
	move.w	16+2(a0),d0
	move.w	#2,d2
	move.w	#%100,d3
	move.w	#1,d4	; heb al iets gedaan !
  third_is_lower1:

	tst.w	d4
	bne.s	laagst_end
	move.w	#0,d2
	move.w	#%001,d3
  laagst_end:


	move.w	2(a0),d0
	move.w	#0,d4

	cmp.w	8+2(a0),d0
	blo	second_is_lower2
	move.w	8+2(a0),d0
	move.w	#1,d1
	or.w	#%010,d3
	move.w	#1,d4	; heb al iets gedaan !
  second_is_lower2:

	cmp.w	16+2(a0),d0
	blo	third_is_lower2
	move.w	16+2(a0),d0
	move.w	#2,d1
	or.w	#%100,d3
	move.w	#1,d4	; heb al iets gedaan !
  third_is_lower2:

	tst.w	d4
	bne.s	hoogst_end
	move.w	#0,d1
	or.w	#%001,d3
  hoogst_end:

  ;hoogst
	asl.w	#3,d1

	move.w	(a0,d1.w),hoogst
	move.w	2(a0,d1.w),hoogst+2
	move.w	4(a0,d1.w),hoogst+4
	move.w	6(a0,d1.w),hoogst+6

  ;laagst
	asl.w	#3,d2

	move.w	(a0,d2.w),laagst
	move.w	2(a0,d2.w),laagst+2
	move.w	4(a0,d2.w),laagst+4
	move.w	6(a0,d2.w),laagst+6

	and.w	#%111,d3

	cmp.w	#%011,d3
	bne.s	not_011
	move.w	#16,d3
	bra	klaar_d3_andere
  not_011:
	cmp.w	#%101,d3
	bne.s	not_101
	move.w	#8,d3
	bra	klaar_d3_andere
  not_101:
	cmp.w	#%110,d3
	bne.s	not_110
	move.w	#0,d3
	bra	klaar_d3_andere
  not_110:

  klaar_d3_andere:

	move.w	(a0,d3.w),andere
	move.w	2(a0,d3.w),andere+2
	move.w	4(a0,d3.w),andere+4
	move.w	6(a0,d3.w),andere+6

	RTS


calc_lines:

; TEKEN de lijn hoog-laag
	move.l	#array3d,a1 ; 1e kolom
	move.w	hoogst+2,d1 ;y
	asl.w	#3,d1
	add.w	d1,a1

	move.w	hoogst,d0   ;x
	move.w	laagst+2,d2 ; y2  y-verschil
	sub.w	hoogst+2,d2 ; -y  in d2
	move.w	laagst,d1 ; x2  x-verschil
	sub.w	hoogst,d1 ; -x  in d1
	btst	#15,d1
	bne.s	xlength_is_negative1
	bsr	do_line_to_right
	bra	endif1
xlength_is_negative1:
	not.w	d1
	bsr	do_line_to_left
endif1:

; TEKEN de lijn hoog-andere-laag
	move.l	#array3d+2,a1 ; 2e kolom
	move.w	hoogst+2,d1 ;y
	asl.w	#3,d1
	add.w	d1,a1

	move.w	hoogst,d0   ;x
	move.w	andere+2,d2 ; y2  y-verschil
	sub.w	hoogst+2,d2 ; -y  in d2
	move.w	andere,d1 ; x2  x-verschil
	sub.w	hoogst,d1 ; -x  in d1
	btst	#15,d1
	bne.s	xlength_is_negative2
	bsr	do_line_to_right
	bra	endif2
xlength_is_negative2:
	not.w	d1
	bsr	do_line_to_left
endif2:

	move.l	#array3d+2,a1 ; 2e kolom
	move.w	andere+2,d1 ;y
	asl.w	#3,d1
	add.w	d1,a1

	move.w	andere,d0   ;x
	move.w	laagst+2,d2 ; y2  y-verschil
	sub.w	andere+2,d2 ; -y  in d2
	move.w	laagst,d1 ; x2  x-verschil
	sub.w	andere,d1 ; -x  in d1
	btst	#15,d1
	bne.s	xlength_is_negative3
	bsr	do_line_to_right
	bra	endif3
xlength_is_negative3:
	not.w	d1
	bsr	do_line_to_left
endif3:




; zet de punten toch nog even 
; in de array.

	move.l	#array3d,a1
	move.w	hoogst,d0   ;x
	move.w	hoogst+2,d1 ;y
	asl.w	#3,d1
	add.w	d1,a1
	move.w	d0,(a1)
	move.w	d0,2(a1)
	move.l	#array3d,a1
	move.w	laagst,d0   ;x
	move.w	laagst+2,d1 ;y
	asl.w	#3,d1
	add.w	d1,a1
	move.w	d0,(a1)
	move.w	d0,2(a1)
	move.l	#array3d,a1
	move.w	andere,d0   ;x
	move.w	andere+2,d1 ;y
	asl.w	#3,d1
	add.w	d1,a1
	move.w	d0,2(a1)
	RTS

; -----------------------
; - de BEREKEN routines -
; -                     -
; -----------------------

do_line_to_right:
	; array in a1
	; bovenx in d0
	; xverschil in d1
	; yverschil in d2
	move.w	d2,d5
	asl.w	#3,d5
	move.w	d2,d3	; d3=loop
do_lin_r_loop:
	move.w	d3,d4	; d4=calcer
	mulu	d1,d4
	divu	d2,d4
	add.w	d0,d4
	move.w	d4,(a1,d5.w)
	sub.w	#8,d5
	dbra	d3,do_lin_r_loop
	RTS

do_line_to_left:
	; array in a1
	; bovenx in d0
	; xverschil in d1
	; yverschil in d2
	move.w	d2,d5
	asl.w	#3,d5
	move.w	d2,d3	; d3=loop
do_lin_l_loop:
	move.w	d3,d4	; d4=calcer
	mulu	d1,d4
	divu	d2,d4
	not.w	d4
	add.w	d0,d4
	move.w	d4,(a1,d5.w)
	sub.w	#8,d5
	dbra	d3,do_lin_l_loop
	RTS

indicator:
	move.l	schermadres,a6
	move.w	#31*64,(a6)
	move.w	#31*64,2(a6)
	move.w	#31*64,4(a6)
	move.w	#31*64,640(a6)
	move.w	#31*64,642(a6)
	move.w	#31*64,644(a6)
	move.w	#31*64,1280(a6)
	move.w	#31*64,1282(a6)
	move.w	#31*64,1284(a6)
	RTS


go_show:
	move.l	schermadres,a3
	move.l	#hlinedata,a4
	move.l	#array3d,a2
	move.w	#-1,d0	; fill
	move.w	#199-1,d3
y_go:
	move.l	a3,a0
	move.l	a4,a1
	move.w	(a2),d2 ; 1st
	and.w	#$000F,d2
	asl.w	#3,d2
	add.w	d2,a1

	move.w	(a2),d2 ; 1st
	and.w	#$FFF0,d2
	asr.w	#1,d2
	add.w	d2,a0

	move.w	2(a2),d2
	sub.w	(a2),d2
	asl.w	#7,d2
	add.w	d2,a1

	move.l	#return,a6
	move.w	(a1)+,d1
	jmp	hlindo(PC,d1.w)
return:

	add.w	#8,a2
	add.w	#160,a3
	dbra	d3,y_go

	RTS

hlindo:
;-- 8
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	jmp	(a6)      ; 2
;-- 16
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$8(a0) ; 4
	jmp	(a6)      ; 2
;-- 20
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$10(a0); 4
	or.w	d0,$8(a0) ; 4
	jmp	(a6)      ; 2
;-- 24
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$18(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	jmp	(a6)      ; 2
;-- 28
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$20(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	jmp	(a6)      ; 2
;-- 32
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$28(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	jmp	(a6)      ; 2
;-- 36
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$30(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	jmp	(a6)      ; 2
;-- 40
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$38(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	jmp	(a6)      ; 2
;-- 44
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$40(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	jmp	(a6)      ; 2
;-- 48
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$48(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	jmp	(a6)      ; 2
;-- 52
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$50(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	jmp	(a6)      ; 2
;-- 56
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$58(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	jmp	(a6)      ; 2
;-- 60
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$60(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	jmp	(a6)      ; 2
;-- 64
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$68(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	jmp	(a6)      ; 2
;-- 68
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$70(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	jmp	(a6)      ; 2
;-- 72
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$78(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	or.w	d0,$70(a0); 4
	jmp	(a6)      ; 2
;-- 76
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$80(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	or.w	d0,$70(a0); 4
	or.w	d0,$78(a0); 4
	jmp	(a6)      ; 2
;-- 80
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$88(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	or.w	d0,$70(a0); 4
	or.w	d0,$78(a0); 4
	or.w	d0,$80(a0); 4
	jmp	(a6)      ; 2
;-- 84
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$90(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	or.w	d0,$70(a0); 4
	or.w	d0,$78(a0); 4
	or.w	d0,$80(a0); 4
	or.w	d0,$88(a0); 4
	jmp	(a6)      ; 2
;-- 88
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,(a0)   ; 2
	move.w	(a1)+,d1  ; 2
	and.w	d0,d1     ; 2
	or.w	d1,$98(a0); 4
	or.w	d0,$8(a0) ; 4
	or.w	d0,$10(a0); 4
	or.w	d0,$18(a0); 4
	or.w	d0,$20(a0); 4
	or.w	d0,$28(a0); 4
	or.w	d0,$30(a0); 4
	or.w	d0,$38(a0); 4
	or.w	d0,$40(a0); 4
	or.w	d0,$48(a0); 4
	or.w	d0,$50(a0); 4
	or.w	d0,$58(a0); 4
	or.w	d0,$60(a0); 4
	or.w	d0,$68(a0); 4
	or.w	d0,$70(a0); 4
	or.w	d0,$78(a0); 4
	or.w	d0,$80(a0); 4
	or.w	d0,$88(a0); 4
	or.w	d0,$90(a0); 4
	jmp	(a6)      ; 2






user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS

sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	move.l	#screen2,schermadres2
	RTS
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
cls:
	move.l	#(160*200)/4/4-1,d0
	move.l	schermadres,a0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
beeld_change:
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	move.l	schermadres2,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2
	RTS


ssp:	dc.l	0
schermadres:	dc.l	0
schermadres2:	dc.l	0
coords:	dc.w	120,40,0,0
	dc.w	20,20,0,0
	dc.w	40,160,0,0
hoogst:	dc.w	0,0,0,0
laagst:	dc.w	0,0,0,0
andere:	dc.w	0,0,0,0

array3d:	
	REPT	200
	dc.w	240,245,0,0
	ENDR
;	ds.w	4*200

screen2:	ds.b	32256

hlinedata:	INCBIN 'F:\PROGRAMM\FASTVECT\POLYDATA.DAT'
;			y,x1,x2
