	bsr	schermadr_opvraag
	bsr	sup_vis_mode

	move.l	#0,$45e
	move.l	#red_video,a0
	bsr	redden_inst
	move.l	#nieuwe_video,a0
	bsr	zetten_inst

back:
	bsr	do_programm_screen_width0
	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back


	move.l	#red_video,a0
	bsr	zetten_inst

	bsr	user_mode
	clr.l	-(sp)
	trap	#1


do_programm_screen_width0
	move.l	schermadres,a0
	add.w	counter,a0
	move.w	counter,(a0)
	add.w	#2,counter
	bsr	vsync
	RTS
do_programm_TC_overscan
	move.l	schermadres,a0
	move.w	#236-1,d0
verloop:
	move.w	#884/4-1,d1
horloop	clr.l	(a0)+
	dbra	d1,horloop
	move.w	#-1,-880+440(a0)
	dbra	d0,verloop
	RTS

do_programm_VGA_overscan:
	move.l	schermadres,a0
	move.w	#216-1,d0
verloo2
	move.w	#440/4-1,d1
horloo2 clr.l	(a0)+
	dbra	d1,horloo2
	move.w	#-1,-440+220(a0)
	dbra	d0,verloo2
	RTS

schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS

zetten_inst:
	move.w	(a0)+,$ffff8210.w
	move.w	(a0)+,d0
	bmi.s	label
	move.w	d0,$ffff8266.w
label:
	move.w	(a0)+,$ffff82a2.w
	move.w	(a0)+,$ffff82a4.w
	move.w	(a0)+,$ffff82a6.w
	move.w	(a0)+,$ffff82a8.w
	move.w	(a0)+,$ffff82aA.w
	move.w	(a0)+,$ffff82aC.w
	move.w	(a0)+,$ffff8282.w
	move.w	(a0)+,$ffff8284.w
	move.w	(a0)+,$ffff8286.w
	move.w	(a0)+,$ffff8288.w
	move.w	(a0)+,$ffff828a.w
	move.w	(a0)+,$ffff828c.w
	move.w	(a0)+,$ffff828e.w
	move.w	(a0)+,$ffff8290.w
	move.w	(a0)+,$ffff82c0.w
	move.w	(a0)+,$ffff82c2.w
	RTS

redden_inst:
	move.w	$ffff8210.w,(a0)+
	move.w	$ffff8266.w,(a0)+
	move.w	$ffff82a2.w,(a0)+
	move.w	$ffff82a4.w,(a0)+
	move.w	$ffff82a6.w,(a0)+
	move.w	$ffff82a8.w,(a0)+
	move.w	$ffff82aA.w,(a0)+
	move.w	$ffff82aC.w,(a0)+
	move.w	$ffff8282.w,(a0)+
	move.w	$ffff8284.w,(a0)+
	move.w	$ffff8286.w,(a0)+
	move.w	$ffff8288.w,(a0)+
	move.w	$ffff828a.w,(a0)+
	move.w	$ffff828c.w,(a0)+
	move.w	$ffff828e.w,(a0)+
	move.w	$ffff8290.w,(a0)+
	move.w	$ffff82c0.w,(a0)+
	move.w	$ffff82c2.w,(a0)+
	RTS

wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS

vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS

user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS

sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
red_video:	ds.w	20

	dc.w	0,256,625,613
	dc.w	47,95,567,619,254
	dc.w	203,39,46,143,216,0
	dc.w	0,387,0

	dc.w	320,256,625,613 ; TC 320*200
	dc.w	47,127,527,619,254
	dc.w	203,39,46,143,216,0
	dc.w	0,387,0

	dc.w	440,256,625,613 ; TC OVERSCAN (BLOKKERIG DOOR ONDERSTE "3")
	dc.w	47,$5f,567,619,254
	dc.w	203,39,$2ec,$8d+$30,216,0
	dc.w	0,387,3

	dc.w	160,16,625,613 ; VGA 320*200
	dc.w	47,127,527,619,254
	dc.w	203,39,28,125,216,0
	dc.w	0,387,0

nieuwe_video:
	dc.w	220,16,625,613 ; VGA OVERSCAN
	dc.w	47,$5f,527,619,254
	dc.w	203,39,$2ec,$8d+32,216,0
	dc.w	0,387,0

	dc.w	$60,$0,$271,$265 ; 384*(+200) 16col
	dc.w	$2f,$5f,$237,$26b,$fe
	dc.w	$cb,$27,$2ec,$8d,$d8,$0
	dc.w	$0,$181,$0

	dc.w	$C0,$10,$271,$265 ; +- 1600*600 16 col
	dc.w	$2f,$57,$237,$26b,$fe
	dc.w	$cb,$27,$2fc,$9d,$d8,$0
	dc.w	$0,$181,$0
ssp:		dc.l	0
schermadres:	dc.l	0
counter:	dc.w	0