; Volume 22 en hoger alleen hoorbaar?

SHOW		EQU	1
TRANSP		EQU	4 ; 4
EXTRALOOP	EQU	1800
SPEED		EQU	30   ; *
BUFFLEN		EQU	600*2
CLSBYTES	EQU	64000

; *** INIT ***
	bsr	schermadr_opvraag
	bsr	install_joy
	bsr	sup_vis_mode
	dc.w	$a00a ; muis uit
	bsr	store_colors
	bsr	set_colors
	bsr	switch_sign_sample ; klaar maken voor volume bewerkingen
	jsr	calc_offsets_samples ; zet offsets in een array
	bsr	calc_loop_further ; Loops <320 groter maken
	bsr	init_music  ; XBIOS
	bsr	set_samples ; zet kanalen eigenlijk aan
	bsr	done_samples_update ; deactiveer in-actieve kanalen
	move.w	#0,syncadd
	move.w	$ffff8210,old8210
	move.l	#module,mod_offset
	move.w	#0,mus_spcounter
	move.w	#5,mus_sp
	move.l	#vol_tab_left,offsetvolume_kan1
	move.l	#vol_tab_right,offsetvolume_kan2
	move.l	#vol_tab_right,offsetvolume_kan3
	move.l	#vol_tab_left,offsetvolume_kan4
	move.l	#1,camerax
	bsr	show_veld_begin
; *** MAIN LOOP ***
back:
	bsr	vsync
	move.l	#$99990099*SHOW,$ffff9800
	bsr	take_care_of_syncscroll
	move.l	#$88880088*SHOW,$ffff9800
	bsr	joy_handle
	move.l	#$66660066*SHOW,$ffff9800

	move.l	#0,$ffff9800
	move.w	volume2,d0
	and.w	#63,d0
	tst.w	d0
	beq.s	skipvol
	sub.w	#1,d0
	move.l	#$00000000,d1
col_loop:
	add.l	#$04000004,d1
	dbra	d0,col_loop
	move.l	d1,$ffff9800
skipvol
	bsr	vol_tab_calc
	bsr	go_muzak

	bsr	update_pospacket
	bsr	show_gone
	bsr	calc_buffer_if_not_ready
	bsr	done_samples_update

	move.l	#$77770077*SHOW,$ffff9800

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back

; *** EXIT ***
	bsr	wacht_toets
	;bsr	old_coolVBL
	bsr	vsync
	bsr	close_music
	move.w	#$2100,SR
	bsr	beeld_restore
	move.w	#$777,$ff8240
	move.l	#$ffff00ff,$ffff9800
	move.w	#127,$ffff82a8 ; 127 -> oud
	move.w	#527,$ffff82aa ; 527 -> oud
	bsr	restore_colors
	bsr	restore_joy
	bsr	user_mode
	clr.l	-(sp)
	trap	#1

;------------------------------------
show_veld_begin:
	move.w	#0,some_y
shveldbegy:
	move.w	#0,some_x
shveldbegx:
	move.w	some_x,d0
	move.w	some_y,d1
	bsr	veld_show_1blok
	add.w	#1,some_x
	cmp.w	#21,some_x
	bne.s	shveldbegx
	add.w	#1,some_y
	cmp.w	#17,some_y
	bne.s	shveldbegy
	RTS

veld_show_1blok:
	move.l	#veld,a0
	move.l	schermadres,a1
	move.l	#block_row+256*3,a2

	add.w	d0,a0 ; Xveld
	clr.l	d2
	move.w	d0,d2 ; Xscreen
	asl.l	#4,d2
	add.l	d2,a1

	clr.l	d2    ; Yveld
	move.w	d1,d2
	asl.l	#8,d2
	add.l	d2,a0
	clr.l	d2    ; Yscreen
	move.w	d1,d2
	mulu	#21,d2
	asl.l	#8,d2
	add.l	d2,a1

	clr.l	d2
	move.b	(a0),d2
	asl.l	#8,d2
	add.l	d2,a2

pl set 0
	REPT	16
	move.l	(a2)+,pl(a1)
	move.l	(a2)+,pl+4(a1)
	move.l	(a2)+,pl+8(a1)
	move.l	(a2)+,pl+12(a1)
pl set pl+336
	ENDR
	RTS


;------------------------------------
vol_tab_calc:
	move.l	#vol_tab_left,d0
	move.w	volume1,d1
	not.w	d1
	and.w	#63,d1 ; AND 127
	asl.w	#8,d1 ; *256
	add.w	d1,d0
	move.l	d0,offsetvolume_kan1

	move.l	#vol_tab_right,d0
	move.w	volume2,d1
	not.w	d1
	and.w	#63,d1 ; AND 127
	asl.w	#8,d1 ; *256
	add.w	d1,d0
	move.l	d0,offsetvolume_kan2

	move.l	#vol_tab_right,d0
	move.w	volume3,d1
	not.w	d1
	and.w	#63,d1 ; AND 127
	asl.w	#8,d1 ; *256
	add.w	d1,d0
	move.l	d0,offsetvolume_kan3

	move.l	#vol_tab_left,d0
	move.w	volume4,d1
	not.w	d1
	and.w	#63,d1 ; AND 127
	asl.w	#8,d1 ; *256
	add.w	d1,d0
	move.l	d0,offsetvolume_kan4
	RTS
;------------------------------------
;--------- Bereken Muziek -----------
;------------------------------------
go_muzak:
	add.w	#1,mus_spcounter
	move.w	mus_sp,d0
	cmp.w	mus_spcounter,d0
	bne.s	no_mus
	move.w	#0,mus_spcounter

; d0 => eigenlijke code
; d1 => kanaal nummer (cc)
; d2 => soort code (kkkkkk)
; d3 => code (vvvvvvvv)

	move.l	mod_offset,a0
nog_een_code:
	move.w	(a0)+,d0
	move.w	d0,d1
	asr.w	#8,d1
	asr.w	#6,d1
	and.w	#3,d1
	move.w	d0,d2
	asr.w	#8,d2
	and.w	#63,d2
	move.w	d0,d3
	and.w	#255,d3

	cmp.w	#63,d2 ; einde song
	beq.s	done_song
	cmp.w	#62,d2 ; einde regel
	beq.s	done_regel

	move.w	#0,mod_chk_handle
	bsr	chk_nieuwe_sample
	bsr	chk_nieuwe_freq
	bsr	chk_nieuwe_volume
	bsr	chk_volume_up
	bsr	chk_volume_down
	bra	nog_een_code
done_regel:
	move.l	a0,mod_offset
	RTS
done_song:
	move.l	#module,mod_offset
no_mus:	RTS

chk_nieuwe_sample:
	move.l	#offsets_samples,a1
	cmp.w	#59,d2
	bne	geen59

	cmp.w	#0,d1 ; kan.nr0
	bne.s	nkan0
	mulu	#40,d3
	add.w	d3,a1
	move.l	(a1)+,offsetsample_kan1
	move.l	(a1)+,offsetsamloop_kan1
	move.l	(a1)+,offsetsamend_kan1
	move.w	(a1)+,loopsetsample_kan1
	move.w	(a1)+,volume1
	move.w	#0,done_kan1
	move.w	#1,mod_chk_handle
	RTS
nkan0:
	cmp.w	#1,d1 ; kan.nr1
	bne.s	nkan1
	mulu	#40,d3
	add.w	d3,a1
	move.l	(a1)+,offsetsample_kan2
	move.l	(a1)+,offsetsamloop_kan2
	move.l	(a1)+,offsetsamend_kan2
	move.w	(a1)+,loopsetsample_kan2
	move.w	(a1)+,volume2
	move.w	#0,done_kan2
	move.w	#1,mod_chk_handle
	RTS
nkan1:
	cmp.w	#2,d1 ; kan.nr2
	bne.s	nkan2
	mulu	#40,d3
	add.w	d3,a1
	move.l	(a1)+,offsetsample_kan3
	move.l	(a1)+,offsetsamloop_kan3
	move.l	(a1)+,offsetsamend_kan3
	move.w	(a1)+,loopsetsample_kan3
	move.w	(a1)+,volume3
	move.w	#0,done_kan3
	move.w	#1,mod_chk_handle
	RTS
nkan2:
	cmp.w	#3,d1 ; kan.nr3
	bne.s	nkan3
	mulu	#40,d3
	add.w	d3,a1
	move.l	(a1)+,offsetsample_kan4
	move.l	(a1)+,offsetsamloop_kan4
	move.l	(a1)+,offsetsamend_kan4
	move.w	(a1)+,loopsetsample_kan4
	move.w	(a1)+,volume4
	move.w	#0,done_kan4
	move.w	#1,mod_chk_handle
	RTS
nkan3:
geen59:
	RTS
chk_nieuwe_freq:
	cmp.w	#32,d2
	bne	geen32
	cmp.w	#0,d1 ; kan.nr0
	bne.s	nkan0b
	mulu	#600,d3
	move.w	d3,eoffspeed_kan1
nkan0b
	cmp.w	#1,d1 ; kan.nr0
	bne.s	nkan1b
	mulu	#600,d3
	move.w	d3,eoffspeed_kan2
nkan1b
	cmp.w	#2,d1 ; kan.nr0
	bne.s	nkan2b
	mulu	#600,d3
	move.w	d3,eoffspeed_kan3
nkan2b
	cmp.w	#3,d1 ; kan.nr0
	bne.s	nkan3b
	mulu	#600,d3
	move.w	d3,eoffspeed_kan4
nkan3b
geen32
	RTS
chk_nieuwe_volume
	cmp.w	#3,d2
	bne	geen3
	cmp.w	#0,d1 ; kan.nr1
	bne.s	nkan0c
	move.w	d3,volume1
	and.w	#63,volume1
nkan0c
	cmp.w	#1,d1 ; kan.nr2
	bne.s	nkan1c
	move.w	d3,volume2
	and.w	#63,volume2
	add.l	#$00cc0000*SHOW,$ffff9800
nkan1c
	cmp.w	#2,d1 ; kan.nr3
	bne.s	nkan2c
	move.w	d3,volume3
	and.w	#63,volume3
nkan2c
	cmp.w	#3,d1 ; kan.nr4
	bne.s	nkan3c
	move.w	d3,volume4
	and.w	#63,volume4
nkan3c
geen3
	RTS
chk_volume_up
	cmp.w	#4,d2
	bne	geen3

	cmp.w	#0,d1 ; kan.nr0
	bne.s	nkan0d
	move.w	volume1,d4
	add.w	d3,d4
	bsr	vol_up_begrens
	move.w	d4,volume1
nkan0d
	cmp.w	#1,d1 ; kan.nr1
	bne.s	nkan1d
	move.w	volume2,d4
	add.w	d3,d4
	bsr	vol_up_begrens
	move.w	d4,volume2
nkan1d
	cmp.w	#2,d1 ; kan.nr2
	bne.s	nkan2d
	move.w	volume3,d4
	add.w	d3,d4
	bsr	vol_up_begrens
	move.w	d4,volume3
nkan2d
	cmp.w	#3,d1 ; kan.nr3
	bne.s	nkan3d
 	move.w	volume4,d4
	add.w	d3,d4
	bsr	vol_up_begrens
	move.w	d4,volume4
nkan3d
	RTS
vol_up_begrens:
	cmp.w	#63,d4
	blo.s	begrens_a
	move.w	#63,d4
begrens_a
	RTS

chk_volume_down
	cmp.w	#5,d2
	bne	geen3

	cmp.w	#0,d1 ; kan.nr0
	bne.s	nkan0e
	move.w	volume1,d4
	sub.w	d3,d4
	bsr	vol_down_begrens
	move.w	d4,volume1
nkan0e
	cmp.w	#1,d1 ; kan.nr1
	bne.s	nkan1e
	move.w	volume2,d4
	sub.w	d3,d4
	bsr	vol_down_begrens
	move.w	d4,volume2
nkan1e
	cmp.w	#2,d1 ; kan.nr2
	bne.s	nkan2e
	move.w	volume3,d4
	sub.w	d3,d4
	bsr	vol_down_begrens
	move.w	d4,volume3
nkan2e
	cmp.w	#3,d1 ; kan.nr3
	bne.s	nkan3e
	move.w	volume4,d4
	sub.w	d3,d4
	bsr	vol_down_begrens
	move.w	d4,volume4
nkan3e
	RTS
vol_down_begrens:
	tst.w	d4
	bge.s	begrens_b
	move.w	#0,d4
begrens_b
	RTS
;------------------------------------
;--- Bereken Volgende Sync-scroll ---
;------------------------------------
take_care_of_syncscroll:
	move.l	cameray,d0
	mulu	#21,d0
	asl.l	#4,d0
	add.l	camerax,d0
	move.l	d0,syncscrolloffset

	move.l	#sync_tabel,a0
	move.l	syncscrolloffset,d0
	asr.w	#4,d0 ;(4) DIV 16
	and.w	#15,d0 ; AND 15
	asl.w	#2,d0 ; *4
	add.w	d0,a0

	move.w	#50,d0 ;(80) upBORDER
	add.w	(a0),d0
	add.w	(a0),d0
	move.w	d0,sync_y

	move.l	schermadres,d0
	asr.l	#8,d0
	add.w	2(a0),d0
	add.w	#1,d0

	move.l	syncscrolloffset,d1
	asr.l	#8,d1 ; DIV 256
	add.l	d1,d0

	move.l	d0,sync_vidadr

	move.l	syncscrolloffset,d0
	and.b	#15,d0
	move.b	d0,sync15  ; $ffff8265

	move.w	#160,d1
	move.w	d1,syncwidth

	move.b	sync15,$ffff8265 ; MOD 15
	move.w	syncwidth,$ffff8210 ; RESTORE PLEASE
	move.w	sync_y,$ffff82a8 ; 50 -> uit beeldscherm !
	move.w	#527+50,$ffff82aa ; 527 -> oud

	move.l	sync_vidadr,d0 ;set schermadres
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	;not.w	VBLsign
	;move.w	#$070,$ff8240
	;move.l	#$00ff0000*SHOW,$ffff9800

	RTS
;------------------------------------
;----------- Loop afhandeling--------
;------------------------------------
calc_loop_further:
	move.l	#offsets_samples,a6
	move.w	#20-1,d7 ; 20
everysamp:
	move.l	8(a6),a1 ;Cloopeind
	move.l	8(a6),a2 ; loopeind
	add.w	#EXTRALOOP,a2

	move.l	8(a6),d0 ; loopeind
	sub.l	4(a6),d0 ; loopbegin

big_looping:
	move.l	4(a6),a0 ;Cloopbegin
	move.l	d0,d1
looping
	move.b	(a0)+,(a1)+
	cmp.l	a1,a2
	beq.s	klaar
	sub.l	#1,d1
	tst.l	d1
	bne.s	looping
	bra	big_looping
klaar:
	add.w	#40,a6
	dbra	d7,everysamp

	RTS
;------------------------------------
;------------ Welke af te spelen ----
;------------------------------------
set_samples:
	move.l	#offsets_samples,a0
	add.w	#40*1,a0
	move.l	(a0),offsetsample_kan1
	move.l	4(a0),offsetsamloop_kan1
	move.l	8(a0),offsetsamend_kan1
	move.w	12(a0),loopsetsample_kan1
	move.w	#600*36,eoffspeed_kan1

	move.l	#offsets_samples,a0
	add.w	#40*1,a0
	move.l	(a0),offsetsample_kan3
	move.l	4(a0),offsetsamloop_kan3
	move.l	8(a0),offsetsamend_kan3
	move.w	12(a0),loopsetsample_kan3
	move.w	#600*40,eoffspeed_kan3

	move.l	#offsets_samples,a0
	add.w	#40*1,a0
	move.l	(a0),offsetsample_kan2
	move.l	4(a0),offsetsamloop_kan2
	move.l	8(a0),offsetsamend_kan2
	move.w	12(a0),loopsetsample_kan2
	move.w	#600*40,eoffspeed_kan2

	move.l	#offsets_samples,a0
	move.l	(a0),offsetsample_kan4
	move.l	4(a0),offsetsamloop_kan4
	move.l	8(a0),offsetsamend_kan4
	move.w	12(a0),loopsetsample_kan4
	move.w	#600*40,eoffspeed_kan4

	move.w	#1,done_kan1 ; 0= AAN
	move.w	#1,done_kan2 ; 1= UIT
	move.w	#1,done_kan3
	move.w	#1,done_kan4
	RTS
;------------------------------------
;------------ Sample Klaar of Loop --
;------------------------------------
done_samples_update:
	move.l	offsetsample_kan1,d0
	move.l	offsetsamend_kan1,d1
	cmp.l	d0,d1 ; nog niet klaar voor loop
	bhi.s	noloop1b
	tst.w	loopsetsample_kan1 ; loop off
	bne.s	noloop1a
	move.w	#1,done_kan1
noloop1a:
	tst.w	loopsetsample_kan1 ; loop off
	beq.s	noloop1b
	move.l	offsetsamend_kan1,d2
	sub.l	offsetsamloop_kan1,d2
goloop1
	sub.l	d2,offsetsample_kan1
	move.l	offsetsample_kan1,d0
	move.l	offsetsamend_kan1,d1
	cmp.l	d0,d1 ; nog niet klaar voor loop
	blo.s	goloop1
	; BY KLEINE LOOPJES!
	;sub.l	d2,offsetsample_kan1
	;move.w	#$007,$ff8240
	;move.l	#$000000ff*SHOW,$ffff9800
noloop1b:

	move.l	offsetsample_kan2,d0
	move.l	offsetsamend_kan2,d1
	cmp.l	d0,d1 ; nog niet klaar voor loop
	bhi.s	noloop2b
	tst.w	loopsetsample_kan2 ; loop off
	bne.s	noloop2a
	move.w	#1,done_kan2
noloop2a:
	tst.w	loopsetsample_kan2 ; loop off
	beq.s	noloop2b

	move.l	offsetsamend_kan2,d2
	sub.l	offsetsamloop_kan2,d2
goloop2
	sub.l	d2,offsetsample_kan2
	move.l	offsetsample_kan2,d0
	move.l	offsetsamend_kan2,d1
	cmp.l	d0,d1 ; nog niet klaar voor loop
	blo.s	goloop2

noloop2b:


	move.l	offsetsample_kan3,d0
	move.l	offsetsamend_kan3,d1
	cmp.l	d0,d1 ; nog niet klaar voor loop
	bhi.s	noloop3b
	tst.w	loopsetsample_kan3 ; loop off
	bne.s	noloop3a
	move.w	#1,done_kan3
noloop3a:
	tst.w	loopsetsample_kan3 ; loop off
	beq.s	noloop3b

	move.l	offsetsamend_kan3,d2
	sub.l	offsetsamloop_kan3,d2
goloop3
	sub.l	d2,offsetsample_kan3
	move.l	offsetsample_kan3,d0
	move.l	offsetsamend_kan3,d1
	cmp.l	d0,d1 ; nog niet klaar voor loop
	blo.s	goloop3

noloop3b:


	move.l	offsetsample_kan4,d0
	move.l	offsetsamend_kan4,d1
	cmp.l	d0,d1 ; nog niet klaar voor loop
	bhi.s	noloop4b
	tst.w	loopsetsample_kan4 ; loop off
	bne.s	noloop4a
	move.w	#1,done_kan4
noloop4a:
	tst.w	loopsetsample_kan4 ; loop off
	beq.s	noloop4b

	move.l	offsetsamend_kan4,d2
	sub.l	offsetsamloop_kan4,d2
goloop4
	sub.l	d2,offsetsample_kan4
	move.l	offsetsample_kan4,d0
	move.l	offsetsamend_kan4,d1
	cmp.l	d0,d1 ; nog niet klaar voor loop
	blo.s	goloop4

noloop4b:

	tst.w	done_kan1
	beq.s	noup1
	move.l	offsetsamend_kan1,offsetsample_kan1
noup1:
	tst.w	done_kan2
	beq.s	noup2
	move.l	offsetsamend_kan2,offsetsample_kan2
noup2:
	tst.w	done_kan3
	beq.s	noup3
	move.l	offsetsamend_kan3,offsetsample_kan3
noup3:
	tst.w	done_kan4
	beq.s	noup4
	move.l	offsetsamend_kan4,offsetsample_kan4
noup4:
	RTS
;------------------------------------
;-----------  Update DMA-buffer -----
;------------------------------------
calc_buffer_if_not_ready:
	move.w	calcbuffnr,d0
	move.w	prevcalcbuffnr,d1
	cmp.w	d0,d1
	beq	calcdone
	move.w	#0,buffdone

	move.l	#dmabuffer,offsetcalcbuff
	move.l	#dmabuffer+BUFFLEN,offsetcalcbuff_end

	cmp.w	#0,d0
	beq.s	nog_zelfde
	move.l	#dmabuffer+BUFFLEN,offsetcalcbuff
	move.l	#dmabuffer+2*BUFFLEN,offsetcalcbuff_end
nog_zelfde:

	cmp.w	#0,buffdone
	bne	calcdone

	; COPY BUFFER,NORMAL
	move.l	offsetcalcbuff,a0
	move.l	offsetsample_kan1,a1
	move.l	offsetsample_kan2,a2
	move.l	#speedline+TRANSP*600,a4
	add.w	eoffspeed_kan1,a4
	move.l	#speedline+TRANSP*600,a5
	add.w	eoffspeed_kan2,a5
	move.l	offsetvolume_kan1,a3
	move.l	offsetvolume_kan2,a6
	move.w	#BUFFLEN/2-1,d0
	move.w	#0,d3
	move.w	#0,d6
	move.b	(a4)+,d3
	move.b	(a5)+,d6
	move.l	#0,d1
	move.l	#0,d4
	move.w	#0,d2
coploop
	REPT	1
	move.b	(a1,d1.w),d2
	move.w	(a3,d2.w),d7
	move.b	(a2,d4.w),d2
	add.w	(a6,d2.w),d7
	move.w	d7,(a0)+
	add.w	d3,d1
	add.w	d6,d4
	ENDR
	move.b	(a4)+,d3
	move.b	(a5)+,d6
	dbra	d0,coploop
	add.l	d1,offsetsample_kan1
	add.l	d4,offsetsample_kan2

	move.l	offsetcalcbuff,a0
	;sub.w	#1,a0
	move.l	offsetsample_kan3,a1
	move.l	offsetsample_kan4,a2
	move.l	#speedline+TRANSP*600,a4
	add.w	eoffspeed_kan3,a4
	move.l	#speedline+TRANSP*600,a5
	add.w	eoffspeed_kan4,a5
	move.l	offsetvolume_kan3,a3
	move.l	offsetvolume_kan4,a6
	move.w	#BUFFLEN/2-1,d0
	move.w	#0,d3
	move.w	#0,d6
	move.b	(a4)+,d3
	move.b	(a5)+,d6
	move.l	#0,d1
	move.l	#0,d4
	move.w	#0,d2
coploop2
	REPT	1
	move.b	(a1,d1.w),d2
	move.w	(a3,d2.w),d7
	move.b	(a2,d4.w),d2
	add.w	(a6,d2.w),d7
	add.w	d7,(a0)+
	add.w	d3,d1
	add.w	d6,d4
	ENDR
	move.b	(a4)+,d3
	move.b	(a5)+,d6
	dbra	d0,coploop2
	add.l	d1,offsetsample_kan3
	add.l	d4,offsetsample_kan4

	;move.l	#DMAHZoffsets+SPEED*4,a5
	;move.l	#DMAHZprogs,a6
	;add.l	(a5),a6
	;move.l	offsetsample_kan1,a0
	;move.l	#volume_tabel,a1
	;move.l	offsetcalcbuff,a2

	;move.w	#0,d0
	;REPT	8
	;jsr	(a6)
	;add.w	#SPEED,a0
	;ENDR
	;move.l	a0,offsetsample_kan1

	move.w	#1,buffdone
calcdone:
	RTS
;------------------------------------
;-------- DMA indicate Welk buffer --
;------------------------------------
show_gone:
	move.w	calcbuffnr,prevcalcbuffnr
	; IN BUFFER 0
	move.w	#1,calcbuffnr
	move.l	#-1,d1
	move.l	#-1,d2
	move.l	#-1,d3
	move.l	#0,d4
	move.l	#dmabuffer+BUFFLEN,d6
	move.l	pospack+0,d7
	cmp.l	d6,d7
	bmi.s	yo
	; IN BUFFER 1
	move.w	#0,calcbuffnr
	move.l	#-1,d1
	move.l	#0,d2
	move.l	#-1,d3
	move.l	#-1,d4
yo:

	;move.l	schermadres,a0
	;move.w	calcbuffnr,d0
	;move.w	d0,16(a0)
	;move.l	#dmabuffer+BUFFLEN,d0
	;sub.l	#dmabuffer,d0
	;asr.l	#8,d0
	;sub.w	#1,d0
;sgoneloop:
	;move.l	d1,(a0)
	;move.l	d2,4(a0)
	;add.w	#336,a0
	;dbra	d0,sgoneloop

	;move.l	#dmabuffer+2*BUFFLEN,d0
	;sub.l	#dmabuffer+BUFFLEN,d0
	;asr.l	#8,d0
	;sub.w	#1,d0
;sgoneloop2:
	;move.l	d3,(a0)
	;move.l	d4,4(a0)
	;add.w	#160,a0
	;dbra	d0,sgoneloop2
	RTS
;-------------------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres_oud	; screen add filled in d0 ->screenadd

	move.l	#screenbuffer,d0
	add.l	#256,d0
	and.l	#$ffffff00,d0
	move.l	d0,schermadres
	RTS
;-------------------------------------
beeld_restore:
	move.l	schermadres_oud,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201
	move.w	old8210,$ffff8210
	move.w	#111,$ffff82a8
	move.b	#0,$ffff8265
	RTS
;-------------------------------------
beeld_change:
	move.l	schermadres,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	;move.l	schermadres2,d0
	;asr.l	#8,d0
	;asl.l	#8,d0
	;move.l	d0,schermadres2
	RTS
;-------------------------------------
joy_handle:
	clr.w	d0

	;move.b	d0,d1
	;and.w	#1,d1
	;tst.w	d1
	;beq.s	not_up
	; NAAR boven
;not_up
	move.b	packet+2,d0
	move.b	d0,d1
	and.w	#4,d1
	tst.w	d1
	beq.s	not_left
	bsr	syncscroll_links
not_left
	move.b	packet+2,d0
	move.b	d0,d1
	and.w	#8,d1
	tst.w	d1
	beq.s	not_right
	bsr	syncscroll_rechts
not_right
	move.b	packet+2,d0
	move.b	d0,d1
	and.w	#2,d1
	tst.w	d1
	beq.s	not_down
	bsr	syncscroll_beneden
not_down
	RTS

syncscroll_rechts:
	; SYNCSCROLL-RECHTS
	add.l	#2,camerax
	move.w	#0,some_y
syncveldy1:
	move.l	camerax,d0
	asr.l	#4,d0
	add.w	#21,d0
	move.l	cameray,d1
	asr.l	#4,d1
	add.w	some_y,d1
	bsr	veld_show_1blok
	add.w	#1,some_y
	cmp.w	#17,some_y
	bne.s	syncveldy1
	RTS

syncscroll_links:
	; SYNCSCROLL-LINKS
	sub.l	#2,camerax
	move.w	#0,some_y
syncveldy2:
	move.l	camerax,d0
	add.w	#1,d0
	asr.l	#4,d0
	add.w	#1,d0
	move.l	cameray,d1
	asr.l	#4,d1
	add.w	some_y,d1
	bsr	veld_show_1blok
	add.w	#1,some_y
	cmp.w	#17,some_y
	bne.s	syncveldy2
	RTS

syncscroll_beneden:
	; SYNCSCROLL-LINKS
	add.l	#2,cameray
	move.w	#0,some_x
syncveldx1:
	move.l	camerax,d0
	add.w	#1,d0
	asr.l	#4,d0
	;add.w	#1,d0
	add.w	some_x,d0

	move.l	cameray,d1
	asr.l	#4,d1
	add.w	#17,d1
	bsr	veld_show_1blok
	add.w	#1,some_x
	cmp.w	#21,some_x
	bne.s	syncveldx1
	RTS

	INCLUDE	"F:\PROGRAMM\NEEDS\VSYNC.S"
	INCLUDE	"F:\PROGRAMM\NEEDS\WAITKEY.S"
	INCLUDE	"F:\PROGRAMM\NEEDS\USERMODE.S"
	INCLUDE	"F:\PROGRAMM\NEEDS\SUPVISOR.S"
	INCLUDE	"F:\PROGRAMM\NEEDS\VGACOLOR.S"
	INCLUDE "F:\PROGRAMM\MOUSE\JOY.S"
;-------------------------------------
wacht_lusje:
	move.l	#8000,d0
wachtlus	nop
	dbra	d0,wachtlus
	RTS
;-------------------------------------
cls:
	move.l	#CLSBYTES/4/4-1,d0
	move.l	schermadres,a0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS
;-------------------------------------
update_pospacket
	move.l	#pospack,-(sp)
	move.w	#$8D,-(sp)
	trap	#14
	addq.l	#6,sp
	RTS
;------------------------------------
;-----------Kill Music Operations ---
;------------------------------------
close_music
;~XBIOS(&h88,0) ;PLAY:DISABLE+NO REP
	move.w	#3,-(sp)
	move.w	#$88,-(sp)
	trap	#14
	addq.l	#4,sp
;~XBIOS(&h82,4,0)
	move.w	#0,-(sp)
	move.w	#4,-(sp)
	move.w	#$82,-(sp)
	trap	#14
	addq.l	#6,sp
;~XBIOS(&h83,0,L:adr%,L:adr%+50) ; BUFFER
	move.l	#dmabuffer+50,-(sp)
	move.l	#dmabuffer,-(sp)
	move.w	#0,-(sp)
	move.w	#$83,-(sp)
	trap	#14
	add.l	#12,sp
	RTS
;------------------------------------
;----------Init Music Operations ----
;------------------------------------
init_music:
;~XBIOS(&h82,0,&h80)
	move.w	vol_l,-(sp)
	move.w	#0,-(sp)
	move.w	#$82,-(sp)
	trap	#14
	addq.l	#6,sp
;~XBIOS(&h82,1,&h80)
	move.w	vol_r,-(sp)
	move.w	#1,-(sp)
	move.w	#$82,-(sp)
	trap	#14
	addq.l	#6,sp
;~XBIOS(&h84,0)
	move.w	#0,-(sp)
	move.w	#$84,-(sp)
	trap	#14
	addq.l	#4,sp
;~XBIOS(&h85,0,0) ;1 links,1 rechts
	move.w	#0,-(sp)
	move.w	#0,-(sp)
	move.w	#$85,-(sp)
	trap	#14
	addq.l	#6,sp
;~XBIOS(&h82,4,2) ; Alleen Input
	move.w	#2,-(sp)
	move.w	#4,-(sp)
	move.w	#$82,-(sp)
	trap	#14
	addq.l	#6,sp
;~XBIOS(&h82,5,0) ; MIC -> ADC-In
	move.w	#0,-(sp)
	move.w	#5,-(sp)
	move.w	#$82,-(sp)
	trap	#14
	addq.l	#6,sp
;~XBIOS(&h89,1,1) ;Matrix verbinden met Externe DSP-Schnittstelle
	move.w	#1,-(sp)
	move.w	#1,-(sp)
	move.w	#$89,-(sp)
	trap	#14
	addq.l	#6,sp
;~XBIOS(&H8B,n1,n2,0,freq%,1)
	move.w	#1,-(sp)
	move.w	freq,-(sp)
	move.w	#0,-(sp)
	move.w	#0,-(sp) ; 3,0
	move.w	#3,-(sp)
	move.w	#$8B,-(sp)
	trap	#14
	add.l	#6,sp
	move.w	#0,-(sp) ; 2,0
	move.w	#2,-(sp)
	move.w	#$8B,-(sp)
	trap	#14
	add.l	#6,sp
	move.w	#3,-(sp) ; 1,3
	move.w	#1,-(sp)
	move.w	#$8B,-(sp)
	trap	#14
	add.l	#6,sp
	move.w	#1,-(sp) ; 0,1
	move.w	#0,-(sp)
	move.w	#$8B,-(sp)
	trap	#14
	add.l	#12,sp
;~XBIOS(&h88,3) ;PLAY:ENABLE+REP
	move.w	#3,-(sp)
	move.w	#$88,-(sp)
	trap	#14
	addq.l	#4,sp
;~XBIOS(&h83,0,L:adr%,L:adr%+len%) ; BUFFER
	move.l	#dmabufferend,-(sp)
	move.l	#dmabuffer,-(sp)
	move.w	#0,-(sp)
	move.w	#$83,-(sp)
	trap	#14
	add.l	#12,sp
	RTS
;------------------------------------
;--- Samples Volume-change ready ----
;------------------------------------
switch_sign_sample:
	move.w	#0,d1
	move.l	#samples_beg,a0
	move.l	#samples_end,d0
	sub.l	#samples_beg,d0
	asr.l	#2,d0
signsw:	REPT	4
	move.b	(a0),d1
	and.b	#$FE,d1
	move.b	d1,(a0)+
	ENDR
	dbra	d0,signsw
	RTS
;-------------------------------------
sync_tabel: ; SYNC-SCROLL-TABEL
	;       x*336+y*256+z*16
	;       x,y,z
	dc.w	3,3
	dc.w	6,7
	dc.w	9,11
	dc.w	12,15
	dc.w	15,19
	dc.w	2,2
	dc.w	5,6
	dc.w	8,10
	dc.w	11,14
	dc.w	14,18
	dc.w	1,1
	dc.w	4,5
	dc.w	7,9
	dc.w	10,13
	dc.w	13,17
	dc.w	0,0
;-------------------------------------
vol_l:		dc.w	$40 ;$40
vol_r:		dc.w	$40 ;$40
freq:		dc.w	3 ; 3
VBLsign:	dc.w	0
ssp:		dc.l	0
schermadres	dc.l	0
schermadres2	dc.l	0
schermadres_oud	dc.l	0
mod_offset	dc.l	0
mus_sp		dc.w	0
mus_spcounter	dc.w	0
mod_chk_handle	dc.w	0
calcbuffnr:	dc.w	0
prevcalcbuffnr:	dc.w	0
buffdone:	dc.w	0
syncadd:	dc.w	0
syncwidth	dc.w	0
sync_vidadr	dc.l	0
sync_y		dc.w	0
sync15		dc.b	0
olda07:		dc.b	0
olda09:		dc.b	0
old8210:	dc.w	0
		even
some_x:		dc.w	0
some_y:		dc.w	0
camerax:	dc.l	0
cameray:	dc.l	0
syncscrolloffset:	dc.l	0
offsetcalcbuff:		dc.l	0
offsetcalcbuff_end	dc.l	0
offsetsample_kan1	dc.l	0
offsetsample_kan2	dc.l	0
offsetsample_kan3	dc.l	0
offsetsample_kan4	dc.l	0
offsetsamloop_kan1	dc.l	0
offsetsamloop_kan2	dc.l	0
offsetsamloop_kan3	dc.l	0
offsetsamloop_kan4	dc.l	0
offsetsamend_kan1	dc.l	0
offsetsamend_kan2	dc.l	0
offsetsamend_kan3	dc.l	0
offsetsamend_kan4	dc.l	0
loopsetsample_kan1	dc.w	0  ; 0=geen loop
loopsetsample_kan2	dc.w	0  ; 1=wel  loop
loopsetsample_kan3	dc.w	0
loopsetsample_kan4	dc.w	0
done_kan1		dc.w	0  ; 0=niet klaar
done_kan2		dc.w	0  ; 1=wel  klaar
done_kan3		dc.w	0
done_kan4		dc.w	0
eoffspeed_kan1		dc.w	0
eoffspeed_kan2		dc.w	0
eoffspeed_kan3		dc.w	0
eoffspeed_kan4		dc.w	0
offsetvolume_kan1	dc.l	0
offsetvolume_kan2	dc.l	0
offsetvolume_kan3	dc.l	0
offsetvolume_kan4	dc.l	0
volume1			dc.w	0
volume2			dc.w	0
volume3			dc.w	0
volume4			dc.w	0
vol_tab_left	INCBIN	"F:\DMAVOLL.DAT"
vol_tab_right	INCBIN	"F:\DMAVOLR.DAT"
speedline	INCBIN	"F:\FREQTAB.DAT"
picture		INCBIN	"F:\BAN_JOE.256\BANABLOK.8PL"
block_row	INCBIN	"F:\BAN_JOE.256\BANABLOK.STR"
module		INCBIN	"F:\MODULES\EXECUTE2.MMD"
oldpal		ds.l	256
dmabuffer	ds.b	2*BUFFLEN
dmabufferend	ds.l	4
pospack		ds.l	4
offsets_samples ds.l	32*40/4 ;32 samples* 40 bytes info
end_of_samples	dc.l	0
		ds.l	10 ;900
;-------------------------------------
calc_offsets_samples:
	move.l	#offsets_samples,a0
	move.l	#samp1+80,(a0)
	move.l	#samp1+80+14517,4(a0)
	move.l	#samp1+80+14518,8(a0)
	move.w	#63,14(a0)
	add.w	#40,a0
	move.l	#samp2+80,(a0)
	move.l	#samp2+80+10277,4(a0)
	move.l	#samp2+80+10278,8(a0)
	move.w	#63,14(a0)
	add.w	#40,a0
	move.l	#samp3+80,(a0)
	move.l	#samp3+80+2715,4(a0)
	move.l	#samp3+80+2716,8(a0)
	move.w	#63,14(a0)
	add.w	#40,a0
	move.l	#samp4+80,(a0)
	move.l	#samp4+80+1809,4(a0)
	move.l	#samp4+80+1810,8(a0)
	move.w	#48,14(a0)
	add.w	#40,a0
	move.l	#samp5+80,(a0)
	move.l	#samp5+80+5317,4(a0)
	move.l	#samp5+80+5318,8(a0)
	move.w	#48,14(a0)
	add.w	#40,a0
	move.l	#samp6+80,(a0)
	move.l	#samp6+80+1009,4(a0)
	move.l	#samp6+80+1010,8(a0)
	move.w	#63,14(a0)
	add.w	#40,a0
	move.l	#samp7+80,(a0)
	move.l	#samp7+80+2196,4(a0)
	move.l	#samp7+80+6050,8(a0)
	move.w	#1,12(a0) ;1
	move.w	#63,14(a0)
	add.w	#40,a0
	move.l	#samp8+80,(a0)
	move.l	#samp8+80+1000,4(a0)
	move.l	#samp8+80+1180,8(a0)
	move.w	#1,12(a0)
	move.w	#63,14(a0)
	add.w	#40,a0
	move.l	#samp9+80,(a0)
	move.l	#samp9+80+3552,4(a0)
	move.l	#samp9+80+3552,8(a0)
	move.w	#63,14(a0)
	add.w	#40,a0
	move.l	#samp10+80,(a0)
	move.l	#samp10+80+2351,4(a0)
	move.l	#samp10+80+2352,8(a0)
	move.w	#63,14(a0)
	add.w	#40,a0
	move.l	#samp11+80,(a0)
	move.l	#samp11+80+2427,4(a0)
	move.l	#samp11+80+2428,8(a0)
	move.w	#63,14(a0)
	add.w	#40,a0
	move.l	#samp12+80,(a0)
	move.l	#samp12+80+3947,4(a0)
	move.l	#samp12+80+3948,8(a0)
	move.w	#63,14(a0)
	add.w	#40,a0
	move.l	#samp13+80,(a0)
	move.l	#samp13+80+12207,4(a0)
	move.l	#samp13+80+12208,8(a0)
	move.w	#63,14(a0)
	add.w	#40,a0
	move.l	#samp14+80,(a0)
	move.l	#samp14+80+3975,4(a0)
	move.l	#samp14+80+3976,8(a0)
	move.w	#63,14(a0)
	add.w	#40,a0
	move.l	#samp15+80,(a0)
	move.l	#samp15+80,4(a0)
	move.l	#samp15+80+1000,8(a0)
	move.w	#-1,12(a0)
	move.w	#63,14(a0)
	add.w	#40,a0
	move.l	#samp16+80,(a0) ; RITME EEN
	move.l	#samp16+80+6819,4(a0)
	move.l	#samp16+80+6820,8(a0)
	move.w	#48,14(a0)
	add.w	#40,a0
	move.l	#samp17+80,(a0) ; RITME TWEE
	move.l	#samp17+80+6416,4(a0)
	move.l	#samp17+80+6920,8(a0)
	move.w	#1,12(a0)
	move.w	#48,14(a0)
	add.w	#40,a0
	move.l	#samp18+80,(a0) ; RITME DRIE
	move.l	#samp18+80+7269,4(a0)
	move.l	#samp18+80+7270,8(a0)
	move.w	#48,14(a0)
	add.w	#40,a0
	move.l	#samp19+80,(a0) ; RITME VIER
	move.l	#samp19+80+7397,4(a0)
	move.l	#samp19+80+7398,8(a0)
	move.w	#48,14(a0)
	add.w	#40,a0
	move.l	#samp20+80,(a0)
	move.l	#samp20+80+7799,4(a0)
	move.l	#samp20+80+7800,8(a0)
	move.w	#63,14(a0)
	move.w	#63,14(a0)
	add.w	#40,a0
	move.l	#samp21+80,(a0)
	move.l	#samp21+80+2063,4(a0)
	move.l	#samp21+80+2064,8(a0)
	move.w	#63,14(a0)
	RTS

samples_beg
samp1		INCBIN	"C:\SAMPLES\3.SMP"
samp1end	ds.b	EXTRALOOP;128
samp2		INCBIN	"C:\SAMPLES\4.SMP"
samp2end	ds.b	EXTRALOOP;128
samp3		INCBIN	"C:\SAMPLES\9.SMP"
samp3end	ds.b	EXTRALOOP;128
samp4		INCBIN	"C:\SAMPLES\10.SMP"
samp4end	ds.b	EXTRALOOP;128
samp5		INCBIN	"C:\SAMPLES\11.SMP"
samp5end	ds.b	EXTRALOOP;128
samp6		INCBIN	"C:\SAMPLES\12.SMP"
samp6end	ds.b	EXTRALOOP;128
samp7		INCBIN	"C:\SAMPLES\14.SMP"
samp7end	ds.b	EXTRALOOP;128
samp8		INCBIN	"C:\SAMPLES\15.SMP"
samp8end	ds.b	EXTRALOOP;128
samp9		INCBIN	"C:\SAMPLES\16.SMP"
samp9end	ds.b	EXTRALOOP;128
samp10		INCBIN	"C:\SAMPLES\17.SMP"
samp10end	ds.b	EXTRALOOP;128
samp11		INCBIN	"C:\SAMPLES\18.SMP"
samp11end	ds.b	EXTRALOOP;128
samp12		INCBIN	"C:\SAMPLES\19.SMP"
samp12end	ds.b	EXTRALOOP;128
samp13		INCBIN	"C:\SAMPLES\20.SMP"
samp13end	ds.b	EXTRALOOP;128
samp14		INCBIN	"C:\SAMPLES\21.SMP"
samp14end	ds.b	EXTRALOOP;128
samp15		INCBIN	"C:\SAMPLES\22.SMP"
samp15end	ds.b	EXTRALOOP;128
samp16		INCBIN	"C:\SAMPLES\23.SMP"
samp16end	ds.b	EXTRALOOP;128
samp17		INCBIN	"C:\SAMPLES\24.SMP"
samp17end	ds.b	EXTRALOOP;128
samp18		INCBIN	"C:\SAMPLES\25.SMP"
samp18end	ds.b	EXTRALOOP;128
samp19		INCBIN	"C:\SAMPLES\26.SMP"
samp19end	ds.b	EXTRALOOP;128
samp20		INCBIN	"C:\SAMPLES\27.SMP"
samp20end	ds.b	EXTRALOOP;128
samp21		INCBIN	"C:\SAMPLES\28.SMP"
samp21end	ds.b	EXTRALOOP;128
samples_end	ds.l	4

veld	dc.b	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	ds.b	256-18

	REPT	3
	dc.b	0,0,0,0,1,1,1,1,1,1,1,0,2,2,2,2,3,1,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3
	ds.b	256-18-16
	dc.b	0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1
	ds.b	256-18
	dc.b	0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1
	ds.b	256-18
	dc.b	0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1
	ds.b	256-18
	dc.b	0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1
	ds.b	256-18
	dc.b	0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1
	ds.b	256-18
	dc.b	0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1
	ds.b	256-18
	dc.b	0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1
	ds.b	256-18
	dc.b	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	ds.b	256-18
	dc.b	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	ds.b	256-18
	dc.b	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	ds.b	256-18
	dc.b	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	ds.b	256-18
	dc.b	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	ds.b	256-18
	dc.b	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	ds.b	256-18
	dc.b	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	ds.b	256-18
	dc.b	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	ds.b	256-18
	ENDR

	REPT	(256*10)/8
	dc.b	1,1,1,1,1,1,1,1
	ENDR

; SCREENS VOOR SYNCSCROLLING
screenbuffer:
	ds.l	524288/4
