	bsr	schermadr_opvraag
	bsr	cls

;	bsr	sup_vis_mode
;	bsr	set_colors
;	bsr	user_mode

	bsr	print
back:
	bsr	vsync

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back
end:


	clr.l	-(sp)
	trap	#1


;********************************
;*	SUBROUTINES    !!!!!	*
;********************************

;-------------------------
print:
	move.l	#tekst,a2

PRNTLOOP:
	move.l	schermadres,a0
	move.l	#font,a1

	clr.w	d1
	move.b	(a2)+,d1
	tst.w	d1
	beq	PRNTEND

	asl.w	#3,d1	; 1 kar=8 bytes
	add.w	d1,a1

	move.w	prntx,d0
	and.w	#%0001,d0 ; 1
	add.w	d0,a0
	
	move.w	prntx,d0
	and.w	#%11111110,d0 ; 2
	asl.w	#3,d0	  ; ->16
	add.w	d0,a0


pl set 0
	REPT	8
	move.b	pl(a1),pl*320(a0)
pl set pl+1
	ENDR

	add.w	#1,prntx

	bra	PRNTLOOP

PRNTEND:

	RTS
;-------------------------
copy_it:
	move.l	schermadres,a1
	move.w	#110-1,d0
copy_y:
pl set 0
	REPT	5
	move.w	pl*2(a0),pl*16(a1)
	move.w	pl*2+10(a0),pl*16+2(a1)
	move.w	pl*2+20(a0),pl*16+4(a1)
	move.w	pl*2+30(a0),pl*16+6(a1)
pl set pl+1
	ENDR
	add.w	#80,a0
	add.w	#320,a1
	dbra	d0,copy_y
	RTS
;-------------------------
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS

;-------------------------
beeld_change:
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	move.l	schermadres2,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2
	RTS

;-------------------------
wacht_toets:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
;-------------------------
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
;-------------------------
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
;-------------------------
cls:
	move.l	#200-1,d0
	move.l	schermadres,a0
go_cls:

pl set 0
	REPT	20
	clr.l	pl(a0)
	clr.l	pl+4(a0)
pl set pl+8
	ENDR
	add.w	#160,a0
	dbra d0,go_cls
	RTS
;-------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	move.l	#screen2,schermadres2
	RTS
;-------------------------
set_colors:
;	move.l	#blokpic+2,a0
;	movem.l	(a0),d0-d7
;	movem.l	d0-d7,$ff8240

;	move.l	#$64*1024+64*4,$ff9800
; 	move.l	#$FFFF,$ff9800


	RTS
;-------------------------
wacht_lusje:
	move.l	#16000,d0
wachtlus	nop
	dbra	d0,wachtlus
	RTS
;-------------------------
	
;	VARIABELEN
;-----------------------------------
schermadres:	dc.l	0
schermadres2:	dc.l	0
ssp:		dc.l	0
screen2:	ds.b	64256
prntx:	dc.w	0
prnty:	dc.w	0
font:	INCBIN	'F:\MARKFNT.FNT'
tekst:	dc.b	'HOI:dit is MARK',0
