;  *****************************************  ;
; *                                         * ;
; *   C O D E D   B Y                       * ;
; *                                         * ;
; *              ___     ___                * ;
; * EXECUTE OF    |  | | |                  * ;
; *               |  |-| |-                 * ;
; *               |  | | |__                * ;
; * ___     __  ___ __    ___      _  ___   * ;
; * |   \ / | | |   | | | |   | | / \ |     * ;
; * |-   X  |-' |-  |-' | |-  |\| |   |-    * ;
; * |__ / \ |   |__ | | | |__ | | \__ |__   * ;
; *                                         * ;
; *                                         * ;
;  *****************************************  ;
;
; HI ! THIS IS XQT(EXECUTE) OF 
; THE EXPERIENCE. THIS PROGRAMM SHOWS
; A SIMPLE (BUT OK!) PLATFORM-GAME.
; TECNIQUES:
;   - 4 PLANES PRE-SHIFTED FOREGROUND
;   - 2 PLANES PRE-SHIFTED BACKGROUND
;   -/|\ (6)PLANES + 2  ->   SPRITES
;     |
;
; IF YOU USE THE SOURCE:
;
;  SEND 15 GUILDERS TO THIS ADDRESS:
;  SPINOZALAAN 18
;  HAREN,THE NETHERLANDS
;
; --- HAVE FUN WITH IT ! ---


mousevec	EQU	16
joyvec		EQU	24

ikbdws		EQU	25
kbdvec		EQU	34

JUMPSTARTSPEED	EQU	8
jumpmaxtime	EQU	80/8

aantblok_cop	EQU	47+1
aantblok_back	EQU	31+1
unusedvoor	EQU	2*(1*20)  ; 20 op veld 1*20 niet
unusedback	EQU	2*(1*20)  ; 20 op veld 1*20 niet
unusedcop	EQU	2*(3*20)  ; 20 op veld 3*20 niet
lengthcop	EQU	4*20  ; 4*20=lengte

;- INIT -

	bsr	sup_vis_mode
	bsr	save_colors
	bsr	schermadr_opvraag
	bsr	install_mo_jo
	bsr	cls
	bsr	fade_out
	bsr	precalveld_back
	bsr	precalveld_cop
	bsr	precalveld_voor
	bsr	do_shift_voor
	bsr	do_shift_back
	bsr	last_init
	bsr	vsync
	bsr	set_colors

; ******

back:
	bsr	clear_sprites
	bsr	calc_new_coords
      ;---------------------;
      ;*** NEWX AND NEWY ***;
      ;---------------------;
	bsr	GO_Y
	bsr	GO_X
   ;----------------------------;
   ;*** NOT OUT OF PLAYFIELD ***;
   ;----------------------------;
	tst	coordx
	bpl	not_negative
	move.w	#0,coordx
not_negative:
	cmp.w	#16*2*30-1,coordx
	blo	not_negativ1
	move.w	#16*2*30-1,coordx
not_negativ1:
   ;---------------------------;
   ;*** IN A SPECIAL AREA ? ***;
   ;---------------------------;
	move.w	#0,special_area

	move.w	coordx,d0
	cmp.w	#22*16,d0
	blo.s	sp1
	cmp.w	#27*16,d0
	bhi.s	sp1
	move.w	#1,special_area
sp1:
	cmp.w	#27*16,d0
	blo.s	sp2
	cmp.w	#32*16,d0
	bhi.s	sp2
	move.w	#2,special_area
sp2:
     ;---------------------;
     ;*** UPDATE SCREEN ***;
     ;---------------------;
	move.w	coordx,d0
	sub.w	#160,d0
	cmp.w	#0,d0
	bpl	not_zero
	move.w	#0,d0
not_zero:
	move.w	d0,screenx

; calc voorgrond / achtergrond speeds
	move.w	screenx,d0
	mulu	#6,d0  ; *6
	asr.w	#2,d0  ; /4
	move.w	d0,screenx2
	move.w	screenx,d0
	divu	#3,d0  ; /3
	move.w	d0,screenx3

;	move.l	#$50000000,$ff9800
	bsr	cop
;	move.l	#$70000000,$ff9800
	bsr	voorcop
;	move.l	#$50000000,$ff9800
	bsr	backcop
;	move.l	#$70000070,$ff9800
	bsr	put_sprites
; 	move.l	#$00000000,$ff9800

	bsr	vsync
	bsr	beeld_change

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back
; ******
;- LEAVE -
	bsr	cls
	bsr	beeld_change
	bsr	cls
	bsr	fade_in
	bsr	rest_colors
	bsr	restore_mo_jo
	bsr	user_mode
	clr.l	-(sp)
	trap	#1
   ;----------------------------;
   ;        SUBROUTINES         ;
   ;----------------------------;
leftcheck2:
	sub.w	#1,coordx
	move.w	coordx,d0
	move.w	coordy,d1
	bsr	check_coords
	move.w	d7,d5
	move.w	coordx,d0
	move.w	coordy,d1
	add.w	#31,d1
	bsr	check_coords
	add.w	d7,d5

	tst.w	d5
	beq.s	cleanleft2

	cmp.w	#1,special_area
	bne.s	no_spec_area3
	bsr	upcheck
no_spec_area3:
	sub.w	#1,speedy
	add.w	#1,speedx
	add.w	#1,coordx
cleanleft2:
	RTS


rightcheck2:
	add.w	#1,coordx
	move.w	coordx,d0
	move.w	coordy,d1
	add.w	#20,d0
	bsr	check_coords
	move.w	d7,d5

	move.w	coordx,d0
	move.w	coordy,d1
	add.w	#20,d0
	add.w	#31,d1
	bsr	check_coords
	add.w	d7,d5

	tst.w	d5
	beq.s	cleanright2

	cmp.w	#2,special_area
	bne.s	no_spec_area4
	bsr	upcheck
no_spec_area4:

	sub.w	#1,speedy
	sub.w	#1,speedx
	sub.w	#1,coordx
cleanright2:
	RTS



leftcheck:
	sub.w	#1,coordx
	move.w	coordx,d0
	move.w	coordy,d1
	bsr	check_coords
	move.w	d7,d5
	move.w	coordx,d0
	move.w	coordy,d1
	add.w	#31,d1
	bsr	check_coords
	add.w	d7,d5

	tst.w	d5
	beq.s	cleanleft

	cmp.w	#1,special_area
	bne.s	no_spec_area1
	bsr	upcheck
	sub.w	#1,speedy
	add.w	#1,speedx
no_spec_area1:
	add.w	#1,coordx
cleanleft:
	RTS


rightcheck:
	add.w	#1,coordx
	move.w	coordx,d0
	move.w	coordy,d1
	add.w	#20,d0
	bsr	check_coords
	move.w	d7,d5

	move.w	coordx,d0
	move.w	coordy,d1
	add.w	#20,d0
	add.w	#31,d1
	bsr	check_coords
	add.w	d7,d5

	tst.w	d5
	beq.s	cleanright

	cmp.w	#2,special_area
	bne.s	no_spec_area2
	bsr	upcheck
	sub.w	#1,speedy
	sub.w	#1,speedx
no_spec_area2:
	sub.w	#1,coordx
cleanright:
	RTS


upcheck:
	sub.w	#1,coordy
	move.w	coordx,d0
	move.w	coordy,d1
	bsr	check_coords
	move.w	d7,d5
	move.w	coordx,d0
	move.w	coordy,d1
	add.w	#20,d0
	bsr	check_coords
	add.w	d7,d5

	tst.w	d5
	beq.s	cleanup
	add.w	#1,coordy
	move.w	#0,speedy
cleanup:
	RTS


downcheck:
	add.w	#1,coordy
	move.w	coordx,d0
	move.w	coordy,d1
	add.w	#31,d1
	bsr	check_coords
	move.w	d7,d5

	move.w	coordx,d0
	move.w	coordy,d1
	add.w	#20,d0
	add.w	#31,d1
	bsr	check_coords
	add.w	d7,d5

	tst.w	d5
	beq	cleandown

	cmp.w	#0,special_area
	bne.s	no_spec_area1a
	sub.w	#1,coordy
	move.w	#0,speedy
	move.w	#1,jumpready
	move.w	#0,jumpteller
no_spec_area1a:

	cmp.w	#1,special_area
	bne.s	no_spec_area1c
	move.b	jpacket+2,d0
	and.w	#2,d0
	tst.w	d0
	beq.s	no_spec_area1b
	sub.w	#1,speedy
	sub.w	#1,coordy
	add.w	#3,speedx
	bra.s	no_spec_area1c
no_spec_area1b:
	move.w	#0,speedy
	sub.w	#1,coordy
no_spec_area1c:

	cmp.w	#2,special_area
	bne.s	no_spec_area2c
	move.b	jpacket+2,d0
	and.w	#2,d0
	tst.w	d0
	beq.s	no_spec_area2b
	sub.w	#1,speedy
	sub.w	#1,coordy
	sub.w	#3,speedx
	bra.s	no_spec_area2c
no_spec_area2b:
	move.w	#0,speedy
	sub.w	#1,coordy
no_spec_area2c:

cleandown:
	RTS

;-------------------------------
GO_X:
	move.w	speedx,d6
	asr.w	#2,d6
	tst.w	d6
	beq.s	NOSPEEDX
	tst.w	d6
	bpl.s	NEGSPEEDX

	not.w	d6
	Linksloop:
	bsr	leftcheck
	dbra	d6,Linksloop
	bra	NOSPEEDX
NEGSPEEDX:
	sub.w	#1,d6
	Rechtsloop:
	bsr	rightcheck
	dbra	d6,Rechtsloop
NOSPEEDX:
	RTS
;-------------------------------
GO_Y:
	move.w	speedy,d6
	asr.w	#1,d6
	tst.w	d6
	beq.s	NOSPEEDY
	tst.w	d6
	bpl.s	NEGSPEEDY

	not.w	d6
	Bovenloop:
	bsr	upcheck
	dbra	d6,Bovenloop
	bra	NOSPEEDY
NEGSPEEDY:
	sub.w	#1,d6
	Onderloop:
	bsr	downcheck
	dbra	d6,Onderloop
NOSPEEDY:
	RTS
;-------------------------------
check_coords:
; d0-coordx
; d1-coordy

	move.l	#kijkveld,a0
	move.l	#maskblokpic+34,a1

	move.w	d0,d2	; (-X-)
	asr.w	#4,d2	; per 16 pix
	asl.w	#1,d2	; .w in tabel
	add.w	d2,a0

	move.w	d1,d2	; (-Y-)
	asr.w	#4,d2	; per 16 pix
	mulu	#lengthcop*2,d2
	add.w	d2,a0

	move.w	(a0),d2 ; indicate
	asr.w	#7,d2	; divu 128

	cmp.w	#1,d2
	bhi	neg_go
	move.w	#1,d2
neg_go:
	sub.w	#1,d2	; -1 blok

	move.w	d2,d3

	divu	#10,d2
	move.w	d2,d4
	mulu	#10,d4
	sub.w	d4,d3

	mulu	#160*16,d2
	add.w	d2,a1

	asl.w	#4,d3	; *16 (2 * 8 bytes)
	add.w	d3,a1

	move.w	d1,d2	; (-Y-)
	and.w	#15,d2	; MOD 16
	mulu	#160,d2 ; *160
	add.w	d2,a1

	move.w	pl*160(a1),d3

	move.l	#tabel3,a3
	move.w	d0,d2	; (-X-)
	and.w	#15,d2	; MOD 16
	asl.w	#1,d2	; *2
	move.w	(a3,d2.w),d2

	and.w	d3,d2 ; 1 bit over uit MOD 16

	move.w	#0,d7	; NO
	tst.w	d2 ; zie je iets -> 1 ANDERS 0
	beq.s	geenbitshow
	move.w	#1,d7	; YES
geenbitshow:

	RTS
;-------------------------------
calc_new_coords:
	clr.w	d0
	move.b	jpacket+2,d0



; joy=UP & jumpready=1
	move.b	d0,d1
	and.w	#1,d1
	tst.w	d1
	beq.s	not_up
	tst.w	jumpready ;  In air=0
	beq.s	not_up
	move.w	#-JUMPSTARTSPEED,speedy
	add.w	#1,jumpteller
not_up

; joy<>UP

	move.b	d0,d1 ; UP losgelaten
	and.w	#1,d1
	tst.w	d1
	bne.s	not_up2
	move.w	#0,jumpready

; jumpteller=JumpMaxTime

not_up2:
	move.w	jumpteller,d1
	cmp.w	#jumpmaxtime,d1
	bne.s	not_maxcnt_jump
	move.w	#0,jumpready
not_maxcnt_jump:


; LINKS EN RECHTS

	move.b	d0,d1
	and.w	#4,d1
	tst.w	d1
	beq.s	not_left
	sub.w	#2,speedx
not_left
	move.b	d0,d1
	and.w	#8,d1
	tst.w	d1
	beq.s	not_right
	add.w	#2,speedx
not_right

; (-Xspeed-) LIMITATIONS

	move.w	speedx,d0
	add.w	#100,d0
	cmp.w	#99,d0
	bhi.s	speed_limit_3
	add.w	#1,d0
speed_limit_3
	cmp.w	#101,d0
	blo.s	speed_limit_4
	sub.w	#1,d0
speed_limit_4

	cmp.w	#0,special_area
	bne.s	speed_limit_2
	cmp.w	#116,d0
	blo.s	speed_limit_1
	move.w	#116,d0
speed_limit_1
	cmp.w	#84,d0
	bhi.s	speed_limit_2
	move.w	#84,d0
speed_limit_2

	sub.w	#100,d0
	move.w	d0,speedx


; (-Yspeed-) LIMITATIONS

	move.w	speedy,d0
	add.w	#100,d0

	add.w	#1,d0

;	cmp.w	#108,d0
;	blo.s	speed_limit_1b
;	move.w	#108,d0
;speed_limit_1b
;	cmp.w	#92,d0
;	bhi.s	speed_limit_2b
;	move.w	#92,d0
;speed_limit_2b
	sub.w	#100,d0
	move.w	d0,speedy

	RTS
;-------------------------------
put_sprites:
	move.l	schermadres,a2
	move.l	#sprites+34,a1
	move.l	#masksprites+34,a3

; real X
	move.w	coordx,d0
	sub.w	screenx,d0
	and.w	#%1111111111110000,d0
	add.w	d0,a2

; real Y
	clr.l	d1
	move.w	coordy,d1
	sub.w	screeny,d1


	move.w	coordx,d7
	sub.w	screenx,d7
	move.w	d7,d3
	and.w	#15,d3

	move.w	#32-1,d2

realshiftlus:
	tst.w	d1
	blo.s	no_draw
	cmp.w	#11*16-1,d1
	bhi.s	no_draw

	move.l	a2,a0
	move.w	d1,d4
	mulu	#160,d4
	ext.l	d4
	asl.l	#1,d4
	add.l	d4,a0

	tst.w	d0
	blo.s	no_draw1
	cmp.w	#20*16,d1
	bhi.s	no_draw1
	bsr	shift_zone1
no_draw1:
	add.w	#16,a0
	add.w	#16,d0
	tst.w	d0
	blo.s	no_draw2
	cmp.w	#20*16,d1
	bhi.s	no_draw2
	bsr	shift_zone2
no_draw2:
;	add.w	#16,a0
;	add.w	#16,d0
;	tst.w	d0
;	blo.s	no_draw3
;	cmp.w	#20*16,d1
;	bhi.s	no_draw3
;	bsr	shift_zone3
;no_draw3:


no_draw:
	add.w	#160,a1 ; eigenlijke sprites
	add.w	#160,a3 ; mask
	add.w	#1,d1
	dbra	d2,realshiftlus
	RTS
;-------------------------------
shift_zone1:
	clr.l	d4
	move.w	0(a3),d4
	bsr	shift_zone5

	clr.l	d4
	move.w	0(a1),d4
	clr.l	d5
	move.w	2(a1),d5
	clr.l	d6
	move.w	4(a1),d6
	clr.l	d7
	move.w	6(a1),d7
	bsr	shift_zone4
	RTS
;-------------------------------
shift_zone2:
	move.w	0(a3),d4
	swap	d4
	move.w	8(a3),d4
	bsr	shift_zone5

	move.w	0(a1),d4
	move.w	2(a1),d5
	move.w	4(a1),d6
	move.w	6(a1),d7
	swap	d4
	swap	d5
	swap	d6
	swap	d7
	move.w	8(a1),d4
	move.w	10(a1),d5
	move.w	12(a1),d6
	move.w	14(a1),d7
	bsr	shift_zone4
	RTS
;-------------------------------
shift_zone3:
	clr.l	d4
	move.w	8(a3),d4
	swap	d4
	bsr	shift_zone5

	clr.l	d4
	move.w	8(a1),d4
	clr.l	d5
	move.w	10(a1),d5
	clr.l	d6
	move.w	12(a1),d6
	clr.l	d7
	move.w	14(a1),d7

	swap	d4
	swap	d5
	swap	d6
	swap	d7
	bsr	shift_zone4

	RTS
;-------------------------------
shift_zone4:
	asr.l	d3,d4
	asr.l	d3,d5
	asr.l	d3,d6
	asr.l	d3,d7
	or.w	d4,0(a0)
	or.w	d5,2(a0)
	or.w	d6,4(a0)
	or.w	d7,6(a0)
	RTS
;-------------------------------
shift_zone5:
	asr.l	d3,d4
	not.w	d4
	and.w	d4,0(a0)
	and.w	d4,2(a0)
	and.w	d4,4(a0)
	and.w	d4,6(a0)
	RTS
;-------------------------------
clear_sprites:
	move.l	schermadres,a2
	move.l	#sprites+34,a1

; real X
	move.w	coordxold,d0
	sub.w	screenx,d0
	and.w	#%1111111111110000,d0
	add.w	d0,a2

; real Y
	clr.l	d1
	move.w	coordyold,d1
	sub.w	screeny,d1

	move.w	coordxold,d7
	sub.w	screenx,d7
	move.w	d7,d3
	and.w	#15,d3

	move.w	#32-1,d2

realclearlus:
	tst.w	d1
	blo.s	no_drawb
	cmp.w	#11*16-1,d1
	bhi.s	no_drawb

	move.l	a2,a0
	move.w	d1,d4
	mulu	#160,d4
	ext.l	d4
	asl.l	#1,d4
	add.l	d4,a0

	tst.w	d0
	blo.s	no_draw1b
	cmp.w	#20*16,d1
	bhi.s	no_draw1b
	bsr	clear_zone
no_draw1b:
	add.w	#16,a0
	add.w	#16,d0
	tst.w	d0
	blo.s	no_draw2b
	cmp.w	#20*16,d1
	bhi.s	no_draw2b
	bsr	clear_zone
no_draw2b:
	add.w	#16,a0
	add.w	#16,d0
	tst.w	d0
	blo.s	no_draw3b
	cmp.w	#20*16,d1
	bhi.s	no_draw3b
	bsr	clear_zone
no_draw3b:
no_drawb:
	add.w	#160,a1
	add.w	#1,d1
	dbra	d2,realclearlus
	RTS
;-------------------------------
clear_zone:
	clr.w	0(a0)
	clr.w	2(a0)
	clr.w	4(a0)
	clr.w	6(a0)
	RTS
;-------------------------------
last_init:
;	move.w	#32,speed2x
	RTS
;-------------------------
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
;-------------------------
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
;-------------------------
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
;-------------------------
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
;-------------------------
cls:
	move.l	#(320*200)/4/4-1,d0
	move.l	schermadres,a0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS
;-------------------------
	move.l	#kijkveld,a3
	mulu	#aantblok_cop*16*8,d0
cop:
	move.l	schermadres,a1
	move.l	#tabel2,a2
	move.l	#kijkveld,a3
	move.l	#shiftpic_voor,a4

	move.w	screenx,d0
	and.w	#15,d0
	mulu	#aantblok_cop*16*8,d0
	add.l	d0,a4

	clr.l	d0
	move.w	screenx,d0
	asr.w	#4,d0
	asl.w	#1,d0
	add.w	d0,a3

	move.w	#11-1,d6
lus2:
	move.w	#20-1,d7
lus:
	move.w	(a3)+,d0
	tst.w	d0
	beq	skipcop
	move.l	a4,a0
	sub.w	#128,d0
	add.w	d0,a0
ad set 0
	REPT	16
	move.l	ad*8(a0),ad*320(a1)
	move.l	ad*8+4(a0),ad*320+4(a1)
ad set ad+1
	ENDR
skipcop:
	add.w	(a2)+,a1
	dbra	d7,lus
	add.w	#unusedcop,a3
	dbra	d6,lus2
	RTS
;-------------------------
voorcop:
	move.l	schermadres,a1
	add.w	#8,a1
	move.l	#tabel2,a2
	move.l	#voorveld,a3
	move.l	#shiftpic_back,a4

	move.w	screenx2,d0
	and.w	#15,d0
	mulu	#aantblok_back*16*4,d0
	add.l	d0,a4

	clr.l	d0
	move.w	screenx2,d0
	asr.w	#4,d0
	asl.w	#1,d0
	add.w	d0,a3

	move.w	#11-1,d6
lus2b:
	move.w	#20-1,d7
lusb:
	move.w	(a3)+,d0
	tst.w	d0
	beq	skipcop2
	move.l	a4,a0
	sub.w	#64,d0
	add.w	d0,a0
ad set 0
	REPT	16
	move.l	ad*4(a0),ad*320(a1)
ad set ad+1
	ENDR
skipcop2:
	add.w	(a2)+,a1
	dbra	d7,lusb
 	add.w	#unusedvoor,a3
	dbra	d6,lus2b
	RTS
;-------------------------
backcop:
	move.l	schermadres,a1
	add.w	#12,a1
	move.l	#tabel2,a2
	move.l	#backveld,a3
	move.l	#shiftpic_back,a4

	move.w	screenx3,d0
	and.w	#15,d0
	mulu	#aantblok_back*16*4,d0
	add.l	d0,a4

	clr.l	d0
	move.w	screenx3,d0
	asr.w	#4,d0
	asl.w	#1,d0
	add.w	d0,a3

	move.w	#11-1,d6
lus2c:
	move.w	#20-1,d7
lusc:
	move.w	(a3)+,d0
	tst.w	d0
	beq	skipcop3
	move.l	a4,a0
	sub.w	#64,d0
	add.w	d0,a0
ad set 0
	REPT	16
	move.l	ad*4(a0),ad*320(a1)
ad set ad+1
	ENDR
skipcop3:
	add.w	(a2)+,a1
	dbra	d7,lusc
 	add.w	#unusedback,a3
	dbra	d6,lus2c
	RTS
;-------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	move.l	#screen2+256,d0
	and.l	#$FFFFFF00,d0
	move.l	d0,schermadres2

	RTS
;-------------------------
install_mo_jo:
	move.w	#kbdvec,-(sp) ; parameter
	trap	#14	      ; naar MO & JO
	addq.l	#2,a7

	move.l	d0,a0
	move.l	d0,save_old_base

	lea	mo_handler,a1
	lea	jo_handler,a2

	move.l	mousevec(a0),save_old_mvec
	move.l	a1,mousevec(a0)
	move.l	joyvec(a0),save_old_jvec
	move.l	a2,joyvec(a0)

; Muis aan : OUT 2,8
	pea	ikbdstring
	move.w	#0,-(sp)
	move.w	#ikbdws,-(sp)
	trap	#14
	addq.l	#8,sp
	RTS
;-------------------------------
restore_mo_jo:
	move.l	save_old_base,a0
	move.l	save_old_mvec,d0
	move.l	d0,mousevec(a0)
	move.l	save_old_jvec,d0
	move.l	d0,joyvec(a0)
	move.w	#0,-(sp)
	trap	#1
	RTS
;-------------------------------
jo_handler:
	lea	jpacket,a1
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	RTS
;-------------------------------
mo_handler:
	lea	mpacket,a1
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
;(x)
;	clr.w	d0
;	move.b	mpacket+1,d0
;	ext.w	d0
;	add.w	d0,speed2x
;;(y)
;	clr.w	d0
;	move.b	mpacket+2,d0
;	ext.w	d0
;	add.w	d0,speed2y

	RTS
;-------------------------
save_colors:
	move.l	#$ffff9800,a0
	move.l	#old_palette,a1
	move.w	#255,d0
save_cloop:
	move.l	(a0)+,(a1)+
	dbra	d0,save_cloop
	RTS
;-------------------------
rest_colors:
	move.l	#old_palette,a0
	move.l	#$ffff9800,a1
	move.w	#255,d0
rest_cloop:
	move.l	(a0)+,(a1)+
	dbra	d0,rest_cloop
	RTS
;-------------------------
set_colors:
	move.l	#new_palette,a0
	move.l	#$ffff9800,a1
	move.w	#255,d0
set_cloop:
	move.l	(a0)+,(a1)+
	dbra	d0,set_cloop
	RTS
;-------------------------
fade_out:
	move.w	#$F,d7
do_fade:
	move.w	d7,d6
	asl.w	#4,d6

	move.w	d6,d5
	asl.w	#8,d6
	or.w	d6,d5

	swap	d5
	asr.w	#8,d6
	move.w	d6,d5

	move.l	d5,$ff9800
	bsr	vsync
	dbra	d7,do_fade
	move.l	#$00000000,$ff9800
	RTS
;-------------------------
fade_in:
	move.w	#$F,d7
do_fade2:
	move.w	#$F,d6
	sub.w	d7,d6
	asl.w	#4,d6

	move.w	d6,d5
	asl.w	#8,d6
	or.w	d6,d5

	swap	d5
	asr.w	#8,d6
	move.w	d6,d5

	move.l	d5,$ff9800
	bsr	vsync
	dbra	d7,do_fade2
	move.l	#$ffff00ff,$ff9800
	RTS
;-------------------------
do_shift_voor:
	move.l	#shiftpic_voor,a1
	move.l	#16-1,d6

shiftlus2:
	move.l	#tabel1,a3
	move.l	#blokpic+34,a0
	move.l	#aantblok_cop-1,d7

shiftlus:
ad set 0
	REPT	16
	move.l	ad*160(a0),d0
	move.w	d0,d2 ;pl2->d2.r
	swap	d0
	move.w	d0,d1 ;pl1->d1.r

	move.l	ad*160+4(a0),d0
	move.w	d0,d4 ;pl2->d2.r
	swap	d0
	move.w	d0,d3 ;pl1->d1.r

	swap	d1 ;r=l,l=r
	swap	d2
	swap	d3
	swap	d4

	move.l	ad*160+8(a0),d0
	move.w	d0,d2 ;pl2->d2.r
	swap	d0
	move.w	d0,d1 ;pl1->d1.r

	move.l	ad*160+12(a0),d0
	move.w	d0,d4 ;pl2->d2.r
	swap	d0
	move.w	d0,d3 ;pl1->d1.r

	asr.l	d6,d1
	asr.l	d6,d2
	asr.l	d6,d3
	asr.l	d6,d4

	move.w	d1,d0
	swap	d0
	move.w	d2,d0
	move.l	d0,ad*8(a1)

	move.w	d3,d0
	swap	d0
	move.w	d4,d0
	move.l	d0,ad*8+4(a1)
ad set ad+1
	ENDR

	add.l	#16*8,a1
	add.w	(a3)+,a0
	add.w	(a3)+,a0
	dbra	d7,shiftlus
	dbra	d6,shiftlus2
	RTS
;-------------------------
precalveld_cop:
	move.l	#kijkveld,a0
	move.l	#kijkveldlen/2-1,d0
veldlus:
	move.w	(a0),d1
	add.w	#1,d1
	mulu	#128,d1
	move.w	d1,(a0)+
	dbra	d0,veldlus
	RTS
;-------------------------
precalveld_back:
	move.l	#backveld,a0
	move.l	#backveldlen/2-1,d0
veldlus2:
	move.w	(a0),d1
	add.w	#1,d1
	mulu	#64,d1
	move.w	d1,(a0)+
	dbra	d0,veldlus2
	RTS
;-------------------------
precalveld_voor:
	move.l	#voorveld,a0
	move.l	#voorveldlen/2-1,d0
veldlus3:
	move.w	(a0),d1
	add.w	#1,d1
	mulu	#64,d1
	move.w	d1,(a0)+
	dbra	d0,veldlus3
	RTS
;-------------------------
do_shift_back:
	move.l	#shiftpic_back,a1
	move.l	#16-1,d6

shiftlus4:
	move.l	#tabel1,a3
	move.l	#backpic+34,a0
	move.l	#aantblok_back-1,d7

shiftlus3:
ad set 0
	REPT	16
	move.l	ad*160(a0),d0
	move.w	d0,d2 ;pl2->d2.r
	swap	d0
	move.w	d0,d1 ;pl1->d1.r

	swap	d1 ;r=l,l=r
	swap	d2

	move.l	ad*160+8(a0),d0
	move.w	d0,d2 ;pl2->d2.r
	swap	d0
	move.w	d0,d1 ;pl1->d1.r

	asr.l	d6,d1
	asr.l	d6,d2

	move.w	d1,d0
	swap	d0
	move.w	d2,d0
	move.l	d0,ad*4(a1)

ad set ad+1
	ENDR

	add.l	#16*4,a1
	add.w	(a3)+,a0
	add.w	(a3)+,a0
	dbra	d7,shiftlus3
	dbra	d6,shiftlus4
	RTS
;-------------------------
beeld_change:
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	move.l	schermadres2,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2

	not.w	swappervbl
	tst.w	swappervbl
	beq.s	swapperjump
	move.w	coordx,coordx2
	move.w	coordy,coordy2
	move.w	coordx3,coordxold
	move.w	coordy3,coordyold
	bra	endswapper
swapperjump:
	move.w	coordx,coordx3
	move.w	coordy,coordy3
	move.w	coordx2,coordxold
	move.w	coordy2,coordyold
endswapper:
	RTS

;-------------------------
;	VARIABELEN
;-----------------------------------
schermadres:	dc.l	0
schermadres2:	dc.l	0
ssp:		dc.l	0
swappervbl:	dc.w	0

speedx:	dc.w	0
speedy:	dc.w	0
coordx:	dc.w	0
coordy:	dc.w	0
coordx2: dc.w	0
coordy2: dc.w	0
coordx3: dc.w	0
coordy3: dc.w	0
coordxold:	dc.w	0
coordyold:	dc.w	0
jumpteller:	dc.w	0
jumpready:	dc.w	0
special_area:	dc.w	0

screenspeedx:	dc.w	0
screenspeedy:	dc.w	0
screenx:	dc.w	0
screeny:	dc.w	0
screenx2:	dc.w	0
screenx3:	dc.w	0

ikbdstring	dc.b	$8
mpacket		ds.b	3
jpacket		ds.b	3
save_old_mvec	ds.l	1
save_old_jvec	ds.l	1
save_old_base	ds.l	1
old_palette:	ds.l	256
new_palette:
col1	set	0
col2	set	0
colv1	set	$D0F000D0
colv2	set	$30C00030
colv3	set	$00800000
;colv1	set	$30300030
;colv2	set	$50500050
;colv3	set	$70700070
pl set 0
	REPT	4

	dc.w	col1,col2
	dc.l	          $C0600000,$E0A00000,$E0E00000
	dc.l	$60000000,$00600000,$00A00000,$00E00000
	dc.l	$A0000000,$60600060,$A0A000A0,$E0E000E0
	dc.l	$E0000000,$000000E0,$C0C000C0,$00E000E0
	dc.l	colv1,colv1,colv1,colv1
	dc.l	colv1,colv1,colv1,colv1
	dc.l	colv1,colv1,colv1,colv1
	dc.l	colv1,colv1,colv1,colv1
	dc.l	colv2,colv2,colv2,colv2
	dc.l	colv2,colv2,colv2,colv2
	dc.l	colv2,colv2,colv2,colv2
	dc.l	colv2,colv2,colv2,colv2
	dc.l	colv3,colv3,colv3,colv3
	dc.l	colv3,colv3,colv3,colv3
	dc.l	colv3,colv3,colv3,colv3
	dc.l	colv3,colv3,colv3,colv3
pl set 0
col1 set col1+$2020
col2 set col2+$0020
	ENDR
;	ds.l	256-64


kijkveld:	
	REPT	2
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	ENDR
	dc.w	-1,-1, 0, 1, 3, 3, 3, 3, 2, 0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	dc.w	 4, 5, 6, 6, 7, 8, 0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 0, 0, 4, 5, 6, 6
	dc.w	 6,10,11, 0, 0,-1,-1,-1,-1, 0, 0,44,45, 6, 7, 8, 0, 0,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 0, 0,23,17,22,22
	dc.w	22,12,13, 0, 0,-1,-1,-1,-1, 0, 0,42,43,22,46,47, 0, 0,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	dc.w	26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,29,30,22,22
	dc.w	22,14,15,16, 0, 0,-1,-1, 0, 0,39,40,41,22,46,47, 0, 0,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	dc.w	24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,28,31,22,22
	dc.w	22,22,18,19,20,21, 0, 0,35,36,37,38,22,22,46,47, 0, 0,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	REPT	600
	dc.w	3
	ENDR
kijkveldend:
kijkveldlen	EQU	kijkveldend-kijkveld

backveld:
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 0,13,14,15,16, 0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 0, 9,10,11,12, 0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 5, 6, 7, 8, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1
	dc.w	17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17
	dc.w	18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

backveldend:
backveldlen	EQU	backveldend-backveld

voorveld:
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 0, 0,27,28,29,30, 0, 0, 0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 0, 0,19,20,21,22,23,24, 0, 0, 0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 0, 0,19,20,21,31,31,22,23,24, 0, 0, 0,27,28,29,30, 0, 0, 0,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 0, 0,19,20,21,25,26,31,31,21,23,24, 0,19,20,21,31,23,24, 0, 0, 0,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	dc.w	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

voorveldend:
voorveldlen	EQU	voorveldend-voorveld

tabel1:
	REPT	13
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8+160*15
	ENDR
tabel2:
	REPT	13
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16+320*15
	ENDR
tabel3:	dc.w	%1000000000000000
	dc.w	%0100000000000000
	dc.w	%0010000000000000
	dc.w	%0001000000000000
	dc.w	%0000100000000000
	dc.w	%0000010000000000
	dc.w	%0000001000000000
	dc.w	%0000000100000000
	dc.w	%0000000010000000
	dc.w	%0000000001000000
	dc.w	%0000000000100000
	dc.w	%0000000000010000
	dc.w	%0000000000001000
	dc.w	%0000000000000100
	dc.w	%0000000000000010
	dc.w	%0000000000000001
blokpic:
	INCBIN	"F:\PROGRAMM\JMP\JMPBLOK.PI1"
maskblokpic:
	INCBIN	"F:\PROGRAMM\JMP\JMPBLOKM.PI1"
backpic:
	INCBIN	"F:\DRAW\PICTURES\PI1'S\BAN_BACK.PI1"
sprites:
	INCBIN	"F:\DRAW\PICTURES\PI1'S\BANANA1.PI1"
masksprites:
	INCBIN	"F:\DRAW\PICTURES\PI1'S\BAN1MASK.PI1"

; 4pl->8
; 16h->16
; 16x->16 *
;      --
;      2048

shiftpic_voor:	ds.l	aantblok_cop*2048
shiftpic_back:	ds.l	aantblok_back*1024

screen2:	ds.l	64256/4


; END 
