R	EQU	2^8
G	EQU	2^16
B	EQU	1
SHOW	EQU	2

	bsr	schermadr_opvraag
	bsr	cls_all

	bsr	sup_vis_mode
	bsr	save_colors
	bsr	set_colors

	bsr	vsync
	move.l	#screen2,schermadres2
	add.l	#256,schermadres2
	and.l	#$FFFFFF00,schermadres2
back:
	bsr	beeld_change
	bsr	cls
	bsr	animate
	bsr	vsync

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back
end:

	bsr	load_colors
	bsr	user_mode

	clr.l	-(sp)
	trap	#1


;********************************
;*	SUBROUTINES    !!!!!	*
;********************************

;-------------------------
animate:
	add.w	#1,animteller
	cmp.w	#6*4-1,animteller
	bne.s	no_res_anim
	move.w	#0,animteller
no_res_anim:
	move.l	#banana+34,a0
	move.l	#banquel,a2

	move.w	animteller,d0
	asr.w	#2,d0
	clr.w	d1
	move.b	(a2,d0.w),d1
	asl.w	#4,d1
	add.w	d1,a0

	add.w	#160*32,a0
	bsr	copy_it

	RTS
;-------------------------
copy_it:
	move.l	schermadres,a1
	move.w	#32-1,d0
copy_y:
	move.l	(a0),(a1)
	move.l	4(a0),4(a1)
	move.l	8(a0),8(a1)
	move.l	12(a0),12(a1)
	add.w	#160,a0
	add.w	#160,a1
	dbra	d0,copy_y
	RTS
;-------------------------
do_it:
;	move.w	#4,-(sp)
;	trap	#14
;	addq	#2,sp
;	move.l	schermadres,a0
;	move.l	d0,8000(a0)
	RTS
;-------------------------
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS

;-------------------------
beeld_change:
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	move.l	schermadres2,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2
	RTS

;-------------------------
wacht_toets:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
;-------------------------
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
;-------------------------
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
;-------------------------
cls:
	move.l	#200-1,d0
	move.l	schermadres,a0
go_cls:

pl set 0
	REPT	20
	clr.l	pl(a0)
	clr.l	pl+4(a0)
pl set pl+8
	ENDR
	add.w	#160,a0
	dbra d0,go_cls
	RTS
;-------------------------
cls_all:
	move.l	#32000/4/4-1,d0
	move.l	schermadres,a0
go_cls_all:
	clr.l	(a0)+ 
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls_all
	RTS
;-------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
;-------------------------
save_colors:
	move.l	#$ff8240,a0
	move.l	#oldpal,a1
	move.w	#7,d0
	move.l	(a0)+,(a1)+
go_save:
	dbra	d0,go_save
	RTS
;-------------------------
set_colors:
	move.l	#banana+2,a0
	move.l	#$ff8240,a1
	move.w	#7,d0
go_set:
	move.l	(a0)+,(a1)+
	dbra	d0,go_set
	RTS
;-------------------------
load_colors:
	move.l	#oldpal,a0
	move.l	#$ff8240,a1
	move.w	#7,d0
go_load:
	move.l	(a0)+,(a1)+
	dbra	d0,go_load
	RTS
;-------------------------
wacht_lusje:
	move.l	#16000,d0
wachtlus	nop
	dbra	d0,wachtlus
	RTS
;-------------------------
	
;	VARIABELEN
;-----------------------------------
schermadres:	dc.l	0
schermadres2:	dc.l	0
ssp:		dc.l	0
animteller:	dc.w	0
screen2:	ds.b	64256
oldpal:	ds.l	256
banana:	INCBIN	"F:\DRAW\PICTURES\PI1'S\BANANA1.PI1"
banquel:	dc.b	0,1,2,3,2,1,0
