SHOW	EQU	2

	bsr	schermadr_opvraag
	bsr	cls_all

	bsr	sup_vis_mode
	bsr	save_colors
	bsr	set_colors

	move.l	#screen2,schermadres2
	add.l	#256,schermadres2
	and.l	#$FFFFFF00,schermadres2
back:
	bsr	beeld_change
	bsr	animate
	bsr	vsync

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back


	bsr	load_colors
	bsr	user_mode
	clr.l	-(sp)
	trap	#1


;********************************
;*	SUBROUTINES    !!!!!	*
;********************************

;-------------------------
animate:
	add.w	#2,bobcntx
	add.w	#2,bobcnty
	cmp.w	#360*2,bobcntx
	blo.s	not_360
	sub.w	#360*2,bobcntx
not_360:
	cmp.w	#480*2,bobcnty
	blo.s	not_480
	sub.w	#480*2,bobcnty
not_480:

	move.l	#sin1,a0
	add.w	bobcntx,a0
	move.w	(a0),d0
	move.w	d0,xbobs

	move.l	#sin2,a0
	add.w	bobcnty,a0
	move.w	(a0),d0
	move.w	d0,ybobs

	bsr	copy_it

	RTS
;-------------------------
copy_it:
	move.l	#bobdata,a0
	move.l	#backgr,a1
	move.b	xbobs+1,d1
	and.w	#7,d1 
	move.w	#16-1,d3

bobcalcloop:

	clr.l	d0
	move.b	(a0),d0
	asl.w	#8,d0
	move.b	(a0)+,d0

	asl.l	d1,d0
	move.w	d0,d2
	swap	d0
	or.w	d0,d2
	move.w	d2,16*2(a1)
	move.w	d2,(a1)+
	dbra	d3,bobcalcloop

	move.l	#backgr,a0
	move.b	ybobs+1,d0
	and.w	#7,d0
	asl.w	#2,d0
	add.w	d0,a0

	move.l	schermadres,a1
	move.w	#25-1,d0
NR	EQU	16
copy_y:
pl set 0
	REPT	8
	move.l	pl*4(a0),d1
	move.l	d1,(a1)
	move.l	d1,NR(a1)
	move.l	d1,NR*2(a1)
	move.l	d1,NR*3(a1)
	move.l	d1,NR*4(a1)
	move.l	d1,NR*5(a1)
	move.l	d1,NR*6(a1)
	move.l	d1,NR*7(a1)
	move.l	d1,NR*8(a1)
	move.l	d1,NR*9(a1)
	move.l	d1,NR*10(a1)
	move.l	d1,NR*11(a1)
	move.l	d1,NR*12(a1)
	move.l	d1,NR*13(a1)
	move.l	d1,NR*14(a1)
	move.l	d1,NR*15(a1)
	move.l	d1,NR*16(a1)
	move.l	d1,NR*17(a1)
	move.l	d1,NR*18(a1)
	move.l	d1,NR*19(a1)
	add.w	#NR*20,a1
pl set pl+1
	ENDR
	dbra	d0,copy_y
	RTS
;-------------------------
do_it:
;	move.w	#4,-(sp)
;	trap	#14
;	addq	#2,sp
;	move.l	schermadres,a0
;	move.l	d0,8000(a0)
	RTS
;-------------------------
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS

;-------------------------
beeld_change:
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	move.l	schermadres2,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2
	RTS

;-------------------------
wacht_toets:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
;-------------------------
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
;-------------------------
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
;-------------------------
cls:
	move.l	#200-1,d0
	move.l	schermadres,a0
go_cls:

pl set 0
	REPT	20
	clr.l	pl(a0)
	clr.l	pl+4(a0)
pl set pl+8
	ENDR
	add.w	#160,a0
	dbra d0,go_cls
	RTS
;-------------------------
cls_all:
	move.l	#64000/4/4-1,d0
	move.l	schermadres,a0
go_cls_all:
	clr.l	(a0)+ 
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls_all
	RTS
;-------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
;-------------------------
save_colors:
	move.l	#$ff9800,a0
	move.l	#oldpal,a1
	move.w	#255,d0
	move.l	(a0)+,(a1)+
go_save:
	dbra	d0,go_save
	RTS
;-------------------------
set_colors:
	move.l	#newpal,a0
	move.l	#$ff9800,a1
	move.w	#255,d0
go_set:
	move.l	(a0)+,(a1)+
	dbra	d0,go_set
	RTS
;-------------------------
load_colors:
	move.l	#oldpal,a0
	move.l	#$ff9800,a1
	move.w	#255,d0
go_load:
	move.l	(a0)+,(a1)+
	dbra	d0,go_load
	RTS

;-------------------------
wacht_lusje:
	move.l	#16000,d0
wachtlus	nop
	dbra	d0,wachtlus
	RTS
;-------------------------
	
;	VARIABELEN
;-----------------------------------
schermadres:	dc.l	0
schermadres2:	dc.l	0
ssp:		dc.l	0
bobcntx:	dc.w	0
bobcnty:	dc.w	0
xbobs:		dc.w	0
ybobs:		dc.w	0
bobdata:
	dc.w	%1111110000000000
	dc.w	%1111111000110000
	dc.w	%1101111001110000
	dc.w	%1110111001110000
	dc.w	%1111101000000000
	dc.w	%1111001000000000
	dc.w	%0111110000000000
	dc.w	%0000000000000000
newpal:	
	dc.l	$080C0010
	dc.l	$00500080
	dc.l	$B0D000F0
	dc.l	$709000B0
	REPT	256
	dc.l	0
	ENDR

oldpal:		ds.l	256
backgr:		ds.w	4*16
screen2:	ds.b	64256
sin1:	INCBIN	'F:\PROGRAMM\ALL_DATA\SIN360.DAT'
sin2:	INCBIN	'F:\PROGRAMM\ALL_DATA\SIN480.DAT'
