
	bsr	schermadr_opvraag
	move.l	#screen2+256,schermadres2
	bsr	cls
	bsr	sup_vis_mode


	and.b	#$df,$fffa09
	and.b	#$fe,$fffa07
	move.l	#VBL,$70
	move.l	#HBL,$120
	or.b	#1,$fffffa07
	or.b	#1,$fffffa13
;	clr.b	$fffffa09.w
	move.w	#$2300,sr
back:
	bsr	vsync

	cmp.b	#01,$fffffc02.w
	bne	back

	move.w	#$777,$ff8240
	move.w	#$000,$ff825E

	bsr	user_mode

	clr.l	-(sp)
	trap	#1


;	SUBROUTINES    !!!!!
;-------------------------
HBL:	
	add.w	#1,$ff8240
	clr.b	$fffffa1b.w
	move.b	#1,$fffffa21.w
	bclr	#0,$fffffa0f.w
	move.b	#8,$fffffa1b.w
	RTE

VBL:	clr.b	$fffffa1b.w
	move.w	#$444,$ff8240
	move.b	#1,$fffffa21.w
	move.b	#8,$fffffa1b.w
	RTE
;-------------------------
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
;-------------------------
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
;-------------------------
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
;-------------------------
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
 	RTS
;-------------------------
cls:
	move.l	#32000/4/4-1,d0
	move.l	schermadres,a0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS
;-------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
;-------------------------
set_colors:
	move.l	#picture+2,a0
	movem.l	(a0),d0-d7
	movem.l	d0-d7,$ff8240
	RTS
;-------------------------------
beeld_change:
	move.l	schermadres,d0
	move.l	schermadres2,schermadres
	move.l	d0,schermadres2

	move.l	schermadres2,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	move.l	schermadres2,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2

	RTS

;	VARIABELEN
;-----------------------------------
picture:	;INCBIN	'IANCPOP1.pi1'
schermadres:	dc.l	0
schermadres2:	dc.l	0
ssp:		dc.l	0

tabel1:
pl set 0
	REPT	20
	dc.w	7,pl
	dc.w	6,pl
	dc.w	5,pl
	dc.w	4,pl
	dc.w	3,pl
	dc.w	2,pl
	dc.w	1,pl
	dc.w	0,pl
	dc.w	7,pl+1
	dc.w	6,pl+1
	dc.w	5,pl+1
	dc.w	4,pl+1
	dc.w	3,pl+1
	dc.w	2,pl+1
	dc.w	1,pl+1
	dc.w	0,pl+1
pl set pl+8
	ENDR

screen2:	ds.b	32256
