R	EQU	2^8
G	EQU	2^16
B	EQU	1
SHOW	EQU	2

	bsr	schermadr_opvraag
	bsr	cls_all

	bsr	sup_vis_mode
	bsr	save_colors
	bsr	set_colors

	move.l	#screen2,schermadres2
	add.l	#256,schermadres2
	and.l	#$FFFFFF00,schermadres2
	move.l	#screen3,schermadres3
	add.l	#256,schermadres3
	and.l	#$FFFFFF00,schermadres3

	move.w	#1,speed

	move.l	schermadres5,schermadresn
	add.l	#320*3,schermadresn
	bsr	copy_it
	move.l	schermadres4,schermadresn
	add.l	#320*2,schermadresn
	bsr	copy_it
	move.l	schermadres3,schermadresn
	add.l	#320*1,schermadresn
	bsr	copy_it
	move.l	schermadres2,schermadresn
	bsr	copy_it
back:
	bsr	beeld_change
	bsr	animate
	bsr	vsync

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back
end:

	bsr	load_colors
	bsr	user_mode

	clr.l	-(sp)
	trap	#1


;********************************
;*	SUBROUTINES    !!!!!	*
;********************************

;-------------------------
animate:

	cmp.w	#399-200,ylook
	blo.s	l200
	move.w	#-1,speed
l200:
	cmp.w	#0,ylook
	bhi.s	l0
	move.w	#1,speed
l0:
	move.w	speed,d0
	add.w	d0,ylook

	move.w	ylook,d0
	and.w	#3,d0
	cmp.w	#0,d0
	bne	its_0
	move.l	schermadres5,schermadresn
its_0
	cmp.w	#1,d0
	bne	its_1
	move.l	schermadres4,schermadresn
its_1
	cmp.w	#2,d0
	bne	its_2
	move.l	schermadres3,schermadresn
its_2
	cmp.w	#3,d0
	bne	its_3
	move.l	schermadres2,schermadresn
its_3

	clr.l	d0
	move.w	ylook,d0
	and.w	#-1-3,d0
	mulu	#320,d0
	add.l	d0,schermadresn

	RTS
;-------------------------
copy_it:
	move.l	#pin0,a0
	move.l	#pin1,a1
	move.l	#pin2,a2
	move.l	#pin3,a3
	move.l	schermadresn,a4
	move.w	#400-1,d0
copy_y:
pl set 0
	REPT	20
	move.w	pl(a0),(a4)+
	move.w	pl+40(a0),(a4)+
	move.w	pl(a1),(a4)+
	move.w	pl+40(a1),(a4)+
	move.w	pl(a2),(a4)+
	move.w	pl+40(a2),(a4)+
	move.w	pl(a3),(a4)+
	move.w	pl+40(a3),(a4)+
pl set pl+2
	ENDR
	add.w	#80,a0
	add.w	#80,a1
	add.w	#80,a2
	add.w	#80,a3
	dbra	d0,copy_y
	RTS
;-------------------------
do_it:
;	move.w	#4,-(sp)
;	trap	#14
;	addq	#2,sp
;	move.l	schermadres,a0
;	move.l	d0,8000(a0)
	RTS
;-------------------------
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS

;-------------------------
beeld_change:
;	move.l	schermadres,d0
;	move.l	schermadres2,schermadres
;	move.l	d0,schermadres2

	move.l	schermadresn,d0
	asr.l	#8,d0
	move.b	d0,$ff8203
	asr	#8,d0
	move.b	d0,$ff8201

	move.l	schermadres2,d0
	asr.l	#8,d0
	asl.l	#8,d0
	move.l	d0,schermadres2
	RTS

;-------------------------
wacht_toets:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
;-------------------------
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
;-------------------------
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
;-------------------------
cls:
	move.l	#200-1,d0
	move.l	schermadres,a0
go_cls:

pl set 0
	REPT	20
	clr.l	pl(a0)
	clr.l	pl+4(a0)
pl set pl+8
	ENDR
	add.w	#160,a0
	dbra d0,go_cls
	RTS
;-------------------------
cls_all:
	move.l	#64000/4/4-1,d0
	move.l	schermadres,a0
go_cls_all:
	clr.l	(a0)+ 
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls_all
	RTS
;-------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
;-------------------------
save_colors:
	move.l	#$ff9800,a0
	move.l	#oldpal,a1
	move.w	#255,d0
	move.l	(a0)+,(a1)+
go_save:
	dbra	d0,go_save
	RTS
;-------------------------
set_colors:
	move.l	#newpal,a0
	move.l	#$ff9800,a1
	move.w	#255,d0
go_set:
	move.l	(a0)+,(a1)+
	dbra	d0,go_set
	RTS
;-------------------------
load_colors:
	move.l	#oldpal,a0
	move.l	#$ff9800,a1
	move.w	#255,d0
go_load:
	move.l	(a0)+,(a1)+
	dbra	d0,go_load
	RTS
;-------------------------
wacht_lusje:
	move.l	#16000,d0
wachtlus	nop
	dbra	d0,wachtlus
	RTS
;-------------------------
	
;	VARIABELEN
;-----------------------------------
schermadres:	dc.l	0
schermadres2:	dc.l	0
schermadres3:	dc.l	0
schermadres4:	dc.l	0
schermadres5:	dc.l	0
schermadresn:	dc.l	0
ssp:		dc.l	0
animteller:	dc.w	0
ylook:		dc.w	0
speed		dc.w	0
		ds.b	256
screen2:	ds.b	128000
screen3:	ds.b	128000+320*4
screen4:	ds.b	128000+320*4
screen5:	ds.b	128000+320*4
oldpal:	ds.l	256
newpal:	

	INCBIN	'F:\DRAW\HIGHGRAP.H\PIN1_1.PAL'

	REPT	256
	dc.l	0
	ENDR

pin0:	INCBIN	'F:\DRAW\HIGHGRAP.H\PIN1_1_0.BLD'
pin1:	INCBIN	'F:\DRAW\HIGHGRAP.H\PIN1_1_1.BLD'
pin2:	INCBIN	'F:\DRAW\HIGHGRAP.H\PIN1_1_2.BLD'
pin3:	INCBIN	'F:\DRAW\HIGHGRAP.H\PIN1_1_3.BLD'
