PLASMAY		EQU	32
PLASMAX		EQU	48
PLASMAY2	EQU	20
PLASMAX2	EQU	44
PLASMAY3	EQU	14
PLASMAX3	EQU	40


	bsr	schermadr_opvraag
	bsr	cls
	bsr	sup_vis_mode
	bsr	store_pal
	;bsr	set_pal
	move.w	#3,$ffff82c2
back:
	add.w	#-2*PLASMAX2+(PLASMAY2*PLASMAX2*2),plasma_offset1
	add.w	#2,plasma_offset2
	add.w	#-2-PLASMAX3*2+(PLASMAY3*PLASMAX3*2),plasma_offset3

	cmp.w	#PLASMAY2*PLASMAX2*2,plasma_offset1
	ble.s	no_wrap1
	sub.w	#PLASMAY2*PLASMAX2*2,plasma_offset1
no_wrap1:
	cmp.w	#PLASMAY*PLASMAX*2,plasma_offset2
	ble.s	no_wrap2
	sub.w	#PLASMAY*PLASMAX*2,plasma_offset2
no_wrap2:
	cmp.w	#PLASMAY3*PLASMAX3*2,plasma_offset3
	ble.s	no_wrap3
	sub.w	#PLASMAY3*PLASMAX3*2,plasma_offset3
no_wrap3:

	add.w	#6,plasma_offsetc
	cmp.w	#plasma_coltabend-plasma_coltab,plasma_offsetc
	blo.s	no_wrap
	sub.w	#plasma_coltabend-plasma_coltab,plasma_offsetc
no_wrap:
	move.l	#$00000000,$ff9800

	;bsr	vsync
	bsr	show_plasma
	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back
	bsr	restore_pal
	move.w	#0,$ffff82c2
	bsr	user_mode
	clr.l	-(sp)
	trap	#1
show_plasma:
	move.l	schermadres,a6
	move.l	#plasma_vorm2,a1
	move.l	#plasma_vorm,a2
	move.l	#plasma_vorm3,a3
	add.w	plasma_offset1,a1
	add.w	plasma_offset2,a2
	add.w	plasma_offset3,a3

	move.l	#plasma_coltab,a5
	add.w	plasma_offsetc,a5
	move.w	#50-1,d7
plasma_yloop:
pl set 0
	REPT	40
	move.w	pl/8(a1),d0
	add.w	pl/8(a2),d0
	sub.w	pl/8(a3),d0
	move.w	(a5,d0.w),d1
	move.w	d1,d2
	swap	d2
	move.w	d1,d2
	move.l	d2,1280(a6)
	move.l	d2,(a6)+
	move.l	d2,1280(a6)
	move.l	d2,(a6)+
	move.l	d2,1280(a6)
	move.l	d2,(a6)+
	move.l	d2,1280(a6)
	move.l	d2,(a6)+
pl set pl+16
	ENDR
	add.w	#640*3,a6
	add.w	#PLASMAX2*2,a1
	add.w	#PLASMAX*2,a2
	add.w	#PLASMAX3*2,a3
	dbra	d7,plasma_yloop
	RTS


vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
wacht_lusje:
	move.l	#16000,d0
wachtlus	nop
	dbra	d0,wachtlus
	RTS
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
store_pal
	move.l	#$ffff9800,a0
	move.l	#oldpal,a1
	bsr	move256long
	RTS
restore_pal
	move.l	#oldpal,a0
	move.l	#$ffff9800,a1
	bsr	move256long
	RTS
set_pal
	move.l	#newpal,a0
	move.l	#$ffff9800,a1
	bsr	move256long
	RTS
move256long
	move.w	#256-1,d0
m256l_loop:
	move.l	(a0)+,(a1)+
	dbra	d0,m256l_loop
	RTS
cls
	move.l	schermadres,a0
	move.w	#128000/4/4-1,d0
clsloop	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra	d0,clsloop
	RTS

oldpal		ds.l	256
newpal		INCBIN	'F:\DRAW\PICTURES\FIT3FADE.DAT'
ssp		dc.l	0
schermadres	dc.l	0
plasma_offset1	dc.w	22*34
plasma_offset2	dc.w	11*34
plasma_offset3	dc.w	0
plasma_offsetc	dc.w	0
plasma_vorm:
	REPT	10 ; 48x 32y
	dc.w	  0, 4, 8,12,16,20,24,28,32,36, 40, 44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56, 52, 48, 44, 40,36,32,28,24,20,16,12, 8, 4, 0
	dc.w	  4, 8,12,16,20,24,28,32,36,40, 44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56, 52, 48, 44,40,36,32,28,24,20,16,12, 8, 4
	dc.w	  8,12,16,20,24,28,32,36,40,44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,102, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56, 52, 48,44,40,36,32,28,24,20,16,12, 8
	dc.w	 12,16,20,24,28,32,36,40,44,48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,106,102, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56, 52,48,44,40,36,32,28,24,20,16,12
	dc.w	 16,20,24,28,32,36,40,44,48,52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,110,110,106,102, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56,52,48,44,40,36,32,28,24,20,16
	dc.w	 20,24,28,32,36,40,44,48,52,56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,110,114,114,110,106,102, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60,56,52,48,44,40,36,32,28,24,20
	dc.w	 24,28,32,36,40,44,48,52,56,60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,110,114,118,118,114,110,106,102, 96, 92, 88, 84, 80, 76, 72, 68, 64,60,56,52,48,44,40,36,32,28,24
	dc.w	 28,32,36,40,44,48,52,56,60,64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,110,114,118,122,122,118,114,110,106,102, 96, 92, 88, 84, 80, 76, 72, 68,64,60,56,52,48,44,40,36,32,28
	dc.w	 32,36,40,44,48,52,56,60,64,68, 72, 76, 80, 84, 88, 92, 96,102,106,110,114,118,122,126,126,122,118,114,110,106,102, 96, 92, 88, 84, 80, 76, 72,68,64,60,56,52,48,44,40,36,32
	dc.w	 36,40,44,48,52,56,60,64,68,72, 76, 80, 84, 88, 92, 96,102,106,110,114,118,122,126,130,130,126,122,118,114,110,106,102, 96, 92, 88, 84, 80, 76,72,68,64,60,56,52,48,44,40,36
	dc.w	 40,44,48,52,56,60,64,68,72,76, 80, 84, 88, 92, 96,102,106,110,114,118,122,126,130,134,134,130,126,122,118,114,110,106,102, 96, 92, 88, 84, 80,76,72,68,64,60,56,52,48,44,40
	dc.w	 44,48,52,56,60,64,68,72,76,80, 84, 88, 92, 96,102,106,110,114,118,122,126,130,134,138,138,134,130,126,122,118,114,110,106,102, 96, 92, 88, 84,80,76,72,68,64,60,56,52,48,44
	dc.w	 48,52,56,60,64,68,72,76,80,84, 88, 92, 96,102,106,110,114,118,122,126,130,134,138,142,142,138,134,130,126,122,118,114,110,106,102, 96, 92, 88,84,80,76,72,68,64,60,56,52,48
	dc.w	 52,56,60,64,68,72,76,80,84,88, 92, 96,102,106,110,114,118,122,126,130,134,138,142,146,146,142,138,134,130,126,122,118,114,110,106,102, 96, 92,88,84,80,76,72,68,64,60,56,52
	dc.w	 56,60,64,68,72,76,80,84,88,92, 96,102,106,110,114,118,122,126,130,134,138,142,146,150,150,146,142,138,134,130,126,122,118,114,110,106,102, 96,92,88,84,80,76,72,68,64,60,56
	dc.w	 60,64,68,72,76,80,84,88,92,96,102,106,110,114,118,122,126,130,134,138,142,146,150,154,154,150,146,142,138,134,130,126,122,118,114,110,106,102,96,92,88,84,80,76,72,68,64,60
	dc.w	 60,64,68,72,76,80,84,88,92,96,102,106,110,114,118,122,126,130,134,138,142,146,150,154,154,150,146,142,138,134,130,126,122,118,114,110,106,102,96,92,88,84,80,76,72,68,64,60
	dc.w	 56,60,64,68,72,76,80,84,88,92, 96,102,106,110,114,118,122,126,130,134,138,142,146,150,150,146,142,138,134,130,126,122,118,114,110,106,102, 96,92,88,84,80,76,72,68,64,60,56
	dc.w	 52,56,60,64,68,72,76,80,84,88, 92, 96,102,106,110,114,118,122,126,130,134,138,142,146,146,142,138,134,130,126,122,118,114,110,106,102, 96, 92,88,84,80,76,72,68,64,60,56,52
	dc.w	 48,52,56,60,64,68,72,76,80,84, 88, 92, 96,102,106,110,114,118,122,126,130,134,138,142,142,138,134,130,126,122,118,114,110,106,102, 96, 92, 88,84,80,76,72,68,64,60,56,52,48
	dc.w	 44,48,52,56,60,64,68,72,76,80, 84, 88, 92, 96,102,106,110,114,118,122,126,130,134,138,138,134,130,126,122,118,114,110,106,102, 96, 92, 88, 84,80,76,72,68,64,60,56,52,48,44
	dc.w	 40,44,48,52,56,60,64,68,72,76, 80, 84, 88, 92, 96,102,106,110,114,118,122,126,130,134,134,130,126,122,118,114,110,106,102, 96, 92, 88, 84, 80,76,72,68,64,60,56,52,48,44,40
	dc.w	 36,40,44,48,52,56,60,64,68,72, 76, 80, 84, 88, 92, 96,102,106,110,114,118,122,126,130,130,126,122,118,114,110,106,102, 96, 92, 88, 84, 80, 76,72,68,64,60,56,52,48,44,40,36
	dc.w	 32,36,40,44,48,52,56,60,64,68, 72, 76, 80, 84, 88, 92, 96,102,106,110,114,118,122,126,126,122,118,114,110,106,102, 96, 92, 88, 84, 80, 76, 72,68,64,60,56,52,48,44,40,36,32
	dc.w	 28,32,36,40,44,48,52,56,60,64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,110,114,118,122,122,118,114,110,106,102, 96, 92, 88, 84, 80, 76, 72, 68,64,60,56,52,48,44,40,36,32,28
	dc.w	 24,28,32,36,40,44,48,52,56,60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,110,114,118,118,114,110,106,102, 96, 92, 88, 84, 80, 76, 72, 68, 64,60,56,52,48,44,40,36,32,28,24
	dc.w	 20,24,28,32,36,40,44,48,52,56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,110,114,114,110,106,102, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60,56,52,48,44,40,36,32,28,24,20
	dc.w	 16,20,24,28,32,36,40,44,48,52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,110,110,106,102, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56,52,48,44,40,36,32,28,24,20,16
	dc.w	 12,16,20,24,28,32,36,40,44,48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,106,102, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56, 52,48,44,40,36,32,28,24,20,16,12
	dc.w	  8,12,16,20,24,28,32,36,40,44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,102, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56, 52, 48,44,40,36,32,28,24,20,16,12, 8
	dc.w	  4, 8,12,16,20,24,28,32,36,40, 44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56, 52, 48, 44,40,36,32,28,24,20,16,12, 8, 4
	dc.w	  0, 4, 8,12,16,20,24,28,32,36, 40, 44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56, 52, 48, 44, 40,36,32,28,24,20,16,12, 8, 4, 0
	ENDR
	ds.l	30

plasma_vorm2:
	REPT	10 ; 48x 32y
	dc.w	  0, 4, 8,12,16,20,24,28,32,36, 40, 44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 84, 80, 76, 72, 68, 64, 60, 56, 52, 48, 44, 40,36,32,28,24,20,16,12, 8, 4, 0
	dc.w	  4, 8,12,16,20,24,28,32,36,40, 44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 88, 84, 80, 76, 72, 68, 64, 60, 56, 52, 48, 44,40,36,32,28,24,20,16,12, 8, 4
	dc.w	  8,12,16,20,24,28,32,36,40,44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56, 52, 48,44,40,36,32,28,24,20,16,12, 8
	dc.w	 12,16,20,24,28,32,36,40,44,48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56, 52,48,44,40,36,32,28,24,20,16,12
	dc.w	 16,20,24,28,32,36,40,44,48,52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,102, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56,52,48,44,40,36,32,28,24,20,16
	dc.w	 20,24,28,32,36,40,44,48,52,56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,106,102, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60,56,52,48,44,40,36,32,28,24,20
	dc.w	 24,28,32,36,40,44,48,52,56,60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,110,110,106,102, 96, 92, 88, 84, 80, 76, 72, 68, 64,60,56,52,48,44,40,36,32,28,24
	dc.w	 28,32,36,40,44,48,52,56,60,64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,110,114,114,110,106,102, 96, 92, 88, 84, 80, 76, 72, 68,64,60,56,52,48,44,40,36,32,28
	dc.w	 32,36,40,44,48,52,56,60,64,68, 72, 76, 80, 84, 88, 92, 96,102,106,110,114,118,118,114,110,106,102, 96, 92, 88, 84, 80, 76, 72,68,64,60,56,52,48,44,40,36,32
	dc.w	 36,40,44,48,52,56,60,64,68,72, 76, 80, 84, 88, 92, 96,102,106,110,114,118,122,122,118,114,110,106,102, 96, 92, 88, 84, 80, 76,72,68,64,60,56,52,48,44,40,36
	dc.w	 36,40,44,48,52,56,60,64,68,72, 76, 80, 84, 88, 92, 96,102,106,110,114,118,122,122,118,114,110,106,102, 96, 92, 88, 84, 80, 76,72,68,64,60,56,52,48,44,40,36
	dc.w	 32,36,40,44,48,52,56,60,64,68, 72, 76, 80, 84, 88, 92, 96,102,106,110,114,118,118,114,110,106,102, 96, 92, 88, 84, 80, 76, 72,68,64,60,56,52,48,44,40,36,32
	dc.w	 28,32,36,40,44,48,52,56,60,64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,110,114,114,110,106,102, 96, 92, 88, 84, 80, 76, 72, 68,64,60,56,52,48,44,40,36,32,28
	dc.w	 24,28,32,36,40,44,48,52,56,60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,110,110,106,102, 96, 92, 88, 84, 80, 76, 72, 68, 64,60,56,52,48,44,40,36,32,28,24
	dc.w	 20,24,28,32,36,40,44,48,52,56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,106,102, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60,56,52,48,44,40,36,32,28,24,20
	dc.w	 16,20,24,28,32,36,40,44,48,52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,102, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56,52,48,44,40,36,32,28,24,20,16
	dc.w	 12,16,20,24,28,32,36,40,44,48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56, 52,48,44,40,36,32,28,24,20,16,12
	dc.w	  8,12,16,20,24,28,32,36,40,44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56, 52, 48,44,40,36,32,28,24,20,16,12, 8
	dc.w	  4, 8,12,16,20,24,28,32,36,40, 44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 88, 84, 80, 76, 72, 68, 64, 60, 56, 52, 48, 44,40,36,32,28,24,20,16,12, 8, 4
	dc.w	  0, 4, 8,12,16,20,24,28,32,36, 40, 44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 84, 80, 76, 72, 68, 64, 60, 56, 52, 48, 44, 40,36,32,28,24,20,16,12, 8, 4, 0
	ENDR
	ds.l	30

plasma_vorm3:
	REPT	10 ; 48x 32y
	dc.w	  0, 4, 8,12,16,20,24,28,32,36, 40, 44, 48, 52, 56, 60, 64, 68, 72, 76, 76, 72, 68, 64, 60, 56, 52, 48, 44, 40,36,32,28,24,20,16,12, 8, 4, 0
	dc.w	  4, 8,12,16,20,24,28,32,36,40, 44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 80, 76, 72, 68, 64, 60, 56, 52, 48, 44,40,36,32,28,24,20,16,12, 8, 4
	dc.w	  8,12,16,20,24,28,32,36,40,44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 84, 80, 76, 72, 68, 64, 60, 56, 52, 48,44,40,36,32,28,24,20,16,12, 8
	dc.w	 12,16,20,24,28,32,36,40,44,48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 88, 84, 80, 76, 72, 68, 64, 60, 56, 52,48,44,40,36,32,28,24,20,16,12
	dc.w	 16,20,24,28,32,36,40,44,48,52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56,52,48,44,40,36,32,28,24,20,16
	dc.w	 20,24,28,32,36,40,44,48,52,56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60,56,52,48,44,40,36,32,28,24,20
	dc.w	 24,28,32,36,40,44,48,52,56,60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,102, 96, 92, 88, 84, 80, 76, 72, 68, 64,60,56,52,48,44,40,36,32,28,24
	;dc.w	 28,32,36,40,44,48,52,56,60,64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,106,102, 96, 92, 88, 84, 80, 76, 72, 68,64,60,56,52,48,44,40,36,32,28
	;dc.w	 28,32,36,40,44,48,52,56,60,64, 68, 72, 76, 80, 84, 88, 92, 96,102,106,106,102, 96, 92, 88, 84, 80, 76, 72, 68,64,60,56,52,48,44,40,36,32,28
	dc.w	 24,28,32,36,40,44,48,52,56,60, 64, 68, 72, 76, 80, 84, 88, 92, 96,102,102, 96, 92, 88, 84, 80, 76, 72, 68, 64,60,56,52,48,44,40,36,32,28,24
	dc.w	 20,24,28,32,36,40,44,48,52,56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96, 96, 92, 88, 84, 80, 76, 72, 68, 64, 60,56,52,48,44,40,36,32,28,24,20
	dc.w	 16,20,24,28,32,36,40,44,48,52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 92, 88, 84, 80, 76, 72, 68, 64, 60, 56,52,48,44,40,36,32,28,24,20,16
	dc.w	 12,16,20,24,28,32,36,40,44,48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 88, 84, 80, 76, 72, 68, 64, 60, 56, 52,48,44,40,36,32,28,24,20,16,12
	dc.w	  8,12,16,20,24,28,32,36,40,44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 84, 80, 76, 72, 68, 64, 60, 56, 52, 48,44,40,36,32,28,24,20,16,12, 8
	dc.w	  4, 8,12,16,20,24,28,32,36,40, 44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 80, 76, 72, 68, 64, 60, 56, 52, 48, 44,40,36,32,28,24,20,16,12, 8, 4
	dc.w	  0, 4, 8,12,16,20,24,28,32,36, 40, 44, 48, 52, 56, 60, 64, 68, 72, 76, 76, 72, 68, 64, 60, 56, 52, 48, 44, 40,36,32,28,24,20,16,12, 8, 4, 0
	ENDR
	ds.l	30


plasma_coltab:
	ds.l	60


	; ZWART-ROOD-GEEL-WIT-GEEL-ROOD-ZWART
pl set 0
	REPT	31
	dc.w	pl*%100000000000
pl set pl+1
	ENDR
pl set 0
	REPT	31
	dc.w	pl*%1000000+31*%100000000000
pl set pl+1
	ENDR
pl set 0
	REPT	31
	dc.w	pl+31*%100001000000
pl set pl+1
	ENDR
pl set 31
	REPT	31
	dc.w	pl+31*%100001000000
pl set pl-1
	ENDR
pl set 31
	REPT	31
	dc.w	pl*%1000000+31*%100000000000
pl set pl-1
	ENDR
pl set 31
	REPT	31
	dc.w	pl*%100000000000
pl set pl-1
	ENDR


pl set 0
	REPT	31
	dc.w	pl*%100000000000
pl set pl+1
	ENDR
pl set 0
	REPT	31
	dc.w	pl*%1000000+31*%100000000000
pl set pl+1
	ENDR
pl set 0
	REPT	31
	dc.w	pl+31*%100001000000
pl set pl+1
	ENDR
pl set 31
	REPT	31
	dc.w	pl+31*%100001000000
pl set pl-1
	ENDR
pl set 31
	REPT	31
	dc.w	pl*%1000000+31*%100000000000
pl set pl-1
	ENDR
pl set 31
	REPT	31
	dc.w	pl*%100000000000
pl set pl-1
	ENDR

	; GRIJS-FADE
pl set 0
	REPT	31
	dc.w	pl*%100001000001
	dc.w	pl*%100001000001
pl set pl+1
	ENDR
	REPT	31
	dc.w	pl*%100001000001
	dc.w	pl*%100001000001
pl set pl-1
	ENDR


	; GREEN-FADE
pl set 0
	REPT	31
	dc.w	pl*%1000000
pl set pl+1
	ENDR
	REPT	31
	dc.w	pl*%1000000
pl set pl-1
	ENDR
	ds.w	32
	REPT	31
	dc.w	pl*%1000000
pl set pl+1
	ENDR
	REPT	31
	dc.w	pl*%1000000
pl set pl-1
	ENDR
	ds.w	32
	REPT	31
	dc.w	pl*%1000000
pl set pl+1
	ENDR
	REPT	31
	dc.w	pl*%1000000
pl set pl-1
	ENDR
	ds.w	32
	REPT	31
	dc.w	pl*%1000000
pl set pl+1
	ENDR
	REPT	31
	dc.w	pl*%1000000
pl set pl-1
	ENDR
	ds.w	32
	dc.w	2048*11
	dc.w	2048*22
	dc.w	2048*31
	dc.w	2048*31
	dc.w	2048*22
	dc.w	2048*11
	ds.w	20
	dc.w	64*11
	dc.w	64*22
	dc.w	64*31
	dc.w	64*31
	dc.w	64*22
	dc.w	64*11
	ds.w	20
	dc.w	1*11
	dc.w	1*22
	dc.w	1*31
	dc.w	1*31
	dc.w	1*22
	dc.w	1*11
	ds.w	32+20

	; RGB-ROUTE
pl set 0		; 000-700
	REPT	31
	dc.w	pl*2048
pl set pl+1
	ENDR
pl set 0		; 700-770
	REPT	31
	dc.w	pl*64+31*2048
pl set pl+1
	ENDR
pl set 31
	REPT	31	; 770-070
	dc.w	pl*2048+31*64
pl set pl-1
	ENDR
pl set 0
	REPT	31	; 070-077
	dc.w	31*64+pl
pl set pl+1
	ENDR
pl set 31
	REPT	31	; 077-007
	dc.w	pl*64+31
pl set pl-1
	ENDR
pl set 0
	REPT	31	; 007-707
	dc.w	31+pl*2048
pl set pl+1
	ENDR
pl set 31
	REPT	31	; 707-700
	dc.w	pl+31*2048
pl set pl-1
	ENDR
pl set 31
	REPT	31
	dc.w	pl*2048
pl set pl-1
	ENDR
	ds.w	32
	dc.w	%0011100111000111
	dc.w	%0011100111000111
	REPT	8
	dc.w	%0111101111001111
	dc.w	%0111101111001111
	ENDR
	dc.w	%1011110111010111
	dc.w	%1111111111011111
	dc.w	%1111111111011111
	dc.w	%1011110111010111
	REPT	8
	dc.w	%0111101111001111
	ENDR
	dc.w	%0011100111000111
	dc.w	%0011100111000111
	ds.w	32
plasma_coltabend:
	ds.l	100
