NR_P	EQU	16

	bsr	schermadr_opvraag
	move.l	schermadres,a0
	bsr	cls
	move.l	schermadres,a0
	add.w	#2,a0
	bsr	cls
	move.l	schermadres,a0
	add.w	#4,a0
	bsr	cls
	move.l	schermadres,a0
	add.w	#6,a0
	bsr	cls
back:
	move.l	schermadres,a0
	bsr	cls
	move.l	schermadres,a0
	bsr	cls

	move.l	schermadres,a0
	add.w	#152,a0
	move.w	#200-1,d0
timeloop1:
	move.w	#1,(a0)
	add.w	#160,a0
	dbra	d0,timeloop1

	add.w	#1,alpha
	cmp.w	#360,alpha
	blo.s	no_al360
	sub.w	#360,alpha
no_al360:
	bsr	do_rotate
	bsr	do_plot_init
	bsr	do_plot

	move.l	schermadres,a0
	add.w	#152,a0
	move.w	#200-1,d0
timeloop2:
	move.w	#-1,(a0)
	add.w	#160,a0
	dbra	d0,timeloop2

	bsr	vsync
	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back


	clr.l	-(sp)
	trap	#1

do_rotate:
	move.l	#oldcoords,a0
	move.l	#newcoords,a1
	move.l	#sinq,a2  ; words
	move.l	#cosq,a3  ; words

	move.w	alpha,d1  ; graden

	move.w	#NR_P-1,d0
rotcalcloop:

; BEREKEN X
;------------
	move.w	4(a0),d2
	sub.w	#180,d2 ; centr
	asl.w	#7,d2
	move.w	d2,4(a1)

; BEREKEN Y
;------------
; COSQ(alpha%)
	move.w	d1,d2	; D2
	asl.w	#1,d2	; words
	move.w	(a3,d2.w),d2
; *y%
	move.w	(a0),d3 ; D3
	sub.w	#180,d3 ; centr
	mulu	d3,d2

; SINQ(alpha%)
	move.w	d1,d3	; D3
	asl.w	#1,d3	; words
	move.w	(a2,d3.w),d3
; *z%
	move.w	2(a0),d4 ; D4
	sub.w	#180,d4 ; centr
	mulu	d4,d3

	add.w	d3,d2	; +

	move.w	d2,(a1)

; BEREKEN Z
;------------
; -SINQ(alpha%)
	move.w	d1,d2	; D2
	asl.w	#1,d2	; words
	move.w	(a2,d2.w),d2
	not.w	d2
; *y%
	move.w	(a0),d3 ; D3
	sub.w	#180,d3 ; centr
	mulu	d3,d2

; COSQ(alpha%)
	move.w	d1,d3	; D3
	asl.w	#1,d3	; words
	move.w	(a3,d3.w),d3
; *z%
	move.w	2(a0),d4 ; D4
	sub.w	#180,d4 ; centr
	mulu	d4,d3

	add.w	d3,d2	; +

	move.w	d2,2(a1)

	add.w	#6,a0
	add.w	#6,a1
	dbra	d0,rotcalcloop
	RTS

do_plot_init:
	move.l	#newcoords,a2
	move.w	#NR_P-1,d0
plinitl:
	move.w	(a2),d1
	asr.w	#8,d1
	asr.w	#1,d1
	add.w	#64,d1
	move.w	d1,(a2)

	move.w	2(a2),d1
	asr.w	#8,d1
	asr.w	#1,d1
	add.w	#64,d1
	move.w	d1,2(a2)

	add.w	#6,a2
	dbra	d0,plinitl
	RTS

do_plot:
	move.l	schermadres,a0
	move.l	#tabel1,a1
	move.l	#newcoords,a2
	move.w	#NR_P-1,d0
plot_loop:
	move.w	(a2)+,d3
	asl.w	#2,d3
	move.w	(a1,d3.w),d1
	move.w	2(a1,d3.w),d2
	move.w	(a2)+,d3
	mulu	#160,d3
	add.w	d3,d1
	bset	d2,(a0,d1.w)
	add.w	#2,a2
	dbra	d0,plot_loop
	RTS

cls:
	move.l	#200-1,d0
go_cls:
pl set 0
	REPT	20
	clr.w	pl(a0)
pl set pl+8
	ENDR
	add.w	#160,a0
	dbra d0,go_cls
	RTS
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS

schermadres:	dc.l	0
alpha:	dc.w	0
newcoords:	
		ds.l	100
w	EQU	180
oldcoords:
	dc.w	0,0,0	;0
	dc.w	0,80,0
	dc.w	20,80,0
	dc.w	20,0,0
	dc.w	20,40,0 ;4
	dc.w	28,48,0
	dc.w	60,48,0
	dc.w	46,34,0
	dc.w	68,0,0  ;8
	dc.w	88,0,0
	dc.w	88,80,0
	dc.w	68,80,0

	dc.w	96,80,0
	dc.w	124,80,0
	dc.w	136,0,0
	dc.w	164,0,0


sinq:	INCBIN	'F:\PROGRAMM\ROTATE\RSIN360.dat'
cosq:	INCBIN	'F:\PROGRAMM\ROTATE\RCOS360.dat'

tabel1:
pl set 0
	REPT	20
	dc.w	pl,7
	dc.w	pl,6
	dc.w	pl,5
	dc.w	pl,4
	dc.w	pl,3
	dc.w	pl,2
	dc.w	pl,1
	dc.w	pl,0
	dc.w	pl+1,7
	dc.w	pl+1,6
	dc.w	pl+1,5
	dc.w	pl+1,4
	dc.w	pl+1,3
	dc.w	pl+1,2
	dc.w	pl+1,1
	dc.w	pl+1,0
pl set pl+8
	ENDR





